#define TEXTLENGTH 256
#define SEPLENGTH 16

/* TEXTLENGTH must be set to 256 to use write_c with big names 
   generated by MMAlpha */

typedef
struct item_ {
	int             type;
	int             prec;
	struct item_   *next;

	union {
		struct {
			struct item_   *item_list;
			char            sep[SEPLENGTH];
			int             width, indent;
		}               hsep;
                struct {
                        struct item_   *item_list;
                        char            sep[SEPLENGTH];
                        int             width, indent;
                }               hlis;
		struct {
			struct item_   *item_list;
			char            sep[SEPLENGTH];
			int             indent;
		}               vsep;
                struct {
                        struct item_   *item_list;
                        char            sep[SEPLENGTH];
                        int             indent;
                }               vlis;
		struct {
			int             indent;
			struct item_   *open, *close, *body;
		}               venc;

		struct {
			int             indent;
			struct item_   *open, *close, *body;
		}               henc;

		struct {
			char            string[TEXTLENGTH];
		}               text;

		struct {
			int             value;
		}               number;

		struct {
			int             n;
		}               hspa;

		struct {
			int             n;
		}               vspa;
		struct {
			struct item_	*body;
			int		n;
		}		pos;
		struct {
			int		n;
		}		align;

	}               the;
}               item;

typedef
enum {
	hsep, hlis, vsep, vlis, venc, henc, text, number, hspa, vspa, pos,
        align
}               item_type;

void print_item();

#define Text(s) new_text(s)
#define Number(v) new_number(v)
#define Hspa(v) new_hspa(v)
#define Vspa(v) new_vspa(v)
#define Venc(i,o,c,b) new_venc(i,o,c,b)
#define Henc(i,o,c,b) new_henc(i,o,c,b)
#define Hsep12(i,s,a,b,c,d,e,f,g,h,j,k,l,m) new_hsep(i,s,new_list12(a,b,c,d,e,f,g,h,j,k,l,m))
#define Hsep11(i,s,a,b,c,d,e,f,g,h,j,k,l) new_hsep(i,s,new_list11(a,b,c,d,e,f,g,h,j,k,l))
#define Hsep10(i,s,a,b,c,d,e,f,g,h,j,k) new_hsep(i,s,new_list10(a,b,c,d,e,f,g,h,j,k))
#define Hsep9(i,s,a,b,c,d,e,f,g,h,j) new_hsep(i,s,new_list9(a,b,c,d,e,f,g,h,j))
#define Hsep8(i,s,a,b,c,d,e,f,g,h) new_hsep(i,s,new_list8(a,b,c,d,e,f,g,h))
#define Hsep7(i,s,a,b,c,d,e,f,g) new_hsep(i,s,new_list7(a,b,c,d,e,f,g))
#define Hsep6(i,s,a,b,c,d,e,f) new_hsep(i,s,new_list6(a,b,c,d,e,f))
#define Hsep5(i,s,a,b,c,d,e) new_hsep(i,s,new_list5(a,b,c,d,e))
#define Hsep4(i,s,a,b,c,d) new_hsep(i,s,new_list4(a,b,c,d))
#define Hsep3(i,s,a,b,c) new_hsep(i,s,new_list3(a,b,c))
#define Hsep2(i,s,a,b) new_hsep(i,s,new_list2(a,b))
#define Hsep1(i,s,a) new_hsep(i,s,a)
#define Hsep(i,s,a) new_hsep(i,s,a)
#define Vsep12(i,s,a,b,c,d,e,f,g,h,j,k,l,m) new_vsep(i,s,new_list12(a,b,c,d,e,f,g,h,j,k,l,m))
#define Vsep11(i,s,a,b,c,d,e,f,g,h,j,k,l) new_vsep(i,s,new_list11(a,b,c,d,e,f,g,h,j,k,l))
#define Vsep10(i,s,a,b,c,d,e,f,g,h,j,k) new_vsep(i,s,new_list10(a,b,c,d,e,f,g,h,j,k))
#define Vsep9(i,s,a,b,c,d,e,f,g,h,j) new_vsep(i,s,new_list9(a,b,c,d,e,f,g,h,j))
#define Vsep8(i,s,a,b,c,d,e,f,g,h) new_vsep(i,s,new_list8(a,b,c,d,e,f,g,h))
#define Vsep7(i,s,a,b,c,d,e,f,g) new_vsep(i,s,new_list7(a,b,c,d,e,f,g))
#define Vsep6(i,s,a,b,c,d,e,f) new_vsep(i,s,new_list6(a,b,c,d,e,f))
#define Vsep5(i,s,a,b,c,d,e) new_vsep(i,s,new_list5(a,b,c,d,e))
#define Vsep4(i,s,a,b,c,d) new_vsep(i,s,new_list4(a,b,c,d))
#define Vsep3(i,s,a,b,c) new_vsep(i,s,new_list3(a,b,c))
#define Vsep2(i,s,a,b) new_vsep(i,s,new_list2(a,b))
#define Vsep1(i,s,a) new_vsep(i,s,a)
#define Vsep(i,s,a) new_vsep(i,s,a)
#define Hlis12(i,s,a,b,c,d,e,f,g,h,j,k,l,m) new_hlis(i,s,new_list12(a,b,c,d,e,f,g,h,j,k,l,m))
#define Hlis11(i,s,a,b,c,d,e,f,g,h,j,k,l) new_hlis(i,s,new_list11(a,b,c,d,e,f,g,h,j,k,l))
#define Hlis10(i,s,a,b,c,d,e,f,g,h,j,k) new_hlis(i,s,new_list10(a,b,c,d,e,f,g,h,j,k))
#define Hlis9(i,s,a,b,c,d,e,f,g,h,j) new_hlis(i,s,new_list9(a,b,c,d,e,f,g,h,j))
#define Hlis8(i,s,a,b,c,d,e,f,g,h) new_hlis(i,s,new_list8(a,b,c,d,e,f,g,h))
#define Hlis7(i,s,a,b,c,d,e,f,g) new_hlis(i,s,new_list7(a,b,c,d,e,f,g))
#define Hlis6(i,s,a,b,c,d,e,f) new_hlis(i,s,new_list6(a,b,c,d,e,f))
#define Hlis5(i,s,a,b,c,d,e) new_hlis(i,s,new_list5(a,b,c,d,e))
#define Hlis4(i,s,a,b,c,d) new_hlis(i,s,new_list4(a,b,c,d))
#define Hlis3(i,s,a,b,c) new_hlis(i,s,new_list3(a,b,c))
#define Hlis2(i,s,a,b) new_hlis(i,s,new_list2(a,b))
#define Hlis1(i,s,a) new_hlis(i,s,a)
#define Hlis(i,s,a) new_hlis(i,s,a)
#define Vlis12(i,s,a,b,c,d,e,f,g,h,j,k,l,m) new_vlis(i,s,new_list12(a,b,c,d,e,f,g,h,j,k,l,m))
#define Vlis11(i,s,a,b,c,d,e,f,g,h,j,k,l) new_vlis(i,s,new_list11(a,b,c,d,e,f,g,h,j,k,l))
#define Vlis10(i,s,a,b,c,d,e,f,g,h,j,k) new_vlis(i,s,new_list10(a,b,c,d,e,f,g,h,j,k))
#define Vlis9(i,s,a,b,c,d,e,f,g,h,j) new_vlis(i,s,new_list9(a,b,c,d,e,f,g,h,j))
#define Vlis8(i,s,a,b,c,d,e,f,g,h) new_vlis(i,s,new_list8(a,b,c,d,e,f,g,h))
#define Vlis7(i,s,a,b,c,d,e,f,g) new_vlis(i,s,new_list7(a,b,c,d,e,f,g))
#define Vlis6(i,s,a,b,c,d,e,f) new_vlis(i,s,new_list6(a,b,c,d,e,f))
#define Vlis5(i,s,a,b,c,d,e) new_vlis(i,s,new_list5(a,b,c,d,e))
#define Vlis4(i,s,a,b,c,d) new_vlis(i,s,new_list4(a,b,c,d))
#define Vlis3(i,s,a,b,c) new_vlis(i,s,new_list3(a,b,c))
#define Vlis2(i,s,a,b) new_vlis(i,s,new_list2(a,b))
#define Vlis1(i,s,a) new_vlis(i,s,a)
#define Vlis(i,s,a) new_vlis(i,s,a)
#define Align(n) new_align(n)
#define Copy(i) copy_item(i)
#define Pos(i,n) new_pos(i,n)
