(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    259345,       6517]
NotebookOptionsPosition[    228796,       5641]
NotebookOutlinePosition[    229826,       5680]
CellTagsIndexPosition[    229681,       5673]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Fifo (does not work, has to be checked)", "Title",
 CellChangeTimes->{{3.480936213286107*^9, 3.480936220734358*^9}},
 FontColor->RGBColor[1, 0, 0],
 CellTags->"firstcell"],

Cell["Alpha Team", "Subsubtitle"],

Cell["April 2001, Revised Dec. 6 2008. ", "Text",
 CellChangeTimes->{{3.437565699815633*^9, 3.437565721981896*^9}}],

Cell["\<\
Irisa, Campus de Beaulieu, 35042 Rennes Cedex, France
quinton@irisa.fr\
\>", "SmallText"],

Cell[CellGroupData[{

Cell["\<\
 Evaluate this cell, before you execute any other cell in this notebook.\
\>", "Subsubsection",
 InitializationCell->True,
 FontColor->RGBColor[1, 0, 0]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"setMMADir", "[", 
  RowBox[{"{", 
   RowBox[{"\"\<demos\>\"", ",", "\"\<NOTEBOOKS\>\"", ",", "\"\<Fifo\>\""}], 
   "}"}], "]"}]], "Input",
 InitializationCell->True],

Cell[BoxData["\<\"/Users/patricequinton/mmalpha/demos/NOTEBOOKS/Fifo\"\>"], \
"Output",
 CellChangeTimes->{3.437563765040285*^9, 3.43756447183953*^9, 
  3.480936044364056*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Summary", "Section",
 FontColor->RGBColor[0, 0, 1],
 CellTags->"Summary"],

Cell["\<\
\tA fifo has N registers R, N status bits T, all numbered from 1 to N. The \
status bit of register R[i], if True, says that the Fifo is full up to \
position i (excluded). Initially, the fifo is empty, therefore, all status \
bits are false, except the Nth one. There is an extra status bit numbered 0, \
which, if true, indicates that the fifo is full.
\tTo implement a fifo in Alpha, we first define a subsystem fifo which reads \
in the value of the register file Rin, and of the status bits Tin before the \
operations, together with the op code, and the input bus. It returns the \
value of the register fine Rout, and the value Tout of the status bits. This \
system is a purely functional definition of the fifo. In our example, this \
system is named \"fifo\". Then we instantiate the fifo for all values of the \
time t, which corresponds to a subsystem call, named \"callfifo\" in the \
following. \
\>", "Text",
 TextAlignment->Left,
 TextJustification->1]
}, Open  ]],

Cell[CellGroupData[{

Cell["All at once", "Section",
 FontColor->RGBColor[0, 0, 1],
 CellTags->"Summary"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Timing", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"load", "[", "\"\<fifo1.alpha\>\"", "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"inlineAll", "[", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"removeSystem", "[", "\"\<fifo\>\"", "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"removeIdEqus", "[", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"normalize", "[", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"simplifySystem", "[", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"normalize", "[", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"ashow", "[", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"toAlpha0v2", "[", "]"}], ";", "\n", 
    RowBox[{"simplifySystem", "[", 
     RowBox[{"alphaFormat", "\[Rule]", "Alpha0"}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"asave", "[", "\"\<temp2.alpha\>\"", "]"}], ";", "\n", 
    RowBox[{"alpha0ToAlphard", "[", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"asaveLib", "[", "\"\<temp3.alpha\>\"", "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"fixParameter", "[", 
     RowBox[{"\"\<N\>\"", ",", "128"}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"a2v", "[", 
     RowBox[{"stdLogic", "\[Rule]", "True"}], "]"}]}], "\[IndentingNewLine]", 
   "]"}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.437565811843684*^9, 3.437565833455838*^9}, {
  3.437565923796734*^9, 3.437565934218979*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"[fifo][callfifo]\"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936044554467*^9}],

Cell[BoxData["\<\"system callfifo :{N | 3<=N}\\n                (busin : {t | \
0<=t} of integer; \\n                 op1 : {t | 0<=t} of boolean; \\n        \
         op2 : {t | 0<=t} of boolean)\\n       returns  (full : {t | 0<=t} of \
boolean; \\n                 empty : {t | 0<=t} of boolean; \\n               \
  wordout : {t | 0<=t} of integer);\\nvar\\n  Rin : {i,t | 1<=i<=N; 0<=t} of \
integer;\\n  Tin : {i,t | 0<=i<=N; 0<=t} of boolean;\\n  RoutXfifo1 : {i,t | \
1<=i<=N; 0<=t} of integer;\\n  ToutXfifo1 : {i,t | 0<=i<=N; 0<=t} of boolean;\
\\nlet\\n  RoutXfifo1[i,t] = \\n      case\\n        { | 2<=i} : if (op1[t]) \
then Rin[i-1,t] else if (op2[t] and Tin[i,t]) then busin[t] else Rin[i,t];\\n \
       { | i=1} : if (op1[i+t-1]) then Rin[i,t] else if (op2[i+t-1] and \
Tin[i,t]) then busin[i+t-1] else Rin[i,t];\\n      esac;\\n  ToutXfifo1[i,t] \
= \\n      case\\n        { | 1<=i<=N-1} : if (op1[t]) then Tin[i-1,t] else \
if (op1[t] and Tin[i,t]) then Tin[i+1,t] else Tin[i,t];\\n        { | i=N} : \
if (op1[i+t-N]) then Tin[i-1,t] else if (op1[i+t-N] and Tin[i,t]) then \
False[] else Tin[i,t];\\n        { | i=0} : if (op1[i+t]) then False[] else \
if (op1[i+t] and Tin[i,t]) then Tin[i+1,t] else Tin[i,t];\\n      esac;\\n  \
Rin[i,t] = \\n      case\\n        { | t=0} : 0[];\\n        { | 1<=t} : \
RoutXfifo1[i,t-1];\\n      esac;\\n  Tin[i,t] = \\n      case\\n        { | \
i<=N-1; t=0} : False[];\\n        { | i=N; t=0} : True[];\\n        { | 1<=t} \
: ToutXfifo1[i,t-1];\\n      esac;\\n  wordout[t] = RoutXfifo1[N,t];\\n  \
full[t] = ToutXfifo1[0,t];\\n  empty[t] = ToutXfifo1[N,t];\\ntel;\"\>"], \
"Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936046127245*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Time index: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}], "\[InvisibleSpace]", "\<\"  space indices: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "2", "}"}]}],
  SequenceForm["Time index: ", {1}, "  space indices: ", {2}],
  Editable->False]], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936046147798*^9}],

Cell[BoxData["\<\"--- Space time decomposition of the equations (Step \
1)\"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936046205648*^9}],

Cell[BoxData["\<\"--- Generating multiplexors (Step 2)\"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936048646064*^9}],

Cell[BoxData["\<\"case\\n  {i,t,N | 1<=i<=N-1; 0<=t; 3<=N} : if \
(op1.(i,t,N->t,N)) then Tin.(i,t,N->i-1,t,N) else if (op1.(i,t,N->t,N) and \
Tin.(i,t,N->i,t,N)) then Tin.(i,t,N->i+1,t,N) else Tin.(i,t,N->i,t,N);\\n  \
{i,t,N | i=N; 0<=t; 3<=N} : if (op1.(i,t,N->i+t-N,N)) then \
Tin.(i,t,N->i-1,t,N) else if (op1.(i,t,N->i+t-N,N) and Tin.(i,t,N->i,t,N)) \
then False.(i,t,N->) else Tin.(i,t,N->i,t,N);\\n  {i,t,N | i=0; 0<=t; 3<=N} : \
if (op1.(i,t,N->i+t,N)) then False.(i,t,N->) else if (op1.(i,t,N->i+t,N) and \
Tin.(i,t,N->i,t,N)) then Tin.(i,t,N->i+1,t,N) else Tin.(i,t,N->i,t,N);\\nesac\
\"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936049620823*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"makeAllMuxControl", "::", "\<\"argerr\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"this expression should be a \
binary case statement\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.480936049754387*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"File was saved in temp.alpha\"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936049811051*^9}],

Cell[BoxData["\<\"\\n**********  Generating Alphard Program **********\"\>"], \
"Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936050064521*^9}],

Cell[BoxData["\<\"Assuming that sys is not a module\"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936050119297*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"-- Building Interface of system: \"\>", 
   "\[InvisibleSpace]", "\<\"callfifo\"\>"}],
  SequenceForm["-- Building Interface of system: ", "callfifo"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936050173397*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Warning : the number of inputs of the module (\"\>", 
   "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\") is different from the number of inputs (\"\>", 
   "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\") of the initial system.\"\>"}],
  SequenceForm[
  "Warning : the number of inputs of the module (", 0, 
   ") is different from the number of inputs (", 3, 
   ") of the initial system."],
  Editable->False]], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936050243503*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Inputs of the module: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "}"}]}],
  SequenceForm["Inputs of the module: ", {}],
  Editable->False]], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.4809360503103952`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Inputs of the system: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"busin\"\>", ",", "\<\"op1\"\>", ",", "\<\"op2\"\>"}], "}"}]}],
  SequenceForm["Inputs of the system: ", {"busin", "op1", "op2"}],
  Editable->False]], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.4809360503939466`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Warning: the number of outputs of the module (\"\>", 
   "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\") is different of the number of outputs (\"\>", 
   "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\") of the initial system.\"\>"}],
  SequenceForm[
  "Warning: the number of outputs of the module (", 2, 
   ") is different of the number of outputs (", 3, ") of the initial system."],
  Editable->False]], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936050457842*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"-- Structuring Module \"\>", 
   "\[InvisibleSpace]", "\<\"callfifoModule\"\>"}],
  SequenceForm["-- Structuring Module ", "callfifoModule"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936050524487*^9}],

Cell[BoxData["\<\"-- Determining the different cell types... \"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.4809360505975924`*^9}],

Cell[BoxData["\<\"   Please wait...\"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.4809360506755877`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"getDeclaration", "::", "\<\"NotFound\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Variable \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"op1\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" not found in system.\\\
\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.4809360507457943`*^9}],

Cell[BoxData["\<\"? Variable op1 is not defined\"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936050810364*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"getDeclaration", "::", "\<\"NotFound\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Variable \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"op2\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" not found in system.\\\
\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.48093605087568*^9}],

Cell[BoxData["\<\"? Variable op2 is not defined\"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936050942905*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"getDeclaration", "::", "\<\"NotFound\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Variable \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"busin\\\"\\), \\\"MT\\\"]\
\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" not found in system.\\\\\\\"\\\", \
\\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.4809360510138063`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Further output of \\\\\\\"\\\
\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(getDeclaration :: \
\\\"NotFound\\\"\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" \
will be suppressed during this calculation.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/stop\\\", \
ButtonNote -> \\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.4809360511072483`*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"? Variable busin is not defined\"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936051158512*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"$Failed", "\[InvisibleSpace]", 
   RowBox[{"domain", "[", 
    RowBox[{"3", ",", 
     RowBox[{"{", 
      RowBox[{"\<\"i\"\>", ",", "\<\"t\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"pol", "[", 
       RowBox[{"5", ",", "5", ",", "0", ",", "0", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", 
            RowBox[{"-", "3"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}]}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "3", ",", "0", ",", "3", ",", "1"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "0", ",", "3", ",", "1"}], "}"}]}], 
         "}"}]}], "]"}], "}"}]}], "]"}]}],
  SequenceForm[$Failed, 
   Alpha`domain[3, {"i", "t", "N"}, {
     Alpha`pol[
     5, 5, 0, 0, {{1, 1, 0, 0, -1}, {1, -1, 0, 1, 0}, {1, 0, 1, 0, 0}, {1, 0, 
      0, 1, -3}, {1, 0, 0, 0, 1}}, {{1, 0, 1, 0, 0}, {1, 0, 0, 1, 0}, {1, 1, 
      0, 1, 0}, {1, 3, 0, 3, 1}, {1, 1, 0, 3, 1}}]}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936051229939*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"DomIntersection", "::", "\<\"params\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"wrong \
parameters\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.480936051292967*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Part", "::", "\<\"partd\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Part specification \
\\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Null \
\[LeftDoubleBracket] 2 \[RightDoubleBracket]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is longer than depth \
of object.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/partd\\\", \
ButtonNote -> \\\"Part::partd\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.480936051377676*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DomProject", "::", "\<\"params\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"wrong \
parameters\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.480936051463202*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"? Variable op1 is not defined\"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936051543796*^9}],

Cell[BoxData["\<\"? Variable op2 is not defined\"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936051617463*^9}],

Cell[BoxData["\<\"? Variable busin is not defined\"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.4809360516765223`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"$Failed", "\[InvisibleSpace]", 
   RowBox[{"domain", "[", 
    RowBox[{"3", ",", 
     RowBox[{"{", 
      RowBox[{"\<\"i\"\>", ",", "\<\"t\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"pol", "[", 
       RowBox[{"5", ",", "5", ",", "0", ",", "0", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", 
            RowBox[{"-", "3"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}]}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "3", ",", "0", ",", "3", ",", "1"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "0", ",", "3", ",", "1"}], "}"}]}], 
         "}"}]}], "]"}], "}"}]}], "]"}]}],
  SequenceForm[$Failed, 
   Alpha`domain[3, {"i", "t", "N"}, {
     Alpha`pol[
     5, 5, 0, 0, {{1, 1, 0, 0, -1}, {1, -1, 0, 1, 0}, {1, 0, 1, 0, 0}, {1, 0, 
      0, 1, -3}, {1, 0, 0, 0, 1}}, {{1, 0, 1, 0, 0}, {1, 0, 0, 1, 0}, {1, 1, 
      0, 1, 0}, {1, 3, 0, 3, 1}, {1, 1, 0, 3, 1}}]}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.4809360517457447`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"DomIntersection", "::", "\<\"params\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"wrong \
parameters\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.4809360518114557`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Part", "::", "\<\"partd\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Part specification \
\\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Null \
\[LeftDoubleBracket] 2 \[RightDoubleBracket]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is longer than depth \
of object.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/partd\\\", \
ButtonNote -> \\\"Part::partd\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.480936051877591*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DomProject", "::", "\<\"params\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"wrong \
parameters\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.4809360519445*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"? Variable op1 is not defined\"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936052010274*^9}],

Cell[BoxData["\<\"? Variable op1 is not defined\"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936052082456*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"$Failed", "\[InvisibleSpace]", 
   RowBox[{"domain", "[", 
    RowBox[{"3", ",", 
     RowBox[{"{", 
      RowBox[{"\<\"i\"\>", ",", "\<\"t\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"pol", "[", 
       RowBox[{"5", ",", "5", ",", "0", ",", "0", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", 
            RowBox[{"-", "3"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}]}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "3", ",", "0", ",", "3", ",", "1"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "3", ",", "1"}], "}"}]}], 
         "}"}]}], "]"}], "}"}]}], "]"}]}],
  SequenceForm[$Failed, 
   Alpha`domain[3, {"i", "t", "N"}, {
     Alpha`pol[
     5, 5, 0, 0, {{1, 1, 0, 0, 0}, {1, -1, 0, 1, 0}, {1, 0, 1, 0, 0}, {1, 0, 
      0, 1, -3}, {1, 0, 0, 0, 1}}, {{1, 0, 1, 0, 0}, {1, 0, 0, 1, 0}, {1, 1, 
      0, 1, 0}, {1, 3, 0, 3, 1}, {1, 0, 0, 3, 1}}]}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936052145588*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"DomIntersection", "::", "\<\"params\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"wrong \
parameters\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.4809360522138023`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Further output of \\\\\\\"\\\
\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(DomIntersection :: \
\\\"params\\\"\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" \
will be suppressed during this calculation.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/stop\\\", \
ButtonNote -> \\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.4809360522793283`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Part", "::", "\<\"partd\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Part specification \
\\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Null \
\[LeftDoubleBracket] 2 \[RightDoubleBracket]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is longer than depth \
of object.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/partd\\\", \
ButtonNote -> \\\"Part::partd\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.480936052345743*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Further output of \\\\\\\"\\\
\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Part :: \\\"partd\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" will be suppressed \
during this calculation.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.4809360524116907`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DomProject", "::", "\<\"params\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"wrong \
parameters\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.480936052484908*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Further output of \\\\\\\"\\\
\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(DomProject :: \
\\\"params\\\"\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" \
will be suppressed during this calculation.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/stop\\\", \
ButtonNote -> \\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.4809360525447893`*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"? Variable op1 is not defined\"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936052628169*^9}],

Cell[BoxData["\<\"? Variable op1 is not defined\"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936052695375*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"$Failed", "\[InvisibleSpace]", 
   RowBox[{"domain", "[", 
    RowBox[{"3", ",", 
     RowBox[{"{", 
      RowBox[{"\<\"i\"\>", ",", "\<\"t\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"pol", "[", 
       RowBox[{"5", ",", "5", ",", "0", ",", "0", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", 
            RowBox[{"-", "3"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}]}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "3", ",", "0", ",", "3", ",", "1"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "3", ",", "1"}], "}"}]}], 
         "}"}]}], "]"}], "}"}]}], "]"}]}],
  SequenceForm[$Failed, 
   Alpha`domain[3, {"i", "t", "N"}, {
     Alpha`pol[
     5, 5, 0, 0, {{1, 1, 0, 0, 0}, {1, -1, 0, 1, 0}, {1, 0, 1, 0, 0}, {1, 0, 
      0, 1, -3}, {1, 0, 0, 0, 1}}, {{1, 0, 1, 0, 0}, {1, 0, 0, 1, 0}, {1, 1, 
      0, 1, 0}, {1, 3, 0, 3, 1}, {1, 0, 0, 3, 1}}]}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936052763674*^9}],

Cell[BoxData["\<\"? Variable op1 is not defined\"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936052828514*^9}],

Cell[BoxData["\<\"? Variable op1 is not defined\"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936052896348*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"$Failed", "\[InvisibleSpace]", 
   RowBox[{"domain", "[", 
    RowBox[{"3", ",", 
     RowBox[{"{", 
      RowBox[{"\<\"i\"\>", ",", "\<\"t\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"pol", "[", 
       RowBox[{"5", ",", "5", ",", "0", ",", "0", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", 
            RowBox[{"-", "3"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}]}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "3", ",", "0", ",", "3", ",", "1"}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "3", ",", "1"}], "}"}]}], 
         "}"}]}], "]"}], "}"}]}], "]"}]}],
  SequenceForm[$Failed, 
   Alpha`domain[3, {"i", "t", "N"}, {
     Alpha`pol[
     5, 5, 0, 0, {{1, 1, 0, 0, 0}, {1, -1, 0, 1, 0}, {1, 0, 1, 0, 0}, {1, 0, 
      0, 1, -3}, {1, 0, 0, 0, 1}}, {{1, 0, 1, 0, 0}, {1, 0, 0, 1, 0}, {1, 1, 
      0, 1, 0}, {1, 3, 0, 3, 1}, {1, 0, 0, 3, 1}}]}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936052964766*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Alpha`Alphard`Private`ToAlphard", "::", "\<\"mixSpaceDom\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"error while calling \
mixSpaceDom\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.480936053038135*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"alpha0ToAlphard", "::", "\<\"errDomains\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"error while building regions\
\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.480936053113855*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"alpha0ToAlphard", "::", "\<\"errModule\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"could not structure \
module.\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.4809360531791353`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"alpha0ToAlphard", "::", "\<\"error\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"something wrong happened \
during transformation to Alphard\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], \
"Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.480936053248855*^9}],

Cell[BoxData["Null"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.4809360533121033`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"alpha0ToAlphard", "::", "\<\"PbOccured\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Problem occured during the \
translation,\\\\\\\\n fatal error\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], \
"Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.480936053380885*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Warning, currently this function supposes that  \"\>", 
   "\[InvisibleSpace]", "\<\"N\"\>", 
   "\[InvisibleSpace]", "\<\" has the same value everywhere and that $result \
contrains the top calling system of the library\"\>"}],
  SequenceForm[
  "Warning, currently this function supposes that  ", "N", 
   " has the same value everywhere and that $result contrains the top calling \
system of the library"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936053446322*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"N\"\>", "\[InvisibleSpace]", "\<\" suppressed in use of \"\>", 
   "\[InvisibleSpace]", "\<\"callfifo\"\>", 
   "\[InvisibleSpace]", "\<\" in library \"\>"}],
  SequenceForm["N", " suppressed in use of ", "callfifo", " in library "],
  Editable->False]], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936053518508*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Vhdl files will be generated in \"\>", 
   "\[InvisibleSpace]", \
"\<\"/Users/patricequinton/mmalpha/demos/NOTEBOOKS/Fifo/\"\>"}],
  SequenceForm[
  "Vhdl files will be generated in ", 
   "/Users/patricequinton/mmalpha/demos/NOTEBOOKS/Fifo/"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936053579006*^9}],

Cell[BoxData["\<\"\\nPlease wait...\\n\"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936053646166*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"callfifo\"\>", 
   "\[InvisibleSpace]", "\<\" was recognized as a Module.\"\>"}],
  SequenceForm["callfifo", " was recognized as a Module."],
  Editable->False]], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936053714699*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"vhdlModule", "::", "\<\"unbd\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"use statement: \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"fifo\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" has an unbounded \
extension domain\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.480936053780589*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vhdlModule", "::", "\<\"assgnerr\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"assignment not recognized, \
lhs is \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"Rin\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\", rhs is \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\({\\(\\({\\(\\(domain[\\(\\(2, \
\\(\\({\\\"i\\\", \\\"t\\\"}\\)\\), \\(\\({\\(pol[\\(\\(2, 2, 1, 1, \
\\(\\({\\(\\({0, 0, 1, 0}\\)\\), \\(\\({1, 0, 0, 1}\\)\\)}\\)\\), \
\\(\\({\\(\\({0, 1, 0, 0}\\)\\), \\(\\({1, 0, 0, \
1}\\)\\)}\\)\\)\\)\\)]\\)}\\)\\)\\)\\)]\\)\\), \
\\(\\({\\(\\({\\(\\\"const\\\"[0]\\)}\\)\\), \\(\\(matrix[\\(\\(1, 3, \\(\\({\
\\\"i\\\", \\\"t\\\"}\\)\\), \\(\\({\\({0, 0, \
1}\\)}\\)\\)\\)\\)]\\)\\)}\\)\\)}\\)\\), \\(\\({\\(\\(domain[\\(\\(2, \\(\\({\
\\\"i\\\", \\\"t\\\"}\\)\\), \\(\\({\\(pol[\\(\\(2, 3, 0, 1, \\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\), \\(\\({\\(\\({0, 1, 0, 0}\\)\\), \
\\(\\({1, 0, 1, 0}\\)\\), \\(\\({1, 0, 1, 1}\\)\\)}\\)\\)\\)\\)]\\)}\\)\\)\\)\
\\)]\\)\\), \\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)}\\)\\)}\\), \\\"MT\
\\\"]\\)\[NoBreak]\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.4809360538718233`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vhdlModule", "::", "\<\"assgnerr\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"assignment not recognized, \
lhs is \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"Tin\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\", rhs is \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\({\\(\\({\\(\\(domain[\\(\\(2, \
\\(\\({\\\"i\\\", \\\"t\\\"}\\)\\), \\(\\({\\(pol[\\(\\(3, 2, 1, 0, \
\\(\\({\\(\\({0, 0, 1, 0}\\)\\), \\(\\({1, \\(\\(-1\\)\\), 0, 127}\\)\\), \\(\
\\({1, 0, 0, 1}\\)\\)}\\)\\), \\(\\({\\(\\({1, \\(\\(-1\\)\\), 0, 0}\\)\\), \
\\(\\({1, 127, 0, 1}\\)\\)}\\)\\)\\)\\)]\\)}\\)\\)\\)\\)]\\)\\), \
\\(\\({\\(\\({\\(\\\"const\\\"[False]\\)}\\)\\), \\(\\(matrix[\\(\\(1, 3, \\(\
\\({\\\"i\\\", \\\"t\\\"}\\)\\), \\(\\({\\({0, 0, \
1}\\)}\\)\\)\\)\\)]\\)\\)}\\)\\)}\\)\\), \\(\\({\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)}\\)\\), \\(\\({\\(\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)\\), \\(\\({\\\"Tout\\\", \\(\\(matrix[\\(\\(3, 3, \\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\), \\(\\({\\(\\({1, 0, 0}\\)\\), \
\\(\\({\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)}\\)\\), \\(\\({0, 0, \
1}\\)\\)}\\)\\)\\)\\)]\\)\\)}\\)\\)}\\)\\)}\\), \
\\\"MT\\\"]\\)\[NoBreak]\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.480936053934424*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vhdlModule", "::", "\<\"unbnd\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"bounds of extension interval \
should be finite. Use statement will be incorrectly generated (see Vhdl \
code).\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.480936054014781*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vhdlModule", "::", "\<\"unbnd\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"bounds of extension interval \
should be finite. Use statement will be incorrectly generated (see Vhdl \
code).\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.480936054083956*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vhdlModule", "::", "\<\"unbnd\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"bounds of extension interval \
should be finite. Use statement will be incorrectly generated (see Vhdl \
code).\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.4809360541646967`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Further output of \\\\\\\"\\\
\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(vhdlModule :: \\\"unbnd\\\
\"\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" will be \
suppressed during this calculation.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/stop\\\", \
ButtonNote -> \\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.4809360542352*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"-------------------- WARNING! \"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.48093605429915*^9}],

Cell[BoxData["\<\"The following subsystems are not in $library: \"\>"], \
"Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936054364006*^9}],

Cell[BoxData[
 RowBox[{"{", "\<\"fifo\"\>", "}"}]], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936054432838*^9}],

Cell[BoxData["\<\"Insert their component description in the VHDL code.\"\>"], \
"Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.4809360545072813`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"a2v", "::", "\<\"error3\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Error while calling \
genModule on \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\
\"callfifo\\\"\\), \\\"MT\\\"]\\)\[NoBreak]\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437564170221148*^9, 3.437565862109054*^9, 
  3.4375659460601177`*^9, 3.4809360545832443`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\" ***** Warning: component \"\>", 
   "\[InvisibleSpace]", "\<\"fifo.component not found\"\>", 
   "\[InvisibleSpace]", "\<\" in directory \
/Users/patricequinton/mmalpha/demos/NOTEBOOKS/Fifo/\"\>"}],
  SequenceForm[
  " ***** Warning: component ", "fifo.component not found", 
   " in directory /Users/patricequinton/mmalpha/demos/NOTEBOOKS/Fifo/"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936054664926*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "0.09191400000000272`", 
   "\[InvisibleSpace]", "\<\" needed to translate \"\>", 
   "\[InvisibleSpace]", "\<\"callfifo\"\>"}],
  SequenceForm[0.09191400000000272, " needed to translate ", "callfifo"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936054732564*^9}],

Cell[BoxData["\<\"End of translation.\"\>"], "Print",
 CellChangeTimes->{3.437563924355948*^9, 3.437565850827523*^9, 
  3.437565934978615*^9, 3.480936054799035*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.8273750000000177`", ",", 
   RowBox[{"{", "Null", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.437564182954638*^9, 3.437565866928795*^9, 
  3.437565947398136*^9, 3.480936054865492*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FileNames", "[", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"callfifo.component\"\>", 
   ",", "\<\"callfifoModule.component\"\>", ",", "\<\"callfifoModule.vhd\"\>",
    ",", "\<\"callfifoSYN\"\>", ",", "\<\"callfifo.vhd\"\>", 
   ",", "\<\"cellcallfifoModule10.component\"\>", 
   ",", "\<\"cellcallfifoModule10.vhd\"\>", 
   ",", "\<\"cellcallfifoModule11.component\"\>", 
   ",", "\<\"cellcallfifoModule11.vhd\"\>", 
   ",", "\<\"cellcallfifoModule12.component\"\>", 
   ",", "\<\"cellcallfifoModule12.vhd\"\>", 
   ",", "\<\"cellcallfifoModule1.component\"\>", 
   ",", "\<\"cellcallfifoModule1.vhd\"\>", 
   ",", "\<\"cellcallfifoModule2.component\"\>", 
   ",", "\<\"cellcallfifoModule2.vhd\"\>", 
   ",", "\<\"cellcallfifoModule3.component\"\>", 
   ",", "\<\"cellcallfifoModule3.vhd\"\>", 
   ",", "\<\"cellcallfifoModule4.component\"\>", 
   ",", "\<\"cellcallfifoModule4.vhd\"\>", 
   ",", "\<\"cellcallfifoModule5.component\"\>", 
   ",", "\<\"cellcallfifoModule5.vhd\"\>", 
   ",", "\<\"cellcallfifoModule6.component\"\>", 
   ",", "\<\"cellcallfifoModule6.vhd\"\>", 
   ",", "\<\"cellcallfifoModule7.component\"\>", 
   ",", "\<\"cellcallfifoModule7.vhd\"\>", 
   ",", "\<\"cellcallfifoModule8.component\"\>", 
   ",", "\<\"cellcallfifoModule8.vhd\"\>", 
   ",", "\<\"cellcallfifoModule9.component\"\>", 
   ",", "\<\"cellcallfifoModule9.vhd\"\>", 
   ",", "\<\"ControlcallfifoModule.component\"\>", 
   ",", "\<\"ControlcallfifoModule.vhd\"\>", ",", "\<\"current.report\"\>", 
   ",", "\<\"CVS\"\>", ",", "\<\"definition.vhd\"\>", 
   ",", "\<\".DS_Store\"\>", ",", "\<\"fifo0.alpha\"\>", 
   ",", "\<\"fifo1.alpha\"\>", ",", "\<\"fifo.component\"\>", 
   ",", "\<\"fifoHard1.alpha\"\>", ",", "\<\"fifoInlined.alpha\"\>", 
   ",", "\<\"Fifo.nb\"\>", ",", "\<\"fifoPiped.alpha\"\>", 
   ",", "\<\"fifoPlaced.alpha\"\>", ",", "\<\"fifoScheduled.alpha\"\>", 
   ",", "\<\"fifo.vhd\"\>", ",", "\<\"temp1.alpha\"\>", 
   ",", "\<\"temp2.alpha\"\>", ",", "\<\"temp3.alpha\"\>", 
   ",", "\<\"temp.alpha\"\>", ",", "\<\"xxxFile.txt \"\>"}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<fifo0.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"[callfifo]\"\>"], "Print"],

Cell[BoxData["\<\" Library Loaded\"\>"], "Print"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"report", "[", "]"}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Loading", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<fifo1.alpha\>\"", "]"}], ";", 
  RowBox[{"ashow", "[", "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"[fifo][callfifo]\"\>"], "Print",
 CellChangeTimes->{3.437564210810347*^9, 3.43756490154025*^9, 
  3.43756605401797*^9, 3.480936061843405*^9}],

Cell[BoxData["\<\"system callfifo :{N | 3<=N}\\n                (busin : {t | \
0<=t} of integer; \\n                 op1 : {t | 0<=t} of boolean; \\n        \
         op2 : {t | 0<=t} of boolean)\\n       returns  (full : {t | 0<=t} of \
boolean; \\n                 empty : {t | 0<=t} of boolean; \\n               \
  wordout : {t | 0<=t} of integer);\\nvar\\n  Rin : {i,t | 1<=i<=N; 0<=t} of \
integer;\\n  Tin : {i,t | 0<=i<=N; 0<=t} of boolean;\\n  Rout : {i,t | \
1<=i<=N; 0<=t} of integer;\\n  Tout : {i,t | 0<=i<=N; 0<=t} of boolean;\\nlet\
\\n  use {t | 0<=t} fifo[N] (Rin, Tin, busin, op1, op2) returns  (Rout, Tout) \
;\\n  Rin[i,t] = \\n      case\\n        { | t=0} : 0[];\\n        { | 1<=t} \
: Rout[i,t-1];\\n      esac;\\n  Tin[i,t] = \\n      case\\n        { | \
i<=N-1; t=0} : False[];\\n        { | i=N; t=0} : True[];\\n        { | 1<=t} \
: Tout[i,t-1];\\n      esac;\\n  wordout[t] = Rout[N,t];\\n  full[t] = \
Tout[0,t];\\n  empty[t] = Tout[N,t];\\ntel;\"\>"], "Print",
 CellChangeTimes->{3.437564210810347*^9, 3.43756490154025*^9, 
  3.43756605401797*^9, 3.480936061903943*^9}]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"changeOfBasis", "[", "\"\<Rin.(p,t->t,p)\>\"", "]"}], ";", 
  RowBox[{"changeOfBasis", "[", "\"\<Tin.(p,t->t,p)\>\"", "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.437566057461854*^9, 3.43756611634063*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"changeOfBasis", "[", "\"\<Rout.(p,t->t,p)\>\"", "]"}], ";", 
  RowBox[{"changeOfBasis", "[", "\"\<Tout.(p,t->t,p)\>\"", "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.437566183596693*^9, 3.4375661915751553`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Warning2 : \"\>", "\[InvisibleSpace]", "\<\"Rout\"\>", 
   "\[InvisibleSpace]", "\<\" appears in the output list of a use :\"\>"}],
  SequenceForm[
  "Warning2 : ", "Rout", " appears in the output list of a use :"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375661924273233`*^9, 3.48093606495503*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Adding the auxilliary variable \"\>", 
   "\[InvisibleSpace]", "\<\"oldXRout\"\>"}],
  SequenceForm["  Adding the auxilliary variable ", "oldXRout"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375661924273233`*^9, 3.480936065011406*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Warning2 : \"\>", "\[InvisibleSpace]", "\<\"Tout\"\>", 
   "\[InvisibleSpace]", "\<\" appears in the output list of a use :\"\>"}],
  SequenceForm[
  "Warning2 : ", "Tout", " appears in the output list of a use :"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375661924273233`*^9, 3.480936065079958*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Adding the auxilliary variable \"\>", 
   "\[InvisibleSpace]", "\<\"oldXTout\"\>"}],
  SequenceForm["  Adding the auxilliary variable ", "oldXTout"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375661924273233`*^9, 3.4809360651506968`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input",
 CellChangeTimes->{{3.437566119820414*^9, 3.43756612472464*^9}}],

Cell[BoxData["\<\"system callfifo :{N | 3<=N}\\n                (busin : {t | \
0<=t} of integer; \\n                 op1 : {t | 0<=t} of boolean; \\n        \
         op2 : {t | 0<=t} of boolean)\\n       returns  (full : {t | 0<=t} of \
boolean; \\n                 empty : {t | 0<=t} of boolean; \\n               \
  wordout : {t | 0<=t} of integer);\\nvar\\n  Rin : {p,t | 0<=p; 1<=t<=N} of \
integer;\\n  Tin : {p,t | 0<=p; 0<=t<=N} of boolean;\\n  Rout : {p,t | 0<=p; \
1<=t<=N} of integer;\\n  Tout : {p,t | 0<=p; 0<=t<=N} of boolean;\\n  \
oldXRout : {i,t | 1<=i<=N; 0<=t} of integer;\\n  oldXTout : {i,t | 0<=i<=N; \
0<=t} of boolean;\\nlet\\n  use {t | 0<=t} fifo[N] (Rin.(p,t->t,p), \
Tin.(p,t->t,p), busin, op1, op2) returns  (oldXRout, oldXTout) ;\\n  \
Tout[p,t] = oldXTout[t,p];\\n  Rout[p,t] = oldXRout[t,p];\\n  Rin[p,t] = \\n  \
    case\\n        { | p=0} : 0[];\\n        { | 1<=p} : Rout[p-1,t];\\n      \
esac;\\n  Tin[p,t] = \\n      case\\n        { | p=0; t<=N-1} : False[];\\n   \
     { | p=0; t=N} : True[];\\n        { | 1<=p} : Tout[p-1,t];\\n      esac;\
\\n  wordout[t] = Rout[t,N];\\n  full[t] = Tout[t,0];\\n  empty[t] = \
Tout[t,N];\\ntel;\"\>"], "Print",
 CellChangeTimes->{3.437566125272304*^9, 3.4375661972237883`*^9, 
  3.480936066869095*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"analyze", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.437564214647327*^9, 3.437566203083289*^9, 
  3.48093606800541*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"callfifo\"\>"}],
  SequenceForm["Static Analysis of system ", "callfifo"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564214647327*^9, 3.437566203083289*^9, 
  3.480936068064713*^9}],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print",
 CellChangeTimes->{3.437564214647327*^9, 3.437566203083289*^9, 
  3.4809360681339684`*^9}],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print",
 CellChangeTimes->{3.437564214647327*^9, 3.437566203083289*^9, 
  3.480936068205988*^9}],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print",
 CellChangeTimes->{3.437564214647327*^9, 3.437566203083289*^9, 
  3.480936068271657*^9}],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print",
 CellChangeTimes->{3.437564214647327*^9, 3.437566203083289*^9, 
  3.480936068339555*^9}],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print",
 CellChangeTimes->{3.437564214647327*^9, 3.437566203083289*^9, 
  3.480936068405993*^9}],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print",
 CellChangeTimes->{3.437564214647327*^9, 3.437566203083289*^9, 
  3.480936068471805*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----use \"\>", "\[InvisibleSpace]", "\<\"fifo\"\>", 
   "\[InvisibleSpace]", "\<\"...\"\>"}],
  SequenceForm["----use ", "fifo", "..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564214647327*^9, 3.437566203083289*^9, 
  3.480936068567124*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Tout\"\>"}],
  SequenceForm["----equation defining ", "Tout"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564214647327*^9, 3.437566203083289*^9, 
  3.480936068638968*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Rout\"\>"}],
  SequenceForm["----equation defining ", "Rout"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564214647327*^9, 3.437566203083289*^9, 
  3.4809360687050323`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Rin\"\>"}],
  SequenceForm["----equation defining ", "Rin"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564214647327*^9, 3.437566203083289*^9, 
  3.4809360687727337`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Tin\"\>"}],
  SequenceForm["----equation defining ", "Tin"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564214647327*^9, 3.437566203083289*^9, 
  3.4809360688563623`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"wordout\"\>"}],
  SequenceForm["----equation defining ", "wordout"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564214647327*^9, 3.437566203083289*^9, 
  3.480936068921629*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"full\"\>"}],
  SequenceForm["----equation defining ", "full"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564214647327*^9, 3.437566203083289*^9, 
  3.480936068988949*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"empty\"\>"}],
  SequenceForm["----equation defining ", "empty"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564214647327*^9, 3.437566203083289*^9, 
  3.480936069054356*^9}],

Cell[BoxData["\<\"--Checking regularity of output equations\"\>"], "Print",
 CellChangeTimes->{3.437564214647327*^9, 3.437566203083289*^9, 
  3.480936069158341*^9}],

Cell[BoxData["\<\"----Outputs equations are regular.\"\>"], "Print",
 CellChangeTimes->{3.437564214647327*^9, 3.437566203083289*^9, 
  3.480936069406972*^9}],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print",
 CellChangeTimes->{3.437564214647327*^9, 3.437566203083289*^9, 
  3.4809360694773273`*^9}]
}, Open  ]],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.437564216333618*^9, 3.437566204689932*^9, 
  3.480936069539383*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Static analysis", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"analyze", "[", 
  RowBox[{"recurse", "\[Rule]", "True"}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Need to analyze : \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"fifo\"\>", ",", "\<\"callfifo\"\>"}], "}"}]}],
  SequenceForm["Need to analyze : ", {"fifo", "callfifo"}],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936071862164*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936071922576*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"fifo\"\>"}],
  SequenceForm["Static Analysis of system ", "fifo"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936072006291*^9}],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936072096814*^9}],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.4809360721802473`*^9}],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936072262165*^9}],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.4809360723295527`*^9}],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.4809360724130793`*^9}],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936072507519*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Rout\"\>"}],
  SequenceForm["----equation defining ", "Rout"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.4809360725791197`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Tout\"\>"}],
  SequenceForm["----equation defining ", "Tout"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936072663218*^9}],

Cell[BoxData["\<\"--Checking regularity of output equations\"\>"], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.4809360727463913`*^9}],

Cell[BoxData["\<\"----Outputs equations are not regular. Use \
mkAllOutputsRegular.\"\>"], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936072812766*^9}],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.4809360728974752`*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936072980089*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"callfifo\"\>"}],
  SequenceForm["Static Analysis of system ", "callfifo"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936073063636*^9}],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936073172165*^9}],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.4809360732474117`*^9}],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.4809360733315763`*^9}],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936073396401*^9}],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936073483602*^9}],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936073545273*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----use \"\>", "\[InvisibleSpace]", "\<\"fifo\"\>", 
   "\[InvisibleSpace]", "\<\"...\"\>"}],
  SequenceForm["----use ", "fifo", "..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936073612814*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Tout\"\>"}],
  SequenceForm["----equation defining ", "Tout"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936073680234*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Rout\"\>"}],
  SequenceForm["----equation defining ", "Rout"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936073746442*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Rin\"\>"}],
  SequenceForm["----equation defining ", "Rin"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.4809360738126173`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Tin\"\>"}],
  SequenceForm["----equation defining ", "Tin"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936073879517*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"wordout\"\>"}],
  SequenceForm["----equation defining ", "wordout"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.4809360739461393`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"full\"\>"}],
  SequenceForm["----equation defining ", "full"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.4809360740200043`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"empty\"\>"}],
  SequenceForm["----equation defining ", "empty"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936074080153*^9}],

Cell[BoxData["\<\"--Checking regularity of output equations\"\>"], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.48093607414682*^9}],

Cell[BoxData["\<\"----Outputs equations are regular.\"\>"], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936074214123*^9}],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936074281376*^9}],

Cell[BoxData["\<\"\\nRecursive Analysis Successful.\"\>"], "Print",
 CellChangeTimes->{3.4375642253636703`*^9, 3.480936074347114*^9}]
}, Open  ]],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.4375642283099327`*^9, 3.480936074414607*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Inline", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<fifo1.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[BoxData["\<\"[fifo][callfifo]\"\>"], "Print",
 CellChangeTimes->{3.480936076454419*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"inlineAll", "[", "]"}], ";", 
  RowBox[{"ashow", "[", "]"}]}]], "Input"],

Cell[BoxData["\<\"system callfifo :{N | 3<=N}\\n                (busin : {t | \
0<=t} of integer; \\n                 op1 : {t | 0<=t} of boolean; \\n        \
         op2 : {t | 0<=t} of boolean)\\n       returns  (full : {t | 0<=t} of \
boolean; \\n                 empty : {t | 0<=t} of boolean; \\n               \
  wordout : {t | 0<=t} of integer);\\nvar\\n  Rin : {i,t | 1<=i<=N; 0<=t} of \
integer;\\n  Tin : {i,t | 0<=i<=N; 0<=t} of boolean;\\n  Rout : {i,t | \
1<=i<=N; 0<=t} of integer;\\n  Tout : {i,t | 0<=i<=N; 0<=t} of boolean;\\n  \
RinXfifo1 : {i,t | 1<=i<=N; 0<=t} of integer;\\n  TinXfifo1 : {i,t | 0<=i<=N; \
0<=t} of boolean;\\n  businXfifo1 : {t | 0<=t} of integer;\\n  op1Xfifo1 : {t \
| 0<=t} of boolean;\\n  op2Xfifo1 : {t | 0<=t} of boolean;\\n  RoutXfifo1 : \
{i,t | 1<=i<=N; 0<=t} of integer;\\n  ToutXfifo1 : {i,t | 0<=i<=N; 0<=t} of \
boolean;\\nlet\\n  RinXfifo1[i,t] = Rin;\\n  TinXfifo1[i,t] = Tin;\\n  \
businXfifo1[t] = busin;\\n  op1Xfifo1[t] = op1;\\n  op2Xfifo1[t] = op2;\\n  \
RoutXfifo1[i,t] = if (op1Xfifo1[t]) then \\n          case\\n            { | \
2<=i; 0<=t} : RinXfifo1[i-1,t];\\n            { | i=1; 0<=t} : \
RinXfifo1[i,t];\\n          esac else if (op2Xfifo1[t] and TinXfifo1[i,t]) \
then businXfifo1[t] else RinXfifo1[i,t];\\n  ToutXfifo1[i,t] = if \
(op1Xfifo1[t]) then \\n          case\\n            { | 1<=i; 0<=t} : \
TinXfifo1[i-1,t];\\n            { | i=0; 0<=t} : False[];\\n          esac \
else if (op1Xfifo1[t] and TinXfifo1[i,t]) then \\n          case\\n           \
 { | i<=N-1; 0<=t} : TinXfifo1[i+1,t];\\n            { | i=N; 0<=t} : \
False[];\\n          esac else TinXfifo1[i,t];\\n  Rout[i,t] = RoutXfifo1;\\n \
 Tout[i,t] = ToutXfifo1;\\n  Rin[i,t] = \\n      case\\n        { | t=0} : \
0[];\\n        { | 1<=t} : Rout[i,t-1];\\n      esac;\\n  Tin[i,t] = \\n      \
case\\n        { | i<=N-1; t=0} : False[];\\n        { | i=N; t=0} : \
True[];\\n        { | 1<=t} : Tout[i,t-1];\\n      esac;\\n  wordout[t] = \
Rout[N,t];\\n  full[t] = Tout[0,t];\\n  empty[t] = Tout[N,t];\\ntel;\"\>"], \
"Print",
 CellChangeTimes->{3.437564235165279*^9, 3.437564944695005*^9, 
  3.480936077602895*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"analyze", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.4809360786553717`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"callfifo\"\>"}],
  SequenceForm["Static Analysis of system ", "callfifo"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.480936078715218*^9}],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.480936078767475*^9}],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.48093607883982*^9}],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.480936078906048*^9}],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.480936078974465*^9}],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.480936079039529*^9}],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.480936079123151*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"RinXfifo1\"\>"}],
  SequenceForm["----equation defining ", "RinXfifo1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.4809360792077103`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TinXfifo1\"\>"}],
  SequenceForm["----equation defining ", "TinXfifo1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.480936079274151*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"businXfifo1\"\>"}],
  SequenceForm["----equation defining ", "businXfifo1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.480936079340147*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op1Xfifo1\"\>"}],
  SequenceForm["----equation defining ", "op1Xfifo1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.480936079408428*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op2Xfifo1\"\>"}],
  SequenceForm["----equation defining ", "op2Xfifo1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.4809360794738092`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"RoutXfifo1\"\>"}],
  SequenceForm["----equation defining ", "RoutXfifo1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.4809360795407763`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1\"\>"}],
  SequenceForm["----equation defining ", "ToutXfifo1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.480936079608252*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Rout\"\>"}],
  SequenceForm["----equation defining ", "Rout"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.480936079674816*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Tout\"\>"}],
  SequenceForm["----equation defining ", "Tout"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.480936079766686*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Rin\"\>"}],
  SequenceForm["----equation defining ", "Rin"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.480936079842477*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Tin\"\>"}],
  SequenceForm["----equation defining ", "Tin"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.4809360799080343`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"wordout\"\>"}],
  SequenceForm["----equation defining ", "wordout"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.48093608007894*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"full\"\>"}],
  SequenceForm["----equation defining ", "full"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.480936080134839*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"empty\"\>"}],
  SequenceForm["----equation defining ", "empty"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.4809360801903057`*^9}],

Cell[BoxData["\<\"--Checking regularity of output equations\"\>"], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.480936080257361*^9}],

Cell[BoxData["\<\"----Outputs equations are regular.\"\>"], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.480936080324132*^9}],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print",
 CellChangeTimes->{3.437564239931232*^9, 3.437564948145467*^9, 
  3.4809360803908587`*^9}]
}, Open  ]],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.437564242730824*^9, 3.437564950882596*^9, 
  3.48093608045645*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"removeIdEqus", "[", 
   RowBox[{"debug", "\[Rule]", "False"}], "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"normalize", "[", "]"}], ";", 
  RowBox[{"ashow", "[", "]"}], ";"}]], "Input"],

Cell[BoxData["\<\"system callfifo :{N | 3<=N}\\n                (busin : {t | \
0<=t} of integer; \\n                 op1 : {t | 0<=t} of boolean; \\n        \
         op2 : {t | 0<=t} of boolean)\\n       returns  (full : {t | 0<=t} of \
boolean; \\n                 empty : {t | 0<=t} of boolean; \\n               \
  wordout : {t | 0<=t} of integer);\\nvar\\n  Rin : {i,t | 1<=i<=N; 0<=t} of \
integer;\\n  Tin : {i,t | 0<=i<=N; 0<=t} of boolean;\\n  RoutXfifo1 : {i,t | \
1<=i<=N; 0<=t} of integer;\\n  ToutXfifo1 : {i,t | 0<=i<=N; 0<=t} of boolean;\
\\nlet\\n  RoutXfifo1[i,t] = \\n      case\\n        { | 2<=i<=N; 0<=t} : if \
(op1[t]) then Rin[i-1,t] else if (op2[t] and Tin[i,t]) then busin[t] else \
Rin[i,t];\\n        { | i=1; 0<=t; 1<=N} : if (op1[t]) then Rin[i,t] else if \
(op2[t] and Tin[i,t]) then busin[t] else Rin[i,t];\\n      esac;\\n  \
ToutXfifo1[i,t] = \\n      case\\n        { | 1<=i<=N-1; 0<=t} : if (op1[t]) \
then Tin[i-1,t] else if (op1[t] and Tin[i,t]) then Tin[i+1,t] else \
Tin[i,t];\\n        { | i=N; 0<=t; 1<=N} : if (op1[t]) then Tin[i-1,t] else \
if (op1[t] and Tin[i,t]) then False[] else Tin[i,t];\\n        { | i=0; 0<=t; \
1<=N} : if (op1[t]) then False[] else if (op1[t] and Tin[i,t]) then \
Tin[i+1,t] else Tin[i,t];\\n        { | i=0; 0<=t; N=0} : if (op1[t]) then \
False[] else if (op1[t] and Tin[i,t]) then False[] else Tin[i,t];\\n      \
esac;\\n  Rin[i,t] = \\n      case\\n        { | t=0} : 0[];\\n        { | \
1<=i<=N; 1<=t} : RoutXfifo1[i,t-1];\\n      esac;\\n  Tin[i,t] = \\n      \
case\\n        { | i<=N-1; t=0} : False[];\\n        { | i=N; t=0} : \
True[];\\n        { | 0<=i<=N; 1<=t} : ToutXfifo1[i,t-1];\\n      esac;\\n  \
wordout[t] = { | 0<=t; 1<=N} : RoutXfifo1[N,t];\\n  full[t] = { | 0<=t; 0<=N} \
: ToutXfifo1[0,t];\\n  empty[t] = { | 0<=t; 0<=N} : ToutXfifo1[N,t];\\ntel;\"\
\>"], "Print",
 CellChangeTimes->{3.4375642519626913`*^9, 3.437564955326829*^9, 
  3.480936083835284*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"simplifySystem", "[", "]"}], ";", 
  RowBox[{"ashow", "[", "]"}], ";"}]], "Input"],

Cell[BoxData["\<\"system callfifo :{N | 3<=N}\\n                (busin : {t | \
0<=t} of integer; \\n                 op1 : {t | 0<=t} of boolean; \\n        \
         op2 : {t | 0<=t} of boolean)\\n       returns  (full : {t | 0<=t} of \
boolean; \\n                 empty : {t | 0<=t} of boolean; \\n               \
  wordout : {t | 0<=t} of integer);\\nvar\\n  Rin : {i,t | 1<=i<=N; 0<=t} of \
integer;\\n  Tin : {i,t | 0<=i<=N; 0<=t} of boolean;\\n  RoutXfifo1 : {i,t | \
1<=i<=N; 0<=t} of integer;\\n  ToutXfifo1 : {i,t | 0<=i<=N; 0<=t} of boolean;\
\\nlet\\n  RoutXfifo1[i,t] = \\n      case\\n        { | 2<=i} : if (op1[t]) \
then Rin[i-1,t] else if (op2[t] and Tin[i,t]) then busin[t] else Rin[i,t];\\n \
       { | i=1} : if (op1[i+t-1]) then Rin[i,t] else if (op2[i+t-1] and \
Tin[i,t]) then busin[i+t-1] else Rin[i,t];\\n      esac;\\n  ToutXfifo1[i,t] \
= \\n      case\\n        { | 1<=i<=N-1} : if (op1[t]) then Tin[i-1,t] else \
if (op1[t] and Tin[i,t]) then Tin[i+1,t] else Tin[i,t];\\n        { | i=N} : \
if (op1[i+t-N]) then Tin[i-1,t] else if (op1[i+t-N] and Tin[i,t]) then \
False[] else Tin[i,t];\\n        { | i=0} : if (op1[i+t]) then False[] else \
if (op1[i+t] and Tin[i,t]) then Tin[i+1,t] else Tin[i,t];\\n      esac;\\n  \
Rin[i,t] = \\n      case\\n        { | t=0} : 0[];\\n        { | 1<=t} : \
RoutXfifo1[i,t-1];\\n      esac;\\n  Tin[i,t] = \\n      case\\n        { | \
i<=N-1; t=0} : False[];\\n        { | i=N; t=0} : True[];\\n        { | 1<=t} \
: ToutXfifo1[i,t-1];\\n      esac;\\n  wordout[t] = RoutXfifo1[N,t];\\n  \
full[t] = ToutXfifo1[0,t];\\n  empty[t] = ToutXfifo1[N,t];\\ntel;\"\>"], \
"Print",
 CellChangeTimes->{3.43756425587868*^9, 3.43756495916918*^9, 
  3.480936086210321*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"asave", "[", "\"\<fifoInlined.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"changeOfBasis", "[", "\"\<ToutXfifo1.(t,p->p,t)\>\"", "]"}], ";", 
  RowBox[{"ashow", "[", "]"}]}]], "Input",
 CellChangeTimes->{{3.4375649664511538`*^9, 3.437565069074235*^9}}],

Cell[BoxData["\<\"system callfifo :{N | 3<=N}\\n                (busin : {t | \
0<=t} of integer; \\n                 op1 : {t | 0<=t} of boolean; \\n        \
         op2 : {t | 0<=t} of boolean)\\n       returns  (full : {t | 0<=t} of \
boolean; \\n                 empty : {t | 0<=t} of boolean; \\n               \
  wordout : {t | 0<=t} of integer);\\nvar\\n  Rin : {i,t | 1<=i<=N; 0<=t} of \
integer;\\n  Tin : {i,t | 0<=i<=N; 0<=t} of boolean;\\n  RoutXfifo1 : {i,t | \
1<=i<=N; 0<=t} of integer;\\n  ToutXfifo1 : {t,p | 0<=t; 0<=p<=N} of boolean;\
\\nlet\\n  RoutXfifo1[i,t] = \\n      case\\n        { | 2<=i} : if (op1[t]) \
then Rin[i-1,t] else if (op2[t] and Tin[i,t]) then busin[t] else Rin[i,t];\\n \
       { | i=1} : if (op1[i+t-1]) then Rin[i,t] else if (op2[i+t-1] and \
Tin[i,t]) then busin[i+t-1] else Rin[i,t];\\n      esac;\\n  ToutXfifo1[t,p] \
= \\n      case\\n        { | 1<=p<=N-1} : if (op1[t]) then Tin[p-1,t] else \
if (op1[t] and Tin[p,t]) then Tin[p+1,t] else Tin[p,t];\\n        { | p=N} : \
if (op1[t+p-N]) then Tin[p-1,t] else if (op1[t+p-N] and Tin[p,t]) then \
False[] else Tin[p,t];\\n        { | p=0} : if (op1[t+p]) then False[] else \
if (op1[t+p] and Tin[p,t]) then Tin[p+1,t] else Tin[p,t];\\n      esac;\\n  \
Rin[i,t] = \\n      case\\n        { | t=0} : 0[];\\n        { | 1<=t} : \
RoutXfifo1[i,t-1];\\n      esac;\\n  Tin[i,t] = \\n      case\\n        { | \
i<=N-1; t=0} : False[];\\n        { | i=N; t=0} : True[];\\n        { | 1<=t} \
: ToutXfifo1[t-1,i];\\n      esac;\\n  wordout[t] = RoutXfifo1[N,t];\\n  \
full[t] = ToutXfifo1[t,0];\\n  empty[t] = ToutXfifo1[t,N];\\ntel;\"\>"], \
"Print",
 CellChangeTimes->{3.437565072220601*^9, 3.480936090098481*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"changeOfBasis", "[", "\"\<RoutXfifo1.(t,p->p,t)\>\"", "]"}], ";", 
  RowBox[{"ashow", "[", "]"}]}]], "Input",
 CellChangeTimes->{{3.4375649664511538`*^9, 3.4375650469055862`*^9}}],

Cell[BoxData["\<\"system callfifo :{N | 3<=N}\\n                (busin : {t | \
0<=t} of integer; \\n                 op1 : {t | 0<=t} of boolean; \\n        \
         op2 : {t | 0<=t} of boolean)\\n       returns  (full : {t | 0<=t} of \
boolean; \\n                 empty : {t | 0<=t} of boolean; \\n               \
  wordout : {t | 0<=t} of integer);\\nvar\\n  Rin : {i,t | 1<=i<=N; 0<=t} of \
integer;\\n  Tin : {i,t | 0<=i<=N; 0<=t} of boolean;\\n  RoutXfifo1 : {t,p | \
0<=t; 1<=p<=N} of integer;\\n  ToutXfifo1 : {t,p | 0<=t; 0<=p<=N} of boolean;\
\\nlet\\n  RoutXfifo1[t,p] = \\n      case\\n        { | 2<=p} : if (op1[t]) \
then Rin[p-1,t] else if (op2[t] and Tin[p,t]) then busin[t] else Rin[p,t];\\n \
       { | p=1} : if (op1[t+p-1]) then Rin[p,t] else if (op2[t+p-1] and \
Tin[p,t]) then busin[t+p-1] else Rin[p,t];\\n      esac;\\n  ToutXfifo1[t,p] \
= \\n      case\\n        { | 1<=p<=N-1} : if (op1[t]) then Tin[p-1,t] else \
if (op1[t] and Tin[p,t]) then Tin[p+1,t] else Tin[p,t];\\n        { | p=N} : \
if (op1[t+p-N]) then Tin[p-1,t] else if (op1[t+p-N] and Tin[p,t]) then \
False[] else Tin[p,t];\\n        { | p=0} : if (op1[t+p]) then False[] else \
if (op1[t+p] and Tin[p,t]) then Tin[p+1,t] else Tin[p,t];\\n      esac;\\n  \
Rin[i,t] = \\n      case\\n        { | t=0} : 0[];\\n        { | 1<=t} : \
RoutXfifo1[t-1,i];\\n      esac;\\n  Tin[i,t] = \\n      case\\n        { | \
i<=N-1; t=0} : False[];\\n        { | i=N; t=0} : True[];\\n        { | 1<=t} \
: ToutXfifo1[t-1,i];\\n      esac;\\n  wordout[t] = RoutXfifo1[t,N];\\n  \
full[t] = ToutXfifo1[t,0];\\n  empty[t] = ToutXfifo1[t,N];\\ntel;\"\>"], \
"Print",
 CellChangeTimes->{3.4375650516142797`*^9, 3.480936090942871*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"changeOfBasis", "[", "\"\<Rin.(t,p->p,t)\>\"", "]"}], ";", 
  RowBox[{"ashow", "[", "]"}]}]], "Input",
 CellChangeTimes->{{3.4375649664511538`*^9, 3.437565024120596*^9}}],

Cell[BoxData["\<\"system callfifo :{N | 3<=N}\\n                (busin : {t | \
0<=t} of integer; \\n                 op1 : {t | 0<=t} of boolean; \\n        \
         op2 : {t | 0<=t} of boolean)\\n       returns  (full : {t | 0<=t} of \
boolean; \\n                 empty : {t | 0<=t} of boolean; \\n               \
  wordout : {t | 0<=t} of integer);\\nvar\\n  Rin : {t,p | 0<=t; 1<=p<=N} of \
integer;\\n  Tin : {i,t | 0<=i<=N; 0<=t} of boolean;\\n  RoutXfifo1 : {t,p | \
0<=t; 1<=p<=N} of integer;\\n  ToutXfifo1 : {t,p | 0<=t; 0<=p<=N} of boolean;\
\\nlet\\n  RoutXfifo1[t,p] = \\n      case\\n        { | 2<=p} : if (op1[t]) \
then Rin[t,p-1] else if (op2[t] and Tin[p,t]) then busin[t] else Rin[t,p];\\n \
       { | p=1} : if (op1[t+p-1]) then Rin[t,p] else if (op2[t+p-1] and \
Tin[p,t]) then busin[t+p-1] else Rin[t,p];\\n      esac;\\n  ToutXfifo1[t,p] \
= \\n      case\\n        { | 1<=p<=N-1} : if (op1[t]) then Tin[p-1,t] else \
if (op1[t] and Tin[p,t]) then Tin[p+1,t] else Tin[p,t];\\n        { | p=N} : \
if (op1[t+p-N]) then Tin[p-1,t] else if (op1[t+p-N] and Tin[p,t]) then \
False[] else Tin[p,t];\\n        { | p=0} : if (op1[t+p]) then False[] else \
if (op1[t+p] and Tin[p,t]) then Tin[p+1,t] else Tin[p,t];\\n      esac;\\n  \
Rin[t,p] = \\n      case\\n        { | t=0} : 0[];\\n        { | 1<=t} : \
RoutXfifo1[t-1,p];\\n      esac;\\n  Tin[i,t] = \\n      case\\n        { | \
i<=N-1; t=0} : False[];\\n        { | i=N; t=0} : True[];\\n        { | 1<=t} \
: ToutXfifo1[t-1,i];\\n      esac;\\n  wordout[t] = RoutXfifo1[t,N];\\n  \
full[t] = ToutXfifo1[t,0];\\n  empty[t] = ToutXfifo1[t,N];\\ntel;\"\>"], \
"Print",
 CellChangeTimes->{3.4375650269139023`*^9, 3.480936092929092*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"changeOfBasis", "[", "\"\<Tin.(t,p->p,t)\>\"", "]"}], ";", 
  RowBox[{"ashow", "[", "]"}]}]], "Input",
 CellChangeTimes->{{3.4375649664511538`*^9, 3.4375649934270983`*^9}}],

Cell[BoxData["\<\"system callfifo :{N | 3<=N}\\n                (busin : {t | \
0<=t} of integer; \\n                 op1 : {t | 0<=t} of boolean; \\n        \
         op2 : {t | 0<=t} of boolean)\\n       returns  (full : {t | 0<=t} of \
boolean; \\n                 empty : {t | 0<=t} of boolean; \\n               \
  wordout : {t | 0<=t} of integer);\\nvar\\n  Rin : {t,p | 0<=t; 1<=p<=N} of \
integer;\\n  Tin : {t,p | 0<=t; 0<=p<=N} of boolean;\\n  RoutXfifo1 : {t,p | \
0<=t; 1<=p<=N} of integer;\\n  ToutXfifo1 : {t,p | 0<=t; 0<=p<=N} of boolean;\
\\nlet\\n  RoutXfifo1[t,p] = \\n      case\\n        { | 2<=p} : if (op1[t]) \
then Rin[t,p-1] else if (op2[t] and Tin[t,p]) then busin[t] else Rin[t,p];\\n \
       { | p=1} : if (op1[t+p-1]) then Rin[t,p] else if (op2[t+p-1] and \
Tin[t,p]) then busin[t+p-1] else Rin[t,p];\\n      esac;\\n  ToutXfifo1[t,p] \
= \\n      case\\n        { | 1<=p<=N-1} : if (op1[t]) then Tin[t,p-1] else \
if (op1[t] and Tin[t,p]) then Tin[t,p+1] else Tin[t,p];\\n        { | p=N} : \
if (op1[t+p-N]) then Tin[t,p-1] else if (op1[t+p-N] and Tin[t,p]) then \
False[] else Tin[t,p];\\n        { | p=0} : if (op1[t+p]) then False[] else \
if (op1[t+p] and Tin[t,p]) then Tin[t,p+1] else Tin[t,p];\\n      esac;\\n  \
Rin[t,p] = \\n      case\\n        { | t=0} : 0[];\\n        { | 1<=t} : \
RoutXfifo1[t-1,p];\\n      esac;\\n  Tin[t,p] = \\n      case\\n        { | \
t=0; p<=N-1} : False[];\\n        { | t=0; p=N} : True[];\\n        { | 1<=t} \
: ToutXfifo1[t-1,p];\\n      esac;\\n  wordout[t] = RoutXfifo1[t,N];\\n  \
full[t] = ToutXfifo1[t,0];\\n  empty[t] = ToutXfifo1[t,N];\\ntel;\"\>"], \
"Print",
 CellChangeTimes->{3.437564994478237*^9, 3.480936094476911*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input",
 CellChangeTimes->{{3.437565091442548*^9, 3.4375650929539127`*^9}}],

Cell[BoxData["\<\"system callfifo :{N | 3<=N}\\n                (busin : {t | \
0<=t} of integer; \\n                 op1 : {t | 0<=t} of boolean; \\n        \
         op2 : {t | 0<=t} of boolean)\\n       returns  (full : {t | 0<=t} of \
boolean; \\n                 empty : {t | 0<=t} of boolean; \\n               \
  wordout : {t | 0<=t} of integer);\\nvar\\n  Rin : {t,p | 0<=t; 1<=p<=N} of \
integer;\\n  Tin : {t,p | 0<=t; 0<=p<=N} of boolean;\\n  RoutXfifo1 : {t,p | \
0<=t; 1<=p<=N} of integer;\\n  ToutXfifo1 : {t,p | 0<=t; 0<=p<=N} of boolean;\
\\nlet\\n  RoutXfifo1[t,p] = \\n      case\\n        { | 2<=p} : if (op1[t]) \
then Rin[t,p-1] else if (op2[t] and Tin[t,p]) then busin[t] else Rin[t,p];\\n \
       { | p=1} : if (op1[t+p-1]) then Rin[t,p] else if (op2[t+p-1] and \
Tin[t,p]) then busin[t+p-1] else Rin[t,p];\\n      esac;\\n  ToutXfifo1[t,p] \
= \\n      case\\n        { | 1<=p<=N-1} : if (op1[t]) then Tin[t,p-1] else \
if (op1[t] and Tin[t,p]) then Tin[t,p+1] else Tin[t,p];\\n        { | p=N} : \
if (op1[t+p-N]) then Tin[t,p-1] else if (op1[t+p-N] and Tin[t,p]) then \
False[] else Tin[t,p];\\n        { | p=0} : if (op1[t+p]) then False[] else \
if (op1[t+p] and Tin[t,p]) then Tin[t,p+1] else Tin[t,p];\\n      esac;\\n  \
Rin[t,p] = \\n      case\\n        { | t=0} : 0[];\\n        { | 1<=t} : \
RoutXfifo1[t-1,p];\\n      esac;\\n  Tin[t,p] = \\n      case\\n        { | \
t=0; p<=N-1} : False[];\\n        { | t=0; p=N} : True[];\\n        { | 1<=t} \
: ToutXfifo1[t-1,p];\\n      esac;\\n  wordout[t] = RoutXfifo1[t,N];\\n  \
full[t] = ToutXfifo1[t,0];\\n  empty[t] = ToutXfifo1[t,N];\\ntel;\"\>"], \
"Print",
 CellChangeTimes->{3.437565093494341*^9, 3.480936095448359*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"asave", "[", "\"\<fifoScheduled.alpha\>\"", "]"}], ";"}]], "Input",\

 CellChangeTimes->{{3.437565110589211*^9, 3.437565124661702*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Schedule", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"analyze", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.437564281558063*^9, 3.480936103011671*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"callfifo\"\>"}],
  SequenceForm["Static Analysis of system ", "callfifo"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564281558063*^9, 3.480936103014732*^9}],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print",
 CellChangeTimes->{3.437564281558063*^9, 3.480936103017795*^9}],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print",
 CellChangeTimes->{3.437564281558063*^9, 3.480936103020898*^9}],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print",
 CellChangeTimes->{3.437564281558063*^9, 3.480936103023967*^9}],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print",
 CellChangeTimes->{3.437564281558063*^9, 3.480936103027194*^9}],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print",
 CellChangeTimes->{3.437564281558063*^9, 3.48093610303051*^9}],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print",
 CellChangeTimes->{3.437564281558063*^9, 3.4809361030354013`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"RoutXfifo1\"\>"}],
  SequenceForm["----equation defining ", "RoutXfifo1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564281558063*^9, 3.480936103038916*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1\"\>"}],
  SequenceForm["----equation defining ", "ToutXfifo1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564281558063*^9, 3.4809361036857233`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Rin\"\>"}],
  SequenceForm["----equation defining ", "Rin"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564281558063*^9, 3.4809361046748857`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Tin\"\>"}],
  SequenceForm["----equation defining ", "Tin"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564281558063*^9, 3.4809361048291197`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"wordout\"\>"}],
  SequenceForm["----equation defining ", "wordout"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564281558063*^9, 3.480936105055654*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"full\"\>"}],
  SequenceForm["----equation defining ", "full"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564281558063*^9, 3.4809361051142282`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"empty\"\>"}],
  SequenceForm["----equation defining ", "empty"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437564281558063*^9, 3.4809361051813*^9}],

Cell[BoxData["\<\"--Checking regularity of output equations\"\>"], "Print",
 CellChangeTimes->{3.437564281558063*^9, 3.4809361052454443`*^9}],

Cell[BoxData["\<\"----Outputs equations are regular.\"\>"], "Print",
 CellChangeTimes->{3.437564281558063*^9, 3.480936105314185*^9}],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print",
 CellChangeTimes->{3.437564281558063*^9, 3.4809361053811502`*^9}]
}, Open  ]],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.4375642846968613`*^9, 3.480936105448045*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<fifoInlined.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[BoxData["\<\"[callfifo]\"\>"], "Print",
 CellChangeTimes->{3.437564342594441*^9, 3.4375644721564903`*^9, 
  3.437564758961588*^9, 3.48093610729781*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input",
 CellChangeTimes->{{3.437564553561265*^9, 3.4375645552804737`*^9}}],

Cell[BoxData["\<\"system callfifo :{N | 3<=N}\\n                (busin : {t | \
0<=t} of integer; \\n                 op1 : {t | 0<=t} of boolean; \\n        \
         op2 : {t | 0<=t} of boolean)\\n       returns  (full : {t | 0<=t} of \
boolean; \\n                 empty : {t | 0<=t} of boolean; \\n               \
  wordout : {t | 0<=t} of integer);\\nvar\\n  Rin : {i,t | 1<=i<=N; 0<=t} of \
integer;\\n  Tin : {i,t | 0<=i<=N; 0<=t} of boolean;\\n  RoutXfifo1 : {i,t | \
1<=i<=N; 0<=t} of integer;\\n  ToutXfifo1 : {i,t | 0<=i<=N; 0<=t} of boolean;\
\\nlet\\n  RoutXfifo1[i,t] = \\n      case\\n        { | 2<=i} : if (op1[t]) \
then Rin[i-1,t] else if (op2[t] and Tin[i,t]) then busin[t] else Rin[i,t];\\n \
       { | i=1} : if (op1[i+t-1]) then Rin[i,t] else if (op2[i+t-1] and \
Tin[i,t]) then busin[i+t-1] else Rin[i,t];\\n      esac;\\n  ToutXfifo1[i,t] \
= \\n      case\\n        { | 1<=i<=N-1} : if (op1[t]) then Tin[i-1,t] else \
if (op1[t] and Tin[i,t]) then Tin[i+1,t] else Tin[i,t];\\n        { | i=N} : \
if (op1[i+t-N]) then Tin[i-1,t] else if (op1[i+t-N] and Tin[i,t]) then \
False[] else Tin[i,t];\\n        { | i=0} : if (op1[i+t]) then False[] else \
if (op1[i+t] and Tin[i,t]) then Tin[i+1,t] else Tin[i,t];\\n      esac;\\n  \
Rin[i,t] = \\n      case\\n        { | t=0} : 0[];\\n        { | 1<=t} : \
RoutXfifo1[i,t-1];\\n      esac;\\n  Tin[i,t] = \\n      case\\n        { | \
i<=N-1; t=0} : False[];\\n        { | i=N; t=0} : True[];\\n        { | 1<=t} \
: ToutXfifo1[i,t-1];\\n      esac;\\n  wordout[t] = RoutXfifo1[N,t];\\n  \
full[t] = ToutXfifo1[0,t];\\n  empty[t] = ToutXfifo1[N,t];\\ntel;\"\>"], \
"Print",
 CellChangeTimes->{3.437564555802915*^9, 3.4375647628026333`*^9, 
  3.480936108185253*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"show", "[", 
  RowBox[{"dep", "[", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.437564731617402*^9, 3.437564735393388*^9}}],

Cell[BoxData["\<\"{i,t,N | 2<=i<=N; 0<=t} : RoutXfifo1[i,t,N] -> \
op1[t,N]\\n{i,t,N | 2<=i<=N; 0<=t} : RoutXfifo1[i,t,N] -> \
Rin[i-1,t,N]\\n{i,t,N | 2<=i<=N; 0<=t} : RoutXfifo1[i,t,N] -> \
op2[t,N]\\n{i,t,N | 2<=i<=N; 0<=t} : RoutXfifo1[i,t,N] -> Tin[i,t,N]\\n{i,t,N \
| 2<=i<=N; 0<=t} : RoutXfifo1[i,t,N] -> busin[t,N]\\n{i,t,N | 2<=i<=N; 0<=t} \
: RoutXfifo1[i,t,N] -> Rin[i,t,N]\\n{i,t,N | i=1; 0<=t; 1<=N} : \
RoutXfifo1[i,t,N] -> op1[i+t-1,N]\\n{i,t,N | i=1; 0<=t; 1<=N} : \
RoutXfifo1[i,t,N] -> Rin[i,t,N]\\n{i,t,N | i=1; 0<=t; 1<=N} : \
RoutXfifo1[i,t,N] -> op2[i+t-1,N]\\n{i,t,N | i=1; 0<=t; 1<=N} : \
RoutXfifo1[i,t,N] -> Tin[i,t,N]\\n{i,t,N | i=1; 0<=t; 1<=N} : \
RoutXfifo1[i,t,N] -> busin[i+t-1,N]\\n{i,t,N | i=1; 0<=t; 1<=N} : \
RoutXfifo1[i,t,N] -> Rin[i,t,N]\\n{i,t,N | 1<=i<=N-1; 0<=t} : \
ToutXfifo1[i,t,N] -> op1[t,N]\\n{i,t,N | 1<=i<=N-1; 0<=t} : ToutXfifo1[i,t,N] \
-> Tin[i-1,t,N]\\n{i,t,N | 1<=i<=N-1; 0<=t} : ToutXfifo1[i,t,N] -> \
op1[t,N]\\n{i,t,N | 1<=i<=N-1; 0<=t} : ToutXfifo1[i,t,N] -> \
Tin[i,t,N]\\n{i,t,N | 1<=i<=N-1; 0<=t} : ToutXfifo1[i,t,N] -> \
Tin[i+1,t,N]\\n{i,t,N | 1<=i<=N-1; 0<=t} : ToutXfifo1[i,t,N] -> \
Tin[i,t,N]\\n{i,t,N | i=N; 0<=t; 0<=N} : ToutXfifo1[i,t,N] -> \
op1[i+t-N,N]\\n{i,t,N | i=N; 0<=t; 1<=N} : ToutXfifo1[i,t,N] -> \
Tin[i-1,t,N]\\n{i,t,N | i=N; 0<=t; 0<=N} : ToutXfifo1[i,t,N] -> \
op1[i+t-N,N]\\n{i,t,N | i=N; 0<=t; 0<=N} : ToutXfifo1[i,t,N] -> \
Tin[i,t,N]\\n{i,t,N | i=N; 0<=t; 0<=N} : ToutXfifo1[i,t,N] -> \
Tin[i,t,N]\\n{i,t,N | i=0; 0<=t; 0<=N} : ToutXfifo1[i,t,N] -> \
op1[i+t,N]\\n{i,t,N | i=0; 0<=t; 0<=N} : ToutXfifo1[i,t,N] -> \
op1[i+t,N]\\n{i,t,N | i=0; 0<=t; 0<=N} : ToutXfifo1[i,t,N] -> \
Tin[i,t,N]\\n{i,t,N | i=0; 0<=t; 1<=N} : ToutXfifo1[i,t,N] -> \
Tin[i+1,t,N]\\n{i,t,N | i=0; 0<=t; 0<=N} : ToutXfifo1[i,t,N] -> \
Tin[i,t,N]\\n{i,t,N | 1<=i<=N; 1<=t} : Rin[i,t,N] -> \
RoutXfifo1[i,t-1,N]\\n{i,t,N | 0<=i<=N; 1<=t} : Tin[i,t,N] -> \
ToutXfifo1[i,t-1,N]\\n{t,N | 0<=t; 1<=N} : wordout[t,N] -> \
RoutXfifo1[N,t,N]\\n{t,N | 0<=t; 0<=N} : full[t,N] -> \
ToutXfifo1[0,t,N]\\n{t,N | 0<=t; 0<=N} : empty[t,N] -> \
ToutXfifo1[N,t,N]\"\>"], "Print",
 CellChangeTimes->{{3.4375647368923187`*^9, 3.4375647665004473`*^9}, 
   3.480936110297846*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"scd", "[", 
  RowBox[{
   RowBox[{"optimizationType", "\[Rule]", "Null"}], ",", 
   RowBox[{"durations", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"addConstraints", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<TbusinD1\[Equal]1\>\"", ",", 
      "\"\<TwordoutD2\[Equal]TfullD2\[Equal]TemptyD2==0\>\""}], "}"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.4375643657921953`*^9, 3.437564403923806*^9}, {
  3.437564469828794*^9, 3.437564547719554*^9}, {3.437564579661909*^9, 
  3.437564618381954*^9}, {3.437564653338881*^9, 3.437564659096794*^9}, {
  3.480936116722612*^9, 3.48093612286345*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"TbusinD1", "::", "\<\"shdw\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Symbol \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"TbusinD1\\\"\\), \\\"MT\\\
\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" appears in multiple contexts \
\\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\({\\\"Alpha`Work`\\\", \
\\\"Global`\\\"}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\"; \
definitions in context \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"Alpha`Work`\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" may shadow or be \
shadowed by other definitions.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/shdw\\\", \
ButtonNote -> \\\"Alpha`Work`TbusinD1::shdw\\\"]\\)\"\>"}]], "Message", "MSG",
 
 CellChangeTimes->{{3.48093611239775*^9, 3.480936126084518*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"TwordoutD2", "::", "\<\"shdw\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Symbol \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"TwordoutD2\\\"\\), \\\"MT\
\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" appears in multiple contexts \
\\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\({\\\"Alpha`Work`\\\", \
\\\"Global`\\\"}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\"; \
definitions in context \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"Alpha`Work`\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" may shadow or be \
shadowed by other definitions.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/shdw\\\", \
ButtonNote -> \\\"Alpha`Work`TwordoutD2::shdw\\\"]\\)\"\>"}]], "Message", \
"MSG",
 CellChangeTimes->{{3.48093611239775*^9, 3.4809361261247272`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"TfullD2", "::", "\<\"shdw\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Symbol \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"TfullD2\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" appears in multiple \
contexts \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\({\\\"Alpha`Work`\\\", \
\\\"Global`\\\"}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\"; \
definitions in context \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"Alpha`Work`\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" may shadow or be \
shadowed by other definitions.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/shdw\\\", \
ButtonNote -> \\\"Alpha`Work`TfullD2::shdw\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.48093611239775*^9, 3.480936126196987*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"TemptyD2", "::", "\<\"shdw\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Symbol \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"TemptyD2\\\"\\), \\\"MT\\\
\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" appears in multiple contexts \
\\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\({\\\"Alpha`Work`\\\", \
\\\"Global`\\\"}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\"; \
definitions in context \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"Alpha`Work`\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" may shadow or be \
shadowed by other definitions.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/shdw\\\", \
ButtonNote -> \\\"Alpha`Work`TemptyD2::shdw\\\"]\\)\"\>"}]], "Message", "MSG",
 
 CellChangeTimes->{{3.48093611239775*^9, 3.480936126284326*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"Method Minimize\"\>"], "Print",
 CellChangeTimes->{3.4809361268406887`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "104", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "34", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   "0.19698099999999386`"}],
  SequenceForm[104, " constraints, ", 34, " variables ", 0.19698099999999386`],
  Editable->False]], "Print",
 CellChangeTimes->{3.480936127145233*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"callfifo\"\>", ",", "34", ",", "97", ",", 
   "0.19698099999999386`", ",", "\<\"Vertex\"\>", ",", "\<\"Flat\"\>"}], 
  "}"}]], "Print",
 CellChangeTimes->{3.480936127195517*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"callfifo\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"busin\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"t\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"empty\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"t\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"full\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"t\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"op1\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"t\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"op2\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"t\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Rin\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"t\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"RoutXfifo1\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"t\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Tin\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"t\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"ToutXfifo1\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"t\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"wordout\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"t\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}]}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{"TN", ",", "aparam"}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.480936127269397*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"showSchedResult", "[", "]"}]], "Input"],

Cell[BoxData["\<\"T_busin{t, N} = 1 + t\\nT_empty{t, N} = 1 + t\\nT_full{t, \
N} = 1 + t\\nT_op1{t, N} = 1 + t\\nT_op2{t, N} = 1 + t\\nT_Rin{i, t, N} = 1 + \
t\\nT_RoutXfifo1{i, t, N} = 1 + t\\nT_Tin{i, t, N} = 1 + t\\nT_ToutXfifo1{i, \
t, N} = 1 + t\\nT_wordout{t, N} = 1 + t\"\>"], "Print",
 CellChangeTimes->{
  3.4375643018705387`*^9, 3.437564351721702*^9, {3.437564514146492*^9, 
   3.437564532562501*^9}, 3.437564587600379*^9, 3.437564625541545*^9, 
   3.437564665311953*^9, 3.480936133542727*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"appSched", "[", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.4375646722239122`*^9, 3.437564676523954*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input",
 CellChangeTimes->{{3.437564681719919*^9, 3.437564683294465*^9}}],

Cell[BoxData["\<\"system callfifo :{N | 3<=N}\\n                (busin : {t | \
0<=t} of integer; \\n                 op1 : {t | 0<=t} of boolean; \\n        \
         op2 : {t | 0<=t} of boolean)\\n       returns  (full : {t | 0<=t} of \
boolean; \\n                 empty : {t | 0<=t} of boolean; \\n               \
  wordout : {t | 0<=t} of integer);\\nvar\\n  Rin : {t,p | 1<=t; 1<=p<=N} of \
integer;\\n  Tin : {t,p | 1<=t; 0<=p<=N} of boolean;\\n  RoutXfifo1 : {t,p | \
1<=t; 1<=p<=N} of integer;\\n  ToutXfifo1 : {t,p | 1<=t; 0<=p<=N} of boolean;\
\\nlet\\n  RoutXfifo1[t,p] = \\n      case\\n        { | 2<=p} : if \
(op1[t-1]) then Rin[t,p-1] else if (op2[t-1] and Tin[t,p]) then busin[t-1] \
else Rin[t,p];\\n        { | p=1} : if (op1[t+p-2]) then Rin[t,p] else if \
(op2[t+p-2] and Tin[t,p]) then busin[t+p-2] else Rin[t,p];\\n      esac;\\n  \
ToutXfifo1[t,p] = \\n      case\\n        { | 1<=p<=N-1} : if (op1[t-1]) then \
Tin[t,p-1] else if (op1[t-1] and Tin[t,p]) then Tin[t,p+1] else Tin[t,p];\\n  \
      { | p=N} : if (op1[t+p-N-1]) then Tin[t,p-1] else if (op1[t+p-N-1] and \
Tin[t,p]) then False[] else Tin[t,p];\\n        { | p=0} : if (op1[t+p-1]) \
then False[] else if (op1[t+p-1] and Tin[t,p]) then Tin[t,p+1] else Tin[t,p];\
\\n      esac;\\n  Rin[t,p] = \\n      case\\n        { | t=1} : 0[];\\n      \
  { | 2<=t} : RoutXfifo1[t-1,p];\\n      esac;\\n  Tin[t,p] = \\n      \
case\\n        { | t=1; p<=N-1} : False[];\\n        { | t=1; p=N} : \
True[];\\n        { | 2<=t} : ToutXfifo1[t-1,p];\\n      esac;\\n  wordout[t] \
= RoutXfifo1[t+1,N];\\n  full[t] = ToutXfifo1[t+1,0];\\n  empty[t] = \
ToutXfifo1[t+1,N];\\ntel;\"\>"], "Print",
 CellChangeTimes->{3.43756468379432*^9, 3.4809361388273983`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"asave", "[", "\"\<fifoPlaced.alpha\>\"", "]"}], ";"}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Apply the schedule", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<fifoPlaced.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[BoxData["\<\"[callfifo]\"\>"], "Print",
 CellChangeTimes->{3.437564850631589*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"appSched", "[", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input"],

Cell[BoxData["\<\"system callfifo :{N | 3<=N}\\n                (busin : {t | \
0<=t} of integer; \\n                 op1 : {t | 0<=t} of boolean; \\n        \
         op2 : {t | 0<=t} of boolean)\\n       returns  (full : {t | 0<=t} of \
boolean; \\n                 empty : {t | 0<=t} of boolean; \\n               \
  wordout : {t | 0<=t} of integer);\\nvar\\n  Rin : {i,t | 1<=i<=N; 0<=t} of \
integer;\\n  Tin : {i,t | 0<=i<=N; 0<=t} of boolean;\\n  RoutXfifo1 : {i,t | \
1<=i<=N; 0<=t} of integer;\\n  ToutXfifo1 : {i,t | 0<=i<=N; 0<=t} of boolean;\
\\nlet\\n  RoutXfifo1[i,t] = \\n      case\\n        { | 2<=i} : if (op1[t]) \
then Rin[i-1,t] else if (op2[t] and Tin[i,t]) then busin[t] else Rin[i,t];\\n \
       { | i=1} : if (op1[i+t-1]) then Rin[i,t] else if (op2[i+t-1] and \
Tin[i,t]) then busin[i+t-1] else Rin[i,t];\\n      esac;\\n  ToutXfifo1[i,t] \
= \\n      case\\n        { | 1<=i<=N-1} : if (op1[t]) then Tin[i-1,t] else \
if (op1[t] and Tin[i,t]) then Tin[i+1,t] else Tin[i,t];\\n        { | i=N} : \
if (op1[i+t-N]) then Tin[i-1,t] else if (op1[i+t-N] and Tin[i,t]) then \
False[] else Tin[i,t];\\n        { | i=0} : if (op1[i+t]) then False[] else \
if (op1[i+t] and Tin[i,t]) then Tin[i+1,t] else Tin[i,t];\\n      esac;\\n  \
Rin[i,t] = \\n      case\\n        { | t=0} : 0[];\\n        { | 1<=t} : \
RoutXfifo1[i,t-1];\\n      esac;\\n  Tin[i,t] = \\n      case\\n        { | \
i<=N-1; t=0} : False[];\\n        { | i=N; t=0} : True[];\\n        { | 1<=t} \
: ToutXfifo1[i,t-1];\\n      esac;\\n  wordout[t] = RoutXfifo1[N,t];\\n  \
full[t] = ToutXfifo1[0,t];\\n  empty[t] = ToutXfifo1[N,t];\\ntel;\"\>"], \
"Print",
 CellChangeTimes->{3.437564854247093*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"analyze", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\" \"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"callfifo\"\>"}],
  SequenceForm["Static Analysis of system ", "callfifo"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"RoutXfifo1\"\>"}],
  SequenceForm["----equation defining ", "RoutXfifo1"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1\"\>"}],
  SequenceForm["----equation defining ", "ToutXfifo1"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Rin\"\>"}],
  SequenceForm["----equation defining ", "Rin"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Tin\"\>"}],
  SequenceForm["----equation defining ", "Tin"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"wordout\"\>"}],
  SequenceForm["----equation defining ", "wordout"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"full\"\>"}],
  SequenceForm["----equation defining ", "full"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"empty\"\>"}],
  SequenceForm["----equation defining ", "empty"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"--Checking regularity of output equations\"\>"], "Print"],

Cell[BoxData["\<\"----Outputs equations are regular.\"\>"], "Print"],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print"]
}, Open  ]],

Cell[BoxData["True"], "Output"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"simplifySystem", "[", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input"],

Cell[BoxData["\<\"system callfifo :{N | 3<=N}\\n                (busin : {t | \
0<=t} of integer; \\n                 op1 : {t | 0<=t} of boolean; \\n        \
         op2 : {t | 0<=t} of boolean)\\n       returns  (full : {t | 0<=t} of \
boolean; \\n                 empty : {t | 0<=t} of boolean; \\n               \
  wordout : {t | 0<=t} of integer);\\nvar\\n  Rin : {t,p | N+1<=t; 1<=p<=N} \
of integer;\\n  Tin : {t,p | N+1<=t; 0<=p<=N} of boolean;\\n  RoutXfifo1 : \
{t,p | N+1<=t; 1<=p<=N} of integer;\\n  ToutXfifo1 : {t,p | N+1<=t; 0<=p<=N} \
of boolean;\\nlet\\n  RoutXfifo1[t,p] = \\n      case\\n        { | 2<=p} : \
if (op1[t-N-1]) then Rin[t,p-1] else if (op2[t-N-1] and Tin[t,p]) then \
busin[t-N-1] else Rin[t,p];\\n        { | p=1} : if (op1[t-N-1]) then \
Rin[t,p] else if (op2[t-N-1] and Tin[t,p]) then busin[t-N-1] else \
Rin[t,p];\\n      esac;\\n  ToutXfifo1[t,p] = \\n      case\\n        { | \
1<=p<=N-1} : if (op1[t-N-1]) then Tin[t,p-1] else if (op1[t-N-1] and \
Tin[t,p]) then Tin[t,p+1] else Tin[t,p];\\n        { | p=N} : if (op1[t-N-1]) \
then Tin[t,p-1] else if (op1[t-N-1] and Tin[t,p]) then False[] else Tin[t,p];\
\\n        { | p=0} : if (op1[t-N-1]) then False[] else if (op1[t-N-1] and \
Tin[t,p]) then Tin[t,p+1] else Tin[t,p];\\n      esac;\\n  Rin[t,p] = \\n     \
 case\\n        { | t=N+1} : 0[];\\n        { | N+2<=t} : \
RoutXfifo1[t-1,p];\\n      esac;\\n  Tin[t,p] = \\n      case\\n        { | \
t=N+1; p<=N-1} : False[];\\n        { | t=N+1; p=N} : True[];\\n        { | \
N+2<=t} : ToutXfifo1[t-1,p];\\n      esac;\\n  wordout[t] = \
RoutXfifo1[t+N+1,N];\\n  full[t] = ToutXfifo1[t+N+1,0];\\n  empty[t] = \
ToutXfifo1[t+N+1,N];\\ntel;\"\>"], "Print"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"asave", "[", "\"\<fifoScheduled.alpha\>\"", "]"}], ";"}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Pipe some variables (may skip it)", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<fifoScheduled.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"[callfifo]\"\>"], "Print"],

Cell[BoxData["\<\" Library Loaded\"\>"], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"pipeVars", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Executing : \"\>", 
   "\[InvisibleSpace]", "\<\"pipeall[ {}, {6, 1, 2, 1, 1, 2, 1}, \
affine[var[\\\"pipeCop15\\\"], matrix[4, 4, {\\\"t\\\", \\\"p\\\", \
\\\"N\\\"}, {{1, 0, 0, 0}, {0, 1, 0, 1}, {0, 0, 1, 0}, {0, 0, 0, \
1}}]],domain[3, {\\\"t\\\", \\\"p\\\", \\\"N\\\"}, {pol[2, 4, 0, 2, {{1, 0, \
1, 0, 0}, {1, 0, 0, 0, 1}}, {{0, 1, 0, 0, 0}, {0, 0, 0, 1, 0}, {1, 0, 1, 0, \
0}, {1, 0, 0, 0, 1}}]}]]\"\>"}],
  SequenceForm[
  "Executing : ", 
   "pipeall[ {}, {6, 1, 2, 1, 1, 2, 1}, affine[var[\"pipeCop15\"], matrix[4, \
4, {\"t\", \"p\", \"N\"}, {{1, 0, 0, 0}, {0, 1, 0, 1}, {0, 0, 1, 0}, {0, 0, \
0, 1}}]],domain[3, {\"t\", \"p\", \"N\"}, {pol[2, 4, 0, 2, {{1, 0, 1, 0, 0}, \
{1, 0, 0, 0, 1}}, {{0, 1, 0, 0, 0}, {0, 0, 0, 1, 0}, {1, 0, 1, 0, 0}, {1, 0, \
0, 0, 1}}]}]]"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Executing : \"\>", 
   "\[InvisibleSpace]", "\<\"pipeall[ {}, {6, 2, 2, 1, 1, 2, 3, 2}, \
affine[var[\\\"pipeCbusin5\\\"], matrix[4, 4, {\\\"t\\\", \\\"p\\\", \
\\\"N\\\"}, {{1, 0, 0, 0}, {0, 1, 0, 1}, {0, 0, 1, 0}, {0, 0, 0, \
1}}]],domain[3, {\\\"t\\\", \\\"p\\\", \\\"N\\\"}, {pol[2, 4, 0, 2, {{1, 0, \
1, 0, 0}, {1, 0, 0, 0, 1}}, {{0, 1, 0, 0, 0}, {0, 0, 0, 1, 0}, {1, 0, 1, 0, \
0}, {1, 0, 0, 0, 1}}]}]]\"\>"}],
  SequenceForm[
  "Executing : ", 
   "pipeall[ {}, {6, 2, 2, 1, 1, 2, 3, 2}, affine[var[\"pipeCbusin5\"], \
matrix[4, 4, {\"t\", \"p\", \"N\"}, {{1, 0, 0, 0}, {0, 1, 0, 1}, {0, 0, 1, \
0}, {0, 0, 0, 1}}]],domain[3, {\"t\", \"p\", \"N\"}, {pol[2, 4, 0, 2, {{1, 0, \
1, 0, 0}, {1, 0, 0, 0, 1}}, {{0, 1, 0, 0, 0}, {0, 0, 0, 1, 0}, {1, 0, 1, 0, \
0}, {1, 0, 0, 0, 1}}]}]]"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Executing : \"\>", 
   "\[InvisibleSpace]", "\<\"pipeall[ {}, {6, 3, 2, 1, 1, 2, 3, 1, 2}, \
affine[var[\\\"pipeCop25\\\"], matrix[4, 4, {\\\"t\\\", \\\"p\\\", \
\\\"N\\\"}, {{1, 0, 0, 0}, {0, 1, 0, 1}, {0, 0, 1, 0}, {0, 0, 0, \
1}}]],domain[3, {\\\"t\\\", \\\"p\\\", \\\"N\\\"}, {pol[2, 4, 0, 2, {{1, 0, \
1, 0, 0}, {1, 0, 0, 0, 1}}, {{0, 1, 0, 0, 0}, {0, 0, 0, 1, 0}, {1, 0, 1, 0, \
0}, {1, 0, 0, 0, 1}}]}]]\"\>"}],
  SequenceForm[
  "Executing : ", 
   "pipeall[ {}, {6, 3, 2, 1, 1, 2, 3, 1, 2}, affine[var[\"pipeCop25\"], \
matrix[4, 4, {\"t\", \"p\", \"N\"}, {{1, 0, 0, 0}, {0, 1, 0, 1}, {0, 0, 1, \
0}, {0, 0, 0, 1}}]],domain[3, {\"t\", \"p\", \"N\"}, {pol[2, 4, 0, 2, {{1, 0, \
1, 0, 0}, {1, 0, 0, 0, 1}}, {{0, 1, 0, 0, 0}, {0, 0, 0, 1, 0}, {1, 0, 1, 0, \
0}, {1, 0, 0, 0, 1}}]}]]"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"Nothing to pipeline\"\>"], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input"],

Cell[BoxData["\<\"system callfifo :{N | 3<=N}\\n                (busin : {t | \
0<=t} of integer; \\n                 op1 : {t | 0<=t} of boolean; \\n        \
         op2 : {t | 0<=t} of boolean)\\n       returns  (full : {t | 0<=t} of \
boolean; \\n                 empty : {t | 0<=t} of boolean; \\n               \
  wordout : {t | 0<=t} of integer);\\nvar\\n  pipeCop25 : {t,p | N+1<=t; \
0<=p<=N; 3<=N} of boolean;\\n  pipeCbusin5 : {t,p | N+1<=t; 0<=p<=N; 3<=N} of \
integer;\\n  pipeCop15 : {t,p | N+1<=t; 0<=p<=N; 3<=N} of boolean;\\n  Rin : \
{t,p | N+1<=t; 1<=p<=N} of integer;\\n  Tin : {t,p | N+1<=t; 0<=p<=N} of \
boolean;\\n  RoutXfifo1 : {t,p | N+1<=t; 1<=p<=N} of integer;\\n  ToutXfifo1 \
: {t,p | N+1<=t; 0<=p<=N} of boolean;\\nlet\\n  pipeCop25[t,p] = \\n      \
case\\n        { | N+1<=t; p=0; 3<=N} : op2[t-N-1];\\n        { | N+1<=t; \
1<=p<=N; 3<=N} : pipeCop25[t,p-1];\\n      esac;\\n  pipeCbusin5[t,p] = \\n   \
   case\\n        { | N+1<=t; p=0; 3<=N} : busin[t-N-1];\\n        { | \
N+1<=t; 1<=p<=N; 3<=N} : pipeCbusin5[t,p-1];\\n      esac;\\n  pipeCop15[t,p] \
= \\n      case\\n        { | N+1<=t; p=0; 3<=N} : op1[t-N-1];\\n        { | \
N+1<=t; 1<=p<=N; 3<=N} : pipeCop15[t,p-1];\\n      esac;\\n  RoutXfifo1[t,p] \
= \\n      case\\n        { | 2<=p} : if (pipeCop15) then Rin[t,p-1] else if \
(pipeCop25 and Tin[t,p]) then pipeCbusin5 else Rin[t,p];\\n        { | p=1} : \
if (pipeCop15) then Rin[t,p] else if (pipeCop25 and Tin[t,p]) then \
pipeCbusin5 else Rin[t,p];\\n      esac;\\n  ToutXfifo1[t,p] = \\n      \
case\\n        { | 1<=p<=N-1} : if (pipeCop15) then Tin[t,p-1] else if \
(pipeCop15 and Tin[t,p]) then Tin[t,p+1] else Tin[t,p];\\n        { | p=N} : \
if (pipeCop15) then Tin[t,p-1] else if (pipeCop15 and Tin[t,p]) then False[] \
else Tin[t,p];\\n        { | p=0} : if (pipeCop15) then False[] else if \
(pipeCop15 and Tin[t,p]) then Tin[t,p+1] else Tin[t,p];\\n      esac;\\n  \
Rin[t,p] = \\n      case\\n        { | t=N+1} : 0[];\\n        { | N+2<=t} : \
RoutXfifo1[t-1,p];\\n      esac;\\n  Tin[t,p] = \\n      case\\n        { | \
t=N+1; p<=N-1} : False[];\\n        { | t=N+1; p=N} : True[];\\n        { | \
N+2<=t} : ToutXfifo1[t-1,p];\\n      esac;\\n  wordout[t] = \
RoutXfifo1[t+N+1,N];\\n  full[t] = ToutXfifo1[t+N+1,0];\\n  empty[t] = \
ToutXfifo1[t+N+1,N];\\ntel;\"\>"], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"asave", "[", "\"\<fifoPiped.alpha\>\"", "]"}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Translate into Alpha0", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<fifoPiped.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"toAlpha0v2", "[", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Time index: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}], "\[InvisibleSpace]", "\<\"  space indices: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "2", "}"}]}],
  SequenceForm["Time index: ", {1}, "  space indices: ", {2}],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565136385694*^9}],

Cell[BoxData["\<\"--- Space time decomposition of the equations (Step \
1)\"\>"], "Print",
 CellChangeTimes->{3.4375651364143333`*^9}],

Cell[BoxData["\<\"--- Generating multiplexors (Step 2)\"\>"], "Print",
 CellChangeTimes->{3.437565142556027*^9}],

Cell[BoxData["\<\"Warning, tried to convexize system\"\>"], "Print",
 CellChangeTimes->{3.437565146262664*^9}],

Cell[BoxData["\<\"--- Pipelining control signals (Step 3)\"\>"], "Print",
 CellChangeTimes->{3.437565146960993*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Pipelining control for: \"\>", 
   "\[InvisibleSpace]", "\<\"RinXctl1\"\>"}],
  SequenceForm["  Pipelining control for: ", "RinXctl1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565147111573*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Pipelining control for: \"\>", 
   "\[InvisibleSpace]", "\<\"TinXctl1\"\>"}],
  SequenceForm["  Pipelining control for: ", "TinXctl1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565147822373*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Pipelining control for: \"\>", 
   "\[InvisibleSpace]", "\<\"TinXctl2\"\>"}],
  SequenceForm["  Pipelining control for: ", "TinXctl2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565148542522*^9}],

Cell[BoxData["\<\"--- Separating space time in dependencies (Step 4)\"\>"], \
"Print",
 CellChangeTimes->{3.4375651506169243`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  In equation of \"\>", "\[InvisibleSpace]", "\<\"Rin\"\>", 
   "\[InvisibleSpace]", "\<\", adding a local variable: \"\>", 
   "\[InvisibleSpace]", "\<\"RoutXfifo1Reg1\"\>"}],
  SequenceForm[
  "  In equation of ", "Rin", ", adding a local variable: ", "RoutXfifo1Reg1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375651506645117`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  In equation of \"\>", 
   "\[InvisibleSpace]", "\<\"RoutXfifo1\"\>", 
   "\[InvisibleSpace]", "\<\", adding a local variable: \"\>", 
   "\[InvisibleSpace]", "\<\"RinReg2\"\>"}],
  SequenceForm[
  "  In equation of ", "RoutXfifo1", ", adding a local variable: ", "RinReg2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565150854842*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  In equation of \"\>", "\[InvisibleSpace]", "\<\"Tin\"\>", 
   "\[InvisibleSpace]", "\<\", adding a local variable: \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1Reg3\"\>"}],
  SequenceForm[
  "  In equation of ", "Tin", ", adding a local variable: ", "ToutXfifo1Reg3"],
  Editable->False]], "Print",
 CellChangeTimes->{3.43756515105234*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  In equation of \"\>", "\[InvisibleSpace]", "\<\"Tin\"\>", 
   "\[InvisibleSpace]", "\<\", adding a local variable: \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1Reg4\"\>"}],
  SequenceForm[
  "  In equation of ", "Tin", ", adding a local variable: ", "ToutXfifo1Reg4"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565151279724*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  In equation of \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1\"\>", 
   "\[InvisibleSpace]", "\<\", adding a local variable: \"\>", 
   "\[InvisibleSpace]", "\<\"TinReg5\"\>"}],
  SequenceForm[
  "  In equation of ", "ToutXfifo1", ", adding a local variable: ", "TinReg5"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565151498715*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  In equation of \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1\"\>", 
   "\[InvisibleSpace]", "\<\", adding a local variable: \"\>", 
   "\[InvisibleSpace]", "\<\"TinReg6\"\>"}],
  SequenceForm[
  "  In equation of ", "ToutXfifo1", ", adding a local variable: ", "TinReg6"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565151693727*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  In equation of \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1\"\>", 
   "\[InvisibleSpace]", "\<\", adding a local variable: \"\>", 
   "\[InvisibleSpace]", "\<\"TinReg7\"\>"}],
  SequenceForm[
  "  In equation of ", "ToutXfifo1", ", adding a local variable: ", "TinReg7"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565151891614*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  In equation of \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1\"\>", 
   "\[InvisibleSpace]", "\<\", adding a local variable: \"\>", 
   "\[InvisibleSpace]", "\<\"TinReg8\"\>"}],
  SequenceForm[
  "  In equation of ", "ToutXfifo1", ", adding a local variable: ", "TinReg8"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565152096181*^9}],

Cell[BoxData["\<\" Decomposing the space/time dependencies\"\>"], "Print",
 CellChangeTimes->{3.437565152314108*^9}],

Cell[BoxData["\<\"--- Generating simple equations (step 5)\"\>"], "Print",
 CellChangeTimes->{3.437565152358198*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"TSep1\"\>", "\[InvisibleSpace]", "\<\" generated ...\"\>"}],
  SequenceForm["TSep1", " generated ..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565152426523*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"TSep2\"\>", "\[InvisibleSpace]", "\<\" generated ...\"\>"}],
  SequenceForm["TSep2", " generated ..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565152494198*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"TSep3\"\>", "\[InvisibleSpace]", "\<\" generated ...\"\>"}],
  SequenceForm["TSep3", " generated ..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565152560156*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"TSep4\"\>", "\[InvisibleSpace]", "\<\" generated ...\"\>"}],
  SequenceForm["TSep4", " generated ..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565152626524*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"TSep5\"\>", "\[InvisibleSpace]", "\<\" generated ...\"\>"}],
  SequenceForm["TSep5", " generated ..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565152693273*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"TSep6\"\>", "\[InvisibleSpace]", "\<\" generated ...\"\>"}],
  SequenceForm["TSep6", " generated ..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565152762992*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"TSep7\"\>", "\[InvisibleSpace]", "\<\" generated ...\"\>"}],
  SequenceForm["TSep7", " generated ..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375651528601017`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"TSep8\"\>", "\[InvisibleSpace]", "\<\" generated ...\"\>"}],
  SequenceForm["TSep8", " generated ..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375651529443197`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"TSep9\"\>", "\[InvisibleSpace]", "\<\" generated ...\"\>"}],
  SequenceForm["TSep9", " generated ..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375651530089817`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"TSep10\"\>", "\[InvisibleSpace]", "\<\" generated ...\"\>"}],
  SequenceForm["TSep10", " generated ..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565153078335*^9}],

Cell[BoxData["\<\"--- Generating mirror equations (step 6)\"\>"], "Print",
 CellChangeTimes->{3.437565153142332*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Adding mirror equation for input \"\>", 
   "\[InvisibleSpace]", "\<\"busin\"\>"}],
  SequenceForm["  Adding mirror equation for input ", "busin"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375651532116327`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Adding mirror equation for input \"\>", 
   "\[InvisibleSpace]", "\<\"busin\"\>"}],
  SequenceForm["  Adding mirror equation for input ", "busin"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565153277453*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Adding mirror equation for input \"\>", 
   "\[InvisibleSpace]", "\<\"op1\"\>"}],
  SequenceForm["  Adding mirror equation for input ", "op1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565153342271*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Adding mirror equation for input \"\>", 
   "\[InvisibleSpace]", "\<\"op1\"\>"}],
  SequenceForm["  Adding mirror equation for input ", "op1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565153443811*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Adding mirror equation for input \"\>", 
   "\[InvisibleSpace]", "\<\"op1\"\>"}],
  SequenceForm["  Adding mirror equation for input ", "op1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565153507495*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Adding mirror equation for input \"\>", 
   "\[InvisibleSpace]", "\<\"op1\"\>"}],
  SequenceForm["  Adding mirror equation for input ", "op1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565153712674*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Adding mirror equation for input \"\>", 
   "\[InvisibleSpace]", "\<\"op1\"\>"}],
  SequenceForm["  Adding mirror equation for input ", "op1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565153999385*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Adding mirror equation for input \"\>", 
   "\[InvisibleSpace]", "\<\"op1\"\>"}],
  SequenceForm["  Adding mirror equation for input ", "op1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375651542899933`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Adding mirror equation for input \"\>", 
   "\[InvisibleSpace]", "\<\"op1\"\>"}],
  SequenceForm["  Adding mirror equation for input ", "op1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.43756515447752*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Adding mirror equation for input \"\>", 
   "\[InvisibleSpace]", "\<\"op1\"\>"}],
  SequenceForm["  Adding mirror equation for input ", "op1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565154670792*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Adding mirror equation for input \"\>", 
   "\[InvisibleSpace]", "\<\"op2\"\>"}],
  SequenceForm["  Adding mirror equation for input ", "op2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565154862836*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Adding mirror equation for input \"\>", 
   "\[InvisibleSpace]", "\<\"op2\"\>"}],
  SequenceForm["  Adding mirror equation for input ", "op2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.43756515513942*^9}],

Cell[BoxData["\<\"--- The End...\"\>"], "Print",
 CellChangeTimes->{3.4375651554297733`*^9}]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"simplifySystem", "[", 
   RowBox[{"alphaFormat", "\[Rule]", "Alpha0"}], "]"}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"asave", "[", "\"\<fifo0.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input",
 CellChangeTimes->{{3.4375651679386883`*^9, 3.437565169624764*^9}}],

Cell[BoxData["\<\"system callfifo :{N | 3<=N}\\n                (busin : {t | \
0<=t} of integer; \\n                 op1 : {t | 0<=t} of boolean; \\n        \
         op2 : {t | 0<=t} of boolean)\\n       returns  (full : {t | 0<=t} of \
boolean; \\n                 empty : {t | 0<=t} of boolean; \\n               \
  wordout : {t | 0<=t} of integer);\\nvar\\n  op2XMirr2 : {t,p | 0<=t; p=1} \
of boolean;\\n  op2XMirr1 : {t,p | 0<=t; 2<=p<=N} of boolean;\\n  op1XMirr8 : \
{t,p | 0<=t; p=0} of boolean;\\n  op1XMirr7 : {t,p | 0<=t; p=N} of \
boolean;\\n  op1XMirr6 : {t,p | 0<=t; 1<=p<=N-1} of boolean;\\n  op1XMirr5 : \
{t,p | 0<=t; p=0} of boolean;\\n  op1XMirr4 : {t,p | 0<=t; p=N} of \
boolean;\\n  op1XMirr3 : {t,p | 0<=t; 1<=p<=N-1} of boolean;\\n  op1XMirr2 : \
{t,p | 0<=t; p=1} of boolean;\\n  op1XMirr1 : {t,p | 0<=t; 2<=p<=N} of \
boolean;\\n  businXMirr2 : {t,p | 0<=t; p=1} of integer;\\n  businXMirr1 : \
{t,p | 0<=t; 2<=p<=N} of integer;\\n  TSep10 : {t,p | 0<=t; p=0} of \
boolean;\\n  TSep9 : {t,p | 0<=t; p=0} of boolean;\\n  TSep8 : {t,p | 0<=t; \
p=N} of boolean;\\n  TSep7 : {t,p | 0<=t; p=N} of boolean;\\n  TSep6 : {t,p | \
0<=t; 1<=p<=N-1} of boolean;\\n  TSep5 : {t,p | 0<=t; 1<=p<=N-1} of \
boolean;\\n  TSep4 : {t,p | 0<=t; p=1} of boolean;\\n  TSep3 : {t,p | 0<=t; \
p=1} of integer;\\n  TSep2 : {t,p | 0<=t; 2<=p<=N} of boolean;\\n  TSep1 : \
{t,p | 0<=t; 2<=p<=N} of integer;\\n  TinReg8 : {t,p | 0<=t; p=0} of boolean;\
\\n  TinReg7 : {t,p | 0<=t; p=N} of boolean;\\n  TinReg6 : {t,p | 0<=t; \
1<=p<=N-1} of boolean;\\n  TinReg5 : {t,p | 0<=t; 1<=p<=N-1} of boolean;\\n  \
ToutXfifo1Reg4 : {t,p | 1<=t; 0<=p<=N-1} of boolean;\\n  ToutXfifo1Reg3 : \
{t,p | 1<=t; p=N} of boolean;\\n  RinReg2 : {t,p | 0<=t; 2<=p<=N} of integer;\
\\n  RoutXfifo1Reg1 : {t,p | 1<=t; 1<=p<=N} of integer;\\n  TinXctl2XIn : \
{t,p | 0<=t; 0<=p<=N-1} of boolean;\\n  TinXctl1XIn : {t,p | 0<=t; p=N} of \
boolean;\\n  RinXctl1XIn : {t,p | 0<=t; 1<=p<=N} of boolean;\\n  Rin : {t,p | \
0<=t; 1<=p<=N} of integer;\\n  Tin : {t,p | 0<=t; 0<=p<=N} of boolean;\\n  \
RoutXfifo1 : {t,p | 0<=t; 1<=p<=N} of integer;\\n  ToutXfifo1 : {t,p | 0<=t; \
0<=p<=N} of boolean;\\n  RinXctl1 : {t | 0<=t} of boolean;\\n  TinXctl1 : {t \
| 0<=t} of boolean;\\n  TinXctl2 : {t | 0<=t} of boolean;\\nlet\\n  \
op2XMirr2[t,p] = op2[t];\\n  op2XMirr1[t,p] = op2[t];\\n  op1XMirr8[t,p] = \
op1[t];\\n  op1XMirr7[t,p] = op1[t];\\n  op1XMirr6[t,p] = op1[t];\\n  \
op1XMirr5[t,p] = op1[t];\\n  op1XMirr4[t,p] = op1[t];\\n  op1XMirr3[t,p] = \
op1[t];\\n  op1XMirr2[t,p] = op1[t];\\n  op1XMirr1[t,p] = op1[t];\\n  \
businXMirr2[t,p] = busin[t];\\n  businXMirr1[t,p] = busin[t];\\n  \
TinReg8[t,p] = Tin[t,p+1];\\n  TinReg7[t,p] = Tin[t,p-1];\\n  TinReg6[t,p] = \
Tin[t,p+1];\\n  TinReg5[t,p] = Tin[t,p-1];\\n  ToutXfifo1Reg4[t,p] = \
ToutXfifo1[t-1,p];\\n  ToutXfifo1Reg3[t,p] = ToutXfifo1[t-1,p];\\n  \
RinReg2[t,p] = Rin[t,p-1];\\n  RoutXfifo1Reg1[t,p] = RoutXfifo1[t-1,p];\\n  \
TinXctl2XIn[t,p] = TinXctl2[t];\\n  TinXctl1XIn[t,p] = TinXctl1[t];\\n  \
RinXctl1XIn[t,p] = RinXctl1[t];\\n  TSep2[t,p] = op2XMirr1 and Tin[t,p];\\n  \
TSep1[t,p] = if (TSep2) then businXMirr1 else Rin[t,p];\\n  TSep4[t,p] = \
op2XMirr2 and Tin[t,p];\\n  TSep3[t,p] = if (TSep4) then businXMirr2 else \
Rin[t,p];\\n  RoutXfifo1[t,p] = \\n      case\\n        { | 2<=p} : if \
(op1XMirr1) then RinReg2 else TSep1;\\n        { | p=1} : if (op1XMirr2) then \
Rin[t,p] else TSep3;\\n      esac;\\n  TSep6[t,p] = op1XMirr3 and \
Tin[t,p];\\n  TSep5[t,p] = if (TSep6) then TinReg6 else Tin[t,p];\\n  \
TSep8[t,p] = op1XMirr4 and Tin[t,p];\\n  TSep7[t,p] = if (TSep8) then False[] \
else Tin[t,p];\\n  TSep10[t,p] = op1XMirr5 and Tin[t,p];\\n  TSep9[t,p] = if \
(TSep10) then TinReg8 else Tin[t,p];\\n  ToutXfifo1[t,p] = \\n      case\\n   \
     { | 1<=p<=N-1} : if (op1XMirr6) then TinReg5 else TSep5;\\n        { | \
p=N} : if (op1XMirr7) then TinReg7 else TSep7;\\n        { | p=0} : if \
(op1XMirr8) then False[] else TSep9;\\n      esac;\\n  RinXctl1[t] = \\n      \
case\\n        case\\n          { | t=0} : True[];\\n          { | 1<=t} : \
False[];\\n        esac;\\n      esac;\\n  Rin[t,p] = \\n      case\\n        \
if (RinXctl1XIn) then \\n            case\\n              { | t=0} : 0[];\\n  \
            { | 1<=t} : 0[];\\n            esac else \\n        case\\n       \
   { | t=0} : 0[];\\n          { | 1<=t} : RoutXfifo1Reg1;\\n        esac;\\n \
     esac;\\n  TinXctl1[t] = \\n      case\\n        case\\n          { | \
t=0} : True[];\\n          { | 1<=t} : False[];\\n        esac;\\n      esac;\
\\n  TinXctl2[t] = \\n      case\\n        case\\n          { | t=0} : \
True[];\\n          { | 1<=t} : False[];\\n        esac;\\n      esac;\\n  \
Tin[t,p] = \\n      case\\n        { | p=N} : if (TinXctl1XIn) then \\n       \
        case\\n                 { | t=0} : True[];\\n                 { | \
1<=t} : False[];\\n               esac else \\n           case\\n             \
{ | t=0} : False[];\\n             { | 1<=t} : ToutXfifo1Reg3;\\n           \
esac;\\n        { | p<=N-1} : if (TinXctl2XIn) then \\n               case\\n \
                { | t=0} : False[];\\n                 { | 1<=t} : \
False[];\\n               esac else \\n           case\\n             { | \
t=0} : False[];\\n             { | 1<=t} : ToutXfifo1Reg4;\\n           esac;\
\\n      esac;\\n  wordout[t] = RoutXfifo1[t,N];\\n  full[t] = \
ToutXfifo1[t,0];\\n  empty[t] = ToutXfifo1[t,N];\\ntel;\"\>"], "Print",
 CellChangeTimes->{3.437565170149788*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Translate to AlpHard", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<fifo0.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"[callfifo]\"\>"], "Print"],

Cell[BoxData["\<\" Library Loaded\"\>"], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input"],

Cell[BoxData["\<\"system callfifo :{N | 3<=N}\\n                (busin : {t | \
0<=t} of integer; \\n                 op1 : {t | 0<=t} of boolean; \\n        \
         op2 : {t | 0<=t} of boolean)\\n       returns  (full : {t | 0<=t} of \
boolean; \\n                 empty : {t | 0<=t} of boolean; \\n               \
  wordout : {t | 0<=t} of integer);\\nvar\\n  op2XMirr1 : {t,p | N+1<=t; p=0} \
of boolean;\\n  op1XMirr1 : {t,p | N+1<=t; p=0} of boolean;\\n  businXMirr1 : \
{t,p | N+1<=t; p=0} of integer;\\n  TSep10 : {t,p | N+1<=t; p=0} of \
boolean;\\n  TSep9 : {t,p | N+1<=t; p=0} of boolean;\\n  TSep8 : {t,p | \
N+1<=t; p=N} of boolean;\\n  TSep7 : {t,p | N+1<=t; p=N} of boolean;\\n  \
TSep6 : {t,p | N+1<=t; 1<=p<=N-1} of boolean;\\n  TSep5 : {t,p | N+1<=t; \
1<=p<=N-1} of boolean;\\n  TSep4 : {t,p | N+1<=t; p=1} of boolean;\\n  TSep3 \
: {t,p | N+1<=t; p=1} of integer;\\n  TSep2 : {t,p | N+1<=t; 2<=p<=N} of \
boolean;\\n  TSep1 : {t,p | N+1<=t; 2<=p<=N} of integer;\\n  TinReg11 : {t,p \
| N+1<=t; p=0} of boolean;\\n  TinReg10 : {t,p | N+1<=t; p=N} of boolean;\\n  \
TinReg9 : {t,p | N+1<=t; 1<=p<=N-1} of boolean;\\n  TinReg8 : {t,p | N+1<=t; \
1<=p<=N-1} of boolean;\\n  ToutXfifo1Reg7 : {t,p | N+2<=t; p=N} of \
boolean;\\n  ToutXfifo1Reg6 : {t,p | N+2<=t; 0<=p<=N-1} of boolean;\\n  \
RinReg5 : {t,p | N+1<=t; 2<=p<=N} of integer;\\n  RoutXfifo1Reg4 : {t,p | \
N+2<=t; 1<=p<=N} of integer;\\n  pipeCop25Reg3 : {t,p | N+1<=t; 1<=p<=N} of \
boolean;\\n  pipeCop15Reg2 : {t,p | N+1<=t; 1<=p<=N} of boolean;\\n  \
pipeCbusin5Reg1 : {t,p | N+1<=t; 1<=p<=N} of integer;\\n  TinXctl2XIn : {t,p \
| N+1<=t; p=N} of boolean;\\n  TinXctl1XIn : {t,p | N+1<=t; 0<=p<=N-1} of \
boolean;\\n  RinXctl1XIn : {t,p | N+1<=t; 1<=p<=N} of boolean;\\n  pipeCop25 \
: {t,p | N+1<=t; 0<=p<=N} of boolean;\\n  pipeCbusin5 : {t,p | N+1<=t; \
0<=p<=N} of integer;\\n  pipeCop15 : {t,p | N+1<=t; 0<=p<=N} of boolean;\\n  \
Rin : {t,p | N+1<=t; 1<=p<=N} of integer;\\n  Tin : {t,p | N+1<=t; 0<=p<=N} \
of boolean;\\n  RoutXfifo1 : {t,p | N+1<=t; 1<=p<=N} of integer;\\n  \
ToutXfifo1 : {t,p | N+1<=t; 0<=p<=N} of boolean;\\n  RinXctl1 : {t | N+1<=t} \
of boolean;\\n  TinXctl1 : {t | N+1<=t} of boolean;\\n  TinXctl2 : {t | \
N+1<=t} of boolean;\\nlet\\n  op2XMirr1[t,p] = op2[t-N-1];\\n  op1XMirr1[t,p] \
= op1[t-N-1];\\n  businXMirr1[t,p] = busin[t-N-1];\\n  TinReg11[t,p] = \
Tin[t,p+1];\\n  TinReg10[t,p] = Tin[t,p-1];\\n  TinReg9[t,p] = Tin[t,p+1];\\n \
 TinReg8[t,p] = Tin[t,p-1];\\n  ToutXfifo1Reg7[t,p] = ToutXfifo1[t-1,p];\\n  \
ToutXfifo1Reg6[t,p] = ToutXfifo1[t-1,p];\\n  RinReg5[t,p] = Rin[t,p-1];\\n  \
RoutXfifo1Reg4[t,p] = RoutXfifo1[t-1,p];\\n  pipeCop25Reg3[t,p] = \
pipeCop25[t,p-1];\\n  pipeCop15Reg2[t,p] = pipeCop15[t,p-1];\\n  \
pipeCbusin5Reg1[t,p] = pipeCbusin5[t,p-1];\\n  TinXctl2XIn[t,p] = \
TinXctl2[t];\\n  TinXctl1XIn[t,p] = TinXctl1[t];\\n  RinXctl1XIn[t,p] = \
RinXctl1[t];\\n  pipeCop25[t,p] = \\n      case\\n        { | p=0} : \
op2XMirr1;\\n        { | 1<=p} : pipeCop25Reg3;\\n      esac;\\n  \
pipeCbusin5[t,p] = \\n      case\\n        { | p=0} : businXMirr1;\\n        \
{ | 1<=p} : pipeCbusin5Reg1;\\n      esac;\\n  pipeCop15[t,p] = \\n      case\
\\n        { | p=0} : op1XMirr1;\\n        { | 1<=p} : pipeCop15Reg2;\\n      \
esac;\\n  TSep2[t,p] = pipeCop25 and Tin[t,p];\\n  TSep1[t,p] = if (TSep2) \
then pipeCbusin5 else Rin[t,p];\\n  TSep4[t,p] = pipeCop25 and Tin[t,p];\\n  \
TSep3[t,p] = if (TSep4) then pipeCbusin5 else Rin[t,p];\\n  RoutXfifo1[t,p] = \
\\n      case\\n        { | 2<=p} : if (pipeCop15) then RinReg5 else \
TSep1;\\n        { | p=1} : if (pipeCop15) then Rin[t,p] else TSep3;\\n      \
esac;\\n  TSep6[t,p] = pipeCop15 and Tin[t,p];\\n  TSep5[t,p] = if (TSep6) \
then TinReg9 else Tin[t,p];\\n  TSep8[t,p] = pipeCop15 and Tin[t,p];\\n  \
TSep7[t,p] = if (TSep8) then False[] else Tin[t,p];\\n  TSep10[t,p] = \
pipeCop15 and Tin[t,p];\\n  TSep9[t,p] = if (TSep10) then TinReg11 else \
Tin[t,p];\\n  ToutXfifo1[t,p] = \\n      case\\n        { | 1<=p<=N-1} : if \
(pipeCop15) then TinReg8 else TSep5;\\n        { | p=N} : if (pipeCop15) then \
TinReg10 else TSep7;\\n        { | p=0} : if (pipeCop15) then False[] else \
TSep9;\\n      esac;\\n  RinXctl1[t] = \\n      case\\n        case\\n        \
  { | t=N+1} : True[];\\n          { | N+2<=t} : False[];\\n        esac;\\n  \
    esac;\\n  Rin[t,p] = \\n      case\\n        { | N+1<=t} : if \
(RinXctl1XIn) then \\n               case\\n                 { | t=N+1} : \
0[];\\n                 { | N+2<=t} : 0[];\\n               esac else \\n     \
      case\\n             { | t=N+1} : 0[];\\n             { | N+2<=t} : \
RoutXfifo1Reg4;\\n           esac;\\n      esac;\\n  TinXctl1[t] = \\n      \
case\\n        case\\n          { | t=N+1} : True[];\\n          { | N+2<=t} \
: False[];\\n        esac;\\n      esac;\\n  TinXctl2[t] = \\n      case\\n   \
     case\\n          { | t=N+1} : True[];\\n          { | N+2<=t} : False[];\
\\n        esac;\\n      esac;\\n  Tin[t,p] = \\n      case\\n        { | \
N+1<=t; p<=N-1} : if (TinXctl1XIn) then \\n               case\\n             \
    { | t=N+1} : False[];\\n                 { | N+2<=t} : False[];\\n        \
       esac else \\n           case\\n             { | t=N+1} : False[];\\n   \
          { | N+2<=t} : ToutXfifo1Reg6;\\n           esac;\\n        { | \
N+1<=t; p=N} : if (TinXctl2XIn) then \\n               case\\n                \
 { | t=N+1} : True[];\\n                 { | N+2<=t} : False[];\\n            \
   esac else \\n           case\\n             { | t=N+1} : False[];\\n       \
      { | N+2<=t} : ToutXfifo1Reg7;\\n           esac;\\n      esac;\\n  \
wordout[t] = RoutXfifo1[t+N+1,N];\\n  full[t] = ToutXfifo1[t+N+1,0];\\n  \
empty[t] = ToutXfifo1[t+N+1,N];\\ntel;\"\>"], "Print"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"alpha0ToAlphard", "[", 
   RowBox[{
    RowBox[{"debug", "\[Rule]", "False"}], ",", 
    RowBox[{"mergeDomains", "\[Rule]", "True"}]}], "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Assuming that sys is not a module\"\>"], "Print",
 CellChangeTimes->{3.43756518100397*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"-- Building Interface of system: \"\>", 
   "\[InvisibleSpace]", "\<\"callfifo\"\>"}],
  SequenceForm["-- Building Interface of system: ", "callfifo"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565181032713*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Warning : the number of inputs of the module (\"\>", 
   "\[InvisibleSpace]", "12", 
   "\[InvisibleSpace]", "\<\") is different from the number of inputs (\"\>", 
   "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\") of the initial system.\"\>"}],
  SequenceForm[
  "Warning : the number of inputs of the module (", 12, 
   ") is different from the number of inputs (", 3, 
   ") of the initial system."],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375651811028347`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Inputs of the module: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"businXMirr1In\"\>", ",", "\<\"businXMirr2In\"\>", 
     ",", "\<\"op1XMirr1In\"\>", ",", "\<\"op1XMirr2In\"\>", 
     ",", "\<\"op1XMirr3In\"\>", ",", "\<\"op1XMirr4In\"\>", 
     ",", "\<\"op1XMirr5In\"\>", ",", "\<\"op1XMirr6In\"\>", 
     ",", "\<\"op1XMirr7In\"\>", ",", "\<\"op1XMirr8In\"\>", 
     ",", "\<\"op2XMirr1In\"\>", ",", "\<\"op2XMirr2In\"\>"}], "}"}]}],
  SequenceForm[
  "Inputs of the module: ", {
   "businXMirr1In", "businXMirr2In", "op1XMirr1In", "op1XMirr2In", 
    "op1XMirr3In", "op1XMirr4In", "op1XMirr5In", "op1XMirr6In", "op1XMirr7In",
     "op1XMirr8In", "op2XMirr1In", "op2XMirr2In"}],
  Editable->False]], "Print",
 CellChangeTimes->{3.43756518118886*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Inputs of the system: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"busin\"\>", ",", "\<\"op1\"\>", ",", "\<\"op2\"\>"}], "}"}]}],
  SequenceForm["Inputs of the system: ", {"busin", "op1", "op2"}],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375651812558727`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Warning: the number of outputs of the module (\"\>", 
   "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\") is different of the number of outputs (\"\>", 
   "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\") of the initial system.\"\>"}],
  SequenceForm[
  "Warning: the number of outputs of the module (", 2, 
   ") is different of the number of outputs (", 3, ") of the initial system."],
  Editable->False]], "Print",
 CellChangeTimes->{3.43756518133722*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"-- Structuring Module \"\>", 
   "\[InvisibleSpace]", "\<\"callfifoModule\"\>"}],
  SequenceForm["-- Structuring Module ", "callfifoModule"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565181421414*^9}],

Cell[BoxData["\<\"-- Determining the different cell types... \"\>"], "Print",
 CellChangeTimes->{3.437565181504217*^9}],

Cell[BoxData["\<\"   Please wait...\"\>"], "Print",
 CellChangeTimes->{3.437565181622004*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   \"\>", "\[InvisibleSpace]", "41", 
   "\[InvisibleSpace]", "\<\" region(s) found before simplification...\"\>"}],
  
  SequenceForm["   ", 41, " region(s) found before simplification..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565186110833*^9}],

Cell[BoxData["\<\"-- Simplifying identical regions ...\"\>"], "Print",
 CellChangeTimes->{3.437565186161119*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\" type(s) of cell have been identified, their \
domains are: \"\>"}],
  SequenceForm[
  "   ", 4, " type(s) of cell have been identified, their domains are: "],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565188074071*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"        \"\>", 
   "\[InvisibleSpace]", "\<\"{p,N | p=N; 3<=N}\"\>"}],
  SequenceForm["        ", "{p,N | p=N; 3<=N}"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375651881215277`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"        \"\>", 
   "\[InvisibleSpace]", "\<\"{p,N | p=1; 3<=N}\"\>"}],
  SequenceForm["        ", "{p,N | p=1; 3<=N}"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565188190567*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"        \"\>", 
   "\[InvisibleSpace]", "\<\"{p,N | 2<=p<=N-1}\"\>"}],
  SequenceForm["        ", "{p,N | 2<=p<=N-1}"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375651882538233`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"        \"\>", 
   "\[InvisibleSpace]", "\<\"{p,N | p=0; 3<=N}\"\>"}],
  SequenceForm["        ", "{p,N | p=0; 3<=N}"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375651883216*^9}],

Cell[BoxData["\<\"--- Generating Controler ...\"\>"], "Print",
 CellChangeTimes->{3.437565188388609*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--- Building cell \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" present on domain: \"\>", 
   "\[InvisibleSpace]", "\<\"{p,N | p=N; 3<=N}\"\>"}],
  SequenceForm[
  "--- Building cell ", 1, " present on domain: ", "{p,N | p=N; 3<=N}"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375651886976748`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"---- Cell name: \"\>", 
   "\[InvisibleSpace]", "\<\"cellcallfifoModule1\"\>"}],
  SequenceForm["---- Cell name: ", "cellcallfifoModule1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565190710513*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"---- Inputs: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"op2XMirr1\"\>", ",", "\<\"op1XMirr7\"\>", 
     ",", "\<\"op1XMirr4\"\>", ",", "\<\"op1XMirr1\"\>", 
     ",", "\<\"businXMirr1\"\>", ",", "\<\"TinReg7\"\>", 
     ",", "\<\"RinReg2\"\>", ",", "\<\"TinXctl1XIn\"\>", 
     ",", "\<\"RinXctl1XIn\"\>"}], "}"}]}],
  SequenceForm[
  "---- Inputs: ", {
   "op2XMirr1", "op1XMirr7", "op1XMirr4", "op1XMirr1", "businXMirr1", 
    "TinReg7", "RinReg2", "TinXctl1XIn", "RinXctl1XIn"}],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375651907665873`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"---- Outputs: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"Tin1\"\>", ",", "\<\"RoutXfifo11\"\>", 
     ",", "\<\"ToutXfifo11\"\>"}], "}"}]}],
  SequenceForm["---- Outputs: ", {"Tin1", "RoutXfifo11", "ToutXfifo11"}],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565190834956*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"buildOneCell::OutputNotSet Warning, it seems that cell \"\>", 
   "\[InvisibleSpace]", "\<\"cellcallfifoModule1\"\>", 
   "\[InvisibleSpace]", "\<\" needs to output signal \"\>", 
   "\[InvisibleSpace]", "\<\"RinReg2\"\>", 
   "\[InvisibleSpace]", "\<\" but it is not specified in the call, please \
check the result\"\>"}],
  SequenceForm[
  "buildOneCell::OutputNotSet Warning, it seems that cell ", 
   "cellcallfifoModule1", " needs to output signal ", "RinReg2", 
   " but it is not specified in the call, please check the result"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565190901083*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--- Building cell \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\" present on domain: \"\>", 
   "\[InvisibleSpace]", "\<\"{p,N | p=1; 3<=N}\"\>"}],
  SequenceForm[
  "--- Building cell ", 2, " present on domain: ", "{p,N | p=1; 3<=N}"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565191647039*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"---- Cell name: \"\>", 
   "\[InvisibleSpace]", "\<\"cellcallfifoModule2\"\>"}],
  SequenceForm["---- Cell name: ", "cellcallfifoModule2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375651936770267`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"---- Inputs: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"op2XMirr2\"\>", ",", "\<\"op1XMirr6\"\>", 
     ",", "\<\"op1XMirr3\"\>", ",", "\<\"op1XMirr2\"\>", 
     ",", "\<\"businXMirr2\"\>", ",", "\<\"TinReg6\"\>", 
     ",", "\<\"TinReg5\"\>", ",", "\<\"TinXctl2XIn\"\>", 
     ",", "\<\"RinXctl1XIn\"\>"}], "}"}]}],
  SequenceForm[
  "---- Inputs: ", {
   "op2XMirr2", "op1XMirr6", "op1XMirr3", "op1XMirr2", "businXMirr2", 
    "TinReg6", "TinReg5", "TinXctl2XIn", "RinXctl1XIn"}],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565193726699*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"---- Outputs: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"Tin2\"\>", ",", "\<\"Rin2\"\>", ",", "\<\"RoutXfifo12\"\>", 
     ",", "\<\"ToutXfifo12\"\>"}], "}"}]}],
  SequenceForm[
  "---- Outputs: ", {"Tin2", "Rin2", "RoutXfifo12", "ToutXfifo12"}],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375651937942877`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--- Building cell \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\" present on domain: \"\>", 
   "\[InvisibleSpace]", "\<\"{p,N | 2<=p<=N-1}\"\>"}],
  SequenceForm[
  "--- Building cell ", 3, " present on domain: ", "{p,N | 2<=p<=N-1}"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565194607678*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"---- Cell name: \"\>", 
   "\[InvisibleSpace]", "\<\"cellcallfifoModule3\"\>"}],
  SequenceForm["---- Cell name: ", "cellcallfifoModule3"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375651966004868`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"---- Inputs: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"op2XMirr1\"\>", ",", "\<\"op1XMirr6\"\>", 
     ",", "\<\"op1XMirr3\"\>", ",", "\<\"op1XMirr1\"\>", 
     ",", "\<\"businXMirr1\"\>", ",", "\<\"TinReg6\"\>", 
     ",", "\<\"TinReg5\"\>", ",", "\<\"RinReg2\"\>", 
     ",", "\<\"TinXctl2XIn\"\>", ",", "\<\"RinXctl1XIn\"\>"}], "}"}]}],
  SequenceForm[
  "---- Inputs: ", {
   "op2XMirr1", "op1XMirr6", "op1XMirr3", "op1XMirr1", "businXMirr1", 
    "TinReg6", "TinReg5", "RinReg2", "TinXctl2XIn", "RinXctl1XIn"}],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565196655033*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"---- Outputs: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"Tin3\"\>", ",", "\<\"Rin3\"\>", ",", "\<\"RoutXfifo13\"\>", 
     ",", "\<\"ToutXfifo13\"\>"}], "}"}]}],
  SequenceForm[
  "---- Outputs: ", {"Tin3", "Rin3", "RoutXfifo13", "ToutXfifo13"}],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375651967227297`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--- Building cell \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\" present on domain: \"\>", 
   "\[InvisibleSpace]", "\<\"{p,N | p=0; 3<=N}\"\>"}],
  SequenceForm[
  "--- Building cell ", 4, " present on domain: ", "{p,N | p=0; 3<=N}"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565197298311*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"---- Cell name: \"\>", 
   "\[InvisibleSpace]", "\<\"cellcallfifoModule4\"\>"}],
  SequenceForm["---- Cell name: ", "cellcallfifoModule4"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375651992798853`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"---- Inputs: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"op1XMirr8\"\>", ",", "\<\"op1XMirr5\"\>", 
     ",", "\<\"TinReg8\"\>", ",", "\<\"TinXctl2XIn\"\>"}], "}"}]}],
  SequenceForm[
  "---- Inputs: ", {"op1XMirr8", "op1XMirr5", "TinReg8", "TinXctl2XIn"}],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375651993336*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"---- Outputs: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"Tin4\"\>", ",", "\<\"ToutXfifo14\"\>"}], "}"}]}],
  SequenceForm["---- Outputs: ", {"Tin4", "ToutXfifo14"}],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375651994008713`*^9}],

Cell[BoxData["\<\"-- Adding local variables in library for isolating output \
pins\"\>"], "Print",
 CellChangeTimes->{3.437565200537429*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"analyze", "[", 
  RowBox[{"recurse", "\[Rule]", "True"}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Need to analyze : \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"callfifoModule\"\>", ",", "\<\"cellcallfifoModule1\"\>", 
     ",", "\<\"cellcallfifoModule2\"\>", ",", "\<\"cellcallfifoModule3\"\>", 
     ",", "\<\"cellcallfifoModule4\"\>", ",", "\<\"ControlcallfifoModule\"\>",
      ",", "\<\"callfifo\"\>"}], "}"}]}],
  SequenceForm[
  "Need to analyze : ", {
   "callfifoModule", "cellcallfifoModule1", "cellcallfifoModule2", 
    "cellcallfifoModule3", "cellcallfifoModule4", "ControlcallfifoModule", 
    "callfifo"}],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565212675362*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.4375652127411118`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"callfifoModule\"\>"}],
  SequenceForm["Static Analysis of system ", "callfifoModule"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565212808247*^9}],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print",
 CellChangeTimes->{3.4375652128748426`*^9}],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print",
 CellChangeTimes->{3.437565212941451*^9}],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print",
 CellChangeTimes->{3.43756521300797*^9}],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print",
 CellChangeTimes->{3.437565213071187*^9}],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print",
 CellChangeTimes->{3.437565213139051*^9}],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print",
 CellChangeTimes->{3.437565213241547*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"businXMirr1\"\>"}],
  SequenceForm["----equation defining ", "businXMirr1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565213322772*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"businXMirr2\"\>"}],
  SequenceForm["----equation defining ", "businXMirr2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565213390306*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op1XMirr1\"\>"}],
  SequenceForm["----equation defining ", "op1XMirr1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.43756521345735*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op1XMirr2\"\>"}],
  SequenceForm["----equation defining ", "op1XMirr2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565213522522*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op1XMirr3\"\>"}],
  SequenceForm["----equation defining ", "op1XMirr3"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565213589425*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op1XMirr4\"\>"}],
  SequenceForm["----equation defining ", "op1XMirr4"],
  Editable->False]], "Print",
 CellChangeTimes->{3.43756521365551*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op1XMirr5\"\>"}],
  SequenceForm["----equation defining ", "op1XMirr5"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565213721683*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op1XMirr6\"\>"}],
  SequenceForm["----equation defining ", "op1XMirr6"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565213833576*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op1XMirr7\"\>"}],
  SequenceForm["----equation defining ", "op1XMirr7"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565213906147*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op1XMirr8\"\>"}],
  SequenceForm["----equation defining ", "op1XMirr8"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565213970702*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op2XMirr1\"\>"}],
  SequenceForm["----equation defining ", "op2XMirr1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565214038191*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op2XMirr2\"\>"}],
  SequenceForm["----equation defining ", "op2XMirr2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565214137587*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"RinReg2\"\>"}],
  SequenceForm["----equation defining ", "RinReg2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652142021837`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"RinXctl1XIn\"\>"}],
  SequenceForm["----equation defining ", "RinXctl1XIn"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565214269614*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"RoutXfifo1Out\"\>"}],
  SequenceForm["----equation defining ", "RoutXfifo1Out"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652143349333`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TinReg5\"\>"}],
  SequenceForm["----equation defining ", "TinReg5"],
  Editable->False]], "Print",
 CellChangeTimes->{3.43756521457952*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TinReg6\"\>"}],
  SequenceForm["----equation defining ", "TinReg6"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652149695263`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TinReg7\"\>"}],
  SequenceForm["----equation defining ", "TinReg7"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565215221846*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TinReg8\"\>"}],
  SequenceForm["----equation defining ", "TinReg8"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652153470793`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TinXctl1XIn\"\>"}],
  SequenceForm["----equation defining ", "TinXctl1XIn"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652154697*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TinXctl2XIn\"\>"}],
  SequenceForm["----equation defining ", "TinXctl2XIn"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652155517817`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1Out\"\>"}],
  SequenceForm["----equation defining ", "ToutXfifo1Out"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652156337147`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----use \"\>", 
   "\[InvisibleSpace]", "\<\"ControlcallfifoModule\"\>", 
   "\[InvisibleSpace]", "\<\"...\"\>"}],
  SequenceForm["----use ", "ControlcallfifoModule", "..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565216247213*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----use \"\>", 
   "\[InvisibleSpace]", "\<\"cellcallfifoModule1\"\>", 
   "\[InvisibleSpace]", "\<\"...\"\>"}],
  SequenceForm["----use ", "cellcallfifoModule1", "..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652164278507`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----use \"\>", 
   "\[InvisibleSpace]", "\<\"cellcallfifoModule2\"\>", 
   "\[InvisibleSpace]", "\<\"...\"\>"}],
  SequenceForm["----use ", "cellcallfifoModule2", "..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652175257072`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----use \"\>", 
   "\[InvisibleSpace]", "\<\"cellcallfifoModule3\"\>", 
   "\[InvisibleSpace]", "\<\"...\"\>"}],
  SequenceForm["----use ", "cellcallfifoModule3", "..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652187160997`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----use \"\>", 
   "\[InvisibleSpace]", "\<\"cellcallfifoModule4\"\>", 
   "\[InvisibleSpace]", "\<\"...\"\>"}],
  SequenceForm["----use ", "cellcallfifoModule4", "..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565219973*^9}],

Cell[BoxData["\<\"--Checking regularity of output equations\"\>"], "Print",
 CellChangeTimes->{3.437565220553822*^9}],

Cell[BoxData["\<\"----Outputs equations are not regular. Use \
mkAllOutputsRegular.\"\>"], "Print",
 CellChangeTimes->{3.437565220610154*^9}],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print",
 CellChangeTimes->{3.437565220675428*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.43756522073915*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"cellcallfifoModule1\"\>"}],
  SequenceForm["Static Analysis of system ", "cellcallfifoModule1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565220808794*^9}],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print",
 CellChangeTimes->{3.437565220873807*^9}],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print",
 CellChangeTimes->{3.437565220939528*^9}],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print",
 CellChangeTimes->{3.437565221005145*^9}],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print",
 CellChangeTimes->{3.4375652211081553`*^9}],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print",
 CellChangeTimes->{3.437565221170014*^9}],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print",
 CellChangeTimes->{3.437565221240912*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1\"\>"}],
  SequenceForm["----equation defining ", "ToutXfifo1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652213062677`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"RoutXfifo1\"\>"}],
  SequenceForm["----equation defining ", "RoutXfifo1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565221374946*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Tin\"\>"}],
  SequenceForm["----equation defining ", "Tin"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565221440946*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1Reg3\"\>"}],
  SequenceForm["----equation defining ", "ToutXfifo1Reg3"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565221507415*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"RoutXfifo1Reg1\"\>"}],
  SequenceForm["----equation defining ", "RoutXfifo1Reg1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565221576021*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TSep2\"\>"}],
  SequenceForm["----equation defining ", "TSep2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565221673498*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TSep1\"\>"}],
  SequenceForm["----equation defining ", "TSep1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565221755176*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"RoutXfifo1loc2\"\>"}],
  SequenceForm["----equation defining ", "RoutXfifo1loc2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565221821753*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TSep8\"\>"}],
  SequenceForm["----equation defining ", "TSep8"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652218904963`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TSep7\"\>"}],
  SequenceForm["----equation defining ", "TSep7"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565222064883*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1loc3\"\>"}],
  SequenceForm["----equation defining ", "ToutXfifo1loc3"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652222892*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Rin\"\>"}],
  SequenceForm["----equation defining ", "Rin"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565222555643*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Tinloc1\"\>"}],
  SequenceForm["----equation defining ", "Tinloc1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565223083478*^9}],

Cell[BoxData["\<\"--Checking regularity of output equations\"\>"], "Print",
 CellChangeTimes->{3.437565223612084*^9}],

Cell[BoxData["\<\"----Outputs equations are regular.\"\>"], "Print",
 CellChangeTimes->{3.437565223668333*^9}],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print",
 CellChangeTimes->{3.4375652237367783`*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.437565223801216*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"cellcallfifoModule2\"\>"}],
  SequenceForm["Static Analysis of system ", "cellcallfifoModule2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652238670797`*^9}],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print",
 CellChangeTimes->{3.437565223937845*^9}],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print",
 CellChangeTimes->{3.43756522400025*^9}],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print",
 CellChangeTimes->{3.437565224066489*^9}],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print",
 CellChangeTimes->{3.437565224168468*^9}],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print",
 CellChangeTimes->{3.437565224251481*^9}],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print",
 CellChangeTimes->{3.4375652243174553`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1\"\>"}],
  SequenceForm["----equation defining ", "ToutXfifo1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565224385495*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"RoutXfifo1\"\>"}],
  SequenceForm["----equation defining ", "RoutXfifo1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565224452786*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Rin\"\>"}],
  SequenceForm["----equation defining ", "Rin"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565224514695*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Tin\"\>"}],
  SequenceForm["----equation defining ", "Tin"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652245861073`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1Reg4\"\>"}],
  SequenceForm["----equation defining ", "ToutXfifo1Reg4"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565224650545*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"RoutXfifo1Reg1\"\>"}],
  SequenceForm["----equation defining ", "RoutXfifo1Reg1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652247525377`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TSep4\"\>"}],
  SequenceForm["----equation defining ", "TSep4"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652248331823`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TSep3\"\>"}],
  SequenceForm["----equation defining ", "TSep3"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652249002028`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"RoutXfifo1loc3\"\>"}],
  SequenceForm["----equation defining ", "RoutXfifo1loc3"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565224966476*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TSep6\"\>"}],
  SequenceForm["----equation defining ", "TSep6"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652250659*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TSep5\"\>"}],
  SequenceForm["----equation defining ", "TSep5"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565225248434*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1loc4\"\>"}],
  SequenceForm["----equation defining ", "ToutXfifo1loc4"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652255134172`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Rinloc2\"\>"}],
  SequenceForm["----equation defining ", "Rinloc2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565225798761*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Tinloc1\"\>"}],
  SequenceForm["----equation defining ", "Tinloc1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565226326974*^9}],

Cell[BoxData["\<\"--Checking regularity of output equations\"\>"], "Print",
 CellChangeTimes->{3.437565226853909*^9}],

Cell[BoxData["\<\"----Outputs equations are regular.\"\>"], "Print",
 CellChangeTimes->{3.437565226911662*^9}],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print",
 CellChangeTimes->{3.437565226978064*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.437565227044634*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"cellcallfifoModule3\"\>"}],
  SequenceForm["Static Analysis of system ", "cellcallfifoModule3"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565227111911*^9}],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print",
 CellChangeTimes->{3.437565227179289*^9}],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print",
 CellChangeTimes->{3.4375652272461233`*^9}],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print",
 CellChangeTimes->{3.437565227312212*^9}],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print",
 CellChangeTimes->{3.4375652274121723`*^9}],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print",
 CellChangeTimes->{3.437565227493265*^9}],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print",
 CellChangeTimes->{3.437565227561586*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1\"\>"}],
  SequenceForm["----equation defining ", "ToutXfifo1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565227628669*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"RoutXfifo1\"\>"}],
  SequenceForm["----equation defining ", "RoutXfifo1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565227693286*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Rin\"\>"}],
  SequenceForm["----equation defining ", "Rin"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565227759882*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Tin\"\>"}],
  SequenceForm["----equation defining ", "Tin"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652278272533`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1Reg4\"\>"}],
  SequenceForm["----equation defining ", "ToutXfifo1Reg4"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565227894527*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"RoutXfifo1Reg1\"\>"}],
  SequenceForm["----equation defining ", "RoutXfifo1Reg1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652279947367`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TSep2\"\>"}],
  SequenceForm["----equation defining ", "TSep2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652280763597`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TSep1\"\>"}],
  SequenceForm["----equation defining ", "TSep1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565228143173*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"RoutXfifo1loc3\"\>"}],
  SequenceForm["----equation defining ", "RoutXfifo1loc3"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565228208503*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TSep6\"\>"}],
  SequenceForm["----equation defining ", "TSep6"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565228277974*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TSep5\"\>"}],
  SequenceForm["----equation defining ", "TSep5"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565228342353*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1loc4\"\>"}],
  SequenceForm["----equation defining ", "ToutXfifo1loc4"],
  Editable->False]], "Print",
 CellChangeTimes->{3.43756522849288*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Rinloc2\"\>"}],
  SequenceForm["----equation defining ", "Rinloc2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.43756522872514*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Tinloc1\"\>"}],
  SequenceForm["----equation defining ", "Tinloc1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565229177618*^9}],

Cell[BoxData["\<\"--Checking regularity of output equations\"\>"], "Print",
 CellChangeTimes->{3.437565229634416*^9}],

Cell[BoxData["\<\"----Outputs equations are regular.\"\>"], "Print",
 CellChangeTimes->{3.437565229689239*^9}],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print",
 CellChangeTimes->{3.437565229756442*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.437565229824472*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"cellcallfifoModule4\"\>"}],
  SequenceForm["Static Analysis of system ", "cellcallfifoModule4"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565229889701*^9}],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print",
 CellChangeTimes->{3.437565229955564*^9}],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print",
 CellChangeTimes->{3.437565230023678*^9}],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print",
 CellChangeTimes->{3.437565230089385*^9}],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print",
 CellChangeTimes->{3.437565230189794*^9}],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print",
 CellChangeTimes->{3.437565230256542*^9}],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print",
 CellChangeTimes->{3.43756523032085*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1\"\>"}],
  SequenceForm["----equation defining ", "ToutXfifo1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565230387515*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Tin\"\>"}],
  SequenceForm["----equation defining ", "Tin"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652304568033`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1Reg4\"\>"}],
  SequenceForm["----equation defining ", "ToutXfifo1Reg4"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652305214367`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TSep10\"\>"}],
  SequenceForm["----equation defining ", "TSep10"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652305873117`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TSep9\"\>"}],
  SequenceForm["----equation defining ", "TSep9"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565230654351*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"ToutXfifo1loc2\"\>"}],
  SequenceForm["----equation defining ", "ToutXfifo1loc2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652307550983`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Tinloc1\"\>"}],
  SequenceForm["----equation defining ", "Tinloc1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565230818021*^9}],

Cell[BoxData["\<\"--Checking regularity of output equations\"\>"], "Print",
 CellChangeTimes->{3.4375652312208548`*^9}],

Cell[BoxData["\<\"----Outputs equations are regular.\"\>"], "Print",
 CellChangeTimes->{3.43756523127061*^9}],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print",
 CellChangeTimes->{3.43756523133515*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.437565231402925*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"ControlcallfifoModule\"\>"}],
  SequenceForm["Static Analysis of system ", "ControlcallfifoModule"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565231468692*^9}],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print",
 CellChangeTimes->{3.437565231536744*^9}],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print",
 CellChangeTimes->{3.4375652316044607`*^9}],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print",
 CellChangeTimes->{3.437565231670274*^9}],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print",
 CellChangeTimes->{3.437565231770246*^9}],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print",
 CellChangeTimes->{3.437565231835824*^9}],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print",
 CellChangeTimes->{3.437565231901725*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"RinXctl1\"\>"}],
  SequenceForm["----equation defining ", "RinXctl1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565231968196*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TinXctl1\"\>"}],
  SequenceForm["----equation defining ", "TinXctl1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565232036552*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"TinXctl2\"\>"}],
  SequenceForm["----equation defining ", "TinXctl2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565232101283*^9}],

Cell[BoxData["\<\"--Checking regularity of output equations\"\>"], "Print",
 CellChangeTimes->{3.437565232167727*^9}],

Cell[BoxData["\<\"----Outputs equations are not regular. Use \
mkAllOutputsRegular.\"\>"], "Print",
 CellChangeTimes->{3.437565232237918*^9}],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print",
 CellChangeTimes->{3.437565232335544*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.437565232400262*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"callfifo\"\>"}],
  SequenceForm["Static Analysis of system ", "callfifo"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565232467197*^9}],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print",
 CellChangeTimes->{3.437565232535337*^9}],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print",
 CellChangeTimes->{3.437565232601725*^9}],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print",
 CellChangeTimes->{3.4375652326657248`*^9}],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print",
 CellChangeTimes->{3.437565232733487*^9}],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print",
 CellChangeTimes->{3.437565232799901*^9}],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print",
 CellChangeTimes->{3.4375652329002953`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op2XMirr2\"\>"}],
  SequenceForm["----equation defining ", "op2XMirr2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565232987453*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op2XMirr1\"\>"}],
  SequenceForm["----equation defining ", "op2XMirr1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565233050395*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op1XMirr8\"\>"}],
  SequenceForm["----equation defining ", "op1XMirr8"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565233118095*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op1XMirr7\"\>"}],
  SequenceForm["----equation defining ", "op1XMirr7"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652331830683`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op1XMirr6\"\>"}],
  SequenceForm["----equation defining ", "op1XMirr6"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565233249007*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op1XMirr5\"\>"}],
  SequenceForm["----equation defining ", "op1XMirr5"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652333155823`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op1XMirr4\"\>"}],
  SequenceForm["----equation defining ", "op1XMirr4"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565233383913*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op1XMirr3\"\>"}],
  SequenceForm["----equation defining ", "op1XMirr3"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652334826107`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op1XMirr2\"\>"}],
  SequenceForm["----equation defining ", "op1XMirr2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565233564286*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"op1XMirr1\"\>"}],
  SequenceForm["----equation defining ", "op1XMirr1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652336322527`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"businXMirr2\"\>"}],
  SequenceForm["----equation defining ", "businXMirr2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565233698906*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"businXMirr1\"\>"}],
  SequenceForm["----equation defining ", "businXMirr1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565233765091*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"wordout\"\>"}],
  SequenceForm["----equation defining ", "wordout"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565233831801*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"full\"\>"}],
  SequenceForm["----equation defining ", "full"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652338979673`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"empty\"\>"}],
  SequenceForm["----equation defining ", "empty"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652339642963`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----use \"\>", "\[InvisibleSpace]", "\<\"callfifoModule\"\>", 
   "\[InvisibleSpace]", "\<\"...\"\>"}],
  SequenceForm["----use ", "callfifoModule", "..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.43756523406571*^9}],

Cell[BoxData["\<\"--Checking regularity of output equations\"\>"], "Print",
 CellChangeTimes->{3.437565234194107*^9}],

Cell[BoxData["\<\"----Outputs equations are regular.\"\>"], "Print",
 CellChangeTimes->{3.437565234264861*^9}],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print",
 CellChangeTimes->{3.437565234330881*^9}],

Cell[BoxData["\<\"\\nRecursive Analysis Successful.\"\>"], "Print",
 CellChangeTimes->{3.4375652343971786`*^9}]
}, Open  ]],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.437565234462543*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"asaveLib", "[", "\"\<fifoHard1.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input"],

Cell[BoxData["\<\"system callfifo :{N | 3<=N}\\n                (busin : {t | \
0<=t} of integer; \\n                 op1 : {t | 0<=t} of boolean; \\n        \
         op2 : {t | 0<=t} of boolean)\\n       returns  (full : {t | 0<=t} of \
boolean; \\n                 empty : {t | 0<=t} of boolean; \\n               \
  wordout : {t | 0<=t} of integer);\\nvar\\n  businXMirr1 : {t,p | 0<=t; \
2<=p<=N} of integer;\\n  businXMirr2 : {t,p | 0<=t; p=1} of integer;\\n  \
op1XMirr1 : {t,p | 0<=t; 2<=p<=N} of boolean;\\n  op1XMirr2 : {t,p | 0<=t; \
p=1} of boolean;\\n  op1XMirr3 : {t,p | 0<=t; 1<=p<=N-1} of boolean;\\n  \
op1XMirr4 : {t,p | 0<=t; p=N} of boolean;\\n  op1XMirr5 : {t,p | 0<=t; p=0} \
of boolean;\\n  op1XMirr6 : {t,p | 0<=t; 1<=p<=N-1} of boolean;\\n  op1XMirr7 \
: {t,p | 0<=t; p=N} of boolean;\\n  op1XMirr8 : {t,p | 0<=t; p=0} of boolean;\
\\n  op2XMirr1 : {t,p | 0<=t; 2<=p<=N} of boolean;\\n  op2XMirr2 : {t,p | \
0<=t; p=1} of boolean;\\n  RoutXfifo1 : {t,p | 0<=t; 1<=p<=N} of integer;\\n  \
ToutXfifo1 : {t,p | 0<=t; 0<=p<=N} of boolean;\\nlet\\n  op2XMirr2[t,p] = \
op2[t];\\n  op2XMirr1[t,p] = op2[t];\\n  op1XMirr8[t,p] = op1[t];\\n  \
op1XMirr7[t,p] = op1[t];\\n  op1XMirr6[t,p] = op1[t];\\n  op1XMirr5[t,p] = \
op1[t];\\n  op1XMirr4[t,p] = op1[t];\\n  op1XMirr3[t,p] = op1[t];\\n  \
op1XMirr2[t,p] = op1[t];\\n  op1XMirr1[t,p] = op1[t];\\n  businXMirr2[t,p] = \
busin[t];\\n  businXMirr1[t,p] = busin[t];\\n  wordout[t] = \
RoutXfifo1[t,N];\\n  full[t] = ToutXfifo1[t,0];\\n  empty[t] = \
ToutXfifo1[t,N];\\n  use  callfifoModule[N] (businXMirr1, businXMirr2, \
op1XMirr1, op1XMirr2, op1XMirr3, op1XMirr4, op1XMirr5, op1XMirr6, op1XMirr7, \
op1XMirr8, op2XMirr1, op2XMirr2) returns  (RoutXfifo1, ToutXfifo1) ;\\ntel;\"\
\>"], "Print",
 CellChangeTimes->{3.43756524024889*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Set parameter value", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<fifoHard1.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"[ControlcallfifoModule][cellcallfifoModule1][\
cellcallfifoModule2][cellcallfifoModule3][cellcallfifoModule4][callfifoModule]\
[callfifo]\"\>"], "Print"],

Cell[BoxData["\<\" Library Loaded\"\>"], "Print"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"fixParameter", "[", 
   RowBox[{"\"\<N\>\"", ",", "6"}], "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input"],

Cell[BoxData["\<\"system callfifo (busin : {t | 0<=t} of integer; \\n         \
        op1 : {t | 0<=t} of boolean; \\n                 op2 : {t | 0<=t} of \
boolean)\\n       returns  (full : {t | 0<=t} of boolean; \\n                 \
empty : {t | 0<=t} of boolean; \\n                 wordout : {t | 0<=t} of \
integer);\\nvar\\n  businXMirr1 : {t,p | 0<=t; 2<=p<=6} of integer;\\n  \
businXMirr2 : {t,p | 0<=t; p=1} of integer;\\n  op1XMirr1 : {t,p | 0<=t; \
2<=p<=6} of boolean;\\n  op1XMirr2 : {t,p | 0<=t; p=1} of boolean;\\n  \
op1XMirr3 : {t,p | 0<=t; 1<=p<=5} of boolean;\\n  op1XMirr4 : {t,p | 0<=t; \
p=6} of boolean;\\n  op1XMirr5 : {t,p | 0<=t; p=0} of boolean;\\n  op1XMirr6 \
: {t,p | 0<=t; 1<=p<=5} of boolean;\\n  op1XMirr7 : {t,p | 0<=t; p=6} of \
boolean;\\n  op1XMirr8 : {t,p | 0<=t; p=0} of boolean;\\n  op2XMirr1 : {t,p | \
0<=t; 2<=p<=6} of boolean;\\n  op2XMirr2 : {t,p | 0<=t; p=1} of boolean;\\n  \
RoutXfifo1 : {t,p | 0<=t; 1<=p<=6} of integer;\\n  ToutXfifo1 : {t,p | 0<=t; \
0<=p<=6} of boolean;\\nlet\\n  op2XMirr2[t,p] = op2[t];\\n  op2XMirr1[t,p] = \
op2[t];\\n  op1XMirr8[t,p] = op1[t];\\n  op1XMirr7[t,p] = op1[t];\\n  \
op1XMirr6[t,p] = op1[t];\\n  op1XMirr5[t,p] = op1[t];\\n  op1XMirr4[t,p] = \
op1[t];\\n  op1XMirr3[t,p] = op1[t];\\n  op1XMirr2[t,p] = op1[t];\\n  \
op1XMirr1[t,p] = op1[t];\\n  businXMirr2[t,p] = busin[t];\\n  \
businXMirr1[t,p] = busin[t];\\n  wordout[t] = RoutXfifo1[t,6];\\n  full[t] = \
ToutXfifo1[t,0];\\n  empty[t] = ToutXfifo1[t,6];\\n  use  callfifoModule[] \
(businXMirr1, businXMirr2, op1XMirr1, op1XMirr2, op1XMirr3, op1XMirr4, \
op1XMirr5, op1XMirr6, op1XMirr7, op1XMirr8, op2XMirr1, op2XMirr2) returns  \
(RoutXfifo1, ToutXfifo1) ;\\ntel;\"\>"], "Print",
 CellChangeTimes->{3.4375652818354683`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generate Vhdl", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a2v", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Vhdl files will be generated in \"\>", 
   "\[InvisibleSpace]", \
"\<\"/Users/quinton/mmalpha/demos/NOTEBOOKS/Fifo/\"\>"}],
  SequenceForm[
  "Vhdl files will be generated in ", 
   "/Users/quinton/mmalpha/demos/NOTEBOOKS/Fifo/"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565263920226*^9}],

Cell[BoxData["\<\"\\nPlease wait...\\n\"\>"], "Print",
 CellChangeTimes->{3.437565263923272*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"a2v", "::", "\<\"unknsys\"\>"}], ":", 
  " ", "\<\"System \\!\\(\\\"fifo\\\"\\) is neither recognized as a cell, a \
module or a controller.\\nTo find out the problem, use the following sequence\
\\n\\ngetSystem[\\\"\\!\\(\\\"fifo\\\"\\)\\\"];checkCell[debug->True];\\n\\\
ngetSystem[\\\"\\!\\(\\\"fifo\\\"\\)\\\"];checkController[debug->True];\\n\\\
ngetSystem[\\\"\\!\\(\\\"fifo\\\"\\)\\\"];checkModule[debug->True];\\n\\nOne \
of these command might explain why your system cannot \\nbe translated to \
Vhdl. Also, remember that a system cannot\\nbe tranlsated to Vhdl if the \
parameter values haven't been \\nset using the fixParameter function. \
\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437565264479458*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "0.0683480000000003`", "\[InvisibleSpace]", "\<\" needed to translate \"\>",
    "\[InvisibleSpace]", "\<\"fifo\"\>"}],
  SequenceForm[0.0683480000000003, " needed to translate ", "fifo"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565264549733*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ControlcallfifoModule\"\>", 
   "\[InvisibleSpace]", "\<\" was recognized as a Controller.\"\>"}],
  SequenceForm["ControlcallfifoModule", " was recognized as a Controller."],
  Editable->False]], "Print",
 CellChangeTimes->{3.43756526461615*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Part", "::", "\<\"partw\"\>"}], ":", 
  " ", "\<\"Part \\!\\(1\\) of \\!\\({}\\) does not exist. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/partw\\\", \
ButtonNote -> \\\"Part::partw\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437565264683991*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"getPart", "::", "\<\"wrgpos\"\>"}], ":", 
  " ", "\<\"position out of expression.\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4375652650510187`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Part", "::", "\<\"partw\"\>"}], ":", 
  " ", "\<\"Part \\!\\(1\\) of \\!\\({}\\) does not exist. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/partw\\\", \
ButtonNote -> \\\"Part::partw\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4375652650991592`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"getPart", "::", "\<\"wrgpos\"\>"}], ":", 
  " ", "\<\"position out of expression.\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437565265164448*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Part", "::", "\<\"partw\"\>"}], ":", 
  " ", "\<\"Part \\!\\(1\\) of \\!\\({}\\) does not exist. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/partw\\\", \
ButtonNote -> \\\"Part::partw\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4375652652320766`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], ":", 
  " ", "\<\"Further output of \\!\\(Part :: \\\"partw\\\"\\) will be \
suppressed during this calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\
\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437565265298101*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"getPart", "::", "\<\"wrgpos\"\>"}], ":", 
  " ", "\<\"position out of expression.\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437565265365217*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], ":", 
  " ", "\<\"Further output of \\!\\(getPart :: \\\"wrgpos\\\"\\) will be \
suppressed during this calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\
\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437565265462022*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"alphardTimeLife", "::", "\<\"Warning\"\>"}], ":", 
  " ", "\<\"you system does not seem to be part of an\\nAlphard \
system\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437565265568984*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"convexize", "::", "\<\"params\"\>"}], ":", 
  " ", "\<\"wrong parameters\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4375652659600697`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Alpha`vhdlCont`Private`mooreFSM", "::", "\<\"params\"\>"}], ":", 
  " ", "\<\"wrong parameters\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437565268342024*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Alpha`vhdlCont`Private`mooreFSM", "::", "\<\"params\"\>"}], ":", 
  " ", "\<\"wrong parameters\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437565268391341*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Alpha`vhdlCont`Private`mooreFSM", "::", "\<\"params\"\>"}], ":", 
  " ", "\<\"wrong parameters\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437565268458213*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], ":", 
  " ", "\<\"Further output of \\!\\(Alpha`vhdlCont`Private`mooreFSM :: \
\\\"params\\\"\\) will be suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/stop\\\", \
ButtonNote -> \\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4375652685232763`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Alpha`vhdlCont`Private`fsmToVhdl", "::", "\<\"params\"\>"}], ":", 
  " ", "\<\"wrong parameters\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437565268773991*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Alpha`vhdlCont`Private`fsmToVhdl", "::", "\<\"params\"\>"}], ":", 
  " ", "\<\"wrong parameters\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437565268822628*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Alpha`vhdlCont`Private`fsmToVhdl", "::", "\<\"params\"\>"}], ":", 
  " ", "\<\"wrong parameters\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437565268887825*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], ":", 
  " ", "\<\"Further output of \\!\\(Alpha`vhdlCont`Private`fsmToVhdl :: \
\\\"params\\\"\\) will be suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/stop\\\", \
ButtonNote -> \\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437565268958701*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringJoin", "::", "\<\"string\"\>"}], ":", 
  " ", "\<\"String expected at position \\!\\(2\\) in \\!\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\). \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/StringJoin\\\", ButtonNote -> \
\\\"StringJoin::string\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437565269052959*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringJoin", "::", "\<\"string\"\>"}], ":", 
  " ", "\<\"String expected at position \\!\\(3\\) in \\!\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\). \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/StringJoin\\\", ButtonNote -> \
\\\"StringJoin::string\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437565269122261*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringJoin", "::", "\<\"string\"\>"}], ":", 
  " ", "\<\"String expected at position \\!\\(4\\) in \\!\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\). \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/StringJoin\\\", ButtonNote -> \
\\\"StringJoin::string\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4375652691862297`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], ":", 
  " ", "\<\"Further output of \\!\\(StringJoin :: \\\"string\\\"\\) will be \
suppressed during this calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\
\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.437565269255829*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"a2v", "::", "\<\"error1\"\>"}], ":", 
  " ", "\<\"Error while calling vhdlCont on \\!\\(\\\"ControlcallfifoModule\\\
\"\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.43756526943477*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "0.29542`", "\[InvisibleSpace]", "\<\" needed to translate \"\>", 
   "\[InvisibleSpace]", "\<\"ControlcallfifoModule\"\>"}],
  SequenceForm[0.29542, " needed to translate ", "ControlcallfifoModule"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652694855957`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"cellcallfifoModule1\"\>", 
   "\[InvisibleSpace]", "\<\" was recognized as a Cell.\"\>"}],
  SequenceForm["cellcallfifoModule1", " was recognized as a Cell."],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565269538341*^9}],

Cell[BoxData["\<\"All modules are known...\"\>"], "Print",
 CellChangeTimes->{3.437565269603773*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "0.08613100000000173`", 
   "\[InvisibleSpace]", "\<\" needed to translate \"\>", 
   "\[InvisibleSpace]", "\<\"cellcallfifoModule1\"\>"}],
  SequenceForm[
  0.08613100000000173, " needed to translate ", "cellcallfifoModule1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565269671921*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"cellcallfifoModule2\"\>", 
   "\[InvisibleSpace]", "\<\" was recognized as a Cell.\"\>"}],
  SequenceForm["cellcallfifoModule2", " was recognized as a Cell."],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652697386436`*^9}],

Cell[BoxData["\<\"All modules are known...\"\>"], "Print",
 CellChangeTimes->{3.437565269804612*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "0.08856299999999706`", 
   "\[InvisibleSpace]", "\<\" needed to translate \"\>", 
   "\[InvisibleSpace]", "\<\"cellcallfifoModule2\"\>"}],
  SequenceForm[
  0.08856299999999706, " needed to translate ", "cellcallfifoModule2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565269871854*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"cellcallfifoModule3\"\>", 
   "\[InvisibleSpace]", "\<\" was recognized as a Cell.\"\>"}],
  SequenceForm["cellcallfifoModule3", " was recognized as a Cell."],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652699850063`*^9}],

Cell[BoxData["\<\"All modules are known...\"\>"], "Print",
 CellChangeTimes->{3.437565270053721*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "0.09070900000000393`", 
   "\[InvisibleSpace]", "\<\" needed to translate \"\>", 
   "\[InvisibleSpace]", "\<\"cellcallfifoModule3\"\>"}],
  SequenceForm[
  0.09070900000000393, " needed to translate ", "cellcallfifoModule3"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565270122954*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"cellcallfifoModule4\"\>", 
   "\[InvisibleSpace]", "\<\" was recognized as a Cell.\"\>"}],
  SequenceForm["cellcallfifoModule4", " was recognized as a Cell."],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565270187951*^9}],

Cell[BoxData["\<\"All modules are known...\"\>"], "Print",
 CellChangeTimes->{3.437565270257125*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "0.045889999999999986`", 
   "\[InvisibleSpace]", "\<\" needed to translate \"\>", 
   "\[InvisibleSpace]", "\<\"cellcallfifoModule4\"\>"}],
  SequenceForm[
  0.045889999999999986`, " needed to translate ", "cellcallfifoModule4"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565270321398*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"a2v", "::", "\<\"unknsys\"\>"}], ":", 
  " ", "\<\"System \\!\\(\\\"callfifoModule\\\"\\) is neither recognized as a \
cell, a module or a controller.\\nTo find out the problem, use the following \
sequence\\n\\ngetSystem[\\\"\\!\\(\\\"callfifoModule\\\"\\)\\\"];checkCell[\
debug->True];\\n\\ngetSystem[\\\"\\!\\(\\\"callfifoModule\\\"\\)\\\"];\
checkController[debug->True];\\n\\ngetSystem[\\\"\\!\\(\\\"callfifoModule\\\"\
\\)\\\"];checkModule[debug->True];\\n\\nOne of these command might explain \
why your system cannot \\nbe translated to Vhdl. Also, remember that a system \
cannot\\nbe tranlsated to Vhdl if the parameter values haven't been \\nset \
using the fixParameter function. \"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.43756527038838*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "0.14180899999999497`", 
   "\[InvisibleSpace]", "\<\" needed to translate \"\>", 
   "\[InvisibleSpace]", "\<\"callfifoModule\"\>"}],
  SequenceForm[
  0.14180899999999497`, " needed to translate ", "callfifoModule"],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565270456629*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"callfifo\"\>", 
   "\[InvisibleSpace]", "\<\" was recognized as a Module.\"\>"}],
  SequenceForm["callfifo", " was recognized as a Module."],
  Editable->False]], "Print",
 CellChangeTimes->{3.437565270599977*^9}],

Cell[BoxData["\<\"All modules are known...\"\>"], "Print",
 CellChangeTimes->{3.437565271057719*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "0.4391809999999978`", "\[InvisibleSpace]", "\<\" needed to translate \"\>",
    "\[InvisibleSpace]", "\<\"callfifo\"\>"}],
  SequenceForm[0.4391809999999978, " needed to translate ", "callfifo"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4375652711043873`*^9}],

Cell[BoxData["\<\"End of translation.\"\>"], "Print",
 CellChangeTimes->{3.437565271171393*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"systemNames", "[", "]"}]], "Input",
 CellChangeTimes->{{3.437565330502542*^9, 3.43756533317992*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"fifo\"\>", ",", "\<\"ControlcallfifoModule\"\>", 
   ",", "\<\"cellcallfifoModule1\"\>", ",", "\<\"cellcallfifoModule2\"\>", 
   ",", "\<\"cellcallfifoModule3\"\>", ",", "\<\"cellcallfifoModule4\"\>", 
   ",", "\<\"callfifoModule\"\>", ",", "\<\"callfifo\"\>"}], "}"}]], "Output",\

 CellChangeTimes->{3.437565333725565*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"removeSystem", "[", "\"\<fifo\>\"", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.437565389571596*^9, 3.437565411011318*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input",
 CellChangeTimes->{{3.4375655739820642`*^9, 3.4375655759780273`*^9}}],

Cell[BoxData["\<\"system callfifoModule (businXMirr1In : {t,p | 0<=t; \
2<=p<=6} of integer; \\n                       businXMirr2In : {t,p | 0<=t; \
p=1} of integer; \\n                       op1XMirr1In : {t,p | 0<=t; \
2<=p<=6} of boolean; \\n                       op1XMirr2In : {t,p | 0<=t; \
p=1} of boolean; \\n                       op1XMirr3In : {t,p | 0<=t; \
1<=p<=5} of boolean; \\n                       op1XMirr4In : {t,p | 0<=t; \
p=6} of boolean; \\n                       op1XMirr5In : {t,p | 0<=t; p=0} of \
boolean; \\n                       op1XMirr6In : {t,p | 0<=t; 1<=p<=5} of \
boolean; \\n                       op1XMirr7In : {t,p | 0<=t; p=6} of \
boolean; \\n                       op1XMirr8In : {t,p | 0<=t; p=0} of \
boolean; \\n                       op2XMirr1In : {t,p | 0<=t; 2<=p<=6} of \
boolean; \\n                       op2XMirr2In : {t,p | 0<=t; p=1} of \
boolean)\\n       returns        (RoutXfifo1Out : {t,p | 0<=t; 1<=p<=6} of \
integer; \\n                       ToutXfifo1Out : {t,p | 0<=t; 0<=p<=6} of \
boolean);\\nvar\\n  RinXctl1 : {t | 0<=t} of boolean;\\n  TinXctl1 : {t | \
0<=t} of boolean;\\n  TinXctl2 : {t | 0<=t} of boolean;\\n  op2XMirr1 : {t,p \
| 0<=t; 2<=p<=6} of boolean;\\n  op1XMirr7 : {t,p | 0<=t; p=6} of boolean;\\n \
 op1XMirr4 : {t,p | 0<=t; p=6} of boolean;\\n  op1XMirr1 : {t,p | 0<=t; \
2<=p<=6} of boolean;\\n  businXMirr1 : {t,p | 0<=t; 2<=p<=6} of integer;\\n  \
Tin1 : {t,p | 0<=t; p=6} of boolean;\\n  TinReg6 : {t,p | 0<=t; 1<=p<=5} of \
boolean;\\n  TinXctl1XIn : {t,p | 0<=t; p=6} of boolean;\\n  RinXctl1XIn : \
{t,p | 0<=t; 1<=p<=6} of boolean;\\n  RoutXfifo11 : {t,p | 0<=t; p=6} of \
integer;\\n  ToutXfifo11 : {t,p | 0<=t; p=6} of boolean;\\n  op2XMirr2 : {t,p \
| 0<=t; p=1} of boolean;\\n  op1XMirr6 : {t,p | 0<=t; 1<=p<=5} of boolean;\\n \
 op1XMirr3 : {t,p | 0<=t; 1<=p<=5} of boolean;\\n  op1XMirr2 : {t,p | 0<=t; \
p=1} of boolean;\\n  businXMirr2 : {t,p | 0<=t; p=1} of integer;\\n  Tin2 : \
{t,p | 0<=t; p=1} of boolean;\\n  TinReg8 : {t,p | 0<=t; p=0} of boolean;\\n  \
TinReg5 : {t,p | 0<=t; 1<=p<=5} of boolean;\\n  Rin2 : {t,p | 0<=t; p=1} of \
integer;\\n  RinReg2 : {t,p | 0<=t; 2<=p<=6} of integer;\\n  TinXctl2XIn : \
{t,p | 0<=t; 0<=p<=5} of boolean;\\n  RoutXfifo12 : {t,p | 0<=t; p=1} of \
integer;\\n  ToutXfifo12 : {t,p | 0<=t; p=1} of boolean;\\n  Tin3 : {t,p | \
0<=t; 2<=p<=5} of boolean;\\n  TinReg7 : {t,p | 0<=t; p=6} of boolean;\\n  \
Rin3 : {t,p | 0<=t; 2<=p<=5} of integer;\\n  RoutXfifo13 : {t,p | 0<=t; \
2<=p<=5} of integer;\\n  ToutXfifo13 : {t,p | 0<=t; 2<=p<=5} of boolean;\\n  \
op1XMirr8 : {t,p | 0<=t; p=0} of boolean;\\n  op1XMirr5 : {t,p | 0<=t; p=0} \
of boolean;\\n  Tin4 : {t,p | 0<=t; p=0} of boolean;\\n  ToutXfifo14 : {t,p | \
0<=t; p=0} of boolean;\\nlet\\n  businXMirr1[t,p] = businXMirr1In[t,p];\\n  \
businXMirr2[t,p] = businXMirr2In[t,p];\\n  op1XMirr1[t,p] = op1XMirr1In[t,p];\
\\n  op1XMirr2[t,p] = op1XMirr2In[t,p];\\n  op1XMirr3[t,p] = \
op1XMirr3In[t,p];\\n  op1XMirr4[t,p] = op1XMirr4In[t,p];\\n  op1XMirr5[t,p] = \
op1XMirr5In[t,p];\\n  op1XMirr6[t,p] = op1XMirr6In[t,p];\\n  op1XMirr7[t,p] = \
op1XMirr7In[t,p];\\n  op1XMirr8[t,p] = op1XMirr8In[t,p];\\n  op2XMirr1[t,p] = \
op2XMirr1In[t,p];\\n  op2XMirr2[t,p] = op2XMirr2In[t,p];\\n  RinReg2[t,p] = \
\\n      case\\n        { | p=2} : Rin2[t,p-1];\\n        { | 3<=p} : \
Rin3[t,p-1];\\n      esac;\\n  RinXctl1XIn[t,p] = RinXctl1[t];\\n  \
RoutXfifo1Out[t,p] = \\n      case\\n        { | p=6} : RoutXfifo11[t,p];\\n  \
      { | p=1} : RoutXfifo12[t,p];\\n        { | 2<=p<=5} : RoutXfifo13[t,p];\
\\n      esac;\\n  TinReg5[t,p] = \\n      case\\n        { | p=2} : \
Tin2[t,p-1];\\n        { | 3<=p} : Tin3[t,p-1];\\n        { | p=1} : \
Tin4[t,p-1];\\n      esac;\\n  TinReg6[t,p] = \\n      case\\n        { | \
p=5} : Tin1[t,p+1];\\n        { | p<=4} : Tin3[t,p+1];\\n      esac;\\n  \
TinReg7[t,p] = \\n      case\\n        Tin3[t,p-1];\\n      esac;\\n  \
TinReg8[t,p] = \\n      case\\n        Tin2[t,p+1];\\n      esac;\\n  \
TinXctl1XIn[t,p] = TinXctl1[t];\\n  TinXctl2XIn[t,p] = TinXctl2[t];\\n  \
ToutXfifo1Out[t,p] = \\n      case\\n        { | p=6} : ToutXfifo11[t,p];\\n  \
      { | p=1} : ToutXfifo12[t,p];\\n        { | 2<=p<=5} : ToutXfifo13[t,p];\
\\n        { | p=0} : ToutXfifo14[t,p];\\n      esac;\\n  use  \
ControlcallfifoModule[] () returns  (RinXctl1, TinXctl1, TinXctl2) ;\\n  use \
{p | p=6} cellcallfifoModule1[p] (op2XMirr1, op1XMirr7, op1XMirr4, op1XMirr1, \
businXMirr1, TinReg7, RinReg2, TinXctl1XIn, RinXctl1XIn) returns  (Tin1, \
RoutXfifo11, ToutXfifo11) ;\\n  use {p | p=1} cellcallfifoModule2[p] \
(op2XMirr2, op1XMirr6, op1XMirr3, op1XMirr2, businXMirr2, TinReg6, TinReg5, \
TinXctl2XIn, RinXctl1XIn) returns  (Tin2, Rin2, RoutXfifo12, ToutXfifo12) \
;\\n  use {p | 2<=p<=5} cellcallfifoModule3[p] (op2XMirr1, op1XMirr6, \
op1XMirr3, op1XMirr1, businXMirr1, TinReg6, TinReg5, RinReg2, TinXctl2XIn, \
RinXctl1XIn) returns  (Tin3, Rin3, RoutXfifo13, ToutXfifo13) ;\\n  use {p | \
p=0} cellcallfifoModule4[p] (op1XMirr8, op1XMirr5, TinReg8, TinXctl2XIn) \
returns  (Tin4, ToutXfifo14) ;\\ntel;\"\>"], "Print",
 CellChangeTimes->{3.4375655765486917`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "alphaFo*"}]], "Input",
 CellChangeTimes->{{3.437565599501378*^9, 3.4375656039788218`*^9}}],

Cell[BoxData[
 StyleBox["\<\"options of simplifySystem: alphaFormat->Alpha \
(default)\\nsimplify a system to the standard normalized Alpha\\nform. \
alphaFormat->Alpha0 simplify to Alpha0 format,\\nalphaFormat->AlpHard is not \
implemented\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.4375656051872787`*^9},
 CellTags->"Info3437569204-7849676"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"normalize", "[", 
   RowBox[{"alphaFormat", "\[Rule]", "Alpha0"}], "]"}], ";", 
  RowBox[{"ashow", "[", "]"}]}]], "Input",
 CellChangeTimes->{{3.437565591546537*^9, 3.437565638033347*^9}}],

Cell[BoxData["\<\"system callfifoModule (businXMirr1In : {t,p | 0<=t; \
2<=p<=6} of integer; \\n                       businXMirr2In : {t,p | 0<=t; \
p=1} of integer; \\n                       op1XMirr1In : {t,p | 0<=t; \
2<=p<=6} of boolean; \\n                       op1XMirr2In : {t,p | 0<=t; \
p=1} of boolean; \\n                       op1XMirr3In : {t,p | 0<=t; \
1<=p<=5} of boolean; \\n                       op1XMirr4In : {t,p | 0<=t; \
p=6} of boolean; \\n                       op1XMirr5In : {t,p | 0<=t; p=0} of \
boolean; \\n                       op1XMirr6In : {t,p | 0<=t; 1<=p<=5} of \
boolean; \\n                       op1XMirr7In : {t,p | 0<=t; p=6} of \
boolean; \\n                       op1XMirr8In : {t,p | 0<=t; p=0} of \
boolean; \\n                       op2XMirr1In : {t,p | 0<=t; 2<=p<=6} of \
boolean; \\n                       op2XMirr2In : {t,p | 0<=t; p=1} of \
boolean)\\n       returns        (RoutXfifo1Out : {t,p | 0<=t; 1<=p<=6} of \
integer; \\n                       ToutXfifo1Out : {t,p | 0<=t; 0<=p<=6} of \
boolean);\\nvar\\n  RinXctl1 : {t | 0<=t} of boolean;\\n  TinXctl1 : {t | \
0<=t} of boolean;\\n  TinXctl2 : {t | 0<=t} of boolean;\\n  op2XMirr1 : {t,p \
| 0<=t; 2<=p<=6} of boolean;\\n  op1XMirr7 : {t,p | 0<=t; p=6} of boolean;\\n \
 op1XMirr4 : {t,p | 0<=t; p=6} of boolean;\\n  op1XMirr1 : {t,p | 0<=t; \
2<=p<=6} of boolean;\\n  businXMirr1 : {t,p | 0<=t; 2<=p<=6} of integer;\\n  \
Tin1 : {t,p | 0<=t; p=6} of boolean;\\n  TinReg6 : {t,p | 0<=t; 1<=p<=5} of \
boolean;\\n  TinXctl1XIn : {t,p | 0<=t; p=6} of boolean;\\n  RinXctl1XIn : \
{t,p | 0<=t; 1<=p<=6} of boolean;\\n  RoutXfifo11 : {t,p | 0<=t; p=6} of \
integer;\\n  ToutXfifo11 : {t,p | 0<=t; p=6} of boolean;\\n  op2XMirr2 : {t,p \
| 0<=t; p=1} of boolean;\\n  op1XMirr6 : {t,p | 0<=t; 1<=p<=5} of boolean;\\n \
 op1XMirr3 : {t,p | 0<=t; 1<=p<=5} of boolean;\\n  op1XMirr2 : {t,p | 0<=t; \
p=1} of boolean;\\n  businXMirr2 : {t,p | 0<=t; p=1} of integer;\\n  Tin2 : \
{t,p | 0<=t; p=1} of boolean;\\n  TinReg8 : {t,p | 0<=t; p=0} of boolean;\\n  \
TinReg5 : {t,p | 0<=t; 1<=p<=5} of boolean;\\n  Rin2 : {t,p | 0<=t; p=1} of \
integer;\\n  RinReg2 : {t,p | 0<=t; 2<=p<=6} of integer;\\n  TinXctl2XIn : \
{t,p | 0<=t; 0<=p<=5} of boolean;\\n  RoutXfifo12 : {t,p | 0<=t; p=1} of \
integer;\\n  ToutXfifo12 : {t,p | 0<=t; p=1} of boolean;\\n  Tin3 : {t,p | \
0<=t; 2<=p<=5} of boolean;\\n  TinReg7 : {t,p | 0<=t; p=6} of boolean;\\n  \
Rin3 : {t,p | 0<=t; 2<=p<=5} of integer;\\n  RoutXfifo13 : {t,p | 0<=t; \
2<=p<=5} of integer;\\n  ToutXfifo13 : {t,p | 0<=t; 2<=p<=5} of boolean;\\n  \
op1XMirr8 : {t,p | 0<=t; p=0} of boolean;\\n  op1XMirr5 : {t,p | 0<=t; p=0} \
of boolean;\\n  Tin4 : {t,p | 0<=t; p=0} of boolean;\\n  ToutXfifo14 : {t,p | \
0<=t; p=0} of boolean;\\nlet\\n  businXMirr1[t,p] = businXMirr1In[t,p];\\n  \
businXMirr2[t,p] = businXMirr2In[t,p];\\n  op1XMirr1[t,p] = op1XMirr1In[t,p];\
\\n  op1XMirr2[t,p] = op1XMirr2In[t,p];\\n  op1XMirr3[t,p] = \
op1XMirr3In[t,p];\\n  op1XMirr4[t,p] = op1XMirr4In[t,p];\\n  op1XMirr5[t,p] = \
op1XMirr5In[t,p];\\n  op1XMirr6[t,p] = op1XMirr6In[t,p];\\n  op1XMirr7[t,p] = \
op1XMirr7In[t,p];\\n  op1XMirr8[t,p] = op1XMirr8In[t,p];\\n  op2XMirr1[t,p] = \
op2XMirr1In[t,p];\\n  op2XMirr2[t,p] = op2XMirr2In[t,p];\\n  RinReg2[t,p] = \
\\n      case\\n        { | p=2} : Rin2[t,p-1];\\n        { | 3<=p} : \
Rin3[t,p-1];\\n      esac;\\n  RinXctl1XIn[t,p] = RinXctl1[t];\\n  \
RoutXfifo1Out[t,p] = \\n      case\\n        { | p=6} : RoutXfifo11[t,p];\\n  \
      { | p=1} : RoutXfifo12[t,p];\\n        { | 2<=p<=5} : RoutXfifo13[t,p];\
\\n      esac;\\n  TinReg5[t,p] = \\n      case\\n        { | p=2} : \
Tin2[t,p-1];\\n        { | 3<=p} : Tin3[t,p-1];\\n        { | p=1} : \
Tin4[t,p-1];\\n      esac;\\n  TinReg6[t,p] = \\n      case\\n        { | \
p=5} : Tin1[t,p+1];\\n        { | p<=4} : Tin3[t,p+1];\\n      esac;\\n  \
TinReg7[t,p] = Tin3[t,p-1];\\n  TinReg8[t,p] = Tin2[t,p+1];\\n  \
TinXctl1XIn[t,p] = TinXctl1[t];\\n  TinXctl2XIn[t,p] = TinXctl2[t];\\n  \
ToutXfifo1Out[t,p] = \\n      case\\n        { | p=6} : ToutXfifo11[t,p];\\n  \
      { | p=1} : ToutXfifo12[t,p];\\n        { | 2<=p<=5} : ToutXfifo13[t,p];\
\\n        { | p=0} : ToutXfifo14[t,p];\\n      esac;\\n  use  \
ControlcallfifoModule[] () returns  (RinXctl1, TinXctl1, TinXctl2) ;\\n  use \
{p | p=6} cellcallfifoModule1[p] (op2XMirr1, op1XMirr7, op1XMirr4, op1XMirr1, \
businXMirr1, TinReg7, RinReg2, TinXctl1XIn, RinXctl1XIn) returns  (Tin1, \
RoutXfifo11, ToutXfifo11) ;\\n  use {p | p=1} cellcallfifoModule2[p] \
(op2XMirr2, op1XMirr6, op1XMirr3, op1XMirr2, businXMirr2, TinReg6, TinReg5, \
TinXctl2XIn, RinXctl1XIn) returns  (Tin2, Rin2, RoutXfifo12, ToutXfifo12) \
;\\n  use {p | 2<=p<=5} cellcallfifoModule3[p] (op2XMirr1, op1XMirr6, \
op1XMirr3, op1XMirr1, businXMirr1, TinReg6, TinReg5, RinReg2, TinXctl2XIn, \
RinXctl1XIn) returns  (Tin3, Rin3, RoutXfifo13, ToutXfifo13) ;\\n  use {p | \
p=0} cellcallfifoModule4[p] (op1XMirr8, op1XMirr5, TinReg8, TinXctl2XIn) \
returns  (Tin4, ToutXfifo14) ;\\ntel;\"\>"], "Print",
 CellChangeTimes->{3.4375656386544323`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<callfifoModule\>\"", "]"}], ";", 
  RowBox[{"ashow", "[", "]"}]}]], "Input",
 CellChangeTimes->{{3.437565357098853*^9, 3.437565367529303*^9}, {
  3.43756541626582*^9, 3.437565493440031*^9}}],

Cell[BoxData["\<\"system callfifoModule (businXMirr1In : {t,p | 0<=t; \
2<=p<=6} of integer; \\n                       businXMirr2In : {t,p | 0<=t; \
p=1} of integer; \\n                       op1XMirr1In : {t,p | 0<=t; \
2<=p<=6} of boolean; \\n                       op1XMirr2In : {t,p | 0<=t; \
p=1} of boolean; \\n                       op1XMirr3In : {t,p | 0<=t; \
1<=p<=5} of boolean; \\n                       op1XMirr4In : {t,p | 0<=t; \
p=6} of boolean; \\n                       op1XMirr5In : {t,p | 0<=t; p=0} of \
boolean; \\n                       op1XMirr6In : {t,p | 0<=t; 1<=p<=5} of \
boolean; \\n                       op1XMirr7In : {t,p | 0<=t; p=6} of \
boolean; \\n                       op1XMirr8In : {t,p | 0<=t; p=0} of \
boolean; \\n                       op2XMirr1In : {t,p | 0<=t; 2<=p<=6} of \
boolean; \\n                       op2XMirr2In : {t,p | 0<=t; p=1} of \
boolean)\\n       returns        (RoutXfifo1Out : {t,p | 0<=t; 1<=p<=6} of \
integer; \\n                       ToutXfifo1Out : {t,p | 0<=t; 0<=p<=6} of \
boolean);\\nvar\\n  RinXctl1 : {t | 0<=t} of boolean;\\n  TinXctl1 : {t | \
0<=t} of boolean;\\n  TinXctl2 : {t | 0<=t} of boolean;\\n  op2XMirr1 : {t,p \
| 0<=t; 2<=p<=6} of boolean;\\n  op1XMirr7 : {t,p | 0<=t; p=6} of boolean;\\n \
 op1XMirr4 : {t,p | 0<=t; p=6} of boolean;\\n  op1XMirr1 : {t,p | 0<=t; \
2<=p<=6} of boolean;\\n  businXMirr1 : {t,p | 0<=t; 2<=p<=6} of integer;\\n  \
Tin1 : {t,p | 0<=t; p=6} of boolean;\\n  TinReg6 : {t,p | 0<=t; 1<=p<=5} of \
boolean;\\n  TinXctl1XIn : {t,p | 0<=t; p=6} of boolean;\\n  RinXctl1XIn : \
{t,p | 0<=t; 1<=p<=6} of boolean;\\n  RoutXfifo11 : {t,p | 0<=t; p=6} of \
integer;\\n  ToutXfifo11 : {t,p | 0<=t; p=6} of boolean;\\n  op2XMirr2 : {t,p \
| 0<=t; p=1} of boolean;\\n  op1XMirr6 : {t,p | 0<=t; 1<=p<=5} of boolean;\\n \
 op1XMirr3 : {t,p | 0<=t; 1<=p<=5} of boolean;\\n  op1XMirr2 : {t,p | 0<=t; \
p=1} of boolean;\\n  businXMirr2 : {t,p | 0<=t; p=1} of integer;\\n  Tin2 : \
{t,p | 0<=t; p=1} of boolean;\\n  TinReg8 : {t,p | 0<=t; p=0} of boolean;\\n  \
TinReg5 : {t,p | 0<=t; 1<=p<=5} of boolean;\\n  Rin2 : {t,p | 0<=t; p=1} of \
integer;\\n  RinReg2 : {t,p | 0<=t; 2<=p<=6} of integer;\\n  TinXctl2XIn : \
{t,p | 0<=t; 0<=p<=5} of boolean;\\n  RoutXfifo12 : {t,p | 0<=t; p=1} of \
integer;\\n  ToutXfifo12 : {t,p | 0<=t; p=1} of boolean;\\n  Tin3 : {t,p | \
0<=t; 2<=p<=5} of boolean;\\n  TinReg7 : {t,p | 0<=t; p=6} of boolean;\\n  \
Rin3 : {t,p | 0<=t; 2<=p<=5} of integer;\\n  RoutXfifo13 : {t,p | 0<=t; \
2<=p<=5} of integer;\\n  ToutXfifo13 : {t,p | 0<=t; 2<=p<=5} of boolean;\\n  \
op1XMirr8 : {t,p | 0<=t; p=0} of boolean;\\n  op1XMirr5 : {t,p | 0<=t; p=0} \
of boolean;\\n  Tin4 : {t,p | 0<=t; p=0} of boolean;\\n  ToutXfifo14 : {t,p | \
0<=t; p=0} of boolean;\\nlet\\n  businXMirr1[t,p] = businXMirr1In[t,p];\\n  \
businXMirr2[t,p] = businXMirr2In[t,p];\\n  op1XMirr1[t,p] = op1XMirr1In[t,p];\
\\n  op1XMirr2[t,p] = op1XMirr2In[t,p];\\n  op1XMirr3[t,p] = \
op1XMirr3In[t,p];\\n  op1XMirr4[t,p] = op1XMirr4In[t,p];\\n  op1XMirr5[t,p] = \
op1XMirr5In[t,p];\\n  op1XMirr6[t,p] = op1XMirr6In[t,p];\\n  op1XMirr7[t,p] = \
op1XMirr7In[t,p];\\n  op1XMirr8[t,p] = op1XMirr8In[t,p];\\n  op2XMirr1[t,p] = \
op2XMirr1In[t,p];\\n  op2XMirr2[t,p] = op2XMirr2In[t,p];\\n  RinReg2[t,p] = \
\\n      case\\n        { | p=2} : Rin2[t,p-1];\\n        { | 3<=p} : \
Rin3[t,p-1];\\n      esac;\\n  RinXctl1XIn[t,p] = RinXctl1[t];\\n  \
RoutXfifo1Out[t,p] = \\n      case\\n        { | p=6} : RoutXfifo11[t,p];\\n  \
      { | p=1} : RoutXfifo12[t,p];\\n        { | 2<=p<=5} : RoutXfifo13[t,p];\
\\n      esac;\\n  TinReg5[t,p] = \\n      case\\n        { | p=2} : \
Tin2[t,p-1];\\n        { | 3<=p} : Tin3[t,p-1];\\n        { | p=1} : \
Tin4[t,p-1];\\n      esac;\\n  TinReg6[t,p] = \\n      case\\n        { | \
p=5} : Tin1[t,p+1];\\n        { | p<=4} : Tin3[t,p+1];\\n      esac;\\n  \
TinReg7[t,p] = \\n      case\\n        Tin3[t,p-1];\\n      esac;\\n  \
TinReg8[t,p] = \\n      case\\n        Tin2[t,p+1];\\n      esac;\\n  \
TinXctl1XIn[t,p] = TinXctl1[t];\\n  TinXctl2XIn[t,p] = TinXctl2[t];\\n  \
ToutXfifo1Out[t,p] = \\n      case\\n        { | p=6} : ToutXfifo11[t,p];\\n  \
      { | p=1} : ToutXfifo12[t,p];\\n        { | 2<=p<=5} : ToutXfifo13[t,p];\
\\n        { | p=0} : ToutXfifo14[t,p];\\n      esac;\\n  use  \
ControlcallfifoModule[] () returns  (RinXctl1, TinXctl1, TinXctl2) ;\\n  use \
{p | p=6} cellcallfifoModule1[p] (op2XMirr1, op1XMirr7, op1XMirr4, op1XMirr1, \
businXMirr1, TinReg7, RinReg2, TinXctl1XIn, RinXctl1XIn) returns  (Tin1, \
RoutXfifo11, ToutXfifo11) ;\\n  use {p | p=1} cellcallfifoModule2[p] \
(op2XMirr2, op1XMirr6, op1XMirr3, op1XMirr2, businXMirr2, TinReg6, TinReg5, \
TinXctl2XIn, RinXctl1XIn) returns  (Tin2, Rin2, RoutXfifo12, ToutXfifo12) \
;\\n  use {p | 2<=p<=5} cellcallfifoModule3[p] (op2XMirr1, op1XMirr6, \
op1XMirr3, op1XMirr1, businXMirr1, TinReg6, TinReg5, RinReg2, TinXctl2XIn, \
RinXctl1XIn) returns  (Tin3, Rin3, RoutXfifo13, ToutXfifo13) ;\\n  use {p | \
p=0} cellcallfifoModule4[p] (op1XMirr8, op1XMirr5, TinReg8, TinXctl2XIn) \
returns  (Tin4, ToutXfifo14) ;\\ntel;\"\>"], "Print",
 CellChangeTimes->{
  3.437565368101822*^9, {3.437565421779928*^9, 3.437565493929902*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"checkModule", "[", 
  RowBox[{"debug", "\[Rule]", "True"}], "]"}]], "Input",
 CellChangeTimes->{{3.43756552569849*^9, 3.4375655371445837`*^9}}],

Cell[BoxData["\<\"This program seems to be an AlpHard Module...\"\>"], "Print",
 CellChangeTimes->{3.4375655392872553`*^9, 3.437565648081316*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.4375655393536377`*^9, 3.437565648086075*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a2v", "[", "$result", "]"}]], "Input",
 CellChangeTimes->{{3.43756542565949*^9, 3.437565430831229*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Vhdl files will be generated in \"\>", 
   "\[InvisibleSpace]", \
"\<\"/Users/quinton/mmalpha/demos/NOTEBOOKS/Fifo/\"\>"}],
  SequenceForm[
  "Vhdl files will be generated in ", 
   "/Users/quinton/mmalpha/demos/NOTEBOOKS/Fifo/"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.437565431428042*^9, 3.437565497019133*^9}, 
   3.43756565134278*^9}],

Cell[BoxData["\<\"\\nPlease wait...\\n\"\>"], "Print",
 CellChangeTimes->{{3.437565431428042*^9, 3.437565497019133*^9}, 
   3.437565651406542*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"callfifoModule\"\>", 
   "\[InvisibleSpace]", "\<\" was recognized as a Module.\"\>"}],
  SequenceForm["callfifoModule", " was recognized as a Module."],
  Editable->False]], "Print",
 CellChangeTimes->{{3.437565431428042*^9, 3.437565497019133*^9}, 
   3.4375656515408077`*^9}],

Cell[BoxData["\<\"All modules are known...\"\>"], "Print",
 CellChangeTimes->{{3.437565431428042*^9, 3.437565497019133*^9}, 
   3.437565654117075*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1.2727640000000022`", "\[InvisibleSpace]", "\<\" needed to translate \"\>",
    "\[InvisibleSpace]", "\<\"callfifoModule\"\>"}],
  SequenceForm[1.2727640000000022`, " needed to translate ", "callfifoModule"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.437565431428042*^9, 3.437565497019133*^9}, 
   3.437565654171042*^9}],

Cell[BoxData["\<\"End of translation.\"\>"], "Print",
 CellChangeTimes->{{3.437565431428042*^9, 3.437565497019133*^9}, 
   3.437565654236808*^9}]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->None,
WindowToolbars->{"RulerBar", "EditBar"},
WindowSize->{1097, 707},
WindowMargins->{{5, Automatic}, {Automatic, 17}},
DockedCells->FEPrivate`FrontEndResource[
 "FEExpressions", "CompatibilityToolbar"],
PrintingCopies->1,
PrintingPageRange->{1, Automatic},
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (February 18, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "firstcell"->{
  Cell[567, 22, 177, 3, 114, "Title",
   CellTags->"firstcell"]},
 "Summary"->{
  Cell[1629, 63, 79, 2, 53, "Section",
   CellTags->"Summary"],
  Cell[2726, 88, 83, 2, 100, "Section",
   CellTags->"Summary"]},
 "Info3437569204-7849676"->{
  Cell[215287, 5403, 359, 6, 198, "Print",
   CellTags->"Info3437569204-7849676"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"firstcell", 229335, 5659},
 {"Summary", 229415, 5662},
 {"Info3437569204-7849676", 229574, 5667}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 177, 3, 114, "Title",
 CellTags->"firstcell"],
Cell[747, 27, 33, 0, 39, "Subsubtitle"],
Cell[783, 29, 115, 1, 39, "Text"],
Cell[901, 32, 99, 3, 49, "SmallText"],
Cell[CellGroupData[{
Cell[1025, 39, 163, 4, 36, "Subsubsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1213, 47, 189, 5, 58, "Input",
 InitializationCell->True],
Cell[1405, 54, 175, 3, 70, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1629, 63, 79, 2, 53, "Section",
 CellTags->"Summary"],
Cell[1711, 67, 978, 16, 197, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2726, 88, 83, 2, 100, "Section",
 CellTags->"Summary"],
Cell[CellGroupData[{
Cell[2834, 94, 1448, 28, 432, "Input"],
Cell[CellGroupData[{
Cell[4307, 126, 161, 2, 30, "Print"],
Cell[4471, 130, 1757, 23, 1020, "Print"],
Cell[6231, 155, 427, 9, 30, "Print"],
Cell[6661, 166, 201, 3, 30, "Print"],
Cell[6865, 171, 181, 2, 30, "Print"],
Cell[7049, 175, 723, 10, 261, "Print"]
}, Open  ]],
Cell[7787, 188, 361, 7, 32, "Message"],
Cell[CellGroupData[{
Cell[8173, 199, 173, 2, 30, "Print"],
Cell[8349, 203, 199, 3, 54, "Print"],
Cell[8551, 208, 178, 2, 30, "Print"],
Cell[8732, 212, 341, 7, 30, "Print"],
Cell[9076, 221, 601, 13, 54, "Print"],
Cell[9680, 236, 313, 7, 30, "Print"],
Cell[9996, 245, 406, 8, 30, "Print"],
Cell[10405, 255, 595, 12, 54, "Print"],
Cell[11003, 269, 331, 7, 30, "Print"],
Cell[11337, 278, 190, 2, 30, "Print"],
Cell[11530, 282, 164, 2, 30, "Print"]
}, Open  ]],
Cell[11709, 287, 479, 9, 32, "Message"],
Cell[12191, 298, 174, 2, 30, "Print"],
Cell[12368, 302, 476, 9, 32, "Message"],
Cell[12847, 313, 174, 2, 30, "Print"],
Cell[13024, 317, 481, 9, 32, "Message"],
Cell[13508, 328, 713, 12, 32, "Message"],
Cell[CellGroupData[{
Cell[14246, 344, 176, 2, 30, "Print"],
Cell[14425, 348, 2065, 52, 77, "Print"]
}, Open  ]],
Cell[16505, 403, 326, 7, 32, "Message"],
Cell[16834, 412, 714, 13, 32, "Message"],
Cell[17551, 427, 321, 7, 32, "Message"],
Cell[CellGroupData[{
Cell[17897, 438, 174, 2, 30, "Print"],
Cell[18074, 442, 174, 2, 30, "Print"],
Cell[18251, 446, 178, 2, 30, "Print"],
Cell[18432, 450, 2067, 52, 77, "Print"]
}, Open  ]],
Cell[20514, 505, 328, 7, 32, "Message"],
Cell[20845, 514, 714, 13, 32, "Message"],
Cell[21562, 529, 319, 7, 32, "Message"],
Cell[CellGroupData[{
Cell[21906, 540, 174, 2, 30, "Print"],
Cell[22083, 544, 174, 2, 30, "Print"],
Cell[22260, 548, 2047, 52, 77, "Print"]
}, Open  ]],
Cell[24322, 603, 328, 7, 32, "Message"],
Cell[24653, 612, 712, 12, 32, "Message"],
Cell[25368, 626, 714, 13, 32, "Message"],
Cell[26085, 641, 700, 12, 32, "Message"],
Cell[26788, 655, 321, 7, 32, "Message"],
Cell[27112, 664, 707, 12, 32, "Message"],
Cell[CellGroupData[{
Cell[27844, 680, 174, 2, 30, "Print"],
Cell[28021, 684, 174, 2, 30, "Print"],
Cell[28198, 688, 2047, 52, 77, "Print"],
Cell[30248, 742, 174, 2, 30, "Print"],
Cell[30425, 746, 174, 2, 30, "Print"],
Cell[30602, 750, 2047, 52, 77, "Print"]
}, Open  ]],
Cell[32664, 805, 362, 7, 32, "Message"],
Cell[33029, 814, 342, 7, 32, "Message"],
Cell[33374, 823, 342, 7, 32, "Message"],
Cell[33719, 832, 368, 8, 32, "Message"],
Cell[34090, 842, 143, 2, 30, "Print"],
Cell[34236, 846, 375, 8, 55, "Message"],
Cell[CellGroupData[{
Cell[34636, 858, 599, 12, 77, "Print"],
Cell[35238, 872, 423, 8, 30, "Print"],
Cell[35664, 882, 434, 10, 30, "Print"],
Cell[36101, 894, 165, 2, 77, "Print"],
Cell[36269, 898, 331, 7, 30, "Print"]
}, Open  ]],
Cell[36615, 908, 489, 9, 30, "Message"],
Cell[37107, 919, 1322, 22, 80, "Message"],
Cell[38432, 943, 1408, 23, 102, "Message"],
Cell[39843, 968, 413, 8, 55, "Message"],
Cell[40259, 978, 413, 8, 55, "Message"],
Cell[40675, 988, 415, 8, 55, "Message"],
Cell[41093, 998, 702, 12, 32, "Message"],
Cell[CellGroupData[{
Cell[41820, 1014, 174, 2, 30, "Print"],
Cell[41997, 1018, 193, 3, 30, "Print"],
Cell[42193, 1023, 171, 3, 30, "Print"],
Cell[42367, 1028, 201, 3, 30, "Print"]
}, Open  ]],
Cell[42583, 1034, 414, 8, 32, "Message"],
Cell[CellGroupData[{
Cell[43022, 1046, 539, 11, 54, "Print"],
Cell[43564, 1059, 390, 9, 30, "Print"],
Cell[43957, 1070, 164, 2, 30, "Print"]
}, Open  ]],
Cell[44136, 1075, 229, 5, 40, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[44402, 1085, 57, 1, 40, "Input"],
Cell[44462, 1088, 2048, 39, 341, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[46547, 1132, 93, 2, 40, "Input"],
Cell[CellGroupData[{
Cell[46665, 1138, 44, 0, 30, "Print"],
Cell[46712, 1140, 49, 0, 30, "Print"]
}, Open  ]]
}, Open  ]],
Cell[46788, 1144, 54, 1, 40, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[46879, 1150, 26, 0, 100, "Section"],
Cell[CellGroupData[{
Cell[46930, 1154, 125, 3, 40, "Input"],
Cell[CellGroupData[{
Cell[47080, 1161, 159, 2, 30, "Print"],
Cell[47242, 1165, 1105, 14, 675, "Print"]
}, Open  ]]
}, Open  ]],
Cell[48374, 1183, 244, 5, 40, "Input"],
Cell[CellGroupData[{
Cell[48643, 1192, 249, 5, 40, "Input"],
Cell[CellGroupData[{
Cell[48917, 1201, 359, 7, 30, "Print"],
Cell[49279, 1210, 296, 6, 30, "Print"],
Cell[49578, 1218, 360, 7, 30, "Print"],
Cell[49941, 1227, 298, 6, 30, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[50288, 1239, 118, 2, 40, "Input"],
Cell[50409, 1243, 1283, 17, 790, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[51729, 1265, 55, 1, 40, "Input"],
Cell[CellGroupData[{
Cell[51809, 1270, 123, 2, 30, "Print"],
Cell[51935, 1274, 305, 7, 30, "Print"],
Cell[52243, 1283, 161, 2, 30, "Print"],
Cell[52407, 1287, 157, 2, 30, "Print"],
Cell[52567, 1291, 174, 3, 30, "Print"],
Cell[52744, 1296, 164, 2, 30, "Print"],
Cell[52911, 1300, 172, 3, 30, "Print"],
Cell[53086, 1305, 181, 3, 30, "Print"],
Cell[53270, 1310, 304, 7, 30, "Print"],
Cell[53577, 1319, 289, 7, 30, "Print"],
Cell[53869, 1328, 291, 7, 30, "Print"],
Cell[54163, 1337, 289, 7, 30, "Print"],
Cell[54455, 1346, 289, 7, 30, "Print"],
Cell[54747, 1355, 295, 7, 30, "Print"],
Cell[55045, 1364, 289, 7, 30, "Print"],
Cell[55337, 1373, 291, 7, 30, "Print"],
Cell[55631, 1382, 164, 2, 30, "Print"],
Cell[55798, 1386, 157, 2, 30, "Print"],
Cell[55958, 1390, 150, 2, 54, "Print"]
}, Open  ]],
Cell[56123, 1395, 120, 2, 40, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[56292, 1403, 34, 0, 100, "Section"],
Cell[CellGroupData[{
Cell[56351, 1407, 98, 2, 40, "Input"],
Cell[CellGroupData[{
Cell[56474, 1413, 332, 7, 30, "Print"],
Cell[56809, 1422, 101, 1, 30, "Print"],
Cell[56913, 1425, 274, 6, 30, "Print"],
Cell[57190, 1433, 136, 1, 30, "Print"],
Cell[57329, 1436, 136, 1, 30, "Print"],
Cell[57468, 1439, 151, 2, 30, "Print"],
Cell[57622, 1443, 143, 1, 30, "Print"],
Cell[57768, 1446, 151, 2, 30, "Print"],
Cell[57922, 1450, 158, 2, 30, "Print"],
Cell[58083, 1454, 268, 6, 30, "Print"],
Cell[58354, 1462, 266, 6, 30, "Print"],
Cell[58623, 1470, 143, 1, 30, "Print"],
Cell[58769, 1473, 165, 2, 30, "Print"],
Cell[58937, 1477, 127, 1, 54, "Print"],
Cell[59067, 1480, 101, 1, 30, "Print"],
Cell[59171, 1483, 282, 6, 30, "Print"],
Cell[59456, 1491, 136, 1, 30, "Print"],
Cell[59595, 1494, 136, 1, 30, "Print"],
Cell[59734, 1497, 153, 2, 30, "Print"],
Cell[59890, 1501, 141, 1, 30, "Print"],
Cell[60034, 1504, 149, 2, 30, "Print"],
Cell[60186, 1508, 158, 2, 30, "Print"],
Cell[60347, 1512, 281, 6, 30, "Print"],
Cell[60631, 1520, 266, 6, 30, "Print"],
Cell[60900, 1528, 266, 6, 30, "Print"],
Cell[61169, 1536, 266, 6, 30, "Print"],
Cell[61438, 1544, 264, 6, 30, "Print"],
Cell[61705, 1552, 274, 6, 30, "Print"],
Cell[61982, 1560, 268, 6, 30, "Print"],
Cell[62253, 1568, 268, 6, 30, "Print"],
Cell[62524, 1576, 140, 1, 30, "Print"],
Cell[62667, 1579, 134, 1, 30, "Print"],
Cell[62804, 1582, 125, 1, 54, "Print"],
Cell[62932, 1585, 133, 1, 54, "Print"]
}, Open  ]],
Cell[63080, 1589, 97, 1, 40, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[63226, 1596, 25, 0, 100, "Section"],
Cell[CellGroupData[{
Cell[63276, 1600, 93, 2, 40, "Input"],
Cell[63372, 1604, 92, 1, 30, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[63501, 1610, 107, 3, 40, "Input"],
Cell[63611, 1615, 2166, 29, 1319, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[65814, 1649, 55, 1, 40, "Input"],
Cell[CellGroupData[{
Cell[65894, 1654, 126, 2, 30, "Print"],
Cell[66023, 1658, 305, 7, 30, "Print"],
Cell[66331, 1667, 159, 2, 30, "Print"],
Cell[66493, 1671, 156, 2, 30, "Print"],
Cell[66652, 1675, 174, 3, 30, "Print"],
Cell[66829, 1680, 164, 2, 30, "Print"],
Cell[66996, 1684, 172, 3, 30, "Print"],
Cell[67171, 1689, 181, 3, 30, "Print"],
Cell[67355, 1694, 301, 7, 30, "Print"],
Cell[67659, 1703, 299, 7, 30, "Print"],
Cell[67961, 1712, 303, 7, 30, "Print"],
Cell[68267, 1721, 299, 7, 30, "Print"],
Cell[68569, 1730, 301, 7, 30, "Print"],
Cell[68873, 1739, 303, 7, 30, "Print"],
Cell[69179, 1748, 301, 7, 30, "Print"],
Cell[69483, 1757, 289, 7, 30, "Print"],
Cell[69775, 1766, 289, 7, 30, "Print"],
Cell[70067, 1775, 287, 7, 30, "Print"],
Cell[70357, 1784, 289, 7, 30, "Print"],
Cell[70649, 1793, 294, 7, 30, "Print"],
Cell[70946, 1802, 289, 7, 30, "Print"],
Cell[71238, 1811, 293, 7, 30, "Print"],
Cell[71534, 1820, 164, 2, 30, "Print"],
Cell[71701, 1824, 157, 2, 30, "Print"],
Cell[71861, 1828, 150, 2, 54, "Print"]
}, Open  ]],
Cell[72026, 1833, 119, 2, 40, "Output"]
}, Open  ]],
Cell[72160, 1838, 121, 3, 40, "Input"],
Cell[CellGroupData[{
Cell[72306, 1845, 112, 3, 40, "Input"],
Cell[72421, 1850, 1957, 26, 1066, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[74415, 1881, 117, 3, 40, "Input"],
Cell[74535, 1886, 1733, 23, 1020, "Print"]
}, Open  ]],
Cell[76283, 1912, 100, 2, 40, "Input"],
Cell[CellGroupData[{
Cell[76408, 1918, 212, 4, 40, "Input"],
Cell[76623, 1924, 1710, 22, 1020, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[78370, 1951, 214, 4, 40, "Input"],
Cell[78587, 1957, 1712, 22, 1020, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[80336, 1984, 205, 4, 40, "Input"],
Cell[80544, 1990, 1712, 22, 1020, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[82293, 2017, 207, 4, 40, "Input"],
Cell[82503, 2023, 1710, 22, 1020, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[84250, 2050, 121, 2, 40, "Input"],
Cell[84374, 2054, 1710, 22, 1020, "Print"]
}, Open  ]],
Cell[86099, 2079, 170, 4, 40, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[86306, 2088, 27, 0, 100, "Section"],
Cell[CellGroupData[{
Cell[86358, 2092, 55, 1, 40, "Input"],
Cell[CellGroupData[{
Cell[86438, 2097, 99, 1, 30, "Print"],
Cell[86540, 2100, 280, 6, 30, "Print"],
Cell[86823, 2108, 134, 1, 30, "Print"],
Cell[86960, 2111, 132, 1, 30, "Print"],
Cell[87095, 2114, 149, 2, 30, "Print"],
Cell[87247, 2118, 139, 1, 30, "Print"],
Cell[87389, 2121, 146, 2, 30, "Print"],
Cell[87538, 2125, 158, 2, 30, "Print"],
Cell[87699, 2129, 276, 6, 30, "Print"],
Cell[87978, 2137, 278, 6, 30, "Print"],
Cell[88259, 2145, 264, 6, 30, "Print"],
Cell[88526, 2153, 264, 6, 30, "Print"],
Cell[88793, 2161, 270, 6, 30, "Print"],
Cell[89066, 2169, 266, 6, 30, "Print"],
Cell[89335, 2177, 264, 6, 30, "Print"],
Cell[89602, 2185, 141, 1, 30, "Print"],
Cell[89746, 2188, 132, 1, 30, "Print"],
Cell[89881, 2191, 125, 1, 54, "Print"]
}, Open  ]],
Cell[90021, 2195, 97, 1, 40, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[90155, 2201, 99, 2, 40, "Input"],
Cell[90257, 2205, 156, 2, 30, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[90450, 2212, 121, 2, 40, "Input"],
Cell[90574, 2216, 1737, 23, 1020, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[92348, 2244, 148, 3, 40, "Input"],
Cell[92499, 2249, 2219, 34, 767, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[94755, 2288, 1015, 21, 110, "Input"],
Cell[95773, 2311, 1019, 18, 56, "Message"],
Cell[96795, 2331, 1027, 18, 56, "Message"],
Cell[97825, 2351, 1014, 17, 56, "Message"],
Cell[98842, 2370, 1019, 18, 56, "Message"],
Cell[CellGroupData[{
Cell[99886, 2392, 93, 1, 30, "Print"],
Cell[99982, 2395, 378, 8, 30, "Print"],
Cell[100363, 2405, 221, 5, 30, "Print"]
}, Open  ]],
Cell[100599, 2413, 3239, 92, 156, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[103875, 2510, 63, 1, 40, "Input"],
Cell[103941, 2513, 503, 7, 248, "Print"]
}, Open  ]],
Cell[104459, 2523, 142, 3, 40, "Input"],
Cell[CellGroupData[{
Cell[104626, 2530, 119, 2, 40, "Input"],
Cell[104748, 2534, 1735, 22, 1020, "Print"]
}, Open  ]],
Cell[106498, 2559, 99, 2, 40, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[106634, 2566, 37, 0, 100, "Section"],
Cell[CellGroupData[{
Cell[106696, 2570, 98, 2, 40, "Input"],
Cell[106797, 2574, 86, 1, 30, "Print"]
}, Open  ]],
Cell[106898, 2578, 74, 2, 40, "Input"],
Cell[CellGroupData[{
Cell[106997, 2584, 53, 1, 40, "Input"],
Cell[107053, 2587, 1688, 22, 1530, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[108778, 2614, 55, 1, 29, "Input"],
Cell[CellGroupData[{
Cell[108858, 2619, 35, 0, 45, "Print"],
Cell[108896, 2621, 216, 5, 45, "Print"],
Cell[109115, 2628, 70, 0, 45, "Print"],
Cell[109188, 2630, 68, 0, 45, "Print"],
Cell[109259, 2632, 85, 1, 45, "Print"],
Cell[109347, 2635, 75, 0, 45, "Print"],
Cell[109425, 2637, 83, 1, 45, "Print"],
Cell[109511, 2640, 92, 1, 45, "Print"],
Cell[109606, 2643, 212, 5, 45, "Print"],
Cell[109821, 2650, 212, 5, 45, "Print"],
Cell[110036, 2657, 198, 5, 45, "Print"],
Cell[110237, 2664, 198, 5, 45, "Print"],
Cell[110438, 2671, 206, 5, 45, "Print"],
Cell[110647, 2678, 200, 5, 45, "Print"],
Cell[110850, 2685, 202, 5, 45, "Print"],
Cell[111055, 2692, 75, 0, 45, "Print"],
Cell[111133, 2694, 68, 0, 45, "Print"],
Cell[111204, 2696, 59, 0, 81, "Print"]
}, Open  ]],
Cell[111278, 2699, 31, 0, 60, "Output"]
}, Closed]],
Cell[111324, 2702, 80, 2, 29, "Input"],
Cell[CellGroupData[{
Cell[111429, 2708, 53, 1, 40, "Input"],
Cell[111485, 2711, 1702, 22, 1530, "Print"]
}, Closed]],
Cell[113202, 2736, 102, 2, 29, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[113341, 2743, 52, 0, 100, "Section"],
Cell[CellGroupData[{
Cell[113418, 2747, 101, 2, 60, "Input"],
Cell[CellGroupData[{
Cell[113544, 2753, 44, 0, 45, "Print"],
Cell[113591, 2755, 49, 0, 45, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[113689, 2761, 56, 1, 60, "Input"],
Cell[CellGroupData[{
Cell[113770, 2766, 857, 16, 184, "Print"],
Cell[114630, 2784, 867, 16, 184, "Print"],
Cell[115500, 2802, 869, 16, 184, "Print"],
Cell[116372, 2820, 53, 0, 51, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[116474, 2826, 53, 1, 58, "Input"],
Cell[116530, 2829, 2347, 30, 2247, "Print"]
}, Open  ]],
Cell[118892, 2862, 98, 2, 58, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[119027, 2869, 40, 0, 53, "Section"],
Cell[119070, 2871, 97, 2, 40, "Input"],
Cell[119170, 2875, 53, 1, 40, "Input"],
Cell[CellGroupData[{
Cell[119248, 2880, 76, 2, 40, "Input"],
Cell[CellGroupData[{
Cell[119349, 2886, 358, 8, 30, "Print"],
Cell[119710, 2896, 134, 2, 30, "Print"],
Cell[119847, 2900, 112, 1, 30, "Print"],
Cell[119962, 2903, 110, 1, 30, "Print"],
Cell[120075, 2906, 115, 1, 30, "Print"],
Cell[120193, 2909, 258, 6, 30, "Print"],
Cell[120454, 2917, 258, 6, 30, "Print"],
Cell[120715, 2925, 258, 6, 30, "Print"],
Cell[120976, 2933, 130, 2, 30, "Print"],
Cell[121109, 2937, 395, 8, 30, "Print"],
Cell[121507, 2947, 397, 9, 30, "Print"],
Cell[121907, 2958, 392, 8, 30, "Print"],
Cell[122302, 2968, 393, 8, 30, "Print"],
Cell[122698, 2978, 397, 9, 30, "Print"],
Cell[123098, 2989, 397, 9, 30, "Print"],
Cell[123498, 3000, 397, 9, 30, "Print"],
Cell[123898, 3011, 397, 9, 30, "Print"],
Cell[124298, 3022, 116, 1, 30, "Print"],
Cell[124417, 3025, 116, 1, 30, "Print"],
Cell[124536, 3028, 224, 5, 30, "Print"],
Cell[124763, 3035, 224, 5, 30, "Print"],
Cell[124990, 3042, 224, 5, 45, "Print"],
Cell[125217, 3049, 224, 5, 45, "Print"],
Cell[125444, 3056, 224, 5, 45, "Print"],
Cell[125671, 3063, 224, 5, 45, "Print"],
Cell[125898, 3070, 226, 5, 45, "Print"],
Cell[126127, 3077, 226, 5, 45, "Print"],
Cell[126356, 3084, 226, 5, 45, "Print"],
Cell[126585, 3091, 226, 5, 45, "Print"],
Cell[126814, 3098, 116, 1, 45, "Print"],
Cell[126933, 3101, 272, 6, 45, "Print"],
Cell[127208, 3109, 270, 6, 45, "Print"],
Cell[127481, 3117, 266, 6, 45, "Print"],
Cell[127750, 3125, 266, 6, 45, "Print"],
Cell[128019, 3133, 266, 6, 45, "Print"],
Cell[128288, 3141, 266, 6, 45, "Print"],
Cell[128557, 3149, 266, 6, 45, "Print"],
Cell[128826, 3157, 268, 6, 45, "Print"],
Cell[129097, 3165, 265, 6, 45, "Print"],
Cell[129365, 3173, 266, 6, 45, "Print"],
Cell[129634, 3181, 266, 6, 45, "Print"],
Cell[129903, 3189, 265, 6, 45, "Print"],
Cell[130171, 3197, 92, 1, 45, "Print"]
}, Open  ]]
}, Open  ]],
Cell[130290, 3202, 130, 3, 60, "Input"],
Cell[130423, 3207, 94, 2, 60, "Input"],
Cell[CellGroupData[{
Cell[130542, 3213, 121, 2, 60, "Input"],
Cell[130666, 3217, 5531, 72, 5221, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[136246, 3295, 39, 0, 150, "Section"],
Cell[CellGroupData[{
Cell[136310, 3299, 93, 2, 60, "Input"],
Cell[CellGroupData[{
Cell[136428, 3305, 44, 0, 45, "Print"],
Cell[136475, 3307, 49, 0, 45, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[136573, 3313, 53, 1, 60, "Input"],
Cell[136629, 3316, 5795, 75, 5428, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[142461, 3396, 194, 5, 43, "Input"],
Cell[CellGroupData[{
Cell[142680, 3405, 108, 1, 45, "Print"],
Cell[142791, 3408, 272, 6, 45, "Print"],
Cell[143066, 3416, 536, 12, 81, "Print"],
Cell[143605, 3430, 820, 16, 115, "Print"],
Cell[144428, 3448, 337, 7, 45, "Print"],
Cell[144768, 3457, 525, 11, 81, "Print"],
Cell[145296, 3470, 262, 6, 45, "Print"],
Cell[145561, 3478, 119, 1, 45, "Print"],
Cell[145683, 3481, 93, 1, 45, "Print"],
Cell[145779, 3484, 312, 7, 45, "Print"],
Cell[146094, 3493, 112, 1, 45, "Print"],
Cell[146209, 3496, 346, 8, 45, "Print"],
Cell[146558, 3506, 242, 6, 45, "Print"],
Cell[146803, 3514, 240, 6, 45, "Print"],
Cell[147046, 3522, 242, 6, 45, "Print"],
Cell[147291, 3530, 238, 6, 45, "Print"],
Cell[147532, 3538, 104, 1, 45, "Print"],
Cell[147639, 3541, 375, 8, 45, "Print"],
Cell[148017, 3551, 260, 6, 45, "Print"],
Cell[148280, 3559, 625, 14, 81, "Print"],
Cell[148908, 3575, 355, 8, 45, "Print"],
Cell[149266, 3585, 658, 13, 115, "Print"],
Cell[149927, 3600, 373, 8, 45, "Print"],
Cell[150303, 3610, 262, 6, 45, "Print"],
Cell[150568, 3618, 623, 14, 81, "Print"],
Cell[151194, 3634, 389, 9, 45, "Print"],
Cell[151586, 3645, 373, 8, 45, "Print"],
Cell[151962, 3655, 262, 6, 45, "Print"],
Cell[152227, 3663, 658, 14, 81, "Print"],
Cell[152888, 3679, 389, 9, 45, "Print"],
Cell[153280, 3690, 373, 8, 45, "Print"],
Cell[153656, 3700, 262, 6, 45, "Print"],
Cell[153921, 3708, 395, 9, 45, "Print"],
Cell[154319, 3719, 308, 7, 45, "Print"],
Cell[154630, 3728, 140, 2, 45, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[154819, 3736, 98, 2, 60, "Input"],
Cell[CellGroupData[{
Cell[154942, 3742, 662, 14, 81, "Print"],
Cell[155607, 3758, 79, 1, 45, "Print"],
Cell[155689, 3761, 270, 6, 45, "Print"],
Cell[155962, 3769, 114, 1, 45, "Print"],
Cell[156079, 3772, 110, 1, 45, "Print"],
Cell[156192, 3775, 126, 2, 45, "Print"],
Cell[156321, 3779, 117, 1, 45, "Print"],
Cell[156441, 3782, 125, 2, 45, "Print"],
Cell[156569, 3786, 134, 2, 45, "Print"],
Cell[156706, 3790, 256, 6, 45, "Print"],
Cell[156965, 3798, 256, 6, 45, "Print"],
Cell[157224, 3806, 251, 6, 45, "Print"],
Cell[157478, 3814, 252, 6, 45, "Print"],
Cell[157733, 3822, 252, 6, 45, "Print"],
Cell[157988, 3830, 251, 6, 45, "Print"],
Cell[158242, 3838, 252, 6, 45, "Print"],
Cell[158497, 3846, 252, 6, 45, "Print"],
Cell[158752, 3854, 252, 6, 45, "Print"],
Cell[159007, 3862, 252, 6, 45, "Print"],
Cell[159262, 3870, 252, 6, 45, "Print"],
Cell[159517, 3878, 252, 6, 45, "Print"],
Cell[159772, 3886, 250, 6, 45, "Print"],
Cell[160025, 3894, 256, 6, 45, "Print"],
Cell[160284, 3902, 262, 6, 45, "Print"],
Cell[160549, 3910, 247, 6, 45, "Print"],
Cell[160799, 3918, 250, 6, 45, "Print"],
Cell[161052, 3926, 248, 6, 45, "Print"],
Cell[161303, 3934, 250, 6, 45, "Print"],
Cell[161556, 3942, 254, 6, 45, "Print"],
Cell[161813, 3950, 258, 6, 45, "Print"],
Cell[162074, 3958, 262, 6, 45, "Print"],
Cell[162339, 3966, 295, 7, 45, "Print"],
Cell[162637, 3975, 293, 7, 45, "Print"],
Cell[162933, 3984, 293, 7, 45, "Print"],
Cell[163229, 3993, 293, 7, 45, "Print"],
Cell[163525, 4002, 288, 7, 45, "Print"],
Cell[163816, 4011, 117, 1, 45, "Print"],
Cell[163936, 4014, 141, 2, 45, "Print"],
Cell[164080, 4018, 101, 1, 81, "Print"],
Cell[164184, 4021, 76, 1, 45, "Print"],
Cell[164263, 4024, 280, 6, 45, "Print"],
Cell[164546, 4032, 112, 1, 45, "Print"],
Cell[164661, 4035, 110, 1, 45, "Print"],
Cell[164774, 4038, 127, 2, 45, "Print"],
Cell[164904, 4042, 119, 1, 45, "Print"],
Cell[165026, 4045, 125, 2, 45, "Print"],
Cell[165154, 4049, 134, 2, 45, "Print"],
Cell[165291, 4053, 256, 6, 45, "Print"],
Cell[165550, 4061, 254, 6, 45, "Print"],
Cell[165807, 4069, 240, 6, 45, "Print"],
Cell[166050, 4077, 262, 6, 45, "Print"],
Cell[166315, 4085, 262, 6, 45, "Print"],
Cell[166580, 4093, 244, 6, 45, "Print"],
Cell[166827, 4101, 244, 6, 45, "Print"],
Cell[167074, 4109, 262, 6, 45, "Print"],
Cell[167339, 4117, 246, 6, 45, "Print"],
Cell[167588, 4125, 244, 6, 45, "Print"],
Cell[167835, 4133, 260, 6, 45, "Print"],
Cell[168098, 4141, 240, 6, 45, "Print"],
Cell[168341, 4149, 248, 6, 45, "Print"],
Cell[168592, 4157, 117, 1, 45, "Print"],
Cell[168712, 4160, 110, 1, 45, "Print"],
Cell[168825, 4163, 103, 1, 81, "Print"],
Cell[168931, 4166, 77, 1, 45, "Print"],
Cell[169011, 4169, 282, 6, 45, "Print"],
Cell[169296, 4177, 112, 1, 45, "Print"],
Cell[169411, 4180, 109, 1, 45, "Print"],
Cell[169523, 4183, 127, 2, 45, "Print"],
Cell[169653, 4187, 117, 1, 45, "Print"],
Cell[169773, 4190, 125, 2, 45, "Print"],
Cell[169901, 4194, 136, 2, 45, "Print"],
Cell[170040, 4198, 254, 6, 45, "Print"],
Cell[170297, 4206, 254, 6, 45, "Print"],
Cell[170554, 4214, 240, 6, 45, "Print"],
Cell[170797, 4222, 242, 6, 45, "Print"],
Cell[171042, 4230, 262, 6, 45, "Print"],
Cell[171307, 4238, 264, 6, 45, "Print"],
Cell[171574, 4246, 246, 6, 45, "Print"],
Cell[171823, 4254, 246, 6, 45, "Print"],
Cell[172072, 4262, 262, 6, 45, "Print"],
Cell[172337, 4270, 242, 6, 45, "Print"],
Cell[172582, 4278, 244, 6, 45, "Print"],
Cell[172829, 4286, 264, 6, 45, "Print"],
Cell[173096, 4294, 248, 6, 45, "Print"],
Cell[173347, 4302, 248, 6, 45, "Print"],
Cell[173598, 4310, 117, 1, 45, "Print"],
Cell[173718, 4313, 110, 1, 45, "Print"],
Cell[173831, 4316, 101, 1, 81, "Print"],
Cell[173935, 4319, 77, 1, 45, "Print"],
Cell[174015, 4322, 280, 6, 45, "Print"],
Cell[174298, 4330, 112, 1, 45, "Print"],
Cell[174413, 4333, 112, 1, 45, "Print"],
Cell[174528, 4336, 127, 2, 45, "Print"],
Cell[174658, 4340, 119, 1, 45, "Print"],
Cell[174780, 4343, 125, 2, 45, "Print"],
Cell[174908, 4347, 134, 2, 45, "Print"],
Cell[175045, 4351, 254, 6, 45, "Print"],
Cell[175302, 4359, 254, 6, 45, "Print"],
Cell[175559, 4367, 240, 6, 45, "Print"],
Cell[175802, 4375, 242, 6, 45, "Print"],
Cell[176047, 4383, 262, 6, 45, "Print"],
Cell[176312, 4391, 264, 6, 45, "Print"],
Cell[176579, 4399, 246, 6, 45, "Print"],
Cell[176828, 4407, 244, 6, 45, "Print"],
Cell[177075, 4415, 262, 6, 45, "Print"],
Cell[177340, 4423, 244, 6, 45, "Print"],
Cell[177587, 4431, 244, 6, 45, "Print"],
Cell[177834, 4439, 261, 6, 45, "Print"],
Cell[178098, 4447, 247, 6, 45, "Print"],
Cell[178348, 4455, 248, 6, 45, "Print"],
Cell[178599, 4463, 117, 1, 45, "Print"],
Cell[178719, 4466, 110, 1, 45, "Print"],
Cell[178832, 4469, 101, 1, 81, "Print"],
Cell[178936, 4472, 77, 1, 45, "Print"],
Cell[179016, 4475, 280, 6, 45, "Print"],
Cell[179299, 4483, 112, 1, 45, "Print"],
Cell[179414, 4486, 110, 1, 45, "Print"],
Cell[179527, 4489, 127, 2, 45, "Print"],
Cell[179657, 4493, 117, 1, 45, "Print"],
Cell[179777, 4496, 125, 2, 45, "Print"],
Cell[179905, 4500, 133, 2, 45, "Print"],
Cell[180041, 4504, 254, 6, 45, "Print"],
Cell[180298, 4512, 242, 6, 45, "Print"],
Cell[180543, 4520, 264, 6, 45, "Print"],
Cell[180810, 4528, 248, 6, 45, "Print"],
Cell[181061, 4536, 244, 6, 45, "Print"],
Cell[181308, 4544, 264, 6, 45, "Print"],
Cell[181575, 4552, 248, 6, 45, "Print"],
Cell[181826, 4560, 119, 1, 45, "Print"],
Cell[181948, 4563, 109, 1, 45, "Print"],
Cell[182060, 4566, 100, 1, 81, "Print"],
Cell[182163, 4569, 77, 1, 45, "Print"],
Cell[182243, 4572, 284, 6, 45, "Print"],
Cell[182530, 4580, 112, 1, 45, "Print"],
Cell[182645, 4583, 112, 1, 45, "Print"],
Cell[182760, 4586, 127, 2, 45, "Print"],
Cell[182890, 4590, 117, 1, 45, "Print"],
Cell[183010, 4593, 125, 2, 45, "Print"],
Cell[183138, 4597, 134, 2, 45, "Print"],
Cell[183275, 4601, 250, 6, 45, "Print"],
Cell[183528, 4609, 250, 6, 45, "Print"],
Cell[183781, 4617, 250, 6, 45, "Print"],
Cell[184034, 4625, 117, 1, 45, "Print"],
Cell[184154, 4628, 141, 2, 45, "Print"],
Cell[184298, 4632, 101, 1, 81, "Print"],
Cell[184402, 4635, 77, 1, 45, "Print"],
Cell[184482, 4638, 258, 6, 45, "Print"],
Cell[184743, 4646, 112, 1, 45, "Print"],
Cell[184858, 4649, 110, 1, 45, "Print"],
Cell[184971, 4652, 129, 2, 45, "Print"],
Cell[185103, 4656, 117, 1, 45, "Print"],
Cell[185223, 4659, 125, 2, 45, "Print"],
Cell[185351, 4663, 136, 2, 45, "Print"],
Cell[185490, 4667, 252, 6, 45, "Print"],
Cell[185745, 4675, 252, 6, 45, "Print"],
Cell[186000, 4683, 252, 6, 45, "Print"],
Cell[186255, 4691, 254, 6, 45, "Print"],
Cell[186512, 4699, 252, 6, 45, "Print"],
Cell[186767, 4707, 254, 6, 45, "Print"],
Cell[187024, 4715, 252, 6, 45, "Print"],
Cell[187279, 4723, 254, 6, 45, "Print"],
Cell[187536, 4731, 252, 6, 45, "Print"],
Cell[187791, 4739, 254, 6, 45, "Print"],
Cell[188048, 4747, 256, 6, 45, "Print"],
Cell[188307, 4755, 256, 6, 45, "Print"],
Cell[188566, 4763, 248, 6, 45, "Print"],
Cell[188817, 4771, 244, 6, 45, "Print"],
Cell[189064, 4779, 246, 6, 45, "Print"],
Cell[189313, 4787, 276, 6, 45, "Print"],
Cell[189592, 4795, 117, 1, 45, "Print"],
Cell[189712, 4798, 110, 1, 45, "Print"],
Cell[189825, 4801, 101, 1, 81, "Print"],
Cell[189929, 4804, 111, 1, 81, "Print"]
}, Open  ]],
Cell[190055, 4808, 73, 1, 60, "Output"]
}, Open  ]],
Cell[190143, 4812, 101, 2, 60, "Input"],
Cell[CellGroupData[{
Cell[190269, 4818, 53, 1, 60, "Input"],
Cell[190325, 4821, 1804, 24, 1461, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[192178, 4851, 38, 0, 150, "Section"],
Cell[CellGroupData[{
Cell[192241, 4855, 97, 2, 60, "Input"],
Cell[CellGroupData[{
Cell[192363, 4861, 171, 2, 81, "Print"],
Cell[192537, 4865, 49, 0, 45, "Print"]
}, Open  ]]
}, Open  ]],
Cell[192613, 4869, 115, 3, 60, "Input"],
Cell[CellGroupData[{
Cell[192753, 4876, 53, 1, 60, "Input"],
Cell[192809, 4879, 1770, 23, 1426, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[194628, 4908, 32, 0, 150, "Section"],
Cell[CellGroupData[{
Cell[194685, 4912, 51, 1, 60, "Input"],
Cell[CellGroupData[{
Cell[194761, 4917, 351, 9, 45, "Print"],
Cell[195115, 4928, 96, 1, 115, "Print"]
}, Open  ]],
Cell[195226, 4932, 757, 12, 474, "Message"],
Cell[CellGroupData[{
Cell[196008, 4948, 307, 7, 45, "Print"],
Cell[196318, 4957, 295, 6, 45, "Print"]
}, Open  ]],
Cell[196628, 4966, 389, 7, 48, "Message"],
Cell[197020, 4975, 187, 4, 48, "Message"],
Cell[197210, 4981, 391, 7, 48, "Message"],
Cell[197604, 4990, 185, 4, 48, "Message"],
Cell[197792, 4996, 391, 7, 48, "Message"],
Cell[198186, 5005, 440, 8, 48, "Message"],
Cell[198629, 5015, 185, 4, 48, "Message"],
Cell[198817, 5021, 444, 8, 48, "Message"],
Cell[199264, 5031, 227, 5, 84, "Message"],
Cell[199494, 5038, 178, 4, 48, "Message"],
Cell[199675, 5044, 198, 4, 48, "Message"],
Cell[199876, 5050, 198, 4, 48, "Message"],
Cell[200077, 5056, 198, 4, 48, "Message"],
Cell[200278, 5062, 470, 8, 84, "Message"],
Cell[200751, 5072, 199, 4, 48, "Message"],
Cell[200953, 5078, 199, 4, 48, "Message"],
Cell[201155, 5084, 199, 4, 48, "Message"],
Cell[201357, 5090, 469, 8, 84, "Message"],
Cell[201829, 5100, 434, 8, 48, "Message"],
Cell[202266, 5110, 434, 8, 48, "Message"],
Cell[202703, 5120, 436, 8, 48, "Message"],
Cell[203142, 5130, 447, 8, 48, "Message"],
Cell[203592, 5140, 225, 5, 48, "Message"],
Cell[CellGroupData[{
Cell[203842, 5149, 321, 7, 45, "Print"],
Cell[204166, 5158, 280, 6, 45, "Print"],
Cell[204449, 5166, 100, 1, 45, "Print"],
Cell[204552, 5169, 346, 9, 45, "Print"],
Cell[204901, 5180, 282, 6, 45, "Print"],
Cell[205186, 5188, 100, 1, 45, "Print"],
Cell[205289, 5191, 346, 9, 45, "Print"],
Cell[205638, 5202, 282, 6, 45, "Print"],
Cell[205923, 5210, 100, 1, 45, "Print"],
Cell[206026, 5213, 346, 9, 45, "Print"],
Cell[206375, 5224, 280, 6, 45, "Print"],
Cell[206658, 5232, 100, 1, 45, "Print"],
Cell[206761, 5235, 349, 9, 45, "Print"]
}, Open  ]],
Cell[207125, 5247, 796, 12, 474, "Message"],
Cell[CellGroupData[{
Cell[207946, 5263, 337, 9, 45, "Print"],
Cell[208286, 5274, 262, 6, 45, "Print"],
Cell[208551, 5282, 100, 1, 45, "Print"],
Cell[208654, 5285, 317, 7, 45, "Print"],
Cell[208974, 5294, 95, 1, 45, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[209118, 5301, 124, 2, 60, "Input"],
Cell[209245, 5305, 368, 7, 96, "Output"]
}, Open  ]],
Cell[209628, 5315, 160, 3, 60, "Input"],
Cell[CellGroupData[{
Cell[209813, 5322, 123, 2, 60, "Input"],
Cell[209939, 5326, 5189, 68, 4048, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[215165, 5399, 119, 2, 43, "Input"],
Cell[215287, 5403, 359, 6, 198, "Print",
 CellTags->"Info3437569204-7849676"]
}, Closed]],
Cell[CellGroupData[{
Cell[215683, 5414, 223, 5, 43, "Input"],
Cell[215909, 5421, 5111, 67, 3841, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[221057, 5493, 247, 5, 60, "Input"],
Cell[221307, 5500, 5236, 69, 4048, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[226580, 5574, 167, 3, 43, "Input"],
Cell[226750, 5579, 145, 1, 45, "Print"],
Cell[226898, 5582, 97, 1, 60, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[227032, 5588, 127, 2, 60, "Input"],
Cell[CellGroupData[{
Cell[227184, 5594, 400, 10, 45, "Print"],
Cell[227587, 5606, 146, 2, 115, "Print"],
Cell[227736, 5610, 326, 7, 45, "Print"],
Cell[228065, 5619, 150, 2, 45, "Print"],
Cell[228218, 5623, 378, 8, 45, "Print"],
Cell[228599, 5633, 145, 2, 45, "Print"]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
