(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    270570,       7576]
NotebookOptionsPosition[    243621,       6761]
NotebookOutlinePosition[    244284,       6789]
CellTagsIndexPosition[    244210,       6784]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["The structured scheduler", "Title",
 FontColor->RGBColor[1, 0, 0],
 CellTags->"firstcell"],

Cell["\<\
Patrice Quinton, Tanguy Risset
September 2001\
\>", "Subsubtitle"],

Cell[CellGroupData[{

Cell["Last modification: July 3, 1998", "Subsubsection",
 FontColor->RGBColor[0, 1, 0]],

Cell["Cr\[EAcute]dits", "SmallText",
 FontColor->RGBColor[0, 1, 0]],

Cell["\<\
      Zbigniew Chamski 
      Catherine Dezan 
      Florent Dupont de Dinechin 
      Patricia Le Mo\[EDoubleDot]nner 
      Herv\[EAcute] Le Verge 
      Christophe Mauras 
      Patrice Quinton 
      Fabien Quillere
      Sanjay Rajopadhye 
      Sophie Robert 
      Tanguy Risset 
      Doran Wilde \
\>", "SmallText"],

Cell["\<\
Irisa, Campus de Beaulieu, 35042, Rennes Cedex, France
quinton@irisa.fr\
\>", "SmallText"]
}, Closed]],

Cell[CellGroupData[{

Cell[" Execute this cell, to go in the right directory. ", "Subsubsection",
 FontColor->RGBColor[1, 0, 0]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"setMMADir", "[", 
  RowBox[{"{", 
   RowBox[{
   "\"\<demos\>\"", ",", "\"\<NOTEBOOKS\>\"", ",", 
    "\"\<StructuredScheduler\>\""}], "}"}], "]"}]], "Input",
 InitializationCell->True],

Cell[BoxData["\<\"/Users/patricequinton/mmalpha/demos/NOTEBOOKS/\
StructuredScheduler\"\>"], "Output",
 CellChangeTimes->{3.4531337462589617`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Introduction",
 FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell["\<\
This demo show the use of the structured schedule on a matrix multiplication \
algorithm described using dot products. \
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<matmults.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"[dot][matmult]\"\>"], "Print"],

Cell[BoxData["\<\" Library Loaded\"\>"], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input"],

Cell[BoxData["\<\"system matmult :{N | 2<=N}\\n               (a : {i,j | \
1<=i<=N; 1<=j<=N} of integer; \\n                b : {i,j | 1<=i<=N; 1<=j<=N} \
of integer)\\n       returns (c : {i,j | 1<=i<=N; 1<=j<=N} of integer);\\nvar\
\\n  A : {k,i,j | 0<=k<=N; 1<=i<=N; 1<=j<=N} of integer;\\n  B : {k,i,j | \
0<=k<=N; 1<=i<=N; 1<=j<=N} of integer;\\nlet\\n  A[k,i,j] = \\n      case\\n  \
      { | k=0} : a[i,j];\\n        { | 1<=k; 2<=j} : A[i,j-1,k];\\n        { \
| 1<=k; j=1} : a[i,k];\\n      esac;\\n  B[k,i,j] = \\n      case\\n        { \
| k=0} : b[i,j];\\n        { | 1<=k; 2<=i} : B[k,i-1,j];\\n        { | 1<=k; \
i=1} : b[j,k];\\n      esac;\\n  use {i,j | 1<=i<=N; 1<=j<=N} dot[N] (A, B) \
returns  (c) ;\\ntel;\"\>"], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"analyze", "[", 
  RowBox[{"recurse", "\[Rule]", "True"}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Need to analyze : \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"dot\"\>", ",", "\<\"matmult\"\>"}], "}"}]}],
  SequenceForm["Need to analyze : ", {"dot", "matmult"}],
  Editable->False]], "Print"],

Cell[BoxData["\<\" \"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"dot\"\>"}],
  SequenceForm["Static Analysis of system ", "dot"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Acc\"\>"}],
  SequenceForm["----equation defining ", "Acc"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"c\"\>"}],
  SequenceForm["----equation defining ", "c"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print"],

Cell[BoxData["\<\" \"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"matmult\"\>"}],
  SequenceForm["Static Analysis of system ", "matmult"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"A\"\>"}],
  SequenceForm["----equation defining ", "A"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"B\"\>"}],
  SequenceForm["----equation defining ", "B"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----use \"\>", "\[InvisibleSpace]", "\<\"dot\"\>", 
   "\[InvisibleSpace]", "\<\"...\"\>"}],
  SequenceForm["----use ", "dot", "..."],
  Editable->False]], "Print"],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print"],

Cell[BoxData["\<\"\\nRecursive Analysis Successful.\"\>"], "Print"]
}, Open  ]],

Cell[BoxData["True"], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Scheduling the dot product",
 FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell["\<\
We first schedule the dot product. This means that we select it (getSystem), \
and schedule it using the farkas scheduler. Important, and difficult to \
explain in a few words: we need to force the inputs of the dot product to \
have the same linear part as the outputs... The result show that the kth \
component of the vector is scheduled at time k, which is reasonable...\
\>", "Text",
 TextAlignment->Left,
 TextJustification->1],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<dot\>\"", "]"}], ";"}], "\n", 
 RowBox[{"schedule", "[", 
  RowBox[{"addConstraints", "\[Rule]", 
   RowBox[{"{", 
    RowBox[{"\"\<TaD1==1\>\"", ",", "\"\<TbD1==1\>\""}], "}"}]}], 
  "]"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Checking options...\"\>"], "Print"],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print"],

Cell[BoxData["\<\"Building LP...\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "2", "\[InvisibleSpace]", "\<\" Recognized added Constraints: \"\>"}],
  SequenceForm[2, " Recognized added Constraints: "],
  Editable->False]], "Print"],

Cell[BoxData["\<\"   -1 + TaD1 = 0,\"\>"], "Print"],

Cell[BoxData["\<\"   -1 + TbD1 = 0,\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "49", 
   "\[InvisibleSpace]", "\<\"      variables, \"\>", "\[InvisibleSpace]", 
   "52", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 49, "      variables, ", 52, " Constraints"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print"],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Total execution Time: \"\>", "\[InvisibleSpace]", 
   RowBox[{"1", "+", "\<\"N\"\>"}]}],
  SequenceForm["Total execution Time: ", 1 + "N"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"a\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"-", "1"}], "+", "\<\"k\"\>"}]}],
  SequenceForm["T_", "a", {"k", "N"}, " = ", -1 + "k"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"b\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"-", "1"}], "+", "\<\"k\"\>"}]}],
  SequenceForm["T_", "b", {"k", "N"}, " = ", -1 + "k"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"c\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", "\<\"N\"\>", "}"}], "\[InvisibleSpace]", "\<\" = \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"1", "+", "\<\"N\"\>"}]}],
  SequenceForm["T_", "c", {"N"}, " = ", 1 + "N"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"Acc\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "\<\"k\"\>"}],
  SequenceForm["T_", "Acc", {"k", "N"}, " = ", "k"],
  Editable->False]], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"dot\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"a\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "1"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"b\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "1"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"c\"\>", ",", 
       RowBox[{"{", "\<\"N\"\>", "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", "1", "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Acc\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}]}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], "]"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<dot\>\"", "]"}], ";"}], "\n", 
 RowBox[{"scd", "[", 
  RowBox[{"addConstraints", "\[Rule]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"TaD1", "==", "1"}], ",", 
     RowBox[{"TbD1", "==", "1"}]}], "}"}]}], "]"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "32", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "13", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   RowBox[{"0.19247000000000014`", " ", "Second"}]}],
  SequenceForm[
  32, " constraints, ", 13, " variables ", 0.19247000000000014` Second],
  Editable->False]], "Print"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"dot\"\>", ",", "13", ",", "30", ",", 
   RowBox[{"0.19247000000000014`", " ", "Second"}], ",", "\<\"Vertex\"\>", 
   ",", "\<\"Flat\"\>"}], "}"}]], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"dot\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"a\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Acc\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"b\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"c\"\>", ",", 
       RowBox[{"{", "\<\"N\"\>", "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", "1", "}"}], ",", "2"}], "]"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}], "]"}]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Scheduling the matmult product",
 FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell["\<\
Then we schedule the main system. This is done by selecting the matmult \
system, and by calling the structured scheduler, structSched. \
\>", "Text",
 TextAlignment->Left,
 TextJustification->1],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<matmult\>\"", "]"}], ";"}], "\n", 
 RowBox[{"scd", "[", 
  RowBox[{
   RowBox[{"addConstraints", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"TBD4", "==", "0"}], "}"}]}], ",", 
   RowBox[{"verbose", "\[Rule]", "False"}]}], "]"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New schedule: \"\>", "\[InvisibleSpace]", 
   RowBox[{"scheduleResult", "[", 
    RowBox[{"\<\"dot\"\>", ",", 
     RowBox[{"{", "\<\"N\"\>", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"\<\"c\"\>", ",", 
        RowBox[{"{", "\<\"N\"\>", "}"}], ",", 
        RowBox[{"sched", "[", 
         RowBox[{
          RowBox[{"{", "1", "}"}], ",", "2"}], "]"}]}], "}"}], "}"}]}], 
    "]"}]}],
  SequenceForm["New schedule: ", 
   scheduleResult["dot", {"N"}, {{"a", {"k", "N"}, 
      sched[{1, 0}, 0]}, {"b", {"k", "N"}, 
      sched[{1, 0}, 0]}}, {{"c", {"N"}, 
      sched[{1}, 2]}}]],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "152", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "28", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   RowBox[{"1.105338999999999`", " ", "Second"}]}],
  SequenceForm[
  152, " constraints, ", 28, " variables ", 1.105338999999999 Second],
  Editable->False]], "Print"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"matmult\"\>", ",", "28", ",", "137", ",", 
   RowBox[{"1.105338999999999`", " ", "Second"}], ",", "\<\"Vertex\"\>", 
   ",", "\<\"Structured\"\>"}], "}"}]], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"matmult\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"a\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           FractionBox["1", "3"], ",", 
           FractionBox["1", "3"], ",", "0"}], "}"}], ",", 
         FractionBox["1", "3"]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", "0"}], 
        "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"b\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           FractionBox["1", "3"], ",", 
           FractionBox["1", "3"], ",", "0"}], "}"}], ",", 
         FractionBox["1", "3"]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"B\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", "0"}], 
        "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"c\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", "2"}], "]"}]}], 
      "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2"}], "}"}]}], "]"}]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData["$scheduleLibrary"], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"scheduleResult", "[", 
    RowBox[{"\<\"matmult\"\>", ",", 
     RowBox[{"{", "\<\"N\"\>", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], 
         ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], 
         ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
        "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"\<\"c\"\>", ",", 
        RowBox[{"{", 
         RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], 
        ",", 
        RowBox[{"sched", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
       "}"}], "}"}]}], "]"}], ",", 
   RowBox[{"scheduleResult", "[", 
    RowBox[{"\<\"dot\"\>", ",", 
     RowBox[{"{", "\<\"N\"\>", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"\<\"c\"\>", ",", 
        RowBox[{"{", "\<\"N\"\>", "}"}], ",", 
        RowBox[{"sched", "[", 
         RowBox[{
          RowBox[{"{", "1", "}"}], ",", "2"}], "]"}]}], "}"}], "}"}]}], 
    "]"}]}], "}"}]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<matmult\>\"", "]"}], ";"}], "\n", 
 RowBox[{"schedule", "[", 
  RowBox[{"subSystems", "\[Rule]", "True"}], "]"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Checking options...\"\>"], "Print"],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print"],

Cell[BoxData["\<\"Building LP...\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "124", 
   "\[InvisibleSpace]", "\<\"      variables, \"\>", "\[InvisibleSpace]", 
   "112", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 124, "      variables, ", 112, " Constraints"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Writing line \"\>", "\[InvisibleSpace]", "100"}],
  SequenceForm["Writing line ", 100],
  Editable->False]], "Print"],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Total execution Time: \"\>", "\[InvisibleSpace]", "0"}],
  SequenceForm["Total execution Time: ", 0],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"a\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "0"}],
  SequenceForm["T_", "a", {"i", "j", "N"}, " = ", 0],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"b\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "0"}],
  SequenceForm["T_", "b", {"i", "j", "N"}, " = ", 0],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"c\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "0"}],
  SequenceForm["T_", "c", {"i", "j", "N"}, " = ", 0],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"A\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
     ",", "\<\"N\"\>"}], "}"}], "\[InvisibleSpace]", "\<\" = \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"\<\"i\"\>", "+", "\<\"j\"\>", "+", "\<\"k\"\>"}]}],
  SequenceForm["T_", "A", {"k", "i", "j", "N"}, " = ", "i" + "j" + "k"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"B\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
     ",", "\<\"N\"\>"}], "}"}], "\[InvisibleSpace]", "\<\" = \"\>", 
   "\[InvisibleSpace]", "\<\"i\"\>"}],
  SequenceForm["T_", "B", {"k", "i", "j", "N"}, " = ", "i"],
  Editable->False]], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"matmult\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"a\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"b\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"c\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", "0"}], 
        "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"B\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", "0"}], 
        "]"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], "]"}]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"showSchedResult", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"a\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "0"}],
  SequenceForm["T_", "a", {"i", "j", "N"}, " = ", 0],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"b\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "0"}],
  SequenceForm["T_", "b", {"i", "j", "N"}, " = ", 0],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"c\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "0"}],
  SequenceForm["T_", "c", {"i", "j", "N"}, " = ", 0],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"A\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
     ",", "\<\"N\"\>"}], "}"}], "\[InvisibleSpace]", "\<\" = \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"\<\"i\"\>", "+", "\<\"j\"\>", "+", "\<\"k\"\>"}]}],
  SequenceForm["T_", "A", {"k", "i", "j", "N"}, " = ", "i" + "j" + "k"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"B\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
     ",", "\<\"N\"\>"}], "}"}], "\[InvisibleSpace]", "\<\" = \"\>", 
   "\[InvisibleSpace]", "\<\"i\"\>"}],
  SequenceForm["T_", "B", {"k", "i", "j", "N"}, " = ", "i"],
  Editable->False]], "Print"]
}, Open  ]]
}, Open  ]],

Cell["\<\
The result is the normal schedule for the systolic matrix multiplication \
algorithm. \
\>", "Text",
 TextAlignment->Left,
 TextJustification->1],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input"],

Cell[BoxData["\<\"system matmult :{N | 2<=N}\\n               (a : {i,j | \
1<=i<=N; 1<=j<=N} of integer; \\n                b : {i,j | 1<=i<=N; 1<=j<=N} \
of integer)\\n       returns (c : {i,j | 1<=i<=N; 1<=j<=N} of integer);\\nvar\
\\n  A : {k,i,j | 0<=k<=N; 1<=i<=N; 1<=j<=N} of integer;\\n  B : {k,i,j | \
0<=k<=N; 1<=i<=N; 1<=j<=N} of integer;\\nlet\\n  A[k,i,j] = \\n      case\\n  \
      { | k=0} : a[i,j];\\n        { | 1<=k; 2<=j} : A[i,j-1,k];\\n        { \
| 1<=k; j=1} : a[i,k];\\n      esac;\\n  B[k,i,j] = \\n      case\\n        { \
| k=0} : b[i,j];\\n        { | 1<=k; 2<=i} : B[k,i-1,j];\\n        { | 1<=k; \
i=1} : b[j,k];\\n      esac;\\n  use {i,j | 1<=i<=N; 1<=j<=N} dot[N] (A, B) \
returns  (c) ;\\ntel;\"\>"], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"scd", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New schedule: \"\>", "\[InvisibleSpace]", 
   RowBox[{"scheduleResult", "[", 
    RowBox[{"\<\"dot\"\>", ",", 
     RowBox[{"{", "\<\"N\"\>", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"\<\"c\"\>", ",", 
        RowBox[{"{", "\<\"N\"\>", "}"}], ",", 
        RowBox[{"sched", "[", 
         RowBox[{
          RowBox[{"{", "1", "}"}], ",", "2"}], "]"}]}], "}"}], "}"}]}], 
    "]"}]}],
  SequenceForm["New schedule: ", 
   scheduleResult["dot", {"N"}, {{"a", {"k", "N"}, 
      sched[{1, 0}, 0]}, {"b", {"k", "N"}, 
      sched[{1, 0}, 0]}}, {{"c", {"N"}, 
      sched[{1}, 2]}}]],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "150", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "28", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   RowBox[{"0.9273690000000006`", " ", "Second"}]}],
  SequenceForm[
  150, " constraints, ", 28, " variables ", 0.9273690000000006 Second],
  Editable->False]], "Print"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"matmult\"\>", ",", "28", ",", "136", ",", 
   RowBox[{"0.9273690000000006`", " ", "Second"}], ",", "\<\"Vertex\"\>", 
   ",", "\<\"Structured\"\>"}], "}"}]], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"matmult\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"a\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           FractionBox["1", "3"], ",", 
           FractionBox["1", "3"], ",", "0"}], "}"}], ",", 
         FractionBox["1", "3"]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", "0"}], 
        "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"b\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           FractionBox["1", "3"], ",", 
           FractionBox["1", "3"], ",", "0"}], "}"}], ",", 
         FractionBox["1", "3"]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"B\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", "0"}], 
        "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"c\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", "2"}], "]"}]}], 
      "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2"}], "}"}]}], "]"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["The full adder example",
 FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input"],

Cell[BoxData["\<\"system Plus :  {W | 2<=W}\\n               (A : {b | \
0<=b<=W} of boolean; \\n                B : {b | 0<=b<=W} of boolean)\\n      \
 returns (S : {b | 0<=b<=W} of boolean);\\nvar\\n  Cin : {b | 0<=b<=W-1} of \
boolean;\\n  Cout : {b | 0<=b<=W-1} of boolean;\\n  X : {b | 0<=b<=W-1} of \
boolean;\\nlet\\n  use {b | 0<=b<=W-1} FullAdder[] (A, B, Cin) returns  (X, \
Cout) ;\\n  Cin[b] = \\n      case\\n        { | b=0} : False[];\\n        { \
| 1<=b} : Cout[b-1];\\n      esac;\\n  S[b] = \\n      case\\n        { | \
b<=W-1} : X[b];\\n        { | b=W} : Cout[W-1];\\n      esac;\\ntel;\"\>"], \
"Print"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<fulladder.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"[FullAdder][Plus]\"\>"], "Print"],

Cell[BoxData["\<\" Library Loaded\"\>"], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "durations"}]], "Input"],

Cell[BoxData["\<\"option of schedule (List) default {}.  select a mode for \
counting the duration of instructions.  durations -> {} : each equation is 1 \
(whatever complex is the computation) (default). durations -> ListOfInteger: \
The duration of each equation is given by the user the options \
\\\"durationByEq\\\" indicates whether these values stand for a duration by \
equation (default in Farkas resolution, not implemented in Vertex resolution) \
or a duration by dependence (default in Vertex resolution, not implemented in \
Farkas resolution). durations -> ListOfListOfInteger: same as previous one \
but for multidimensionnal scheduling (one list of integer by dimension).  \
\"\>"], "Print"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<FullAdder\>\"", "]"}], ";", 
  RowBox[{"show", "[", "]"}], ";", 
  RowBox[{"schedule", "[", 
   RowBox[{"durations", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
   "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"system FullAdder (A :  boolean; \\n                  B :  \
boolean; \\n                  Cin :  boolean)\\n       returns   (X :  \
boolean; \\n                  Cout :  boolean);\\nlet\\n  X = A xor B xor \
Cin;\\n  Cout = A and B or A and Cin or B and Cin;\\ntel;\"\>"], "Print"],

Cell[BoxData["\<\"Checking options...\"\>"], "Print"],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Duration not null for :\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "}"}]}],
  SequenceForm["Duration not null for :", {}],
  Editable->False]], "Print"],

Cell[BoxData["\<\"Building LP...\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "40", 
   "\[InvisibleSpace]", "\<\"      variables, \"\>", "\[InvisibleSpace]", 
   "32", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 40, "      variables, ", 32, " Constraints"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print"],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Total execution Time: \"\>", "\[InvisibleSpace]", "0"}],
  SequenceForm["Total execution Time: ", 0],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"A\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", "}"}], "\[InvisibleSpace]", "\<\" = \"\>", 
   "\[InvisibleSpace]", "0"}],
  SequenceForm["T_", "A", {}, " = ", 0],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"B\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", "}"}], "\[InvisibleSpace]", "\<\" = \"\>", 
   "\[InvisibleSpace]", "0"}],
  SequenceForm["T_", "B", {}, " = ", 0],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"Cin\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "}"}], "\[InvisibleSpace]", "\<\" = \"\>", 
   "\[InvisibleSpace]", "0"}],
  SequenceForm["T_", "Cin", {}, " = ", 0],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"X\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", "}"}], "\[InvisibleSpace]", "\<\" = \"\>", 
   "\[InvisibleSpace]", "0"}],
  SequenceForm["T_", "X", {}, " = ", 0],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"Cout\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "}"}], "\[InvisibleSpace]", "\<\" = \"\>", 
   "\[InvisibleSpace]", "0"}],
  SequenceForm["T_", "Cout", {}, " = ", 0],
  Editable->False]], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"FullAdder\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"B\"\>", ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Cin\"\>", ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"X\"\>", ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Cout\"\>", ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", "0"}], "]"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", "0", "}"}]}], "]"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"show", "[", 
  RowBox[{"dep", "[", "]"}], "]"}]], "Input"],

Cell[BoxData["\<\"{ | 1>=0} : X[] -> A[]\\n{ | 1>=0} : X[] -> B[]\\n{ | 1>=0} \
: X[] -> Cin[]\\n{ | 1>=0} : Cout[] -> A[]\\n{ | 1>=0} : Cout[] -> B[]\\n{ | \
1>=0} : Cout[] -> A[]\\n{ | 1>=0} : Cout[] -> Cin[]\\n{ | 1>=0} : Cout[] -> \
B[]\\n{ | 1>=0} : Cout[] -> Cin[]\"\>"], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<Plus\>\"", "]"}], ";"}], "\n", 
 RowBox[{"structSched", "[", 
  RowBox[{"debug", "\[Rule]", "False"}], "]"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Checking options...\"\>"], "Print"],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print"],

Cell[BoxData["\<\"Building LP...\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "12", "\[InvisibleSpace]", "\<\" Recognized added Constraints: \"\>"}],
  SequenceForm[12, " Recognized added Constraints: "],
  Editable->False]], "Print"],

Cell[BoxData["\<\"   -CA + CB = 0,\"\>"], "Print"],

Cell[BoxData["\<\"   -TAD2 + TBD2 = 0,\"\>"], "Print"],

Cell[BoxData["\<\"   -CA + CCin = 0,\"\>"], "Print"],

Cell[BoxData["\<\"   -TAD2 + TCinD2 = 0,\"\>"], "Print"],

Cell[BoxData["\<\"   -CA + CX = 0,\"\>"], "Print"],

Cell[BoxData["\<\"   -TAD2 + TXD2 = 0,\"\>"], "Print"],

Cell[BoxData["\<\"   -CA + CCout = 0,\"\>"], "Print"],

Cell[BoxData["\<\"   -TAD2 + TCoutD2 = 0,\"\>"], "Print"],

Cell[BoxData["\<\"   -TAD1 + TBD1 = 0,\"\>"], "Print"],

Cell[BoxData["\<\"   -TAD1 + TCinD1 = 0,\"\>"], "Print"],

Cell[BoxData["\<\"   -TAD1 + TXD1 = 0,\"\>"], "Print"],

Cell[BoxData["\<\"   -TAD1 + TCoutD1 = 0,\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "71", 
   "\[InvisibleSpace]", "\<\"      variables, \"\>", "\[InvisibleSpace]", 
   "84", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 71, "      variables, ", 84, " Constraints"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print"],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Total execution Time: \"\>", 
   "\[InvisibleSpace]", "\<\"W\"\>"}],
  SequenceForm["Total execution Time: ", "W"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"A\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "\<\"b\"\>"}],
  SequenceForm["T_", "A", {"b", "W"}, " = ", "b"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"B\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "\<\"b\"\>"}],
  SequenceForm["T_", "B", {"b", "W"}, " = ", "b"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"S\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "\<\"W\"\>"}],
  SequenceForm["T_", "S", {"b", "W"}, " = ", "W"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"Cin\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "\<\"b\"\>"}],
  SequenceForm["T_", "Cin", {"b", "W"}, " = ", "b"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"Cout\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "\<\"b\"\>"}],
  SequenceForm["T_", "Cout", {"b", "W"}, " = ", "b"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"X\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "\<\"b\"\>"}],
  SequenceForm["T_", "X", {"b", "W"}, " = ", "b"],
  Editable->False]], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"Plus\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"B\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"S\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Cin\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Cout\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"X\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}]}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}]}], "]"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input"],

Cell[BoxData["\<\"system Plus :  {W | 2<=W}\\n               (A : {b | \
0<=b<=W} of boolean; \\n                B : {b | 0<=b<=W} of boolean)\\n      \
 returns (S : {b | 0<=b<=W} of boolean);\\nvar\\n  Cin : {b | 0<=b<=W-1} of \
boolean;\\n  Cout : {b | 0<=b<=W-1} of boolean;\\n  X : {b | 0<=b<=W-1} of \
boolean;\\nlet\\n  use {b | 0<=b<=W-1} FullAdder[] (A, B, Cin) returns  (X, \
Cout) ;\\n  Cin[b] = \\n      case\\n        { | b=0} : False[];\\n        { \
| 1<=b} : Cout[b-1];\\n      esac;\\n  S[b] = \\n      case\\n        { | \
b<=W-1} : X[b];\\n        { | b=W} : Cout[W-1];\\n      esac;\\ntel;\"\>"], \
"Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"appSched", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Warning2 : \"\>", "\[InvisibleSpace]", "\<\"Cout\"\>", 
   "\[InvisibleSpace]", "\<\" appears in the output list of a use :\"\>"}],
  SequenceForm[
  "Warning2 : ", "Cout", " appears in the output list of a use :"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Adding the auxilliary variable \"\>", 
   "\[InvisibleSpace]", "\<\"oldXCout\"\>"}],
  SequenceForm["  Adding the auxilliary variable ", "oldXCout"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Warning2 : \"\>", "\[InvisibleSpace]", "\<\"X\"\>", 
   "\[InvisibleSpace]", "\<\" appears in the output list of a use :\"\>"}],
  SequenceForm["Warning2 : ", "X", " appears in the output list of a use :"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Adding the auxilliary variable \"\>", 
   "\[InvisibleSpace]", "\<\"oldXX\"\>"}],
  SequenceForm["  Adding the auxilliary variable ", "oldXX"],
  Editable->False]], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"system", "[", 
  RowBox[{"\<\"Plus\"\>", ",", 
   RowBox[{"domain", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", "\<\"W\"\>", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"pol", "[", 
       RowBox[{"2", ",", "2", ",", "0", ",", "0", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", 
            RowBox[{"-", "2"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "1"}], "}"}]}], "}"}]}], "]"}], 
      "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"decl", "[", 
      RowBox[{"\<\"A\"\>", ",", "boolean", ",", 
       RowBox[{"domain", "[", 
        RowBox[{"2", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"pol", "[", 
           RowBox[{"3", ",", "3", ",", "0", ",", "0", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
           "]"}], "}"}]}], "]"}]}], "]"}], ",", 
     RowBox[{"decl", "[", 
      RowBox[{"\<\"B\"\>", ",", "boolean", ",", 
       RowBox[{"domain", "[", 
        RowBox[{"2", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"pol", "[", 
           RowBox[{"3", ",", "3", ",", "0", ",", "0", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
           "]"}], "}"}]}], "]"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"decl", "[", 
     RowBox[{"\<\"S\"\>", ",", "boolean", ",", 
      RowBox[{"domain", "[", 
       RowBox[{"2", ",", 
        RowBox[{"{", 
         RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"pol", "[", 
          RowBox[{"3", ",", "3", ",", "0", ",", "0", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
          "]"}], "}"}]}], "]"}]}], "]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"decl", "[", 
      RowBox[{"\<\"Cin\"\>", ",", "boolean", ",", 
       RowBox[{"domain", "[", 
        RowBox[{"2", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"t\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"pol", "[", 
           RowBox[{"3", ",", "3", ",", "0", ",", "0", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", "1"}], ",", "1", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
           "]"}], "}"}]}], "]"}]}], "]"}], ",", 
     RowBox[{"decl", "[", 
      RowBox[{"\<\"Cout\"\>", ",", "boolean", ",", 
       RowBox[{"domain", "[", 
        RowBox[{"2", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"t\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"pol", "[", 
           RowBox[{"3", ",", "3", ",", "0", ",", "0", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", "1"}], ",", "1", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
           "]"}], "}"}]}], "]"}]}], "]"}], ",", 
     RowBox[{"decl", "[", 
      RowBox[{"\<\"X\"\>", ",", "boolean", ",", 
       RowBox[{"domain", "[", 
        RowBox[{"2", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"t\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"pol", "[", 
           RowBox[{"3", ",", "3", ",", "0", ",", "0", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", "1"}], ",", "1", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
           "]"}], "}"}]}], "]"}]}], "]"}], ",", 
     RowBox[{"decl", "[", 
      RowBox[{"\<\"oldXCout\"\>", ",", "boolean", ",", 
       RowBox[{"domain", "[", 
        RowBox[{"2", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"pol", "[", 
           RowBox[{"3", ",", "3", ",", "0", ",", "0", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", "1"}], ",", "1", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
           "]"}], "}"}]}], "]"}]}], "]"}], ",", 
     RowBox[{"decl", "[", 
      RowBox[{"\<\"oldXX\"\>", ",", "boolean", ",", 
       RowBox[{"domain", "[", 
        RowBox[{"2", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"pol", "[", 
           RowBox[{"3", ",", "3", ",", "0", ",", "0", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", "1"}], ",", "1", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
           "]"}], "}"}]}], "]"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"use", "[", 
      RowBox[{"\<\"FullAdder\"\>", ",", 
       RowBox[{"domain", "[", 
        RowBox[{"2", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"pol", "[", 
           RowBox[{"3", ",", "3", ",", "0", ",", "0", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", "1"}], ",", "1", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
           "]"}], "}"}]}], "]"}], ",", 
       RowBox[{"matrix", "[", 
        RowBox[{"1", ",", "3", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0", ",", "1"}], "}"}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"var", "[", "\<\"A\"\>", "]"}], ",", 
         RowBox[{"var", "[", "\<\"B\"\>", "]"}], ",", 
         RowBox[{"affine", "[", 
          RowBox[{
           RowBox[{"var", "[", "\<\"Cin\"\>", "]"}], ",", 
           RowBox[{"matrix", "[", 
            RowBox[{"3", ",", "3", ",", 
             RowBox[{"{", 
              RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], "]"}]}], 
          "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\<\"oldXX\"\>", ",", "\<\"oldXCout\"\>"}], "}"}]}], "]"}], 
     ",", 
     RowBox[{"equation", "[", 
      RowBox[{"\<\"X\"\>", ",", 
       RowBox[{"affine", "[", 
        RowBox[{
         RowBox[{"var", "[", "\<\"oldXX\"\>", "]"}], ",", 
         RowBox[{"matrix", "[", 
          RowBox[{"3", ",", "3", ",", 
           RowBox[{"{", 
            RowBox[{"\<\"t\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], "]"}]}], 
        "]"}]}], "]"}], ",", 
     RowBox[{"equation", "[", 
      RowBox[{"\<\"Cout\"\>", ",", 
       RowBox[{"affine", "[", 
        RowBox[{
         RowBox[{"var", "[", "\<\"oldXCout\"\>", "]"}], ",", 
         RowBox[{"matrix", "[", 
          RowBox[{"3", ",", "3", ",", 
           RowBox[{"{", 
            RowBox[{"\<\"t\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], "]"}]}], 
        "]"}]}], "]"}], ",", 
     RowBox[{"equation", "[", 
      RowBox[{"\<\"Cin\"\>", ",", 
       RowBox[{"case", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"restrict", "[", 
           RowBox[{
            RowBox[{"domain", "[", 
             RowBox[{"2", ",", 
              RowBox[{"{", 
               RowBox[{"\<\"t\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"pol", "[", 
                RowBox[{"2", ",", "2", ",", "1", ",", "1", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], 
                  "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], 
                  "}"}]}], "]"}], "}"}]}], "]"}], ",", 
            RowBox[{"affine", "[", 
             RowBox[{
              RowBox[{"const", "[", "False", "]"}], ",", 
              RowBox[{"matrix", "[", 
               RowBox[{"1", ",", "3", ",", 
                RowBox[{"{", 
                 RowBox[{"\<\"t\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0", ",", "1"}], "}"}], "}"}]}], "]"}]}], 
             "]"}]}], "]"}], ",", 
          RowBox[{"restrict", "[", 
           RowBox[{
            RowBox[{"domain", "[", 
             RowBox[{"2", ",", 
              RowBox[{"{", 
               RowBox[{"\<\"t\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"pol", "[", 
                RowBox[{"2", ",", "3", ",", "0", ",", "1", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "0", ",", 
                    RowBox[{"-", "1"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], 
                  "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}]}], 
                  "}"}]}], "]"}], "}"}]}], "]"}], ",", 
            RowBox[{"affine", "[", 
             RowBox[{
              RowBox[{"var", "[", "\<\"Cout\"\>", "]"}], ",", 
              RowBox[{"matrix", "[", 
               RowBox[{"3", ",", "3", ",", 
                RowBox[{"{", 
                 RowBox[{"\<\"t\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"1", ",", "0", ",", 
                    RowBox[{"-", "1"}]}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
               "]"}]}], "]"}]}], "]"}]}], "}"}], "]"}]}], "]"}], ",", 
     RowBox[{"equation", "[", 
      RowBox[{"\<\"S\"\>", ",", 
       RowBox[{"case", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"restrict", "[", 
           RowBox[{
            RowBox[{"domain", "[", 
             RowBox[{"2", ",", 
              RowBox[{"{", 
               RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"pol", "[", 
                RowBox[{"2", ",", "3", ",", "0", ",", "1", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", 
                    RowBox[{"-", "1"}], ",", "1", ",", 
                    RowBox[{"-", "1"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], 
                  "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}]}], 
                  "}"}]}], "]"}], "}"}]}], "]"}], ",", 
            RowBox[{"affine", "[", 
             RowBox[{
              RowBox[{"var", "[", "\<\"X\"\>", "]"}], ",", 
              RowBox[{"matrix", "[", 
               RowBox[{"3", ",", "3", ",", 
                RowBox[{"{", 
                 RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
               "]"}]}], "]"}]}], "]"}], ",", 
          RowBox[{"restrict", "[", 
           RowBox[{
            RowBox[{"domain", "[", 
             RowBox[{"2", ",", 
              RowBox[{"{", 
               RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"pol", "[", 
                RowBox[{"2", ",", "2", ",", "1", ",", "1", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "1", ",", 
                    RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], 
                  "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], 
                  "}"}]}], "]"}], "}"}]}], "]"}], ",", 
            RowBox[{"affine", "[", 
             RowBox[{
              RowBox[{"var", "[", "\<\"Cout\"\>", "]"}], ",", 
              RowBox[{"matrix", "[", 
               RowBox[{"3", ",", "3", ",", 
                RowBox[{"{", 
                 RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"0", ",", "1", ",", 
                    RowBox[{"-", "1"}]}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
               "]"}]}], "]"}]}], "]"}]}], "}"}], "]"}]}], "]"}]}], "}"}]}], 
  "]"}]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input"],

Cell[BoxData["\<\"system Plus :  {W | 2<=W}\\n               (A : {b | \
0<=b<=W} of boolean; \\n                B : {b | 0<=b<=W} of boolean)\\n      \
 returns (S : {b | 0<=b<=W} of boolean);\\nvar\\n  Cin : {t | 0<=t<=W-1} of \
boolean;\\n  Cout : {t | 0<=t<=W-1} of boolean;\\n  X : {t | 0<=t<=W-1} of \
boolean;\\n  oldXCout : {b | 0<=b<=W-1} of boolean;\\n  oldXX : {b | \
0<=b<=W-1} of boolean;\\nlet\\n  use {b | 0<=b<=W-1} FullAdder[] (A, B, \
Cin.(b->b)) returns  (oldXX, oldXCout) ;\\n  X[t] = oldXX[t];\\n  Cout[t] = \
oldXCout[t];\\n  Cin[t] = \\n      case\\n        { | t=0} : False[];\\n      \
  { | 1<=t} : Cout[t-1];\\n      esac;\\n  S[b] = \\n      case\\n        { | \
b<=W-1} : X[b];\\n        { | b=W} : Cout[W-1];\\n      esac;\\ntel;\"\>"], \
"Print"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Running the example all at once",
 FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"load", "[", "\"\<matmults.alpha\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<dot\>\"", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"schedule", "[", 
   RowBox[{"addConstraints", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<TaD1==1\>\"", ",", "\"\<TbD1==1\>\""}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<matmult\>\"", "]"}], ";"}], "\n", 
 RowBox[{"structSched", "[", "]"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"[dot][matmult]\"\>"], "Print",
 CellChangeTimes->{3.453133746425068*^9}],

Cell[BoxData["\<\"Checking options...\"\>"], "Print",
 CellChangeTimes->{3.4531337464277697`*^9}],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print",
 CellChangeTimes->{3.453133746478661*^9}],

Cell[BoxData["\<\"Building LP...\"\>"], "Print",
 CellChangeTimes->{3.453133746534463*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "2", "\[InvisibleSpace]", "\<\" Recognized added Constraints: \"\>"}],
  SequenceForm[2, " Recognized added Constraints: "],
  Editable->False]], "Print",
 CellChangeTimes->{3.453133746578244*^9}],

Cell[BoxData["\<\"   -1 + TaD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.453133746580158*^9}],

Cell[BoxData["\<\"   -1 + TbD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4531337465819187`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "49", 
   "\[InvisibleSpace]", "\<\"\\n\\t\\t\\t   variables, \"\>", 
   "\[InvisibleSpace]", "52", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 49, "\n\t\t\t   variables, ", 52, " Constraints"],
  Editable->False]], "Print",
 CellChangeTimes->{3.453133746610139*^9}],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print",
 CellChangeTimes->{3.453133746644003*^9}],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print",
 CellChangeTimes->{3.453133746683916*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Total execution Time: \"\>", "\[InvisibleSpace]", 
   RowBox[{"1", "+", "\<\"N\"\>"}]}],
  SequenceForm["Total execution Time: ", 1 + "N"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4531337467176313`*^9}],

Cell[BoxData["\<\"T_a{k, N} = -1 + k\\nT_b{k, N} = -1 + k\\nT_c{N} = 1 + \
N\\nT_Acc{k, N} = k\"\>"], "Print",
 CellChangeTimes->{3.453133746767453*^9}],

Cell[BoxData["\<\"Checking options...\"\>"], "Print",
 CellChangeTimes->{3.453133746817618*^9}],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print",
 CellChangeTimes->{3.453133746866954*^9}],

Cell[BoxData["\<\"Building LP...\"\>"], "Print",
 CellChangeTimes->{3.4531337469289923`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "10", "\[InvisibleSpace]", "\<\" Recognized added Constraints: \"\>"}],
  SequenceForm[10, " Recognized added Constraints: "],
  Editable->False]], "Print",
 CellChangeTimes->{3.453133746961722*^9}],

Cell[BoxData["\<\"   -1 + TAD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4531337469933233`*^9}],

Cell[BoxData["\<\"   -CA + CB = 0,\"\>"], "Print",
 CellChangeTimes->{3.453133747032371*^9}],

Cell[BoxData["\<\"   -1 + TBD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.453133747065146*^9}],

Cell[BoxData["\<\"   -TAD4 + TBD4 = 0,\"\>"], "Print",
 CellChangeTimes->{3.453133747098193*^9}],

Cell[BoxData["\<\"   -2 - CA + Cc = 0,\"\>"], "Print",
 CellChangeTimes->{3.4531337471276407`*^9}],

Cell[BoxData["\<\"   -1 - TAD4 + TcD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4531337471668386`*^9}],

Cell[BoxData["\<\"   -TAD2 + TBD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4531337471955442`*^9}],

Cell[BoxData["\<\"   -TAD3 + TBD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.453133747233803*^9}],

Cell[BoxData["\<\"   -TAD2 + TcD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.453133747267785*^9}],

Cell[BoxData["\<\"   -TAD3 + TcD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.453133747300826*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "124", 
   "\[InvisibleSpace]", "\<\"\\n\\t\\t\\t   variables, \"\>", 
   "\[InvisibleSpace]", "132", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 124, "\n\t\t\t   variables, ", 132, " Constraints"],
  Editable->False]], "Print",
 CellChangeTimes->{3.453133747333651*^9}],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print",
 CellChangeTimes->{3.453133747367433*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Writing line \"\>", "\[InvisibleSpace]", "100"}],
  SequenceForm["Writing line ", 100],
  Editable->False]], "Print",
 CellChangeTimes->{3.453133747414947*^9}],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print",
 CellChangeTimes->{3.45313374744696*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Total execution Time: \"\>", "\[InvisibleSpace]", 
   RowBox[{"1", "+", 
    RowBox[{"3", " ", "\<\"N\"\>"}]}]}],
  SequenceForm["Total execution Time: ", 1 + 3 "N"],
  Editable->False]], "Print",
 CellChangeTimes->{3.453133747484578*^9}],

Cell[BoxData["\<\"T_a{i, j, N} = 0\\nT_b{i, j, N} = 0\\nT_c{i, j, N} = 1 + i \
+ j + N\\nT_A{k, i, j, N} = -1 + i + j + k\\nT_B{k, i, j, N} = -1 + i + j + k\
\"\>"], "Print",
 CellChangeTimes->{3.453133747517767*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"matmult\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"a\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"b\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"c\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", "1"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "1"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"B\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "1"}]}], "]"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.4531337475460978`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"scd", "[", "]"}]], "Input",
 CellChangeTimes->{{3.4531337671954536`*^9, 3.453133770225109*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"Method Minimize\"\>"], "Print",
 CellChangeTimes->{3.4531337774334793`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "153", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "28", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   "0.09970799999999969`"}],
  SequenceForm[153, " constraints, ", 28, " variables ", 0.09970799999999969],
  
  Editable->False]], "Print",
 CellChangeTimes->{3.453133777510724*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"matmult\"\>", ",", "28", ",", "138", ",", 
   "0.09970799999999969`", ",", "\<\"Vertex\"\>", ",", "\<\"Structured\"\>"}],
   "}"}]], "Print",
 CellChangeTimes->{3.453133777512957*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"matmult\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"a\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "2"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "1"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"b\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "2"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"B\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "1"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"c\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", "1"}], "]"}]}], 
      "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.453133777515964*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ddd", "=", 
  RowBox[{"AbsoluteTiming", "[", 
   RowBox[{"scdConsToDomain", "[", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.45313375091847*^9, 3.453133783613512*^9}, {
  3.453133814190716*^9, 3.453133822380682*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.041031`5.0646570951372585", ",", 
   RowBox[{"domain", "[", 
    RowBox[{"28", ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Aa\"\>", ",", "\<\"AA\"\>", ",", "\<\"Ab\"\>", 
       ",", "\<\"AB\"\>", ",", "\<\"Ac\"\>", ",", "\<\"aparam\"\>", 
       ",", "\<\"TaD1\"\>", ",", "\<\"TAD1\"\>", ",", "\<\"TaD2\"\>", 
       ",", "\<\"TAD2\"\>", ",", "\<\"TaD3\"\>", ",", "\<\"TAD3\"\>", 
       ",", "\<\"TAD4\"\>", ",", "\<\"TbD1\"\>", ",", "\<\"TBD1\"\>", 
       ",", "\<\"TbD2\"\>", ",", "\<\"TBD2\"\>", ",", "\<\"TbD3\"\>", 
       ",", "\<\"TBD3\"\>", ",", "\<\"TBD4\"\>", ",", "\<\"TcD1\"\>", 
       ",", "\<\"TcD2\"\>", ",", "\<\"TcD3\"\>", ",", "\<\"TN\"\>", 
       ",", "\<\"Tuse1\"\>", ",", "\<\"TuseExt11\"\>", 
       ",", "\<\"TuseExt21\"\>", ",", "\<\"TuseN1\"\>"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"pol", "[", 
       RowBox[{"44", ",", "57", ",", "16", ",", "0", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "1"}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "1"}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "1", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "1", ",", "0", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
            "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
            "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
            "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", 
            RowBox[{"-", "1"}], ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
            "2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", 
            RowBox[{"-", "2"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "2", ",", 
            "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", 
            RowBox[{"-", "2"}], ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", 
            RowBox[{"-", "2"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "2", ",", 
            "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", 
            RowBox[{"-", "2"}], ",", "0", ",", 
            RowBox[{"-", "2"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "2", ",", 
            "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", 
            RowBox[{"-", "2"}], ",", "0", ",", 
            RowBox[{"-", "2"}], ",", "0", ",", 
            RowBox[{"-", "2"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "2", ",", 
            "2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}],
            "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}],
            "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}],
            "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "2"}],
            "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", 
            RowBox[{"-", "2"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "2", ",", "0"}],
            "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "2"}], ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", 
            RowBox[{"-", "2"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "2", ",", "1"}],
            "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", 
            RowBox[{"-", "2"}], ",", "0", ",", 
            RowBox[{"-", "2"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "2", ",", "1"}],
            "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "2"}], ",", "0", ",", 
            RowBox[{"-", "2"}], ",", "0", ",", 
            RowBox[{"-", "2"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "2", ",", "2"}],
            "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
            "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "3"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "2", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", 
            RowBox[{"-", "2"}], ",", 
            RowBox[{"-", "7"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
            "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
            "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "2"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], 
          ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "0", ",", "1", ",", 
            "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", 
            ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "1", ",", "1", ",", "3", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "2"}], ",", 
            RowBox[{"-", "1"}], ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "1", ",", 
            "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", 
            ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "1", ",", "1", ",", "3", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "0", ",", "1", ",", 
            "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", 
            ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "1", ",", "1", ",", "3", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "2"}], ",", 
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "1", ",", 
            "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", 
            ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "1", ",", "1", ",", "3", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "0", ",", "1", ",", 
            "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", 
            ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "1", ",", "1", ",", "3", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "1", ",", 
            "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", 
            ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "1", ",", "1", ",", "3", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "0", ",", "1", ",", 
            "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", 
            ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "1", ",", "1", ",", "3", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "2"}], ",", 
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "0", ",", "1", ",", 
            "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", 
            ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "1", ",", "1", ",", "3", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "0", ",", "1", ",", 
            "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", 
            ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "1", ",", "1", ",", "3", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "2"}], ",", 
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "0", ",", "1", ",", 
            "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", 
            ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "1", ",", "1", ",", "3", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "0", ",", "1", ",", 
            "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", 
            ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "1", ",", "1", ",", "3", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "2"}], ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "2"}], ",", 
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "1", ",", 
            "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", 
            ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "1", ",", "1", ",", "3", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "2"}], ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "1", ",", 
            "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", 
            ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "1", ",", "1", ",", "3", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "1", ",", 
            "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", 
            ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "1", ",", "1", ",", "3", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "1", ",", 
            "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", 
            ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "1", ",", "1", ",", "3", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "2"}], ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "1", ",", 
            "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", 
            ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "1", ",", "1", ",", "3", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "1", ",", 
            "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
            "1", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "1", ",", 
            "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "2", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "1", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "1", ",", 
            "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "1", ",", 
            "0", ",", "1", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "1", ",", 
            "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
            "1", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "1", ",", 
            "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "1", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "1", ",", 
            "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", 
            ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", 
            ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
            "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "1", ",", 
            "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", 
            ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
            "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
            "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
            "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
            "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
            "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
            "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "2", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
            "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "2", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
            "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "2", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
            "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
            ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
            "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
            "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
            "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
            "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
            "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
            "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "1", ",", 
            "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
            "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "2", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
            "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
            "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "2", ",", "0", ",", "2", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
            "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "2", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
            "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "1", ",", "0", ",", "2", ",", "0", ",", "0", ",", "0", 
            ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "1", ",", 
            "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
            "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "1", ",", 
            "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
            ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
            "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "1", ",", "0", ",", "2", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
            ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
            "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", 
            ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
            "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
            "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "2", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
            "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
            "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
            "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
            "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
            "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
            "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "2", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "1", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
            "1", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "1", ",", 
            "0", ",", "1", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
            "1", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
            "1", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "0", ",", "1", ",", 
            "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
            ",", "1", ",", "0"}], "}"}]}], "}"}]}], "]"}], "}"}]}], "]"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.453133784669355*^9, 3.453133823242281*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"vertices", "[", "ddd", "]"}]], "Input",
 CellChangeTimes->{{3.453133789497305*^9, 3.4531337926853533`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", "0", ",", 
     RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "3", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2"}], ",", 
     RowBox[{"-", "1"}], ",", "0", ",", 
     RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "3", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "1"}], ",", "0", ",", 
     RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "3", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "2"}], ",", 
     RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "3", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "3", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", "0", ",", 
     RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "3", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "3", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "2"}], ",", 
     RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "3", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "3", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "2"}], ",", 
     RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "3", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "3", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "2"}], ",", 
     RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "3", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "3", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "3", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "3", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "3", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.4531337931425943`*^9}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Test1 of scd",
 FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<testscd1.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"[add][testscd1]\"\>"], "Print"],

Cell[BoxData["\<\" Library Loaded\"\>"], "Print"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"asaveLib", "[", "\"\<testscd1\>\"", "]"}], ";"}], "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$scheduleLibrary", "=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"analyze", "[", 
  RowBox[{"recurse", "\[Rule]", "True"}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Need to analyze : \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"add\"\>", ",", "\<\"testscd1\"\>"}], "}"}]}],
  SequenceForm["Need to analyze : ", {"add", "testscd1"}],
  Editable->False]], "Print"],

Cell[BoxData["\<\" \"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"add\"\>"}],
  SequenceForm["Static Analysis of system ", "add"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"c\"\>"}],
  SequenceForm["----equation defining ", "c"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print"],

Cell[BoxData["\<\" \"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"testscd1\"\>"}],
  SequenceForm["Static Analysis of system ", "testscd1"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"A\"\>"}],
  SequenceForm["----equation defining ", "A"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----use \"\>", "\[InvisibleSpace]", "\<\"add\"\>", 
   "\[InvisibleSpace]", "\<\"...\"\>"}],
  SequenceForm["----use ", "add", "..."],
  Editable->False]], "Print"],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print"],

Cell[BoxData["\<\"\\nRecursive Analysis Successful.\"\>"], "Print"]
}, Open  ]],

Cell[BoxData["True"], "Output"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<add\>\"", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"scd", "[", 
  RowBox[{"addConstraints", "\[Rule]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"TaD1", "==", "1"}], ",", 
     RowBox[{"TbD1", "==", "1"}], ",", 
     RowBox[{"TcD1", "\[Equal]", "1"}]}], "}"}]}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "27", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "11", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   RowBox[{"0.010183999999995308`", " ", "Second"}]}],
  SequenceForm[
  27, " constraints, ", 11, " variables ", 0.010183999999995308` Second],
  Editable->False]], "Print"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"add\"\>", ",", "11", ",", "24", ",", 
   RowBox[{"0.010183999999995308`", " ", "Second"}], ",", "\<\"Vertex\"\>", 
   ",", "\<\"Flat\"\>"}], "}"}]], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"add\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"a\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"b\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"c\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}]}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], "]"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"showSchedResult", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"a\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "\<\"k\"\>"}],
  SequenceForm["T_", "a", {"k", "N"}, " = ", "k"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"b\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "\<\"k\"\>"}],
  SequenceForm["T_", "b", {"k", "N"}, " = ", "k"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"c\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"1", "+", "\<\"k\"\>"}]}],
  SequenceForm["T_", "c", {"k", "N"}, " = ", 1 + "k"],
  Editable->False]], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"systemNames", "[", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"add\"\>", ",", "\<\"testscd1\"\>"}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<testscd1\>\"", "]"}], ";", 
  RowBox[{"ashow", "[", "]"}]}]], "Input"],

Cell[BoxData["\<\"system testscd1 :{M | 1<=M}\\n                (in : {k | \
1<=k<=M} of integer)\\n       returns  (out : {k | 1<=k<=M} of \
integer);\\nvar\\n  A : {k | 1<=k<=M} of integer;\\nlet\\n  A[k] = in;\\n  \
use  add[M] (in, A) returns  (out) ;\\ntel;\"\>"], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"scd", "[", "]"}]], "Input"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New schedule: \"\>", "\[InvisibleSpace]", 
   RowBox[{"scheduleResult", "[", 
    RowBox[{"\<\"add\"\>", ",", 
     RowBox[{"{", "\<\"M\"\>", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"\<\"c\"\>", ",", 
        RowBox[{"{", 
         RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
        RowBox[{"sched", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], 
      "}"}]}], "]"}]}],
  SequenceForm["New schedule: ", 
   scheduleResult["add", {"M"}, {{"a", {"k", "M"}, 
      sched[{1, 0}, 0]}, {"b", {"k", "M"}, 
      sched[{1, 0}, 0]}}, {{"c", {"k", "M"}, 
      sched[{1, 0}, 1]}}]],
  Editable->False]], "Print"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Minimize", "::", "\<\"natt\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"The minimum is not attained at any point satisfying the \
given constraints. \\!\\(\\*ButtonBox[\\\"Plus\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Minimize::natt\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData["\<\"No unidimensional schedule\"\>"], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"showSchedResult", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"A\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "\<\"k\"\>"}],
  SequenceForm["T_", "A", {"k", "M"}, " = ", "k"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"in\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"-", "1"}], "+", "\<\"k\"\>"}]}],
  SequenceForm["T_", "in", {"k", "M"}, " = ", -1 + "k"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"out\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"1", "+", "\<\"k\"\>"}]}],
  SequenceForm["T_", "out", {"k", "M"}, " = ", 1 + "k"],
  Editable->False]], "Print"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Test2 of scd",
 FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"<<", "Alpha/VertexSchedule.m"}]], "Input"],

Cell[BoxData["\<\"Do not forget to change the initialization of \
$scheduleLibrary\"\>"], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<testscd2.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"[add][testscd2]\"\>"], "Print"],

Cell[BoxData["\<\" Library Loaded\"\>"], "Print"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"asaveLib", "[", "\"\<testscd1\>\"", "]"}], ";"}], "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<add\>\"", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"scd", "[", 
  RowBox[{"addConstraints", "\[Rule]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"TaD1", "==", "1"}], ",", 
     RowBox[{"TbD1", "==", "1"}]}], "}"}]}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "25", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "11", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   RowBox[{"0.008926999999985696`", " ", "Second"}]}],
  SequenceForm[
  25, " constraints, ", 11, " variables ", 0.008926999999985696 Second],
  Editable->False]], "Print"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"add\"\>", ",", "11", ",", "23", ",", 
   RowBox[{"0.008926999999985696`", " ", "Second"}], ",", "\<\"Vertex\"\>", 
   ",", "\<\"Flat\"\>"}], "}"}]], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"add\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"a\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"b\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"c\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}], ",", "1"}], "]"}]}], "}"}]}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], "]"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"analyze", "[", 
  RowBox[{"recurse", "\[Rule]", "True"}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Need to analyze : \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "\<\"add\"\>", "}"}]}],
  SequenceForm["Need to analyze : ", {"add"}],
  Editable->False]], "Print"],

Cell[BoxData["\<\" \"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"add\"\>"}],
  SequenceForm["Static Analysis of system ", "add"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"c\"\>"}],
  SequenceForm["----equation defining ", "c"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print"],

Cell[BoxData["\<\"\\nRecursive Analysis Successful.\"\>"], "Print"]
}, Open  ]],

Cell[BoxData["True"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<testscd2\>\"", "]"}], ";", 
  RowBox[{"ashow", "[", "]"}]}]], "Input"],

Cell[BoxData["\<\"system testscd2 :{M | 1<=M}\\n                (in : {k | \
1<=k<=M} of integer)\\n       returns  (out : {k | 1<=k<=M} of \
integer);\\nvar\\n  A : {k | 1<=k<=M} of integer;\\n  B : {k | 1<=k<=M} of \
integer;\\nlet\\n  A[k] = in;\\n  use  add[M] (in, A) returns  (B) ;\\n  use  \
add[M] (A, B) returns  (out) ;\\ntel;\"\>"], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"scd", "[", 
  RowBox[{
   RowBox[{"addConstraints", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"TinD1", "\[Equal]", "0"}], "}"}]}], ",", 
   RowBox[{"debug", "\[Rule]", "False"}]}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New schedule: \"\>", "\[InvisibleSpace]", 
   RowBox[{"scheduleResult", "[", 
    RowBox[{"\<\"add\"\>", ",", 
     RowBox[{"{", "\<\"M\"\>", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"\<\"c\"\>", ",", 
        RowBox[{"{", 
         RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
        RowBox[{"sched", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}], ",", "1"}], "]"}]}], "}"}], 
      "}"}]}], "]"}]}],
  SequenceForm["New schedule: ", 
   scheduleResult["add", {"M"}, {{"a", {"k", "M"}, 
      sched[{1, 0}, 0]}, {"b", {"k", "M"}, 
      sched[{1, 0}, 0]}}, {{"c", {"k", "M"}, 
      sched[{0, 1}, 1]}}]],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New schedule: \"\>", "\[InvisibleSpace]", 
   RowBox[{"scheduleResult", "[", 
    RowBox[{"\<\"add\"\>", ",", 
     RowBox[{"{", "\<\"M\"\>", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"\<\"c\"\>", ",", 
        RowBox[{"{", 
         RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
        RowBox[{"sched", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}], ",", "1"}], "]"}]}], "}"}], 
      "}"}]}], "]"}]}],
  SequenceForm["New schedule: ", 
   scheduleResult["add", {"M"}, {{"a", {"k", "M"}, 
      sched[{1, 0}, 0]}, {"b", {"k", "M"}, 
      sched[{1, 0}, 0]}}, {{"c", {"k", "M"}, 
      sched[{0, 1}, 1]}}]],
  Editable->False]], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Minimize", "::", "\<\"natt\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"The minimum is not attained at any point satisfying the \
given constraints. \\!\\(\\*ButtonBox[\\\"Plus\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Minimize::natt\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData["\<\"No unidimensional schedule\"\>"], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"adaptUses", "[", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"scd", "[", 
  RowBox[{
   RowBox[{"addConstraints", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"TinD1", "\[Equal]", "0"}], "}"}]}], ",", 
   RowBox[{"debug", "\[Rule]", "False"}]}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New schedule: \"\>", "\[InvisibleSpace]", 
   RowBox[{"scheduleResult", "[", 
    RowBox[{"\<\"add\"\>", ",", 
     RowBox[{"{", "\<\"M\"\>", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"\<\"c\"\>", ",", 
        RowBox[{"{", 
         RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
        RowBox[{"sched", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}], ",", "1"}], "]"}]}], "}"}], 
      "}"}]}], "]"}]}],
  SequenceForm["New schedule: ", 
   scheduleResult["add", {"M"}, {{"a", {"k", "M"}, 
      sched[{1, 0}, 0]}, {"b", {"k", "M"}, 
      sched[{1, 0}, 0]}}, {{"c", {"k", "M"}, 
      sched[{0, 1}, 1]}}]],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New schedule: \"\>", "\[InvisibleSpace]", 
   RowBox[{"scheduleResult", "[", 
    RowBox[{"\<\"add\"\>", ",", 
     RowBox[{"{", "\<\"M\"\>", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"\<\"c\"\>", ",", 
        RowBox[{"{", 
         RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
        RowBox[{"sched", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}], ",", "1"}], "]"}]}], "}"}], 
      "}"}]}], "]"}]}],
  SequenceForm["New schedule: ", 
   scheduleResult["add", {"M"}, {{"a", {"k", "M"}, 
      sched[{1, 0}, 0]}, {"b", {"k", "M"}, 
      sched[{1, 0}, 0]}}, {{"c", {"k", "M"}, 
      sched[{0, 1}, 1]}}]],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "93", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "30", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   RowBox[{"1.241761000000011`", " ", "Second"}]}],
  SequenceForm[
  93, " constraints, ", 30, " variables ", 1.241761000000011 Second],
  Editable->False]], "Print"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"testscd2\"\>", ",", "30", ",", "74", ",", 
   RowBox[{"1.241761000000011`", " ", "Second"}], ",", "\<\"Vertex\"\>", 
   ",", "\<\"Structured\"\>"}], "}"}]], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"testscd2\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"adaptIn21\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"adaptIn22\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"adaptIn31\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", "2"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"adaptIn32\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", "2"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"B\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}], ",", "2"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"in\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"out\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "2"}], "}"}], ",", "3"}], "]"}]}], "}"}]}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}]}], "]"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"showSchedResult", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"A\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["T_", "A", {"k", "M"}, " = ", 1],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"adaptIn21\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"1", "+", "\<\"k\"\>"}]}],
  SequenceForm["T_", "adaptIn21", {"k", "M"}, " = ", 1 + "k"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"adaptIn22\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"1", "+", "\<\"k\"\>"}]}],
  SequenceForm["T_", "adaptIn22", {"k", "M"}, " = ", 1 + "k"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"adaptIn31\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"2", "+", "\<\"k\"\>", "+", "\<\"M\"\>"}]}],
  SequenceForm["T_", "adaptIn31", {"k", "M"}, " = ", 2 + "k" + "M"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"adaptIn32\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"2", "+", "\<\"k\"\>", "+", "\<\"M\"\>"}]}],
  SequenceForm["T_", "adaptIn32", {"k", "M"}, " = ", 2 + "k" + "M"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"B\"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"2", "+", "\<\"M\"\>"}]}],
  SequenceForm["T_", "B", {"k", "M"}, " = ", 2 + "M"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"in\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "0"}],
  SequenceForm["T_", "in", {"k", "M"}, " = ", 0],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"out\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"3", "+", 
    RowBox[{"2", " ", "\<\"M\"\>"}]}]}],
  SequenceForm["T_", "out", {"k", "M"}, " = ", 3 + 2 "M"],
  Editable->False]], "Print"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Test3 of scd",
 FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"<<", "Alpha/VertexSchedule.m"}]], "Input"],

Cell[BoxData["\<\"Do not forget to change the initialization of \
$scheduleLibrary\"\>"], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<testscd3.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"[add][testscd3]\"\>"], "Print"],

Cell[BoxData["\<\" Library Loaded\"\>"], "Print"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"asaveLib", "[", "\"\<testscd1\>\"", "]"}], ";"}], "*)"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"analyze", "[", 
  RowBox[{"recurse", "\[Rule]", "True"}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Need to analyze : \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"add\"\>", ",", "\<\"testscd3\"\>"}], "}"}]}],
  SequenceForm["Need to analyze : ", {"add", "testscd3"}],
  Editable->False]], "Print"],

Cell[BoxData["\<\" \"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"add\"\>"}],
  SequenceForm["Static Analysis of system ", "add"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"c\"\>"}],
  SequenceForm["----equation defining ", "c"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print"],

Cell[BoxData["\<\" \"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"testscd3\"\>"}],
  SequenceForm["Static Analysis of system ", "testscd3"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----use \"\>", "\[InvisibleSpace]", "\<\"add\"\>", 
   "\[InvisibleSpace]", "\<\"...\"\>"}],
  SequenceForm["----use ", "add", "..."],
  Editable->False]], "Print"],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print"],

Cell[BoxData["\<\"\\nRecursive Analysis Successful.\"\>"], "Print"]
}, Open  ]],

Cell[BoxData["True"], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<testscd2\>\"", "]"}], ";", 
  RowBox[{"ashow", "[", "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"testscd2\"\>", 
   "\[InvisibleSpace]", "\<\" : not found in the library.\"\>"}],
  SequenceForm["testscd2", " : not found in the library."],
  Editable->False]], "Print"],

Cell[BoxData["\<\"system testscd3 :{M | 1<=M}\\n                (in : {k,i | \
1<=k<=M; 1<=i<=10} of integer)\\n       returns  (out : {k,i | 1<=k<=M; \
1<=i<=10} of integer);\\nlet\\n  use {i | 1<=i<=10} add[M] (in, in) returns  \
(out) ;\\ntel;\"\>"], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"scd", "[", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"addConstraints", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"TinD1", "\[Equal]", "0"}], "}"}]}], ","}], "*)"}], 
  RowBox[{"debug", "\[Rule]", "False"}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New schedule: \"\>", "\[InvisibleSpace]", 
   RowBox[{"scheduleResult", "[", 
    RowBox[{"\<\"add\"\>", ",", 
     RowBox[{"{", "\<\"M\"\>", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"\<\"c\"\>", ",", 
        RowBox[{"{", 
         RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
        RowBox[{"sched", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], 
      "}"}]}], "]"}]}],
  SequenceForm["New schedule: ", 
   scheduleResult["add", {"M"}, {{"a", {"k", "M"}, 
      sched[{1, 0}, 0]}, {"b", {"k", "M"}, 
      sched[{1, 0}, 0]}}, {{"c", {"k", "M"}, 
      sched[{1, 0}, 1]}}]],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "22", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "12", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   RowBox[{"0.02000000000000135`", " ", "Second"}]}],
  SequenceForm[
  22, " constraints, ", 12, " variables ", 0.02000000000000135 Second],
  Editable->False]], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"testscd3\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"in\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", 
           FractionBox["1", "10"], ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"out\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", "1"}], "]"}]}], 
      "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], "]"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"$scheduleMDSol", "[", "1", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"TM", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"0", "==", "ToutD3"}], ",", 
     RowBox[{"Aout", "==", 
      RowBox[{"1", "+", "AlphaVars`Tuse1"}]}], ",", 
     RowBox[{"TinD1", "==", "1"}], ",", 
     RowBox[{"ToutD1", "==", "1"}], ",", 
     RowBox[{"TinD3", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TinD1", "+", "TinD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TinD3"}], "+", "TM"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TinD1"}], "-", "TinD3", "+", "TM"}], "\[GreaterEqual]", 
      "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ain"}], "+", "aparam", "-", "TinD1", "-", 
       RowBox[{"10", " ", "TinD2"}], "-", "TinD3", "+", "TM"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ain"}], "+", "aparam", "-", "TinD1", "-", "TinD2", "-", 
       "TinD3", "+", "TM"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TM", "-", "ToutD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TM", "-", "ToutD1", "-", "ToutD3"}], "\[GreaterEqual]", "0"}], 
     ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aout"}], "+", "aparam", "+", "TM", "-", "ToutD1", "-", 
       RowBox[{"10", " ", "ToutD2"}], "-", "ToutD3"}], "\[GreaterEqual]", 
      "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aout"}], "+", "aparam", "+", "TM", "-", "ToutD1", "-", 
       "ToutD2", "-", "ToutD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"AlphaVars`Tuse1", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"AlphaVars`TuseM1", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"0", "\[LessEqual]", "TinD3"}], ",", 
     RowBox[{"Ain", "\[LessEqual]", "AlphaVars`Tuse1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "Ain", ",", "Aout", ",", "aparam", ",", "TinD1", ",", "TinD2", ",", 
     "TinD3", ",", "TM", ",", "ToutD1", ",", "ToutD2", ",", "ToutD3", ",", 
     "AlphaVars`Tuse1", ",", "AlphaVars`TuseM1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Ain", "\[Rule]", "0"}], ",", 
       RowBox[{"Aout", "\[Rule]", "1"}], ",", 
       RowBox[{"aparam", "\[Rule]", "1"}], ",", 
       RowBox[{"TinD1", "\[Rule]", "1"}], ",", 
       RowBox[{"TinD2", "\[Rule]", 
        FractionBox["1", "10"]}], ",", 
       RowBox[{"TinD3", "\[Rule]", "0"}], ",", 
       RowBox[{"TM", "\[Rule]", "1"}], ",", 
       RowBox[{"ToutD1", "\[Rule]", "1"}], ",", 
       RowBox[{"ToutD2", "\[Rule]", "0"}], ",", 
       RowBox[{"ToutD3", "\[Rule]", "0"}], ",", 
       RowBox[{"AlphaVars`Tuse1", "\[Rule]", "0"}], ",", 
       RowBox[{"AlphaVars`TuseM1", "\[Rule]", "0"}]}], "}"}]}], "}"}]}], 
  "}"}]], "Output"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"adaptUses", "[", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"scd", "[", 
  RowBox[{
   RowBox[{"addConstraints", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"TinD2", "\[Equal]", "0"}], ",", 
      RowBox[{"TinD1", "\[Equal]", "0"}], ",", 
      RowBox[{"TadaptIn11D2", "\[Equal]", "0"}], ",", 
      RowBox[{"TadaptIn12D2", "\[Equal]", "0"}]}], "}"}]}], ",", 
   RowBox[{"debug", "\[Rule]", "False"}]}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New schedule: \"\>", "\[InvisibleSpace]", 
   RowBox[{"scheduleResult", "[", 
    RowBox[{"\<\"add\"\>", ",", 
     RowBox[{"{", "\<\"M\"\>", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"\<\"c\"\>", ",", 
        RowBox[{"{", 
         RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
        RowBox[{"sched", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], 
      "}"}]}], "]"}]}],
  SequenceForm["New schedule: ", 
   scheduleResult["add", {"M"}, {{"a", {"k", "M"}, 
      sched[{1, 0}, 0]}, {"b", {"k", "M"}, 
      sched[{1, 0}, 0]}}, {{"c", {"k", "M"}, 
      sched[{1, 0}, 1]}}]],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "54", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "20", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   RowBox[{"0.030000000000001137`", " ", "Second"}]}],
  SequenceForm[
  54, " constraints, ", 20, " variables ", 0.030000000000001137` Second],
  Editable->False]], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"testscd3\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"adaptIn11\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"adaptIn12\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"in\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"out\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", "1"}], "]"}]}], 
      "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], "]"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"showSchedResult", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"adaptIn11\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "\<\"k\"\>"}],
  SequenceForm["T_", "adaptIn11", {"k", "i", "M"}, " = ", "k"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"adaptIn12\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "\<\"k\"\>"}],
  SequenceForm["T_", "adaptIn12", {"k", "i", "M"}, " = ", "k"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"in\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "0"}],
  SequenceForm["T_", "in", {"k", "i", "M"}, " = ", 0],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"out\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"1", "+", "\<\"k\"\>"}]}],
  SequenceForm["T_", "out", {"k", "i", "M"}, " = ", 1 + "k"],
  Editable->False]], "Print"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Test4 of scd",
 FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"<<", "Alpha/VertexSchedule.m"}]], "Input"],

Cell[BoxData["\<\"Do not forget to change the initialization of \
$scheduleLibrary\"\>"], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<testscd4.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"[add][testscd4]\"\>"], "Print"],

Cell[BoxData["\<\" Library Loaded\"\>"], "Print"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"asaveLib", "[", "\"\<testscd1\>\"", "]"}], ";"}], "*)"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"analyze", "[", 
  RowBox[{"recurse", "\[Rule]", "True"}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Need to analyze : \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"add\"\>", ",", "\<\"testscd3\"\>"}], "}"}]}],
  SequenceForm["Need to analyze : ", {"add", "testscd3"}],
  Editable->False]], "Print"],

Cell[BoxData["\<\" \"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"add\"\>"}],
  SequenceForm["Static Analysis of system ", "add"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"c\"\>"}],
  SequenceForm["----equation defining ", "c"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print"],

Cell[BoxData["\<\" \"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"testscd3\"\>"}],
  SequenceForm["Static Analysis of system ", "testscd3"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----use \"\>", "\[InvisibleSpace]", "\<\"add\"\>", 
   "\[InvisibleSpace]", "\<\"...\"\>"}],
  SequenceForm["----use ", "add", "..."],
  Editable->False]], "Print"],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print"],

Cell[BoxData["\<\"\\nRecursive Analysis Successful.\"\>"], "Print"]
}, Open  ]],

Cell[BoxData["True"], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<testscd4\>\"", "]"}], ";", 
  RowBox[{"ashow", "[", "]"}]}]], "Input"],

Cell[BoxData["\<\"system testscd4 :{M | 1<=M}\\n                (in : {k | \
1<=k<=M} of integer)\\n       returns  (out : {k,i | 1<=k<=M; 1<=i<=10} of \
integer);\\nvar\\n  A : {k,i | 1<=k<=M; 1<=i<=10} of integer;\\nlet\\n  \
A[k,i] = \\n      case\\n        { | i=1} : in[k,i];\\n        { | 2<=i} : \
A[k,i-1] + 1[];\\n      esac;\\n  use {i | 1<=i<=10} add[M] (A, A) returns  \
(out) ;\\ntel;\"\>"], "Print"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"analyze", "[", 
  RowBox[{"recurse", "\[Rule]", "True"}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Need to analyze : \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"add\"\>", ",", "\<\"testscd4\"\>"}], "}"}]}],
  SequenceForm["Need to analyze : ", {"add", "testscd4"}],
  Editable->False]], "Print"],

Cell[BoxData["\<\" \"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"add\"\>"}],
  SequenceForm["Static Analysis of system ", "add"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"c\"\>"}],
  SequenceForm["----equation defining ", "c"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print"],

Cell[BoxData["\<\" \"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"testscd4\"\>"}],
  SequenceForm["Static Analysis of system ", "testscd4"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print"],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print"],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"A\"\>"}],
  SequenceForm["----equation defining ", "A"],
  Editable->False]], "Print"],

Cell[BoxData["\<\"ERROR: Dimensions not compatible in dependence :\"\>"], \
"Print"],

Cell[BoxData["\<\"in.(k,i,M->k,i,M)\"\>"], "Print"],

Cell[BoxData["\<\" \"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----use \"\>", "\[InvisibleSpace]", "\<\"add\"\>", 
   "\[InvisibleSpace]", "\<\"...\"\>"}],
  SequenceForm["----use ", "add", "..."],
  Editable->False]], "Print"],

Cell[BoxData["\<\"\\n*** Analysis failed ***\"\>"], "Print"],

Cell[BoxData["\<\"\\n***Recursive Analysis failed ***\"\>"], "Print"]
}, Open  ]],

Cell[BoxData["False"], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"show", "[", 
  RowBox[{"$scheduleDepTable", ",", 
   RowBox[{"silent", "\[Rule]", "True"}]}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Regular dependences: \"\>"], "Print"],

Cell[BoxData["\<\"Subsystems dependences: \"\>"], "Print"],

Cell[BoxData["\<\"add[(i,M->M)](A,A) <- (out)\"\>"], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"scd", "[", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"addConstraints", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"TinD1", "\[Equal]", "0"}], "}"}]}], ","}], "*)"}], 
  RowBox[{
   RowBox[{"debug", "\[Rule]", "False"}], ",", 
   RowBox[{"verbose", "\[Rule]", "True"}]}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Dependencies kept are:\"\>"], "Print"],

Cell[BoxData["\<\"Regular dependences: \"\>"], "Print"],

Cell[BoxData["\<\"{k,i,M | 1<=k<=M; i=1} : A[k,i,M] -> in[k,i+M-1]\\n{k,i,M | \
1<=k<=M; 2<=i<=10} : A[k,i,M] -> A[k,i-1,M]\"\>"], "Print"],

Cell[BoxData["\<\"Subsystems dependences: \"\>"], "Print"],

Cell[BoxData["\<\"add[(i,M->M)](A,A) <- (out)\"\>"], "Print"],

Cell[BoxData["\<\"----------------------------\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--- LHS variable: \"\>", "\[InvisibleSpace]", "\<\"in\"\>", 
   "\[InvisibleSpace]", "\<\", RHS variable: \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["--- LHS variable: ", "in", ", RHS variable: ", ""],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constraints: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"TinD2", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TinD1", "+", "TinD2"}], "\[GreaterEqual]", "0"}]}], "}"}]}],
  SequenceForm["    Constraints: ", {TinD2 >= 0, TinD1 + TinD2 >= 0}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--- LHS variable: \"\>", "\[InvisibleSpace]", "\<\"A\"\>", 
   "\[InvisibleSpace]", "\<\", RHS variable: \"\>", 
   "\[InvisibleSpace]", "\<\"in\"\>"}],
  SequenceForm["--- LHS variable: ", "A", ", RHS variable: ", "in"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constraints: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"TAD3", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD1", "+", "TAD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD3", "-", "TinD2"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD1", "+", "TAD3", "-", "TinD1", "-", "TinD2"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
      "AA", "-", "Ain", "+", "TAD1", "+", "TAD2", "+", "TAD3", "-", "TinD1", 
       "-", "TinD2"}], "\[GreaterEqual]", "1"}]}], "}"}]}],
  SequenceForm[
  "    Constraints: ", {
   TAD3 >= 0, TAD1 + TAD3 >= 0, TAD3 - TinD2 >= 0, 
    TAD1 + TAD3 - TinD1 - TinD2 >= 0, 
    AA - Ain + TAD1 + TAD2 + TAD3 - TinD1 - TinD2 >= 1}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--- LHS variable: \"\>", "\[InvisibleSpace]", "\<\"A\"\>", 
   "\[InvisibleSpace]", "\<\", RHS variable: \"\>", 
   "\[InvisibleSpace]", "\<\"A\"\>"}],
  SequenceForm["--- LHS variable: ", "A", ", RHS variable: ", "A"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constraints: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"True", ",", 
     RowBox[{"TAD2", "\[GreaterEqual]", "1"}], ",", 
     RowBox[{"TAD3", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD1", "+", "TAD3"}], "\[GreaterEqual]", "0"}]}], "}"}]}],
  SequenceForm[
  "    Constraints: ", {True, TAD2 >= 1, TAD3 >= 0, TAD1 + TAD3 >= 0}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"-----------------------\\n\"\>", 
   "\[InvisibleSpace]", "\<\"Entering getUseSchedule on subsystem: \"\>", 
   "\[InvisibleSpace]", "\<\"add\"\>"}],
  SequenceForm[
  "-----------------------\n", "Entering getUseSchedule on subsystem: ", 
   "add"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Extension domain: \"\>", 
   "\[InvisibleSpace]", "\<\"{i,M | 1<=i<=10}\"\>"}],
  SequenceForm["Extension domain: ", "{i,M | 1<=i<=10}"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Parameters of the calling system: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "\<\"M\"\>", "}"}]}],
  SequenceForm["Parameters of the calling system: ", {"M"}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"alpha form of the calling matrix is: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"matrix", "[", 
    RowBox[{"2", ",", "3", ",", 
     RowBox[{"{", 
      RowBox[{"\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], "]"}], 
   "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", "\<\"(i,M->M)\"\>"}],
  SequenceForm["alpha form of the calling matrix is: ", 
   matrix[2, 3, {"i", "M"}, {{0, 1, 0}, {0, 0, 1}}], "\n", "(i,M->M)"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"MMA form of the calling matrix is: \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], "}"}]}],
  SequenceForm["MMA form of the calling matrix is: ", {{0, 1}}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Translation of the calling matrix is: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "0", "}"}]}],
  SequenceForm["Translation of the calling matrix is: ", {0}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Dependence table entry: \"\>", "\[InvisibleSpace]", 
   RowBox[{"dependuse", "[", 
    RowBox[{"\<\"add\"\>", ",", 
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", "\<\"A\"\>"}], "}"}], ",", 
     RowBox[{"{", "\<\"out\"\>", "}"}], ",", "1", ",", 
     RowBox[{"domain", "[", 
      RowBox[{"2", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"pol", "[", 
         RowBox[{"2", ",", "3", ",", "0", ",", "1", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "0", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", 
              RowBox[{"-", "1"}], ",", "0", ",", "10"}], "}"}]}], "}"}], ",", 
          
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "10", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
         "]"}], "}"}]}], "]"}], ",", 
     RowBox[{"matrix", "[", 
      RowBox[{"2", ",", "3", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], "]"}]}], 
    "]"}]}],
  SequenceForm["Dependence table entry: ", 
   dependuse["add", {"A", "A"}, {"out"}, 1, 
    domain[2, {"i", "M"}, {
      pol[
      2, 3, 0, 1, {{1, 1, 0, -1}, {1, -1, 0, 10}}, {{0, 0, 1, 0}, {1, 1, 0, 
       1}, {1, 10, 0, 1}}]}], 
    matrix[2, 3, {"i", "M"}, {{0, 1, 0}, {0, 0, 1}}]]],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Schedule found for system \"\>", 
   "\[InvisibleSpace]", "\<\"add\"\>", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"scheduleResult", "[", 
     RowBox[{"\<\"add\"\>", ",", 
      RowBox[{"{", "\<\"N\"\>", "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\<\"a\"\>", ",", 
          RowBox[{"{", 
           RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
          RowBox[{"sched", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
        
        RowBox[{"{", 
         RowBox[{"\<\"b\"\>", ",", 
          RowBox[{"{", 
           RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
          RowBox[{"sched", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}]}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"\<\"c\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], 
       "}"}]}], "]"}], "}"}]}],
  SequenceForm["Schedule found for system ", "add", ": ", {
    scheduleResult["add", {"N"}, {{"a", {"k", "N"}, 
       sched[{1, 0}, 0]}, {"b", {"k", "N"}, 
       sched[{1, 0}, 0]}}, {{"c", {"k", "N"}, 
       sched[{1, 0}, 1]}}]}],
  Editable->False]], "Print"],

Cell[BoxData["\<\"Number of actual input arguments is OK\"\>"], "Print"],

Cell[BoxData["\<\"Number of actual output arguments is OK\"\>"], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Schedule : \"\>", "\[InvisibleSpace]", 
   RowBox[{"scheduleResult", "[", 
    RowBox[{"\<\"add\"\>", ",", 
     RowBox[{"{", "\<\"N\"\>", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"\<\"c\"\>", ",", 
        RowBox[{"{", 
         RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
        RowBox[{"sched", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], 
      "}"}]}], "]"}]}],
  SequenceForm["Schedule : ", 
   scheduleResult["add", {"N"}, {{"a", {"k", "N"}, 
      sched[{1, 0}, 0]}, {"b", {"k", "N"}, 
      sched[{1, 0}, 0]}}, {{"c", {"k", "N"}, 
      sched[{1, 0}, 1]}}]],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Parameter matrix: \"\>", "\[InvisibleSpace]", 
   RowBox[{"matrix", "[", 
    RowBox[{"2", ",", "3", ",", 
     RowBox[{"{", 
      RowBox[{"\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], "]"}]}],
  SequenceForm["Parameter matrix: ", 
   matrix[2, 3, {"i", "M"}, {{0, 1, 0}, {0, 0, 1}}]],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Actual values of the parameters: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "\<\"M\"\>", "}"}]}],
  SequenceForm["Actual values of the parameters: ", {"M"}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Rules found: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"N\"\>", "\[Rule]", "\<\"M\"\>"}], "}"}]}],
  SequenceForm["Rules found: ", {"N" -> "M"}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Symbolic rules found: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"N\"\>", "\[Rule]", "\<\"M\"\>"}], "}"}]}],
  SequenceForm["Symbolic rules found: ", {"N" -> "M"}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Symbolic rules plus periodicity: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\<\"N\"\>", "\[Rule]", "\<\"M\"\>"}], ",", 
     RowBox[{"\<\"$P\"\>", "\[Rule]", "1"}]}], "}"}]}],
  SequenceForm["Symbolic rules plus periodicity: ", {"N" -> "M", "$P" -> 1}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New schedule: \"\>", "\[InvisibleSpace]", 
   RowBox[{"scheduleResult", "[", 
    RowBox[{"\<\"add\"\>", ",", 
     RowBox[{"{", "\<\"M\"\>", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"\<\"c\"\>", ",", 
        RowBox[{"{", 
         RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
        RowBox[{"sched", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], 
      "}"}]}], "]"}]}],
  SequenceForm["New schedule: ", 
   scheduleResult["add", {"M"}, {{"a", {"k", "M"}, 
      sched[{1, 0}, 0]}, {"b", {"k", "M"}, 
      sched[{1, 0}, 0]}}, {{"c", {"k", "M"}, 
      sched[{1, 0}, 1]}}]],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Schedule of inputs is: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"a\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"b\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}]}], 
    "}"}]}],
  SequenceForm["Schedule of inputs is: ", {{"a", {"k", "M"}, 
     sched[{1, 0}, 0]}, {"b", {"k", "M"}, 
     sched[{1, 0}, 0]}}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Schedule of outputs is: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"\<\"c\"\>", ",", 
      RowBox[{"{", 
       RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
      RowBox[{"sched", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], "}"}]}],
  SequenceForm["Schedule of outputs is: ", {{"c", {"k", "M"}, 
     sched[{1, 0}, 1]}}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Parameters (in subsystem) are: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "\<\"N\"\>", "}"}]}],
  SequenceForm["Parameters (in subsystem) are: ", {"N"}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Constant is : \"\>", "\[InvisibleSpace]", "AlphaVars`Tuse1"}],
  SequenceForm["Constant is : ", AlphaVars`Tuse1],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Calling system parameter coefficients are: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "AlphaVars`TuseM1", "}"}]}],
  SequenceForm[
  "Calling system parameter coefficients are: ", {AlphaVars`TuseM1}],
  Editable->False]], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "::", "\<\"iterb\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"Iterator \\!\\({Alpha`VertexSchedule`Private`i, 1, \\(\\(\
\[LeftSkeleton] 44 \[RightSkeleton]\\)\\)}\\) does not have appropriate \
bounds.\"\>"}]], "Message"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Coefficient of constant (useextconstants) is: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"ToExpression", "[", 
      RowBox[{"\<\"AlphaVars`TuseExt\"\>", "<>", 
       RowBox[{"ToString", "[", "Alpha`VertexSchedule`Private`i", "]"}], "<>",
        
       RowBox[{"ToString", "[", "1", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "Alpha`VertexSchedule`Private`i", ",", "1", ",", 
       "Alpha`VertexSchedule`Private`extraDimensions"}], "}"}]}], "]"}]}],
  SequenceForm["Coefficient of constant (useextconstants) is: ", 
   Table[
    ToExpression[
     StringJoin["AlphaVars`TuseExt", 
      ToString[Alpha`VertexSchedule`Private`i], 
      ToString[1]]], {
    Alpha`VertexSchedule`Private`i, 1, 
     Alpha`VertexSchedule`Private`extraDimensions}]],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"resi before call: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}]}], 
    "}"}]}],
  SequenceForm["resi before call: ", {{"A", 
     sched[{1, 0}, 0]}, {"A", 
     sched[{1, 0}, 0]}}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"resi before call: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"\<\"out\"\>", ",", 
      RowBox[{"sched", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], "}"}]}],
  SequenceForm["resi before call: ", {{"out", 
     sched[{1, 0}, 1]}}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--------------\\n\"\>", 
   "\[InvisibleSpace]", "\<\"Variable considered is: \"\>", 
   "\[InvisibleSpace]", "\<\"A\"\>"}],
  SequenceForm["--------------\n", "Variable considered is: ", "A"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Coefficients (coefs) of variable \"\>", 
   "\[InvisibleSpace]", "\<\"A\"\>", 
   "\[InvisibleSpace]", "\<\" in calling system are: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"TAD1", ",", "TAD2", ",", "TAD3"}], "}"}], ",", "AA"}], "}"}]}],
  
  SequenceForm[
  "Coefficients (coefs) of variable ", "A", 
   " in calling system are: ", {{TAD1, TAD2, TAD3}, AA}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Dimensions of variable \"\>", "\[InvisibleSpace]", "\<\"A\"\>",
    "\[InvisibleSpace]", "\<\" less params dimensions is: \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm[
  "Dimensions of variable ", "A", " less params dimensions is: ", 2],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Extension dimensions of variable \"\>", 
   "\[InvisibleSpace]", "\<\"A\"\>", "\[InvisibleSpace]", "\<\" is: \"\>", 
   "\[InvisibleSpace]", "1"}],
  SequenceForm["Extension dimensions of variable ", "A", " is: ", 1],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Index coefficients (coefsindex) are \"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", "TAD1", "}"}]}],
  SequenceForm["Index coefficients (coefsindex) are ", {TAD1}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Extension coefficients (coefsext) are \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "TAD2", "}"}]}],
  SequenceForm["Extension coefficients (coefsext) are ", {TAD2}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Params coefficients (coefsp) are \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "TAD3", "}"}]}],
  SequenceForm["Params coefficients (coefsp) are ", {TAD3}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Constant coefficient (coefsconstants) is \"\>", 
   "\[InvisibleSpace]", "AA"}],
  SequenceForm["Constant coefficient (coefsconstants) is ", AA],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Linear transformation of the caller's parameters (mmamat): \
\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], "}"}]}],
  SequenceForm[
  "Linear transformation of the caller's parameters (mmamat): ", {{0, 1}}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Actual coefficients (coefsParamsCalled) of parameters in \
calling system are \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "TAD3", "}"}]}],
  SequenceForm[
  "Actual coefficients (coefsParamsCalled) of parameters in calling system \
are ", {TAD3}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"s is \"\>", "\[InvisibleSpace]", 
   RowBox[{"sched", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}],
  SequenceForm["s is ", 
   sched[{1, 0}, 0]],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Coefficients of linear (coefslinear) part are \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["Coefficients of linear (coefslinear) part are ", {1}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Value of coefficients (coefsParamsCalledValue) of parameters \
in called system are \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0", "}"}]}],
  SequenceForm[
  "Value of coefficients (coefsParamsCalledValue) of parameters in called \
system are ", {0}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Parameters of caller (paramscaller:) \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "\<\"M\"\>", "}"}], 
   "\[InvisibleSpace]", "\<\"\\nParameters of called (paramscallee:) \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "\<\"N\"\>", "}"}], 
   "\[InvisibleSpace]", "\<\"\\nCoefficients of parameters in caller \
(coefsp:) \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "TAD3", "}"}], 
   "\[InvisibleSpace]", "\<\"\\nCoefficients of parameters in called \
(coefsParamsCalled:) \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "TAD3", "}"}]}],
  SequenceForm[
  "Parameters of caller (paramscaller:) ", {"M"}, 
   "\nParameters of called (paramscallee:) ", {"N"}, 
   "\nCoefficients of parameters in caller (coefsp:) ", {TAD3}, 
   "\nCoefficients of parameters in called (coefsParamsCalled:) ", {TAD3}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Coefficient of constant (coefConstant) is: \"\>", 
   "\[InvisibleSpace]", "AlphaVars`Tuse1"}],
  SequenceForm[
  "Coefficient of constant (coefConstant) is: ", AlphaVars`Tuse1],
  Editable->False]], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "::", "\<\"iterb\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"Iterator \\!\\({Alpha`VertexSchedule`Private`i, 1, \\(\\(\
\[LeftSkeleton] 44 \[RightSkeleton]\\)\\)}\\) does not have appropriate \
bounds.\"\>"}]], "Message"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MapThread", "::", "\<\"mptd\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"Object \\!\\(Table[\\(\\(\\(\\(ToExpression[\\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\), \\(\\({\\(\\(\[LeftSkeleton] \
30 \[RightSkeleton]\\)\\), 1, \\(\\(\[LeftSkeleton] 44 \
\[RightSkeleton]\\)\\)}\\)\\)\\)\\)]\\) at position {2, \\!\\(2\\)} in \
\\!\\(MapThread[\\(\\(\\(\\(\\(\\(#1 == #2\\)\\) &\\)\\), \\(\\({\\(\\({TAD2}\
\\)\\), \\(\\(Table[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)}\\)\
\\)\\)\\)]\\) has only \\!\\(0\\) of required \\!\\(1\\) dimensions.\"\>"}]], \
"Message"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Parameter constants in the use (useparamsconstants) is: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "AlphaVars`TuseM1", "}"}]}],
  SequenceForm[
  "Parameter constants in the use (useparamsconstants) is: ", {
   AlphaVars`TuseM1}],
  Editable->False]], "Print"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Join", "::", "\<\"heads\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"Heads \\!\\(Table\\) and \\!\\(List\\) at positions \
\\!\\(1\\) and \\!\\(2\\) are expected to be the same.\"\>"}]], "Message"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MapThread", "::", "\<\"mptd\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"Object \\!\\(\\(\\({\\({0, 1}\\)}\\)\\) . \
\\(\\(Join[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\) at \
position {2, \\!\\(2\\)} in \\!\\(MapThread[\\(\\(\\(\\(\\(\\(#1 + #2\\)\\) &\
\\)\\), \\(\\({\\(\\({TAD3}\\)\\), \\(\\(\\(\\({\\({0, 1}\\)}\\)\\) . \\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)\\)\\)}\\)\\)\\)\\)]\\) has only \
\\!\\(0\\) of required \\!\\(1\\) dimensions.\"\>"}]], "Message"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Coefficient parameters, once adapted are \"\>", 
   "\[InvisibleSpace]", "AlphaVars`Tuse1"}],
  SequenceForm["Coefficient parameters, once adapted are ", AlphaVars`Tuse1],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Constraints due to parameters: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0", "\[LessEqual]", "TAD3"}], "}"}]}],
  SequenceForm["Constraints due to parameters: ", {0 <= TAD3}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Coefficient parameters, once adapted are \"\>", 
   "\[InvisibleSpace]", "AlphaVars`Tuse1"}],
  SequenceForm["Coefficient parameters, once adapted are ", AlphaVars`Tuse1],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Constraints due to constants: \"\>", "\[InvisibleSpace]", 
   RowBox[{"AA", "\[LessEqual]", "AlphaVars`Tuse1"}]}],
  SequenceForm["Constraints due to constants: ", AA <= AlphaVars`Tuse1],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Constraints due to linear part: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"TAD1", "==", "1"}], "}"}]}],
  SequenceForm["Constraints due to linear part: ", {TAD1 == 1}],
  Editable->False]], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Join", "::", "\<\"heads\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"Heads \\!\\(List\\) and \\!\\(MapThread\\) at positions \
\\!\\(1\\) and \\!\\(3\\) are expected to be the same.\"\>"}]], "Message"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--------------\\n\"\>", 
   "\[InvisibleSpace]", "\<\"Variable considered is: \"\>", 
   "\[InvisibleSpace]", "\<\"A\"\>"}],
  SequenceForm["--------------\n", "Variable considered is: ", "A"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Coefficients (coefs) of variable \"\>", 
   "\[InvisibleSpace]", "\<\"A\"\>", 
   "\[InvisibleSpace]", "\<\" in calling system are: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"TAD1", ",", "TAD2", ",", "TAD3"}], "}"}], ",", "AA"}], "}"}]}],
  
  SequenceForm[
  "Coefficients (coefs) of variable ", "A", 
   " in calling system are: ", {{TAD1, TAD2, TAD3}, AA}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Dimensions of variable \"\>", "\[InvisibleSpace]", "\<\"A\"\>",
    "\[InvisibleSpace]", "\<\" less params dimensions is: \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm[
  "Dimensions of variable ", "A", " less params dimensions is: ", 2],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Extension dimensions of variable \"\>", 
   "\[InvisibleSpace]", "\<\"A\"\>", "\[InvisibleSpace]", "\<\" is: \"\>", 
   "\[InvisibleSpace]", "1"}],
  SequenceForm["Extension dimensions of variable ", "A", " is: ", 1],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Index coefficients (coefsindex) are \"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", "TAD1", "}"}]}],
  SequenceForm["Index coefficients (coefsindex) are ", {TAD1}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Extension coefficients (coefsext) are \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "TAD2", "}"}]}],
  SequenceForm["Extension coefficients (coefsext) are ", {TAD2}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Params coefficients (coefsp) are \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "TAD3", "}"}]}],
  SequenceForm["Params coefficients (coefsp) are ", {TAD3}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Constant coefficient (coefsconstants) is \"\>", 
   "\[InvisibleSpace]", "AA"}],
  SequenceForm["Constant coefficient (coefsconstants) is ", AA],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Linear transformation of the caller's parameters (mmamat): \
\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], "}"}]}],
  SequenceForm[
  "Linear transformation of the caller's parameters (mmamat): ", {{0, 1}}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Actual coefficients (coefsParamsCalled) of parameters in \
calling system are \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "TAD3", "}"}]}],
  SequenceForm[
  "Actual coefficients (coefsParamsCalled) of parameters in calling system \
are ", {TAD3}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"s is \"\>", "\[InvisibleSpace]", 
   RowBox[{"sched", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}],
  SequenceForm["s is ", 
   sched[{1, 0}, 0]],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Coefficients of linear (coefslinear) part are \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["Coefficients of linear (coefslinear) part are ", {1}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Value of coefficients (coefsParamsCalledValue) of parameters \
in called system are \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0", "}"}]}],
  SequenceForm[
  "Value of coefficients (coefsParamsCalledValue) of parameters in called \
system are ", {0}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Parameters of caller (paramscaller:) \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "\<\"M\"\>", "}"}], 
   "\[InvisibleSpace]", "\<\"\\nParameters of called (paramscallee:) \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "\<\"N\"\>", "}"}], 
   "\[InvisibleSpace]", "\<\"\\nCoefficients of parameters in caller \
(coefsp:) \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "TAD3", "}"}], 
   "\[InvisibleSpace]", "\<\"\\nCoefficients of parameters in called \
(coefsParamsCalled:) \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "TAD3", "}"}]}],
  SequenceForm[
  "Parameters of caller (paramscaller:) ", {"M"}, 
   "\nParameters of called (paramscallee:) ", {"N"}, 
   "\nCoefficients of parameters in caller (coefsp:) ", {TAD3}, 
   "\nCoefficients of parameters in called (coefsParamsCalled:) ", {TAD3}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Coefficient of constant (coefConstant) is: \"\>", 
   "\[InvisibleSpace]", "AlphaVars`Tuse1"}],
  SequenceForm[
  "Coefficient of constant (coefConstant) is: ", AlphaVars`Tuse1],
  Editable->False]], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "::", "\<\"iterb\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"Iterator \\!\\({Alpha`VertexSchedule`Private`i, 1, \\(\\(\
\[LeftSkeleton] 44 \[RightSkeleton]\\)\\)}\\) does not have appropriate \
bounds.\"\>"}]], "Message"],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"Further output of \\!\\(Table :: \\\"iterb\\\"\\) will be \
suppressed during this calculation.\"\>"}]], "Message"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MapThread", "::", "\<\"mptd\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"Object \\!\\(Table[\\(\\(\\(\\(ToExpression[\\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\), \\(\\({\\(\\(\[LeftSkeleton] \
30 \[RightSkeleton]\\)\\), 1, \\(\\(\[LeftSkeleton] 44 \
\[RightSkeleton]\\)\\)}\\)\\)\\)\\)]\\) at position {2, \\!\\(2\\)} in \
\\!\\(MapThread[\\(\\(\\(\\(\\(\\(#1 == #2\\)\\) &\\)\\), \\(\\({\\(\\({TAD2}\
\\)\\), \\(\\(Table[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)}\\)\
\\)\\)\\)]\\) has only \\!\\(0\\) of required \\!\\(1\\) dimensions.\"\>"}]], \
"Message"],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"Further output of \\!\\(MapThread :: \\\"mptd\\\"\\) will \
be suppressed during this calculation.\"\>"}]], "Message"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Parameter constants in the use (useparamsconstants) is: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "AlphaVars`TuseM1", "}"}]}],
  SequenceForm[
  "Parameter constants in the use (useparamsconstants) is: ", {
   AlphaVars`TuseM1}],
  Editable->False]], "Print"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Join", "::", "\<\"heads\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"Heads \\!\\(Table\\) and \\!\\(List\\) at positions \
\\!\\(1\\) and \\!\\(2\\) are expected to be the same.\"\>"}]], "Message"],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"Further output of \\!\\(Join :: \\\"heads\\\"\\) will be \
suppressed during this calculation.\"\>"}]], "Message"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Coefficient parameters, once adapted are \"\>", 
   "\[InvisibleSpace]", "AlphaVars`Tuse1"}],
  SequenceForm["Coefficient parameters, once adapted are ", AlphaVars`Tuse1],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Constraints due to parameters: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0", "\[LessEqual]", "TAD3"}], "}"}]}],
  SequenceForm["Constraints due to parameters: ", {0 <= TAD3}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Coefficient parameters, once adapted are \"\>", 
   "\[InvisibleSpace]", "AlphaVars`Tuse1"}],
  SequenceForm["Coefficient parameters, once adapted are ", AlphaVars`Tuse1],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Constraints due to constants: \"\>", "\[InvisibleSpace]", 
   RowBox[{"AA", "\[LessEqual]", "AlphaVars`Tuse1"}]}],
  SequenceForm["Constraints due to constants: ", AA <= AlphaVars`Tuse1],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Constraints due to linear part: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"TAD1", "==", "1"}], "}"}]}],
  SequenceForm["Constraints due to linear part: ", {TAD1 == 1}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--------------\\n\"\>", 
   "\[InvisibleSpace]", "\<\"Variable considered is: \"\>", 
   "\[InvisibleSpace]", "\<\"out\"\>"}],
  SequenceForm["--------------\n", "Variable considered is: ", "out"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Coefficients (coefs) of variable \"\>", 
   "\[InvisibleSpace]", "\<\"out\"\>", 
   "\[InvisibleSpace]", "\<\" in calling system are: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ToutD1", ",", "ToutD2", ",", "ToutD3"}], "}"}], ",", "Aout"}], 
    "}"}]}],
  SequenceForm[
  "Coefficients (coefs) of variable ", "out", 
   " in calling system are: ", {{ToutD1, ToutD2, ToutD3}, Aout}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Dimensions of variable \"\>", 
   "\[InvisibleSpace]", "\<\"out\"\>", 
   "\[InvisibleSpace]", "\<\" less params dimensions is: \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm[
  "Dimensions of variable ", "out", " less params dimensions is: ", 2],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Extension dimensions of variable \"\>", 
   "\[InvisibleSpace]", "\<\"out\"\>", "\[InvisibleSpace]", "\<\" is: \"\>", 
   "\[InvisibleSpace]", "1"}],
  SequenceForm["Extension dimensions of variable ", "out", " is: ", 1],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Index coefficients (coefsindex) are \"\>", "\[InvisibleSpace]",
    
   RowBox[{"{", "ToutD1", "}"}]}],
  SequenceForm["Index coefficients (coefsindex) are ", {ToutD1}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Extension coefficients (coefsext) are \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "ToutD2", "}"}]}],
  SequenceForm["Extension coefficients (coefsext) are ", {ToutD2}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Params coefficients (coefsp) are \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "ToutD3", "}"}]}],
  SequenceForm["Params coefficients (coefsp) are ", {ToutD3}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Constant coefficient (coefsconstants) is \"\>", 
   "\[InvisibleSpace]", "Aout"}],
  SequenceForm["Constant coefficient (coefsconstants) is ", Aout],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Linear transformation of the caller's parameters (mmamat): \
\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], "}"}]}],
  SequenceForm[
  "Linear transformation of the caller's parameters (mmamat): ", {{0, 1}}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Actual coefficients (coefsParamsCalled) of parameters in \
calling system are \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "ToutD3", "}"}]}],
  SequenceForm[
  "Actual coefficients (coefsParamsCalled) of parameters in calling system \
are ", {ToutD3}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"s is \"\>", "\[InvisibleSpace]", 
   RowBox[{"sched", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}],
  SequenceForm["s is ", 
   sched[{1, 0}, 1]],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Coefficients of linear (coefslinear) part are \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["Coefficients of linear (coefslinear) part are ", {1}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Value of coefficients (coefsParamsCalledValue) of parameters \
in called system are \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0", "}"}]}],
  SequenceForm[
  "Value of coefficients (coefsParamsCalledValue) of parameters in called \
system are ", {0}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Parameters of caller (paramscaller:) \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "\<\"M\"\>", "}"}], 
   "\[InvisibleSpace]", "\<\"\\nParameters of called (paramscallee:) \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "\<\"N\"\>", "}"}], 
   "\[InvisibleSpace]", "\<\"\\nCoefficients of parameters in caller \
(coefsp:) \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "ToutD3", "}"}], 
   "\[InvisibleSpace]", "\<\"\\nCoefficients of parameters in called \
(coefsParamsCalled:) \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "ToutD3", "}"}]}],
  SequenceForm[
  "Parameters of caller (paramscaller:) ", {"M"}, 
   "\nParameters of called (paramscallee:) ", {"N"}, 
   "\nCoefficients of parameters in caller (coefsp:) ", {ToutD3}, 
   "\nCoefficients of parameters in called (coefsParamsCalled:) ", {ToutD3}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Coefficient of constant (coefConstant) is: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"1", "+", "AlphaVars`Tuse1"}]}],
  SequenceForm[
  "Coefficient of constant (coefConstant) is: ", 1 + AlphaVars`Tuse1],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Parameter constants in the use (useparamsconstants) is: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "AlphaVars`TuseM1", "}"}]}],
  SequenceForm[
  "Parameter constants in the use (useparamsconstants) is: ", {
   AlphaVars`TuseM1}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Coefficient parameters, once adapted are \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"1", "+", "AlphaVars`Tuse1"}]}],
  SequenceForm[
  "Coefficient parameters, once adapted are ", 1 + AlphaVars`Tuse1],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Constraints due to parameters: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0", "==", "ToutD3"}], "}"}]}],
  SequenceForm["Constraints due to parameters: ", {0 == ToutD3}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Coefficient parameters, once adapted are \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"1", "+", "AlphaVars`Tuse1"}]}],
  SequenceForm[
  "Coefficient parameters, once adapted are ", 1 + AlphaVars`Tuse1],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Constraints due to constants: \"\>", "\[InvisibleSpace]", 
   RowBox[{"Aout", "==", 
    RowBox[{"1", "+", "AlphaVars`Tuse1"}]}]}],
  SequenceForm["Constraints due to constants: ", Aout == 1 + AlphaVars`Tuse1],
  
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Constraints due to linear part: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"ToutD1", "==", "1"}], "}"}]}],
  SequenceForm["Constraints due to linear part: ", {ToutD1 == 1}],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"resi: \"\>", "\[InvisibleSpace]", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"TAD1", "==", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", "\[LessEqual]", "TAD3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"AA", "\[LessEqual]", "AlphaVars`Tuse1"}], "}"}], ",", 
     RowBox[{"MapThread", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#1", "==", "#2"}], "&"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "TAD2", "}"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ToExpression", "[", 
            RowBox[{"\<\"AlphaVars`TuseExt\"\>", "<>", 
             RowBox[{"ToString", "[", "Alpha`VertexSchedule`Private`i", "]"}],
              "<>", 
             RowBox[{"ToString", "[", "1", "]"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "Alpha`VertexSchedule`Private`i", ",", "1", ",", 
             "Alpha`VertexSchedule`Private`extraDimensions"}], "}"}]}], 
          "]"}]}], "}"}]}], "]"}]}], "]"}]}],
  SequenceForm["resi: ", 
   Join[{TAD1 == 1}, {0 <= TAD3}, {AA <= AlphaVars`Tuse1}, 
    MapThread[# == #2& , {{TAD2}, 
      Table[
       ToExpression[
        StringJoin["AlphaVars`TuseExt", 
         ToString[Alpha`VertexSchedule`Private`i], 
         ToString[1]]], {
       Alpha`VertexSchedule`Private`i, 1, 
        Alpha`VertexSchedule`Private`extraDimensions}]}]]],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"reso: \"\>", "\[InvisibleSpace]", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", "==", "ToutD3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Aout", "==", 
       RowBox[{"1", "+", "AlphaVars`Tuse1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"ToutD1", "==", "1"}], "}"}], ",", 
     RowBox[{"MapThread", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#1", "==", "#2"}], "&"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "ToutD2", "}"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ToExpression", "[", 
            RowBox[{"\<\"AlphaVars`TuseExt\"\>", "<>", 
             RowBox[{"ToString", "[", "Alpha`VertexSchedule`Private`i", "]"}],
              "<>", 
             RowBox[{"ToString", "[", "1", "]"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "Alpha`VertexSchedule`Private`i", ",", "1", ",", 
             "Alpha`VertexSchedule`Private`extraDimensions"}], "}"}]}], 
          "]"}]}], "}"}]}], "]"}]}], "]"}]}],
  SequenceForm["reso: ", 
   Join[{0 == ToutD3}, {Aout == 1 + AlphaVars`Tuse1}, {ToutD1 == 1}, 
    MapThread[# == #2& , {{ToutD2}, 
      Table[
       ToExpression[
        StringJoin["AlphaVars`TuseExt", 
         ToString[Alpha`VertexSchedule`Private`i], 
         ToString[1]]], {
       Alpha`VertexSchedule`Private`i, 1, 
        Alpha`VertexSchedule`Private`extraDimensions}]}]]],
  Editable->False]], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Union", "::", "\<\"heads\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"Heads \\!\\(List\\) and \\!\\(Join\\) at positions \\!\\(3\
\\) and \\!\\(1\\) are expected to be the same.\"\>"}]], "Message"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Union", "::", "\<\"heads\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"Heads \\!\\(Table\\) and \\!\\(List\\) at positions \
\\!\\(2\\) and \\!\\(1\\) are expected to be the same.\"\>"}]], "Message"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Result : \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"TAD1", "==", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", "\[LessEqual]", "TAD3"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"AA", "\[LessEqual]", "AlphaVars`Tuse1"}], "}"}], ",", 
        RowBox[{"MapThread", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"#1", "==", "#2"}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", "TAD2", "}"}], ",", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"ToExpression", "[", 
               RowBox[{"\<\"AlphaVars`TuseExt\"\>", "<>", 
                RowBox[{
                "ToString", "[", "Alpha`VertexSchedule`Private`i", "]"}], "<>",
                 
                RowBox[{"ToString", "[", "1", "]"}]}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{
               "Alpha`VertexSchedule`Private`i", ",", "1", ",", 
                "Alpha`VertexSchedule`Private`extraDimensions"}], "}"}]}], 
             "]"}]}], "}"}]}], "]"}]}], "]"}], "\[Union]", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", "==", "ToutD3"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Aout", "==", 
          RowBox[{"1", "+", "AlphaVars`Tuse1"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"ToutD1", "==", "1"}], "}"}], ",", 
        RowBox[{"MapThread", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"#1", "==", "#2"}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", "ToutD2", "}"}], ",", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"ToExpression", "[", 
               RowBox[{"\<\"AlphaVars`TuseExt\"\>", "<>", 
                RowBox[{
                "ToString", "[", "Alpha`VertexSchedule`Private`i", "]"}], "<>",
                 
                RowBox[{"ToString", "[", "1", "]"}]}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{
               "Alpha`VertexSchedule`Private`i", ",", "1", ",", 
                "Alpha`VertexSchedule`Private`extraDimensions"}], "}"}]}], 
             "]"}]}], "}"}]}], "]"}]}], "]"}], "\[Union]", 
      RowBox[{"{", 
       RowBox[{"AlphaVars`Tuse1", "\[GreaterEqual]", "0"}], "}"}], "\[Union]",
       
      RowBox[{"{", 
       RowBox[{"AlphaVars`TuseM1", "\[GreaterEqual]", "0"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"AlphaVars`Tuse1", ",", "AlphaVars`TuseM1"}], "}"}], 
      "\[Union]", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"ToExpression", "[", 
         RowBox[{"\<\"AlphaVars`TuseExt\"\>", "<>", 
          RowBox[{"ToString", "[", "Alpha`VertexSchedule`Private`i", "]"}], "<>",
           
          RowBox[{"ToString", "[", "1", "]"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Alpha`VertexSchedule`Private`i", ",", "1", ",", 
          "Alpha`VertexSchedule`Private`extraDimensions"}], "}"}]}], 
       "]"}]}]}], "}"}]}],
  SequenceForm["Result : ", {
    Union[
     Join[{TAD1 == 1}, {0 <= TAD3}, {AA <= AlphaVars`Tuse1}, 
      MapThread[# == #2& , {{TAD2}, 
        Table[
         ToExpression[
          StringJoin["AlphaVars`TuseExt", 
           ToString[Alpha`VertexSchedule`Private`i], 
           ToString[1]]], {
         Alpha`VertexSchedule`Private`i, 1, 
          Alpha`VertexSchedule`Private`extraDimensions}]}]], 
     Join[{0 == ToutD3}, {Aout == 1 + AlphaVars`Tuse1}, {ToutD1 == 1}, 
      MapThread[# == #2& , {{ToutD2}, 
        Table[
         ToExpression[
          StringJoin["AlphaVars`TuseExt", 
           ToString[Alpha`VertexSchedule`Private`i], 
           ToString[1]]], {
         Alpha`VertexSchedule`Private`i, 1, 
          Alpha`VertexSchedule`Private`extraDimensions}]}]], {
     AlphaVars`Tuse1 >= 0}, {AlphaVars`TuseM1 >= 0}], 
    Union[{AlphaVars`Tuse1, AlphaVars`TuseM1}, 
     Table[
      ToExpression[
       StringJoin["AlphaVars`TuseExt", 
        ToString[Alpha`VertexSchedule`Private`i], 
        ToString[1]]], {
      Alpha`VertexSchedule`Private`i, 1, 
       Alpha`VertexSchedule`Private`extraDimensions}]]}],
  Editable->False]], "Print"],

Cell[BoxData[
 RowBox[{
  RowBox[{"scd", "::", "\<\"error1\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"Error while calling scheduleConstraints\"\>"}]], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"$scheduleMDSol", "[", "1", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"TM", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"0", "==", "ToutD3"}], ",", 
     RowBox[{"Aout", "==", 
      RowBox[{"1", "+", "AlphaVars`Tuse1"}]}], ",", 
     RowBox[{"TAD1", "==", "1"}], ",", 
     RowBox[{"TAD2", "==", "AlphaVars`TuseExt11"}], ",", 
     RowBox[{"ToutD1", "==", "1"}], ",", 
     RowBox[{"ToutD2", "==", "AlphaVars`TuseExt11"}], ",", 
     RowBox[{"TAD2", "\[GreaterEqual]", "1"}], ",", 
     RowBox[{"TAD3", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD1", "+", "TAD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD3", "-", "TinD2"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD1", "+", "TAD3", "-", "TinD1", "-", "TinD2"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
      "AA", "-", "Ain", "+", "TAD1", "+", "TAD2", "+", "TAD3", "-", "TinD1", 
       "-", "TinD2"}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{"TinD2", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TinD1", "+", "TinD2"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TAD3"}], "+", "TM"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TAD1"}], "-", "TAD3", "+", "TM"}], "\[GreaterEqual]", 
      "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "AA"}], "+", "aparam", "-", "TAD1", "-", 
       RowBox[{"10", " ", "TAD2"}], "-", "TAD3", "+", "TM"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "AA"}], "+", "aparam", "-", "TAD1", "-", "TAD2", "-", 
       "TAD3", "+", "TM"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TinD2"}], "+", "TM"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TinD1"}], "-", "TinD2", "+", "TM"}], "\[GreaterEqual]", 
      "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ain"}], "+", "aparam", "-", "TinD1", "-", "TinD2", "+", 
       "TM"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TM", "-", "ToutD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TM", "-", "ToutD1", "-", "ToutD3"}], "\[GreaterEqual]", "0"}], 
     ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aout"}], "+", "aparam", "+", "TM", "-", "ToutD1", "-", 
       RowBox[{"10", " ", "ToutD2"}], "-", "ToutD3"}], "\[GreaterEqual]", 
      "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aout"}], "+", "aparam", "+", "TM", "-", "ToutD1", "-", 
       "ToutD2", "-", "ToutD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"AlphaVars`Tuse1", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"AlphaVars`TuseM1", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"0", "\[LessEqual]", "TAD3"}], ",", 
     RowBox[{"AA", "\[LessEqual]", "AlphaVars`Tuse1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "AA", ",", "Ain", ",", "Aout", ",", "aparam", ",", "TAD1", ",", "TAD2", 
     ",", "TAD3", ",", "TinD1", ",", "TinD2", ",", "TM", ",", "ToutD1", ",", 
     "ToutD2", ",", "ToutD3", ",", "AlphaVars`Tuse1", ",", 
     "AlphaVars`TuseM1"}], "}"}]}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullForm", "[", 
  RowBox[{
   RowBox[{"$scheduleMDSol", "[", "1", "]"}], "[", 
   RowBox[{"[", 
    RowBox[{"2", ",", "4"}], "]"}], "]"}], "]"}]], "Input"],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"Equal", "[", 
    RowBox[{"TAD2", ",", "AlphaVars`TuseExt11"}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"adaptUses", "[", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"scd", "[", 
  RowBox[{
   RowBox[{"addConstraints", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"TinD2", "\[Equal]", "0"}], ",", 
      RowBox[{"TinD1", "\[Equal]", "0"}], ",", 
      RowBox[{"TadaptIn11D2", "\[Equal]", "0"}], ",", 
      RowBox[{"TadaptIn12D2", "\[Equal]", "0"}]}], "}"}]}], ",", 
   RowBox[{"debug", "\[Rule]", "False"}]}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New schedule: \"\>", "\[InvisibleSpace]", 
   RowBox[{"scheduleResult", "[", 
    RowBox[{"\<\"add\"\>", ",", 
     RowBox[{"{", "\<\"M\"\>", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\<\"a\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"\<\"c\"\>", ",", 
        RowBox[{"{", 
         RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
        RowBox[{"sched", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], 
      "}"}]}], "]"}]}],
  SequenceForm["New schedule: ", 
   scheduleResult["add", {"M"}, {{"a", {"k", "M"}, 
      sched[{1, 0}, 0]}, {"b", {"k", "M"}, 
      sched[{1, 0}, 0]}}, {{"c", {"k", "M"}, 
      sched[{1, 0}, 1]}}]],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "54", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "20", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   RowBox[{"0.030000000000001137`", " ", "Second"}]}],
  SequenceForm[
  54, " constraints, ", 20, " variables ", 0.030000000000001137` Second],
  Editable->False]], "Print"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"testscd3\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"adaptIn11\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"adaptIn12\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"in\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"out\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], ",",
        
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", "1"}], "]"}]}], 
      "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], "]"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"showSchedResult", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"adaptIn11\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "\<\"k\"\>"}],
  SequenceForm["T_", "adaptIn11", {"k", "i", "M"}, " = ", "k"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"adaptIn12\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "\<\"k\"\>"}],
  SequenceForm["T_", "adaptIn12", {"k", "i", "M"}, " = ", "k"],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"in\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", "0"}],
  SequenceForm["T_", "in", {"k", "i", "M"}, " = ", 0],
  Editable->False]], "Print"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T_\"\>", "\[InvisibleSpace]", "\<\"out\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"M\"\>"}], "}"}], 
   "\[InvisibleSpace]", "\<\" = \"\>", "\[InvisibleSpace]", 
   RowBox[{"1", "+", "\<\"k\"\>"}]}],
  SequenceForm["T_", "out", {"k", "i", "M"}, " = ", 1 + "k"],
  Editable->False]], "Print"]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->None,
WindowToolbars->{"RulerBar", "EditBar"},
Evaluator->"Local",
WindowSize->{929, 642},
WindowMargins->{{22, Automatic}, {81, Automatic}},
DockedCells->FEPrivate`FrontEndResource[
 "FEExpressions", "CompatibilityToolbar"],
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"6.0 for Mac OS X x86 (32-bit) (June 19, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "firstcell"->{
  Cell[590, 23, 96, 2, 114, "Title",
   CellTags->"firstcell"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"firstcell", 244122, 6778}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 96, 2, 114, "Title",
 CellTags->"firstcell"],
Cell[689, 27, 76, 3, 65, "Subsubtitle"],
Cell[CellGroupData[{
Cell[790, 34, 87, 1, 37, "Subsubsection"],
Cell[880, 37, 67, 1, 40, "SmallText"],
Cell[950, 40, 334, 13, 277, "SmallText"],
Cell[1287, 55, 100, 3, 62, "SmallText"]
}, Closed]],
Cell[CellGroupData[{
Cell[1424, 63, 106, 1, 26, "Subsubsection"],
Cell[CellGroupData[{
Cell[1555, 68, 209, 6, 39, "Input",
 InitializationCell->True],
Cell[1767, 76, 146, 2, 70, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1962, 84, 82, 1, 53, "Section"],
Cell[2047, 87, 143, 3, 73, "Text"],
Cell[CellGroupData[{
Cell[2215, 94, 96, 2, 39, "Input"],
Cell[CellGroupData[{
Cell[2336, 100, 48, 0, 34, "Print"],
Cell[2387, 102, 49, 0, 34, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2485, 108, 53, 1, 39, "Input"],
Cell[2541, 111, 744, 9, 538, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3322, 125, 98, 2, 39, "Input"],
Cell[CellGroupData[{
Cell[3445, 131, 262, 6, 34, "Print"],
Cell[3710, 139, 35, 0, 34, "Print"],
Cell[3748, 141, 206, 5, 34, "Print"],
Cell[3957, 148, 70, 0, 34, "Print"],
Cell[4030, 150, 68, 0, 34, "Print"],
Cell[4101, 152, 85, 1, 34, "Print"],
Cell[4189, 155, 75, 0, 34, "Print"],
Cell[4267, 157, 83, 1, 34, "Print"],
Cell[4353, 160, 92, 1, 34, "Print"],
Cell[4448, 163, 198, 5, 34, "Print"],
Cell[4649, 170, 194, 5, 34, "Print"],
Cell[4846, 177, 59, 0, 58, "Print"],
Cell[4908, 179, 35, 0, 34, "Print"],
Cell[4946, 181, 214, 5, 34, "Print"],
Cell[5163, 188, 70, 0, 34, "Print"],
Cell[5236, 190, 68, 0, 34, "Print"],
Cell[5307, 192, 85, 1, 34, "Print"],
Cell[5395, 195, 75, 0, 34, "Print"],
Cell[5473, 197, 83, 1, 34, "Print"],
Cell[5559, 200, 92, 1, 34, "Print"],
Cell[5654, 203, 194, 5, 34, "Print"],
Cell[5851, 210, 194, 5, 34, "Print"],
Cell[6048, 217, 213, 5, 34, "Print"],
Cell[6264, 224, 59, 0, 58, "Print"],
Cell[6326, 226, 67, 0, 58, "Print"]
}, Open  ]],
Cell[6408, 229, 31, 0, 40, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[6488, 235, 96, 1, 53, "Section"],
Cell[6587, 238, 443, 8, 125, "Text"],
Cell[CellGroupData[{
Cell[7055, 250, 259, 7, 62, "Input"],
Cell[CellGroupData[{
Cell[7339, 261, 53, 0, 34, "Print"],
Cell[7395, 263, 56, 0, 34, "Print"],
Cell[7454, 265, 48, 0, 34, "Print"],
Cell[7505, 267, 201, 5, 34, "Print"],
Cell[7709, 274, 51, 0, 34, "Print"],
Cell[7763, 276, 51, 0, 34, "Print"],
Cell[7817, 278, 317, 6, 34, "Print"],
Cell[8137, 286, 58, 0, 34, "Print"],
Cell[8198, 288, 51, 0, 34, "Print"],
Cell[8252, 290, 218, 5, 34, "Print"],
Cell[8473, 297, 392, 10, 34, "Print"],
Cell[8868, 309, 392, 10, 34, "Print"],
Cell[9263, 321, 333, 8, 34, "Print"],
Cell[9599, 331, 347, 8, 34, "Print"]
}, Open  ]],
Cell[9961, 342, 1301, 39, 88, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11299, 386, 283, 8, 62, "Input"],
Cell[CellGroupData[{
Cell[11607, 398, 369, 8, 34, "Print"],
Cell[11979, 408, 200, 4, 34, "Print"]
}, Open  ]],
Cell[12194, 415, 1247, 36, 88, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[13490, 457, 100, 1, 53, "Section"],
Cell[13593, 460, 205, 5, 73, "Text"],
Cell[CellGroupData[{
Cell[13823, 469, 297, 8, 62, "Input"],
Cell[CellGroupData[{
Cell[14145, 481, 1328, 38, 82, "Print"],
Cell[15476, 521, 366, 8, 34, "Print"],
Cell[15845, 531, 209, 4, 34, "Print"]
}, Open  ]],
Cell[16069, 538, 2039, 60, 182, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[18145, 603, 42, 0, 32, "Input"],
Cell[18190, 605, 2284, 68, 136, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[20511, 678, 182, 4, 55, "Input"],
Cell[CellGroupData[{
Cell[20718, 686, 53, 0, 34, "Print"],
Cell[20774, 688, 56, 0, 34, "Print"],
Cell[20833, 690, 48, 0, 34, "Print"],
Cell[20884, 692, 321, 6, 34, "Print"],
Cell[21208, 700, 58, 0, 34, "Print"],
Cell[21269, 702, 166, 4, 34, "Print"],
Cell[21438, 708, 51, 0, 34, "Print"],
Cell[21492, 710, 180, 4, 34, "Print"],
Cell[21675, 716, 356, 8, 34, "Print"],
Cell[22034, 726, 356, 8, 34, "Print"],
Cell[22393, 736, 356, 8, 34, "Print"],
Cell[22752, 746, 457, 10, 34, "Print"],
Cell[23212, 758, 395, 9, 34, "Print"]
}, Open  ]],
Cell[23622, 770, 1877, 56, 112, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[25536, 831, 63, 1, 32, "Input"],
Cell[CellGroupData[{
Cell[25624, 836, 356, 8, 34, "Print"],
Cell[25983, 846, 356, 8, 34, "Print"],
Cell[26342, 856, 356, 8, 34, "Print"],
Cell[26701, 866, 457, 10, 34, "Print"],
Cell[27161, 878, 395, 9, 34, "Print"]
}, Open  ]]
}, Open  ]],
Cell[27583, 891, 155, 5, 47, "Text"],
Cell[CellGroupData[{
Cell[27763, 900, 53, 1, 39, "Input"],
Cell[27819, 903, 744, 9, 538, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28600, 917, 51, 1, 39, "Input"],
Cell[CellGroupData[{
Cell[28676, 922, 1328, 38, 82, "Print"],
Cell[30007, 962, 368, 8, 34, "Print"],
Cell[30378, 972, 210, 4, 34, "Print"]
}, Open  ]],
Cell[30603, 979, 2039, 60, 182, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[32691, 1045, 92, 1, 53, "Section"],
Cell[CellGroupData[{
Cell[32808, 1050, 53, 1, 39, "Input"],
Cell[32864, 1053, 627, 8, 514, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[33528, 1066, 97, 2, 32, "Input"],
Cell[CellGroupData[{
Cell[33650, 1072, 51, 0, 34, "Print"],
Cell[33704, 1074, 49, 0, 34, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[33802, 1080, 52, 1, 39, "Input"],
Cell[33857, 1083, 707, 9, 260, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[34601, 1097, 295, 8, 55, "Input"],
Cell[CellGroupData[{
Cell[34921, 1109, 300, 3, 226, "Print"],
Cell[35224, 1114, 53, 0, 34, "Print"],
Cell[35280, 1116, 56, 0, 34, "Print"],
Cell[35339, 1118, 202, 5, 34, "Print"],
Cell[35544, 1125, 48, 0, 34, "Print"],
Cell[35595, 1127, 317, 6, 34, "Print"],
Cell[35915, 1135, 58, 0, 34, "Print"],
Cell[35976, 1137, 51, 0, 34, "Print"],
Cell[36030, 1139, 180, 4, 34, "Print"],
Cell[36213, 1145, 279, 7, 34, "Print"],
Cell[36495, 1154, 279, 7, 34, "Print"],
Cell[36777, 1163, 283, 7, 34, "Print"],
Cell[37063, 1172, 279, 7, 34, "Print"],
Cell[37345, 1181, 285, 7, 34, "Print"]
}, Open  ]],
Cell[37645, 1191, 1150, 35, 88, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[38832, 1231, 82, 2, 39, "Input"],
Cell[38917, 1235, 286, 3, 226, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[39240, 1243, 178, 4, 62, "Input"],
Cell[CellGroupData[{
Cell[39443, 1251, 53, 0, 34, "Print"],
Cell[39499, 1253, 56, 0, 34, "Print"],
Cell[39558, 1255, 48, 0, 34, "Print"],
Cell[39609, 1257, 203, 5, 34, "Print"],
Cell[39815, 1264, 50, 0, 34, "Print"],
Cell[39868, 1266, 54, 0, 34, "Print"],
Cell[39925, 1268, 52, 0, 34, "Print"],
Cell[39980, 1270, 56, 0, 34, "Print"],
Cell[40039, 1272, 50, 0, 34, "Print"],
Cell[40092, 1274, 54, 0, 34, "Print"],
Cell[40149, 1276, 53, 0, 34, "Print"],
Cell[40205, 1278, 57, 0, 34, "Print"],
Cell[40265, 1280, 54, 0, 34, "Print"],
Cell[40322, 1282, 56, 0, 34, "Print"],
Cell[40381, 1284, 54, 0, 34, "Print"],
Cell[40438, 1286, 57, 0, 34, "Print"],
Cell[40498, 1288, 317, 6, 34, "Print"],
Cell[40818, 1296, 58, 0, 34, "Print"],
Cell[40879, 1298, 51, 0, 34, "Print"],
Cell[40933, 1300, 194, 5, 34, "Print"],
Cell[41130, 1307, 343, 8, 34, "Print"],
Cell[41476, 1317, 343, 8, 34, "Print"],
Cell[41822, 1327, 343, 8, 34, "Print"],
Cell[42168, 1337, 347, 8, 34, "Print"],
Cell[42518, 1347, 349, 8, 34, "Print"],
Cell[42870, 1357, 343, 8, 34, "Print"]
}, Open  ]],
Cell[43228, 1368, 1885, 55, 112, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[45150, 1428, 53, 1, 39, "Input"],
Cell[45206, 1431, 627, 8, 514, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[45870, 1444, 56, 1, 39, "Input"],
Cell[CellGroupData[{
Cell[45951, 1449, 294, 6, 34, "Print"],
Cell[46248, 1457, 230, 5, 34, "Print"],
Cell[46481, 1464, 285, 5, 34, "Print"],
Cell[46769, 1471, 224, 5, 34, "Print"]
}, Open  ]],
Cell[47008, 1479, 21290, 525, 1120, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[68335, 2009, 53, 1, 32, "Input"],
Cell[68391, 2012, 777, 10, 634, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[69217, 2028, 101, 1, 53, "Section"],
Cell[CellGroupData[{
Cell[69343, 2033, 518, 14, 133, "Input"],
Cell[CellGroupData[{
Cell[69886, 2051, 90, 1, 30, "Print"],
Cell[69979, 2054, 97, 1, 30, "Print"],
Cell[70079, 2057, 98, 1, 30, "Print"],
Cell[70180, 2060, 90, 1, 30, "Print"],
Cell[70273, 2063, 243, 6, 30, "Print"],
Cell[70519, 2071, 93, 1, 30, "Print"],
Cell[70615, 2074, 95, 1, 30, "Print"],
Cell[70713, 2077, 373, 7, 54, "Print"],
Cell[71089, 2086, 100, 1, 30, "Print"],
Cell[71192, 2089, 93, 1, 30, "Print"],
Cell[71288, 2092, 262, 6, 30, "Print"],
Cell[71553, 2100, 152, 2, 100, "Print"],
Cell[71708, 2104, 95, 1, 30, "Print"],
Cell[71806, 2107, 98, 1, 30, "Print"],
Cell[71907, 2110, 92, 1, 30, "Print"],
Cell[72002, 2113, 245, 6, 30, "Print"],
Cell[72250, 2121, 95, 1, 30, "Print"],
Cell[72348, 2124, 92, 1, 30, "Print"],
Cell[72443, 2127, 93, 1, 30, "Print"],
Cell[72539, 2130, 96, 1, 30, "Print"],
Cell[72638, 2133, 98, 1, 30, "Print"],
Cell[72739, 2136, 102, 1, 30, "Print"],
Cell[72844, 2139, 98, 1, 30, "Print"],
Cell[72945, 2142, 96, 1, 30, "Print"],
Cell[73044, 2145, 96, 1, 30, "Print"],
Cell[73143, 2148, 96, 1, 30, "Print"],
Cell[73242, 2151, 377, 7, 54, "Print"],
Cell[73622, 2160, 100, 1, 30, "Print"],
Cell[73725, 2163, 208, 5, 30, "Print"],
Cell[73936, 2170, 92, 1, 30, "Print"],
Cell[74031, 2173, 287, 7, 30, "Print"],
Cell[74321, 2182, 216, 3, 123, "Print"]
}, Open  ]],
Cell[74552, 2188, 1953, 57, 110, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[76542, 2250, 119, 2, 40, "Input"],
Cell[CellGroupData[{
Cell[76686, 2256, 93, 1, 30, "Print"],
Cell[76782, 2259, 380, 9, 30, "Print"],
Cell[77165, 2270, 227, 5, 30, "Print"]
}, Open  ]],
Cell[77407, 2278, 1987, 57, 133, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[79431, 2340, 244, 5, 40, "Input"],
Cell[79678, 2347, 47155, 852, 3560, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[126870, 3204, 131, 2, 29, "Input"],
Cell[127004, 3208, 6668, 140, 570, "Output"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[133721, 3354, 82, 1, 100, "Section"],
Cell[CellGroupData[{
Cell[133828, 3359, 96, 2, 40, "Input"],
Cell[CellGroupData[{
Cell[133949, 3365, 49, 0, 30, "Print"],
Cell[134001, 3367, 49, 0, 30, "Print"]
}, Open  ]]
}, Open  ]],
Cell[134077, 3371, 125, 3, 40, "Input"],
Cell[134205, 3376, 101, 3, 40, "Input"],
Cell[CellGroupData[{
Cell[134331, 3383, 98, 2, 40, "Input"],
Cell[CellGroupData[{
Cell[134454, 3389, 264, 6, 30, "Print"],
Cell[134721, 3397, 35, 0, 30, "Print"],
Cell[134759, 3399, 206, 5, 30, "Print"],
Cell[134968, 3406, 70, 0, 30, "Print"],
Cell[135041, 3408, 68, 0, 30, "Print"],
Cell[135112, 3410, 85, 1, 30, "Print"],
Cell[135200, 3413, 75, 0, 30, "Print"],
Cell[135278, 3415, 83, 1, 30, "Print"],
Cell[135364, 3418, 92, 1, 30, "Print"],
Cell[135459, 3421, 194, 5, 30, "Print"],
Cell[135656, 3428, 59, 0, 54, "Print"],
Cell[135718, 3430, 35, 0, 30, "Print"],
Cell[135756, 3432, 216, 5, 30, "Print"],
Cell[135975, 3439, 70, 0, 30, "Print"],
Cell[136048, 3441, 68, 0, 30, "Print"],
Cell[136119, 3443, 85, 1, 30, "Print"],
Cell[136207, 3446, 75, 0, 30, "Print"],
Cell[136285, 3448, 83, 1, 30, "Print"],
Cell[136371, 3451, 92, 1, 30, "Print"],
Cell[136466, 3454, 194, 5, 30, "Print"],
Cell[136663, 3461, 213, 5, 30, "Print"],
Cell[136879, 3468, 59, 0, 54, "Print"],
Cell[136941, 3470, 67, 0, 54, "Print"]
}, Open  ]],
Cell[137023, 3473, 31, 0, 40, "Output"]
}, Open  ]],
Cell[137069, 3476, 90, 2, 40, "Input"],
Cell[CellGroupData[{
Cell[137184, 3482, 253, 7, 40, "Input"],
Cell[CellGroupData[{
Cell[137462, 3493, 371, 8, 30, "Print"],
Cell[137836, 3503, 201, 4, 30, "Print"]
}, Open  ]],
Cell[138052, 3510, 1036, 31, 64, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[139125, 3546, 63, 1, 40, "Input"],
Cell[CellGroupData[{
Cell[139213, 3551, 343, 8, 30, "Print"],
Cell[139559, 3561, 343, 8, 30, "Print"],
Cell[139905, 3571, 371, 9, 30, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[140325, 3586, 59, 1, 40, "Input"],
Cell[140387, 3589, 98, 2, 40, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[140522, 3596, 127, 3, 40, "Input"],
Cell[140652, 3601, 278, 3, 215, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[140967, 3609, 51, 1, 40, "Input"],
Cell[141021, 3612, 1408, 40, 77, "Print"],
Cell[142432, 3654, 342, 7, 49, "Message"],
Cell[142777, 3663, 60, 0, 30, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[142874, 3668, 63, 1, 40, "Input"],
Cell[CellGroupData[{
Cell[142962, 3673, 343, 8, 30, "Print"],
Cell[143308, 3683, 394, 10, 30, "Print"],
Cell[143705, 3695, 375, 9, 30, "Print"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[144141, 3711, 82, 1, 100, "Section"],
Cell[CellGroupData[{
Cell[144248, 3716, 66, 1, 39, "Input"],
Cell[144317, 3719, 98, 1, 34, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[144452, 3725, 96, 2, 39, "Input"],
Cell[CellGroupData[{
Cell[144573, 3731, 49, 0, 34, "Print"],
Cell[144625, 3733, 49, 0, 34, "Print"]
}, Open  ]]
}, Open  ]],
Cell[144701, 3737, 125, 3, 39, "Input"],
Cell[144829, 3742, 90, 2, 39, "Input"],
Cell[CellGroupData[{
Cell[144944, 3748, 207, 6, 39, "Input"],
Cell[CellGroupData[{
Cell[145176, 3758, 370, 8, 34, "Print"],
Cell[145549, 3768, 201, 4, 34, "Print"]
}, Open  ]],
Cell[145765, 3775, 1036, 31, 64, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[146838, 3811, 98, 2, 39, "Input"],
Cell[CellGroupData[{
Cell[146961, 3817, 212, 5, 34, "Print"],
Cell[147176, 3824, 35, 0, 34, "Print"],
Cell[147214, 3826, 206, 5, 34, "Print"],
Cell[147423, 3833, 70, 0, 34, "Print"],
Cell[147496, 3835, 68, 0, 34, "Print"],
Cell[147567, 3837, 85, 1, 34, "Print"],
Cell[147655, 3840, 75, 0, 34, "Print"],
Cell[147733, 3842, 83, 1, 34, "Print"],
Cell[147819, 3845, 92, 1, 34, "Print"],
Cell[147914, 3848, 194, 5, 34, "Print"],
Cell[148111, 3855, 59, 0, 58, "Print"],
Cell[148173, 3857, 67, 0, 58, "Print"]
}, Open  ]],
Cell[148255, 3860, 31, 0, 40, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[148323, 3865, 127, 3, 39, "Input"],
Cell[148453, 3870, 352, 4, 274, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[148842, 3879, 222, 6, 39, "Input"],
Cell[CellGroupData[{
Cell[149089, 3889, 1408, 40, 82, "Print"],
Cell[150500, 3931, 1408, 40, 82, "Print"]
}, Open  ]],
Cell[151923, 3974, 342, 7, 49, "Message"],
Cell[152268, 3983, 60, 0, 34, "Print"]
}, Open  ]],
Cell[152343, 3986, 75, 2, 39, "Input"],
Cell[CellGroupData[{
Cell[152443, 3992, 222, 6, 39, "Input"],
Cell[CellGroupData[{
Cell[152690, 4002, 1408, 40, 82, "Print"],
Cell[154101, 4044, 1408, 40, 82, "Print"],
Cell[155512, 4086, 364, 8, 34, "Print"],
Cell[155879, 4096, 209, 4, 34, "Print"]
}, Open  ]],
Cell[156103, 4103, 2481, 71, 160, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[158621, 4179, 63, 1, 39, "Input"],
Cell[CellGroupData[{
Cell[158709, 4184, 333, 8, 34, "Print"],
Cell[159045, 4194, 387, 9, 34, "Print"],
Cell[159435, 4205, 387, 9, 34, "Print"],
Cell[159825, 4216, 411, 9, 34, "Print"],
Cell[160239, 4227, 411, 9, 34, "Print"],
Cell[160653, 4238, 371, 9, 34, "Print"],
Cell[161027, 4249, 335, 8, 34, "Print"],
Cell[161365, 4259, 402, 10, 34, "Print"]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[161828, 4276, 82, 1, 53, "Section"],
Cell[CellGroupData[{
Cell[161935, 4281, 66, 1, 39, "Input"],
Cell[162004, 4284, 98, 1, 34, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[162139, 4290, 96, 2, 39, "Input"],
Cell[CellGroupData[{
Cell[162260, 4296, 49, 0, 34, "Print"],
Cell[162312, 4298, 49, 0, 34, "Print"]
}, Open  ]]
}, Open  ]],
Cell[162388, 4302, 125, 3, 39, "Input"],
Cell[CellGroupData[{
Cell[162538, 4309, 98, 2, 39, "Input"],
Cell[CellGroupData[{
Cell[162661, 4315, 264, 6, 35, "Print"],
Cell[162928, 4323, 35, 0, 35, "Print"],
Cell[162966, 4325, 206, 5, 35, "Print"],
Cell[163175, 4332, 70, 0, 35, "Print"],
Cell[163248, 4334, 68, 0, 35, "Print"],
Cell[163319, 4336, 85, 1, 35, "Print"],
Cell[163407, 4339, 75, 0, 35, "Print"],
Cell[163485, 4341, 83, 1, 35, "Print"],
Cell[163571, 4344, 92, 1, 35, "Print"],
Cell[163666, 4347, 194, 5, 35, "Print"],
Cell[163863, 4354, 59, 0, 60, "Print"],
Cell[163925, 4356, 35, 0, 35, "Print"],
Cell[163963, 4358, 216, 5, 35, "Print"],
Cell[164182, 4365, 70, 0, 35, "Print"],
Cell[164255, 4367, 68, 0, 35, "Print"],
Cell[164326, 4369, 85, 1, 35, "Print"],
Cell[164414, 4372, 75, 0, 35, "Print"],
Cell[164492, 4374, 83, 1, 35, "Print"],
Cell[164578, 4377, 92, 1, 35, "Print"],
Cell[164673, 4380, 213, 5, 35, "Print"],
Cell[164889, 4387, 59, 0, 60, "Print"],
Cell[164951, 4389, 67, 0, 60, "Print"]
}, Open  ]],
Cell[165033, 4392, 31, 0, 41, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[165101, 4397, 127, 3, 32, "Input"],
Cell[CellGroupData[{
Cell[165253, 4404, 220, 5, 34, "Print"],
Cell[165476, 4411, 262, 3, 154, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[165787, 4420, 255, 7, 39, "Input"],
Cell[CellGroupData[{
Cell[166067, 4431, 1408, 40, 82, "Print"],
Cell[167478, 4473, 368, 8, 34, "Print"]
}, Open  ]],
Cell[167861, 4484, 876, 27, 88, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[168774, 4516, 67, 1, 39, "Input"],
Cell[168844, 4519, 2806, 69, 358, "Output"]
}, Open  ]],
Cell[171665, 4591, 75, 2, 39, "Input"],
Cell[CellGroupData[{
Cell[171765, 4597, 397, 10, 62, "Input"],
Cell[CellGroupData[{
Cell[172187, 4611, 1408, 40, 82, "Print"],
Cell[173598, 4653, 371, 8, 34, "Print"]
}, Open  ]],
Cell[173984, 4664, 1509, 46, 112, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[175530, 4715, 63, 1, 39, "Input"],
Cell[CellGroupData[{
Cell[175618, 4720, 382, 8, 34, "Print"],
Cell[176003, 4730, 382, 8, 34, "Print"],
Cell[176388, 4740, 358, 8, 34, "Print"],
Cell[176749, 4750, 398, 9, 34, "Print"]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[177208, 4766, 82, 1, 53, "Section"],
Cell[CellGroupData[{
Cell[177315, 4771, 66, 1, 39, "Input"],
Cell[177384, 4774, 98, 1, 34, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[177519, 4780, 96, 2, 39, "Input"],
Cell[CellGroupData[{
Cell[177640, 4786, 49, 0, 34, "Print"],
Cell[177692, 4788, 49, 0, 34, "Print"]
}, Open  ]]
}, Open  ]],
Cell[177768, 4792, 125, 3, 39, "Input"],
Cell[CellGroupData[{
Cell[177918, 4799, 98, 2, 39, "Input"],
Cell[CellGroupData[{
Cell[178041, 4805, 264, 6, 35, "Print"],
Cell[178308, 4813, 35, 0, 35, "Print"],
Cell[178346, 4815, 206, 5, 35, "Print"],
Cell[178555, 4822, 70, 0, 35, "Print"],
Cell[178628, 4824, 68, 0, 35, "Print"],
Cell[178699, 4826, 85, 1, 35, "Print"],
Cell[178787, 4829, 75, 0, 35, "Print"],
Cell[178865, 4831, 83, 1, 35, "Print"],
Cell[178951, 4834, 92, 1, 35, "Print"],
Cell[179046, 4837, 194, 5, 35, "Print"],
Cell[179243, 4844, 59, 0, 60, "Print"],
Cell[179305, 4846, 35, 0, 35, "Print"],
Cell[179343, 4848, 216, 5, 35, "Print"],
Cell[179562, 4855, 70, 0, 35, "Print"],
Cell[179635, 4857, 68, 0, 35, "Print"],
Cell[179706, 4859, 85, 1, 35, "Print"],
Cell[179794, 4862, 75, 0, 35, "Print"],
Cell[179872, 4864, 83, 1, 35, "Print"],
Cell[179958, 4867, 92, 1, 35, "Print"],
Cell[180053, 4870, 213, 5, 35, "Print"],
Cell[180269, 4877, 59, 0, 60, "Print"],
Cell[180331, 4879, 67, 0, 60, "Print"]
}, Open  ]],
Cell[180413, 4882, 31, 0, 41, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[180481, 4887, 127, 3, 32, "Input"],
Cell[180611, 4892, 413, 5, 335, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[181061, 4902, 98, 2, 32, "Input"],
Cell[CellGroupData[{
Cell[181184, 4908, 264, 6, 35, "Print"],
Cell[181451, 4916, 35, 0, 35, "Print"],
Cell[181489, 4918, 206, 5, 35, "Print"],
Cell[181698, 4925, 70, 0, 35, "Print"],
Cell[181771, 4927, 68, 0, 35, "Print"],
Cell[181842, 4929, 85, 1, 35, "Print"],
Cell[181930, 4932, 75, 0, 35, "Print"],
Cell[182008, 4934, 83, 1, 35, "Print"],
Cell[182094, 4937, 92, 1, 35, "Print"],
Cell[182189, 4940, 194, 5, 35, "Print"],
Cell[182386, 4947, 59, 0, 60, "Print"],
Cell[182448, 4949, 35, 0, 35, "Print"],
Cell[182486, 4951, 216, 5, 35, "Print"],
Cell[182705, 4958, 70, 0, 35, "Print"],
Cell[182778, 4960, 68, 0, 35, "Print"],
Cell[182849, 4962, 85, 1, 35, "Print"],
Cell[182937, 4965, 75, 0, 35, "Print"],
Cell[183015, 4967, 83, 1, 35, "Print"],
Cell[183101, 4970, 92, 1, 35, "Print"],
Cell[183196, 4973, 194, 5, 35, "Print"],
Cell[183393, 4980, 84, 1, 35, "Print"],
Cell[183480, 4983, 51, 0, 35, "Print"],
Cell[183534, 4985, 35, 0, 35, "Print"],
Cell[183572, 4987, 213, 5, 35, "Print"],
Cell[183788, 4994, 60, 0, 60, "Print"],
Cell[183851, 4996, 69, 0, 60, "Print"]
}, Open  ]],
Cell[183935, 4999, 32, 0, 41, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[184004, 5004, 134, 3, 32, "Input"],
Cell[CellGroupData[{
Cell[184163, 5011, 55, 0, 34, "Print"],
Cell[184221, 5013, 58, 0, 34, "Print"],
Cell[184282, 5015, 61, 0, 34, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[184392, 5021, 318, 9, 39, "Input"],
Cell[CellGroupData[{
Cell[184735, 5034, 56, 0, 34, "Print"],
Cell[184794, 5036, 55, 0, 34, "Print"],
Cell[184852, 5038, 139, 1, 58, "Print"],
Cell[184994, 5041, 58, 0, 34, "Print"],
Cell[185055, 5043, 61, 0, 34, "Print"],
Cell[185119, 5045, 62, 0, 35, "Print"],
Cell[185184, 5047, 298, 6, 35, "Print"],
Cell[185485, 5055, 369, 9, 35, "Print"],
Cell[185857, 5066, 300, 6, 35, "Print"],
Cell[186160, 5074, 849, 22, 60, "Print"],
Cell[187012, 5098, 298, 6, 35, "Print"],
Cell[187313, 5106, 449, 11, 35, "Print"],
Cell[187765, 5119, 329, 8, 60, "Print"],
Cell[188097, 5129, 216, 5, 35, "Print"],
Cell[188316, 5136, 240, 5, 35, "Print"],
Cell[188559, 5143, 703, 18, 85, "Print"],
Cell[189265, 5163, 292, 8, 35, "Print"],
Cell[189560, 5173, 242, 6, 35, "Print"],
Cell[189805, 5181, 1940, 51, 110, "Print"],
Cell[191748, 5234, 1595, 44, 85, "Print"],
Cell[193346, 5280, 72, 0, 35, "Print"],
Cell[193421, 5282, 73, 0, 35, "Print"],
Cell[193497, 5284, 1402, 40, 85, "Print"],
Cell[194902, 5326, 558, 15, 35, "Print"],
Cell[195463, 5343, 238, 5, 35, "Print"],
Cell[195704, 5350, 244, 6, 35, "Print"],
Cell[195951, 5358, 262, 6, 35, "Print"],
Cell[196216, 5366, 362, 8, 35, "Print"],
Cell[196581, 5376, 1408, 40, 85, "Print"],
Cell[197992, 5418, 863, 25, 60, "Print"],
Cell[198858, 5445, 513, 14, 35, "Print"],
Cell[199374, 5461, 234, 5, 35, "Print"],
Cell[199611, 5468, 192, 4, 35, "Print"],
Cell[199806, 5474, 285, 7, 35, "Print"]
}, Open  ]],
Cell[200106, 5484, 259, 6, 60, "Message"],
Cell[CellGroupData[{
Cell[200390, 5494, 891, 23, 135, "Print"],
Cell[201284, 5519, 663, 21, 35, "Print"],
Cell[201950, 5542, 412, 12, 35, "Print"],
Cell[202365, 5556, 272, 6, 60, "Print"],
Cell[202640, 5564, 493, 14, 60, "Print"],
Cell[203136, 5580, 325, 7, 35, "Print"],
Cell[203464, 5589, 296, 6, 35, "Print"],
Cell[203763, 5597, 244, 6, 35, "Print"],
Cell[204010, 5605, 248, 6, 35, "Print"],
Cell[204261, 5613, 234, 5, 35, "Print"],
Cell[204498, 5620, 224, 5, 35, "Print"],
Cell[204725, 5627, 341, 9, 35, "Print"],
Cell[205069, 5638, 327, 8, 60, "Print"],
Cell[205399, 5648, 276, 9, 35, "Print"],
Cell[205678, 5659, 258, 6, 35, "Print"],
Cell[205939, 5667, 333, 8, 60, "Print"],
Cell[206275, 5677, 882, 19, 110, "Print"],
Cell[207160, 5698, 257, 6, 35, "Print"]
}, Open  ]],
Cell[207432, 5707, 259, 6, 60, "Message"],
Cell[207694, 5715, 612, 11, 110, "Message"],
Cell[208309, 5728, 315, 8, 60, "Print"],
Cell[208627, 5738, 226, 5, 60, "Message"],
Cell[208856, 5745, 516, 9, 85, "Message"],
Cell[CellGroupData[{
Cell[209397, 5758, 250, 5, 35, "Print"],
Cell[209650, 5765, 271, 6, 35, "Print"],
Cell[209924, 5773, 250, 5, 35, "Print"],
Cell[210177, 5780, 266, 5, 35, "Print"],
Cell[210446, 5787, 263, 6, 35, "Print"]
}, Open  ]],
Cell[210724, 5796, 230, 5, 60, "Message"],
Cell[CellGroupData[{
Cell[210979, 5805, 272, 6, 60, "Print"],
Cell[211254, 5813, 493, 14, 60, "Print"],
Cell[211750, 5829, 325, 7, 35, "Print"],
Cell[212078, 5838, 296, 6, 35, "Print"],
Cell[212377, 5846, 244, 6, 35, "Print"],
Cell[212624, 5854, 248, 6, 35, "Print"],
Cell[212875, 5862, 234, 5, 35, "Print"],
Cell[213112, 5869, 224, 5, 35, "Print"],
Cell[213339, 5876, 341, 9, 35, "Print"],
Cell[213683, 5887, 327, 8, 60, "Print"],
Cell[214013, 5897, 276, 9, 35, "Print"],
Cell[214292, 5908, 258, 6, 35, "Print"],
Cell[214553, 5916, 333, 8, 60, "Print"],
Cell[214889, 5926, 882, 19, 110, "Print"],
Cell[215774, 5947, 257, 6, 35, "Print"]
}, Open  ]],
Cell[216046, 5956, 259, 6, 60, "Message"],
Cell[216308, 5964, 215, 5, 60, "Message"],
Cell[216526, 5971, 612, 11, 110, "Message"],
Cell[217141, 5984, 218, 5, 60, "Message"],
Cell[217362, 5991, 315, 8, 60, "Print"],
Cell[217680, 6001, 226, 5, 60, "Message"],
Cell[217909, 6008, 214, 5, 60, "Message"],
Cell[CellGroupData[{
Cell[218148, 6017, 250, 5, 35, "Print"],
Cell[218401, 6024, 271, 6, 35, "Print"],
Cell[218675, 6032, 250, 5, 35, "Print"],
Cell[218928, 6039, 266, 5, 35, "Print"],
Cell[219197, 6046, 263, 6, 35, "Print"],
Cell[219463, 6054, 276, 6, 60, "Print"],
Cell[219742, 6062, 515, 14, 60, "Print"],
Cell[220260, 6078, 333, 8, 35, "Print"],
Cell[220596, 6088, 300, 6, 35, "Print"],
Cell[220899, 6096, 248, 6, 35, "Print"],
Cell[221150, 6104, 252, 6, 35, "Print"],
Cell[221405, 6112, 238, 5, 35, "Print"],
Cell[221646, 6119, 228, 5, 35, "Print"],
Cell[221877, 6126, 341, 9, 35, "Print"],
Cell[222221, 6137, 331, 8, 60, "Print"],
Cell[222555, 6147, 276, 9, 35, "Print"],
Cell[222834, 6158, 258, 6, 35, "Print"],
Cell[223095, 6166, 333, 8, 60, "Print"],
Cell[223431, 6176, 890, 19, 110, "Print"],
Cell[224324, 6197, 285, 7, 35, "Print"],
Cell[224612, 6206, 315, 8, 60, "Print"],
Cell[224930, 6216, 281, 7, 35, "Print"],
Cell[225214, 6225, 265, 6, 35, "Print"],
Cell[225482, 6233, 281, 7, 35, "Print"],
Cell[225766, 6242, 292, 7, 35, "Print"],
Cell[226061, 6251, 267, 6, 35, "Print"],
Cell[226331, 6259, 1494, 40, 135, "Print"],
Cell[227828, 6301, 1522, 41, 135, "Print"]
}, Open  ]],
Cell[229365, 6345, 226, 5, 60, "Message"],
Cell[229594, 6352, 227, 5, 60, "Message"],
Cell[229824, 6359, 4361, 113, 435, "Print"],
Cell[234188, 6474, 157, 4, 35, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[234382, 6483, 67, 1, 42, "Input"],
Cell[234452, 6486, 3172, 78, 366, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[237661, 6569, 180, 5, 42, "Input"],
Cell[237844, 6576, 228, 8, 60, "Output"]
}, Open  ]],
Cell[238087, 6587, 75, 2, 42, "Input"],
Cell[CellGroupData[{
Cell[238187, 6593, 397, 10, 68, "Input"],
Cell[CellGroupData[{
Cell[238609, 6607, 1408, 40, 85, "Print"],
Cell[240020, 6649, 371, 8, 35, "Print"]
}, Open  ]],
Cell[240406, 6660, 1509, 46, 116, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[241952, 6711, 63, 1, 42, "Input"],
Cell[CellGroupData[{
Cell[242040, 6716, 382, 8, 35, "Print"],
Cell[242425, 6726, 382, 8, 35, "Print"],
Cell[242810, 6736, 358, 8, 35, "Print"],
Cell[243171, 6746, 398, 9, 35, "Print"]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

