(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     49419,       1190]
NotebookOptionsPosition[     43653,       1009]
NotebookOutlinePosition[     44355,       1038]
CellTagsIndexPosition[     44282,       1033]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Synthesis examples", "Title",
 TextAlignment->Left,
 TextJustification->1,
 FontColor->RGBColor[1, 0, 0],
 CellTags->"firstcell"],

Cell[CellGroupData[{

Cell[" Execute this cell, to go in the right directory", "Subsubsection",
 FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
 RowBox[{
  RowBox[{"setMMADir", "[", 
   RowBox[{"{", 
    RowBox[{
    "\"\<demos\>\"", ",", "\"\<NOTEBOOKS\>\"", ",", "\"\<Synthesis\>\""}], 
    "}"}], "]"}], ";"}]], "Input",
 InitializationCell->True],

Cell["This notebooks show examples of synthesis.", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Fir filter (2.78 s)", "Section",
 CellChangeTimes->{{3.439552104104047*^9, 3.439552107446032*^9}, {
  3.467794207877726*^9, 3.467794210253674*^9}},
 FontColor->RGBColor[0, 0, 1]],

Cell["\<\
This example shows a finite impulse response filter. Generated files are in \
directory $MMALPHA/demos/NOTEBOOKS/Synthesis/firSYN/ .\
\>", "Text"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"debug", "\[Rule]", "False"}], ",", 
   RowBox[{"verbose", "\[Rule]", "False"}], ",", 
   RowBox[{"position", "\[Rule]", "False"}], ",", 
   RowBox[{"execute", "\[Rule]", "False"}], ",", 
   RowBox[{"pipeConstants", "\[Rule]", "False"}], ",", 
   RowBox[{"mute", "\[Rule]", "False"}], ",", 
   RowBox[{"oneStep", "\[Rule]", "False"}]}], "}"}]], "Output",
 CellChangeTimes->{3.467793215283002*^9, 3.467793891805613*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"syn", "[", 
  RowBox[{"\"\<fir.alpha\>\"", ",", 
   RowBox[{"parameterRules", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\"\<N\>\"", "\[Rule]", "4"}], ",", 
      RowBox[{"\"\<M\>\"", "\[Rule]", "100"}]}], "}"}]}], ",", 
   RowBox[{"verbose", "\[Rule]", "True"}], ",", 
   RowBox[{"schedMethod", "\[Rule]", "vertex"}], ",", 
   RowBox[{"mute", "\[Rule]", "True"}], ",", 
   RowBox[{"optionsOfScheduler", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"addConstraints", "\[Rule]", 
       RowBox[{"{", "\"\<TxD1>=1\>\"", "}"}]}], ",", 
      RowBox[{"lpResolution", "\[Rule]", "False"}], ",", 
      RowBox[{"integerSolution", "\[Rule]", "False"}]}], "}"}]}]}], 
  RowBox[{"(*", 
   RowBox[{",", 
    RowBox[{"pipe", "\[Rule]", "True"}], ",", 
    RowBox[{"pipeInputOutputs", "\[Rule]", "True"}]}], "*)"}], "]"}]], "Input",\

 CellChangeTimes->{{3.432142174600781*^9, 3.432142177830409*^9}, {
   3.432142209386484*^9, 3.432142276042139*^9}, {3.432142412649147*^9, 
   3.432142413982089*^9}, {3.4321424658587017`*^9, 3.4321424910960417`*^9}, 
   3.4321425732469683`*^9, {3.4321427134830227`*^9, 3.432142720936294*^9}, {
   3.433380067570182*^9, 3.433380113729054*^9}, {3.439365366051406*^9, 
   3.4393653699195347`*^9}, {3.43955211310811*^9, 3.439552114072892*^9}, {
   3.439552308946697*^9, 3.43955234965728*^9}, {3.4395524293842907`*^9, 
   3.439552447148347*^9}, {3.439552562197516*^9, 3.439552577888707*^9}, {
   3.4395526120368834`*^9, 3.43955261659413*^9}, {3.439554839654149*^9, 
   3.439554856253949*^9}, {3.439554958937255*^9, 3.43955497238387*^9}, {
   3.439555026844448*^9, 3.4395550285230627`*^9}, {3.439555347408589*^9, 
   3.439555413296154*^9}, {3.439555537973308*^9, 3.43955554038706*^9}, {
   3.4395558880981617`*^9, 3.439555994056958*^9}, {3.4400917299976463`*^9, 
   3.440091730659411*^9}, {3.440092512224333*^9, 3.4400925260296087`*^9}, {
   3.440125998615872*^9, 3.4401260085221653`*^9}, {3.467794043708023*^9, 
   3.467794050977521*^9}, {3.467794238048491*^9, 3.4677942739165583`*^9}, {
   3.4677943205452013`*^9, 3.4677943213922462`*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"++++  Loading file...\"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.480935469811068*^9}],

Cell[BoxData["\<\"[fir]\"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.4809354698884487`*^9}],

Cell[BoxData["\<\"----  File loaded ...\"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.480935469890633*^9}],

Cell[BoxData["\<\"++++  Analyzing ...\"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.480935469893001*^9}],

Cell[BoxData["\<\"----  Analysis successful ...\"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.480935470309731*^9}],

Cell[BoxData["\<\"++++  Scheduling ... \\n\"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.480935470389024*^9}],

Cell[BoxData["\<\"Method Minimize\"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.4809354704856253`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "62", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "20", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   "0.033656999999990944`"}],
  SequenceForm[62, " constraints, ", 20, " variables ", 0.033656999999990944`],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.480935470624711*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"fir\"\>", ",", "20", ",", "61", ",", "0.033656999999990944`", 
   ",", "\<\"Vertex\"\>", ",", "\<\"Flat\"\>"}], "}"}]], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.4809354706992397`*^9}],

Cell[BoxData["\<\"----  File scheduled...\"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.4809354707881613`*^9}],

Cell[BoxData["\<\"++++  Applying schedule ...\"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.480935470872344*^9}],

Cell[BoxData["\<\"----  Schedule applied...\"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.480935470956464*^9}],

Cell[BoxData["\<\"++++  Piping variables ...\\n\"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.480935471056518*^9}],

Cell[BoxData["\<\"----  Variables piped...\"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.4809354716287737`*^9}],

Cell[BoxData["\<\"++++  Generating Alpha0 ...\"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.480935471698251*^9}],

Cell[BoxData["\<\"----  Alpha0 generated...\"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.480935475401699*^9}],

Cell[BoxData["\<\"----  Writes a report...\"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.480935475456497*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"HXMirr1\"\>", ",", "\<\"xXMirr1\"\>", 
   ",", "\<\"pipeCx1Reg2Xloc\"\>", ",", "\<\"pipeCx1Reg2\"\>", 
   ",", "\<\"ser1Reg3\"\>", ",", "\<\"pipeCH1Reg1\"\>", 
   ",", "\<\"ser1Xctl1XIn\"\>", ",", "\<\"pipeCx1\"\>", 
   ",", "\<\"pipeCH1\"\>", ",", "\<\"ser1Xctl1\"\>", ",", "\<\"TSep1\"\>", 
   ",", "\<\"TSep2\"\>", ",", "\<\"ser1\"\>", ",", "\<\"res\"\>"}], 
  "}"}]], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.480935475545841*^9}],

Cell[BoxData["\<\" spatial case \"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.480935475845976*^9}],

Cell[BoxData["\<\" spatial case \"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.480935475952054*^9}],

Cell[BoxData["\<\"++++  Generating AlpHard ...\"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.4809354762495537`*^9}],

Cell[BoxData["\<\"----  AlpHard generated...\"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.480935480803338*^9}],

Cell[BoxData["\<\"++++  Setting parameter's value ...\"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.4809354808512983`*^9}],

Cell[BoxData["\<\"----  Parameter's value was set...\"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.4809354812971697`*^9}],

Cell[BoxData["\<\"++++  Generating Vhdl ...\"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.4809354813500566`*^9}],

Cell[BoxData["\<\"101010101010 --- Modify delete components \"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.480935482331998*^9}],

Cell[BoxData["\<\"----  Vhdl was generated in Directory firSYN/VHDL\"\>"], \
"Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.4809354823850594`*^9}],

Cell[BoxData["\<\"----  Congratulations, you made it ! \"\>"], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.4809354824748993`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----  Total time: \"\>", "\[InvisibleSpace]", 
   "2.8766430000000014`", "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["----  Total time: ", 2.8766430000000014`, " seconds"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.467728336243121*^9, 3.467729367925704*^9, 3.467786324491346*^9, 
   3.467786364226729*^9, 3.467791084517975*^9, 3.467791437248021*^9, 
   3.467793335584077*^9, 3.467793432536825*^9, 3.467793752990472*^9, 
   3.467793785358431*^9, 3.467794017159747*^9, 3.4677940525218773`*^9, {
   3.467794260290448*^9, 3.4677943217704573`*^9}, 3.4809354825582247`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Compute Distance (10.08 s). Does not work currently... so ignore\
\>", "Section",
 CellChangeTimes->{{3.440091043852586*^9, 3.440091053769792*^9}},
 FontColor->RGBColor[0, 0, 1]],

Cell["For future tests...", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"syn", "[", 
  RowBox[{"\"\<tempfile.alpha\>\"", ",", 
   RowBox[{"parameterRules", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\"\<N\>\"", "\[Rule]", "20"}], ",", 
      RowBox[{"\"\<M\>\"", "\[Rule]", "100"}]}], "}"}]}], ",", 
   RowBox[{"verbose", "\[Rule]", "False"}], ",", 
   RowBox[{"pipe", "\[Rule]", "False"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.432142817684774*^9, 3.432142821210803*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "::", "\<\"notFound\"\>"}], ":", 
  " ", "\<\" File \\!\\(\\\"tempfile.alpha\\\"\\) not found \"\>"}]], \
"Message", "MSG",
 CellChangeTimes->{3.467728351715773*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"syn", "::", "\<\"errorLoad\"\>"}], ":", 
  " ", "\<\"error while loading file. syn aborted...\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.467728351941147*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Samba (3,91 s)", "Section",
 CellChangeTimes->{{3.433380367330264*^9, 3.4333803703345613`*^9}, {
  3.467794364798847*^9, 3.467794367532823*^9}},
 FontColor->RGBColor[0, 0, 1]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"syn", "[", 
  RowBox[{"\"\<Samba.alpha\>\"", ",", 
   RowBox[{"parameterRules", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\"\<X\>\"", "\[Rule]", "20"}], ",", 
      RowBox[{"\"\<Y\>\"", "\[Rule]", "100"}]}], "}"}]}], ",", 
   RowBox[{"schedMethod", "\[Rule]", "vertex"}], ",", 
   RowBox[{"verbose", "\[Rule]", "True"}], ",", 
   RowBox[{"debug", "\[Rule]", "True"}], ",", 
   RowBox[{"pipe", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.432142825437786*^9, 3.432142829556223*^9}, {
  3.433380314406139*^9, 3.433380315254409*^9}, {3.4395520092860813`*^9, 
  3.439552018672991*^9}, {3.467728592002172*^9, 3.4677285951729813`*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"++++  Loading file...\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.4809355198512*^9}],

Cell[BoxData["\<\"[sequence]\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.480935519853135*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Directory: \"\>", 
   "\[InvisibleSpace]", \
"\<\"/Users/patricequinton/mmalpha/demos/NOTEBOOKS/Synthesis/sequenceSYN/\"\>\
"}],
  SequenceForm[
  "Directory: ", 
   "/Users/patricequinton/mmalpha/demos/NOTEBOOKS/Synthesis/sequenceSYN/"],
  Editable->False]], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.48093551985581*^9}],

Cell[BoxData["\<\"system sequence :{X,Y | 3<=X<=Y-1}\\n                (QS : \
{i | 1<=i<=X} of integer; \\n                 DB : {j | 1<=j<=Y} of \
integer)\\n       returns  (res : {j | 1<=j<=Y} of integer);\\nvar\\n  M : \
{i,j | 0<=i<=X; 0<=j<=Y} of integer;\\n  MatchQ : {i,j | 1<=i<=X; 1<=j<=Y} of \
integer;\\nlet\\n  M[i,j] = \\n      case\\n        { | i=0} : 0[];\\n        \
{ | 1<=i; j=0} : 0[];\\n        { | 1<=i; 1<=j} : max(0[], max((M[i,j-1] - \
8[]), (M[i-1,j-1] + MatchQ[i,j])));\\n      esac;\\n  MatchQ[i,j] = if (QS[i] \
= DB[j]) then 15[] else -12[];\\n  res[j] = M[X,j];\\ntel;\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.480935519858403*^9}],

Cell[BoxData["\<\"----  File loaded ...\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.480935519934058*^9}],

Cell[BoxData["\<\"++++  Analyzing ...\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.48093552001917*^9}],

Cell[BoxData["\<\"----  Analysis successful ...\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.480935520554387*^9}],

Cell[BoxData["\<\"++++  Scheduling ... \\n\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.4809355206146717`*^9}],

Cell[BoxData["\<\"Method Minimize\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.480935520772995*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "99", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "25", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   "0.08465499999999793`"}],
  SequenceForm[99, " constraints, ", 25, " variables ", 0.08465499999999793],
  Editable->False]], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.4809355208634863`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"sequence\"\>", ",", "25", ",", "98", ",", 
   "0.08465499999999793`", ",", "\<\"Vertex\"\>", ",", "\<\"Flat\"\>"}], 
  "}"}]], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.48093552091934*^9}],

Cell[BoxData["\<\"----  File scheduled...\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.4809355210051317`*^9}],

Cell[BoxData["\<\"++++  Applying schedule ...\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.480935521088076*^9}],

Cell[BoxData["\<\"----  Schedule applied...\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.480935521620862*^9}],

Cell[BoxData["\<\"++++  Piping variables ...\\n\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.4809355216641607`*^9}],

Cell[BoxData["\<\"----  Variables piped...\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.480935522399476*^9}],

Cell[BoxData["\<\"++++  Generating Alpha0 ...\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.48093552244983*^9}],

Cell[BoxData["\<\"----  Alpha0 generated...\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.4809355291365557`*^9}],

Cell[BoxData["\<\"----  Writes a report...\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.4809355291934347`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"DBXMirr1\"\>", ",", "\<\"MReg2Xloc\"\>", ",", "\<\"MReg2\"\>", 
   ",", "\<\"pipeCQS1Reg5\"\>", ",", "\<\"pipeCDB1Reg4\"\>", 
   ",", "\<\"MatchQReg3\"\>", ",", "\<\"MReg1\"\>", ",", "\<\"MXctl2XIn\"\>", 
   ",", "\<\"pipeCQS1Xctl1XIn\"\>", ",", "\<\"pipeCDB1\"\>", 
   ",", "\<\"pipeCQS1Xctl1\"\>", ",", "\<\"TSep3\"\>", 
   ",", "\<\"pipeCQS1\"\>", ",", "\<\"MXctl2\"\>", ",", "\<\"TSep4\"\>", 
   ",", "\<\"TSep5\"\>", ",", "\<\"TSep6\"\>", ",", "\<\"TSep7\"\>", 
   ",", "\<\"M\"\>", ",", "\<\"TSep1\"\>", ",", "\<\"TSep2\"\>", 
   ",", "\<\"MatchQ\"\>", ",", "\<\"res\"\>"}], "}"}]], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.480935529266478*^9}],

Cell[BoxData["\<\" spatial case \"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.480935529791144*^9}],

Cell[BoxData["\<\"++++  Generating AlpHard ...\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.480935530567686*^9}],

Cell[BoxData["\<\"----  AlpHard generated...\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.480935535346869*^9}],

Cell[BoxData["\<\"++++  Setting parameter's value ...\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.4809355354056664`*^9}],

Cell[BoxData["\<\"----  Parameter's value was set...\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.480935535875938*^9}],

Cell[BoxData["\<\"++++  Generating Vhdl ...\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.480935535919984*^9}],

Cell[BoxData["\<\"101010101010 --- Modify delete components \"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.480935536882349*^9}],

Cell[BoxData["\<\"----  Vhdl was generated in Directory \
sequenceSYN/VHDL\"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.480935536939475*^9}],

Cell[BoxData["\<\"----  Congratulations, you made it ! \"\>"], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.480935537012759*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----  Total time: \"\>", "\[InvisibleSpace]", 
   "4.028408999999982`", "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["----  Total time: ", 4.028408999999982, " seconds"],
  Editable->False]], "Print",
 CellChangeTimes->{3.467728354625893*^9, 3.467728595971428*^9, 
  3.4677293267508574`*^9, 3.467794078120788*^9, 3.467794340922365*^9, 
  3.4809355370960627`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Matrix Vector multiplication (1,72 s)", "Section",
 CellChangeTimes->{{3.433380423530739*^9, 3.433380424856881*^9}, {
  3.467794414868472*^9, 3.467794418106538*^9}},
 FontColor->RGBColor[0, 0, 1]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"syn", "[", 
  RowBox[{"\"\<MV1.alpha\>\"", ",", 
   RowBox[{"parameterRules", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<N\>\"", "\[Rule]", "20"}], "}"}]}], ",", 
   RowBox[{"pipe", "\[Rule]", "True"}], ",", 
   RowBox[{"schedMethod", "\[Rule]", "vertex"}], ",", 
   RowBox[{"pipe", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.4321429893784637`*^9, 3.432142992935914*^9}, {
  3.433380386744597*^9, 3.433380387400585*^9}, {3.4677943828727016`*^9, 
  3.46779440230059*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"[prodVect]\"\>"], "Print",
 CellChangeTimes->{3.467728367376363*^9, 3.467794099046397*^9, 
  3.4677944028471317`*^9, 3.4809355457616158`*^9}],

Cell[BoxData["\<\"Method Minimize\"\>"], "Print",
 CellChangeTimes->{3.467728367376363*^9, 3.467794099046397*^9, 
  3.4677944028471317`*^9, 3.480935546176098*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "58", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "16", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   "0.015291000000004829`"}],
  SequenceForm[58, " constraints, ", 16, " variables ", 0.015291000000004829`],
  Editable->False]], "Print",
 CellChangeTimes->{3.467728367376363*^9, 3.467794099046397*^9, 
  3.4677944028471317`*^9, 3.4809355462297*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"prodVect\"\>", ",", "16", ",", "57", ",", 
   "0.015291000000004829`", ",", "\<\"Vertex\"\>", ",", "\<\"Flat\"\>"}], 
  "}"}]], "Print",
 CellChangeTimes->{3.467728367376363*^9, 3.467794099046397*^9, 
  3.4677944028471317`*^9, 3.480935546232313*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"bXMirr1\"\>", ",", "\<\"pipeCb1Reg3\"\>", ",", "\<\"aReg2\"\>",
    ",", "\<\"CReg1\"\>", ",", "\<\"CXctl1XIn\"\>", ",", "\<\"pipeCb1\"\>", 
   ",", "\<\"CXctl1\"\>", ",", "\<\"TSep1\"\>", ",", "\<\"TSep2\"\>", 
   ",", "\<\"C\"\>", ",", "\<\"c\"\>"}], "}"}]], "Print",
 CellChangeTimes->{3.467728367376363*^9, 3.467794099046397*^9, 
  3.4677944028471317`*^9, 3.480935549675151*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"checkVhdlIdentifiers", "::", "\<\"error\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"in program \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"prodVect\\\"\\), \\\"MT\\\
\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" and for identifiers in \
\\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\({\\\"C\\\", \
\\\"c\\\"}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\", there \
will be a problem when generating VHDL code, since Vhdl is not case-sensitive\
\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.480935552975856*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"syn", "::", "\<\"errorVhdl\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"error while generating Vhdl. \
syn aborted...\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.480935553160832*^9}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Distances (3,25 s)", "Section",
 CellChangeTimes->{{3.4333804882290173`*^9, 3.433380490098515*^9}, {
  3.467794451682609*^9, 3.467794453752606*^9}},
 FontColor->RGBColor[0, 0, 1]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"syn", "[", 
  RowBox[{"\"\<distances.alpha\>\"", ",", 
   RowBox[{"parameterRules", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\"\<N\>\"", "\[Rule]", "20"}], ",", 
      RowBox[{"\"\<M\>\"", "\[Rule]", "100"}]}], "}"}]}], ",", 
   RowBox[{"verbose", "\[Rule]", "False"}], ",", " ", 
   RowBox[{"schedMethod", "\[Rule]", "vertex"}], ",", 
   RowBox[{"pipe", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.4321430611735353`*^9, 3.432143065491418*^9}, {
  3.433380449677143*^9, 3.433380450378826*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"[distance][computeDistances]\"\>"], "Print",
 CellChangeTimes->{3.467728383870472*^9, 3.4677944326443443`*^9, 
  3.480935568254323*^9}],

Cell[BoxData["\<\"system computeDistances :{N,M | 1<=N; 2<=M}\\n              \
          (descriptor : {i | 0<=i<=N-1} of integer[S,15]; \\n                 \
        image : {i,j | 0<=i<=N-1; 0<=j<=M-1} of integer[S,15])\\n       \
returns          (distances : {j | 0<=j<=M-1} of integer[S,15]);\\nvar\\n  \
temp : {i,j | 0<=i<=N-1; 0<=j<=M-1} of integer[S,15];\\n  d : {j | 0<=j<=M-1} \
of integer[S,15];\\n  dloc : {i,j | -1<=i<=N-1; 0<=j<=M-1} of \
integer[S,15];\\n  diff : {i,j | 0<=i<=N-1; 0<=j<=M-1} of integer[S,15];\\n  \
absValue : {i,j | 0<=i<=N-1; 0<=j<=M-1} of integer[S,15];\\nlet\\n  temp[i,j] \
= descriptor[i];\\n  diff[i,j] = image[i,j] - temp[i,j];\\n  absValue[i,j] = \
if (diff[i,j]>0[]) then diff[i,j] else -diff[i,j];\\n  dloc[i,j] = \\n      \
case\\n        { | i=-1} : 0[];\\n        { | 0<=i} : dloc[i-1,j] + \
absValue[i,j];\\n      esac;\\n  d[j] = dloc[N-1,j];\\n  distances[j] = \
d;\\ntel;\"\>"], "Print",
 CellChangeTimes->{3.467728383870472*^9, 3.4677944326443443`*^9, 
  3.480935568595029*^9}],

Cell[BoxData["\<\"[computeDistances]\"\>"], "Print",
 CellChangeTimes->{3.467728383870472*^9, 3.4677944326443443`*^9, 
  3.480935568648991*^9}],

Cell[BoxData["\<\"Method Minimize\"\>"], "Print",
 CellChangeTimes->{3.467728383870472*^9, 3.4677944326443443`*^9, 
  3.480935569514928*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "117", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "40", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   "0.43106599999998707`"}],
  SequenceForm[117, " constraints, ", 40, " variables ", 0.43106599999998707`],
  Editable->False]], "Print",
 CellChangeTimes->{3.467728383870472*^9, 3.4677944326443443`*^9, 
  3.48093557000935*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"computeDistances\"\>", ",", "40", ",", "116", ",", 
   "0.43106599999998707`", ",", "\<\"Vertex\"\>", ",", "\<\"Flat\"\>"}], 
  "}"}]], "Print",
 CellChangeTimes->{3.467728383870472*^9, 3.4677944326443443`*^9, 
  3.480935570076466*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"descriptorXMirr1\"\>", ",", "\<\"pipeCdescriptor1Reg8\"\>", 
   ",", "\<\"absValueReg7\"\>", ",", "\<\"dlocReg6\"\>", 
   ",", "\<\"tempReg5\"\>", ",", "\<\"imageReg4\"\>", ",", "\<\"diffReg3\"\>",
    ",", "\<\"diffReg2\"\>", ",", "\<\"diffReg1\"\>", 
   ",", "\<\"dlocXctl1XIn\"\>", ",", "\<\"pipeCdescriptor1\"\>", 
   ",", "\<\"temp\"\>", ",", "\<\"diff\"\>", ",", "\<\"TSep1\"\>", 
   ",", "\<\"TSep2\"\>", ",", "\<\"absValue\"\>", ",", "\<\"dlocXctl1\"\>", 
   ",", "\<\"TSep3\"\>", ",", "\<\"dloc\"\>", ",", "\<\"d\"\>", 
   ",", "\<\"distances\"\>"}], "}"}]], "Print",
 CellChangeTimes->{3.467728383870472*^9, 3.4677944326443443`*^9, 
  3.480935575119299*^9}],

Cell[BoxData["\<\" spatial case \"\>"], "Print",
 CellChangeTimes->{3.467728383870472*^9, 3.4677944326443443`*^9, 
  3.480935575701439*^9}],

Cell[BoxData["\<\"101010101010 --- Modify delete components \"\>"], "Print",
 CellChangeTimes->{3.467728383870472*^9, 3.4677944326443443`*^9, 
  3.480935580727034*^9}],

Cell[BoxData["\<\"----  Congratulations, you made it ! \"\>"], "Print",
 CellChangeTimes->{3.467728383870472*^9, 3.4677944326443443`*^9, 
  3.4809355807774878`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----  Total time: \"\>", "\[InvisibleSpace]", 
   "3.412188999999998`", "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["----  Total time: ", 3.412188999999998, " seconds"],
  Editable->False]], "Print",
 CellChangeTimes->{3.467728383870472*^9, 3.4677944326443443`*^9, 
  3.480935580850704*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Matmult (5,92 s) Failed during VHDL generation.", "Section",
 CellChangeTimes->{{3.4333805165204687`*^9, 3.433380520315673*^9}},
 FontColor->RGBColor[0, 0, 1]],

Cell["\<\
The current error is actually not important, as it concerns only the most \
external module. Moreover, I think that there should not be such an error...\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"syn", "[", 
  RowBox[{"\"\<matmult.alpha\>\"", ",", 
   RowBox[{"parameterRules", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<M\>\"", "\[Rule]", "100"}], "}"}]}], ",", 
   RowBox[{"pipe", "\[Rule]", "False"}], ",", 
   RowBox[{"verbose", "\[Rule]", "False"}], ",", " ", 
   RowBox[{"schedMethod", "\[Rule]", "vertex"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.4333805295458813`*^9, 3.433380536965806*^9}, {
  3.467794134950447*^9, 3.467794139655753*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"[matmult]\"\>"], "Print",
 CellChangeTimes->{3.467728393249235*^9, 3.467794140840658*^9, 
  3.4677944670653343`*^9, 3.4809356019829407`*^9}],

Cell[BoxData["\<\"Method Minimize\"\>"], "Print",
 CellChangeTimes->{3.467728393249235*^9, 3.467794140840658*^9, 
  3.4677944670653343`*^9, 3.4809356024705467`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "102", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "19", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   "0.04648699999999906`"}],
  SequenceForm[102, " constraints, ", 19, " variables ", 0.04648699999999906],
  
  Editable->False]], "Print",
 CellChangeTimes->{3.467728393249235*^9, 3.467794140840658*^9, 
  3.4677944670653343`*^9, 3.480935602520939*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"matmult\"\>", ",", "19", ",", "101", ",", 
   "0.04648699999999906`", ",", "\<\"Vertex\"\>", ",", "\<\"Flat\"\>"}], 
  "}"}]], "Print",
 CellChangeTimes->{3.467728393249235*^9, 3.467794140840658*^9, 
  3.4677944670653343`*^9, 3.480935602569532*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"bXMirr1\"\>", ",", "\<\"aXMirr1\"\>", ",", "\<\"CReg1\"\>", 
   ",", "\<\"CXctl1XIn\"\>", ",", "\<\"c\"\>", ",", "\<\"CXctl1\"\>", 
   ",", "\<\"TSep1\"\>", ",", "\<\"TSep2\"\>", ",", "\<\"C\"\>"}], 
  "}"}]], "Print",
 CellChangeTimes->{3.467728393249235*^9, 3.467794140840658*^9, 
  3.4677944670653343`*^9, 3.4809356056592197`*^9}],

Cell[BoxData["\<\"8888888888\"\>"], "Print",
 CellChangeTimes->{3.467728393249235*^9, 3.467794140840658*^9, 
  3.4677944670653343`*^9, 3.4809356081280327`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"checkVhdlIdentifiers", "::", "\<\"error\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"in program \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"matmult\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" and for identifiers in \
\\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\({\\\"C\\\", \
\\\"c\\\"}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\", there \
will be a problem when generating VHDL code, since Vhdl is not case-sensitive\
\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.467728393584694*^9, 3.46779414730328*^9, 
  3.4677944731758738`*^9, 3.480935608148625*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"In definition of variable \"\>", 
   "\[InvisibleSpace]", "\<\"bXMirr1\"\>"}],
  SequenceForm["In definition of variable ", "bXMirr1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.467728393249235*^9, 3.467794140840658*^9, 
  3.4677944670653343`*^9, 3.48093560823904*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vhdlModule", "::", "\<\"impossibleassignement\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"the assignement is \
impossible because it is a broadcast in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"12\\\"\\), \\\"MT\\\"]\\)\
\[NoBreak]\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.467728393584694*^9, 3.46779414730328*^9, 
  3.4677944731758738`*^9, 3.480935608282587*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"In definition of variable \"\>", 
   "\[InvisibleSpace]", "\<\"aXMirr1\"\>"}],
  SequenceForm["In definition of variable ", "aXMirr1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.467728393249235*^9, 3.467794140840658*^9, 
  3.4677944670653343`*^9, 3.480935608332221*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vhdlModule", "::", "\<\"impossibleassignement\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"the assignement is \
impossible because it is a broadcast in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"12\\\"\\), \\\"MT\\\"]\\)\
\[NoBreak]\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.467728393584694*^9, 3.46779414730328*^9, 
  3.4677944731758738`*^9, 3.4809356083334093`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"In definition of variable \"\>", 
   "\[InvisibleSpace]", "\<\"c\"\>"}],
  SequenceForm["In definition of variable ", "c"],
  Editable->False]], "Print",
 CellChangeTimes->{3.467728393249235*^9, 3.467794140840658*^9, 
  3.4677944670653343`*^9, 3.48093560835973*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"vhdlModule", "::", "\<\"impossibleassignement\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"the assignement is \
impossible because it is a broadcast in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"16ter\\\"\\), \\\"MT\\\"]\
\\)\[NoBreak]\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.467728393584694*^9, 3.46779414730328*^9, 
  3.4677944731758738`*^9, 3.480935608360944*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Further output of \\\\\\\"\\\
\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(vhdlModule :: \
\\\"impossibleassignement\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" will be suppressed \
during this calculation.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.467728393584694*^9, 3.46779414730328*^9, 
  3.4677944731758738`*^9, 3.4809356084385977`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"a2v", "::", "\<\"error3\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Error while calling \
genModule on \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\
\"matmult\\\"\\), \\\"MT\\\"]\\)\[NoBreak]\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.467728393584694*^9, 3.46779414730328*^9, 
  3.4677944731758738`*^9, 3.48093560852234*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"syn", "::", "\<\"errorVhdl\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"error while generating Vhdl. \
syn aborted...\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.467728393584694*^9, 3.46779414730328*^9, 
  3.4677944731758738`*^9, 3.4809356086069117`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->None,
WindowToolbars->{"RulerBar", "EditBar"},
WindowSize->{1243, 759},
WindowMargins->{{38, Automatic}, {Automatic, 0}},
DockedCells->FEPrivate`FrontEndResource[
 "FEExpressions", "CompatibilityToolbar"],
PrintingCopies->1,
PrintingPageRange->{21, Automatic},
ShowSelection->True,
Magnification->1.25,
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (February 18, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "firstcell"->{
  Cell[567, 22, 135, 4, 95, "Title",
   CellTags->"firstcell"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"firstcell", 44194, 1027}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 135, 4, 95, "Title",
 CellTags->"firstcell"],
Cell[CellGroupData[{
Cell[727, 30, 104, 1, 30, "Subsubsection"],
Cell[834, 33, 220, 7, 33, "Input",
 InitializationCell->True],
Cell[1057, 42, 58, 0, 32, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1152, 47, 184, 3, 83, "Section"],
Cell[1339, 52, 156, 3, 32, "Text"],
Cell[1498, 57, 469, 10, 33, "Output"],
Cell[CellGroupData[{
Cell[1992, 71, 2110, 39, 72, "Input"],
Cell[CellGroupData[{
Cell[4127, 114, 430, 6, 25, "Print"],
Cell[4560, 122, 416, 6, 25, "Print"],
Cell[4979, 130, 430, 6, 25, "Print"],
Cell[5412, 138, 428, 6, 25, "Print"],
Cell[5843, 146, 438, 6, 25, "Print"],
Cell[6284, 154, 433, 6, 45, "Print"],
Cell[6720, 162, 426, 6, 25, "Print"],
Cell[7149, 170, 711, 13, 25, "Print"],
Cell[7863, 185, 549, 9, 25, "Print"],
Cell[8415, 196, 434, 6, 25, "Print"],
Cell[8852, 204, 436, 6, 25, "Print"],
Cell[9291, 212, 434, 6, 25, "Print"],
Cell[9728, 220, 438, 6, 45, "Print"],
Cell[10169, 228, 435, 6, 25, "Print"],
Cell[10607, 236, 436, 6, 25, "Print"],
Cell[11046, 244, 434, 6, 25, "Print"],
Cell[11483, 252, 433, 6, 25, "Print"],
Cell[11919, 260, 799, 14, 45, "Print"],
Cell[12721, 276, 423, 6, 25, "Print"],
Cell[13147, 284, 423, 6, 25, "Print"],
Cell[13573, 292, 439, 6, 25, "Print"],
Cell[14015, 300, 435, 6, 25, "Print"],
Cell[14453, 308, 446, 6, 25, "Print"],
Cell[14902, 316, 445, 6, 25, "Print"],
Cell[15350, 324, 436, 6, 25, "Print"],
Cell[15789, 332, 451, 6, 25, "Print"],
Cell[16243, 340, 462, 7, 25, "Print"],
Cell[16708, 349, 448, 6, 25, "Print"],
Cell[17159, 357, 642, 11, 25, "Print"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[17862, 375, 188, 4, 83, "Section"],
Cell[18053, 381, 35, 0, 32, "Text"],
Cell[CellGroupData[{
Cell[18113, 385, 442, 10, 33, "Input"],
Cell[18558, 397, 207, 5, 26, "Message"],
Cell[18768, 404, 197, 4, 26, "Message"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[19014, 414, 181, 3, 83, "Section"],
Cell[CellGroupData[{
Cell[19220, 421, 687, 14, 53, "Input"],
Cell[CellGroupData[{
Cell[19932, 439, 213, 3, 25, "Print"],
Cell[20148, 444, 204, 3, 25, "Print"],
Cell[20355, 449, 476, 12, 25, "Print"],
Cell[20834, 463, 777, 10, 330, "Print"],
Cell[21614, 475, 215, 3, 25, "Print"],
Cell[21832, 480, 212, 3, 25, "Print"],
Cell[22047, 485, 223, 3, 25, "Print"],
Cell[22273, 490, 220, 3, 45, "Print"],
Cell[22496, 495, 209, 3, 25, "Print"],
Cell[22708, 500, 495, 10, 25, "Print"],
Cell[23206, 512, 338, 7, 25, "Print"],
Cell[23547, 521, 219, 3, 25, "Print"],
Cell[23769, 526, 221, 3, 25, "Print"],
Cell[23993, 531, 219, 3, 25, "Print"],
Cell[24215, 536, 225, 3, 45, "Print"],
Cell[24443, 541, 218, 3, 25, "Print"],
Cell[24664, 546, 220, 3, 25, "Print"],
Cell[24887, 551, 221, 3, 25, "Print"],
Cell[25111, 556, 220, 3, 25, "Print"],
Cell[25334, 561, 801, 13, 45, "Print"],
Cell[26138, 576, 208, 3, 25, "Print"],
Cell[26349, 581, 222, 3, 25, "Print"],
Cell[26574, 586, 220, 3, 25, "Print"],
Cell[26797, 591, 231, 3, 25, "Print"],
Cell[27031, 596, 228, 3, 25, "Print"],
Cell[27262, 601, 219, 3, 25, "Print"],
Cell[27484, 606, 236, 3, 25, "Print"],
Cell[27723, 611, 250, 4, 25, "Print"],
Cell[27976, 617, 231, 3, 25, "Print"],
Cell[28210, 622, 424, 8, 25, "Print"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[28695, 637, 202, 3, 83, "Section"],
Cell[CellGroupData[{
Cell[28922, 644, 518, 11, 33, "Input"],
Cell[CellGroupData[{
Cell[29465, 659, 159, 2, 25, "Print"],
Cell[29627, 663, 162, 2, 25, "Print"],
Cell[29792, 667, 447, 9, 25, "Print"],
Cell[30242, 678, 293, 6, 25, "Print"],
Cell[30538, 686, 426, 7, 25, "Print"]
}, Open  ]],
Cell[30979, 696, 653, 11, 26, "Message"],
Cell[31635, 709, 273, 6, 26, "Message"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[31957, 721, 185, 3, 83, "Section"],
Cell[CellGroupData[{
Cell[32167, 728, 553, 12, 33, "Input"],
Cell[CellGroupData[{
Cell[32745, 744, 153, 2, 25, "Print"],
Cell[32901, 748, 1031, 14, 425, "Print"],
Cell[33935, 764, 143, 2, 25, "Print"],
Cell[34081, 768, 140, 2, 25, "Print"],
Cell[34224, 772, 426, 9, 25, "Print"],
Cell[34653, 783, 279, 6, 25, "Print"],
Cell[34935, 791, 711, 12, 45, "Print"],
Cell[35649, 805, 139, 2, 25, "Print"],
Cell[35791, 809, 167, 2, 25, "Print"],
Cell[35961, 813, 164, 2, 25, "Print"],
Cell[36128, 817, 353, 7, 25, "Print"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[36542, 831, 165, 2, 83, "Section"],
Cell[36710, 835, 176, 3, 32, "Text"],
Cell[CellGroupData[{
Cell[36911, 842, 483, 10, 33, "Input"],
Cell[CellGroupData[{
Cell[37419, 856, 158, 2, 25, "Print"],
Cell[37580, 860, 164, 2, 25, "Print"],
Cell[37747, 864, 451, 10, 25, "Print"],
Cell[38201, 876, 292, 6, 25, "Print"],
Cell[38496, 884, 377, 7, 25, "Print"],
Cell[38876, 893, 159, 2, 25, "Print"]
}, Open  ]],
Cell[39050, 898, 722, 12, 26, "Message"],
Cell[39775, 912, 326, 7, 25, "Print"],
Cell[40104, 921, 455, 9, 26, "Message"],
Cell[40562, 932, 327, 7, 25, "Print"],
Cell[40892, 941, 457, 9, 26, "Message"],
Cell[41352, 952, 314, 7, 25, "Print"],
Cell[41669, 961, 458, 9, 26, "Message"],
Cell[42130, 972, 723, 13, 26, "Message"],
Cell[42856, 987, 409, 8, 26, "Message"],
Cell[43268, 997, 345, 7, 26, "Message"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
