(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      6630,        288]*)
(*NotebookOutlinePosition[      7965,        332]*)
(*  CellTagsIndexPosition[      7921,        328]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["The \"Semantics\" package", "Title",
  FontColor->RGBColor[1, 0, 0]],

Cell["Patrice Quinton", "Subsubtitle"],

Cell["July 2002", "Text"],

Cell["\<\
Irisa, Campus de Beaulieu, 35042 Rennes Cedex, France
alpha@irisa.fr\
\>", "SmallText"],

Cell[CellGroupData[{

Cell[" Execute this cell, to redefine the current directory", "Subsubsection",
  FontColor->RGBColor[1, 0, 0]],

Cell[BoxData[
    \(setMMADir[{"\<doc\>", "\<packages\>", "\<Semantics\>"}]\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Introduction", "Section",
  FontColor->RGBColor[0, 0, 1]],

Cell[TextData[{
  "The ",
  StyleBox["Semantics",
    FontColor->RGBColor[1, 0, 0]],
  " package contains functions to analyze the type of Alpha expressions. "
}], "Text",
  TextAlignment->Left,
  TextJustification->1],

Cell[BoxData[
    \(SymbolsInContext["\<Alpha`Semantics`\>"]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["changeType", "Section",
  FontColor->RGBColor[0, 0, 1]],

Cell["The normalization rules are contained in several variables:", "Text"],

Cell[BoxData[
    \(\(?normalizationRules\)\)], "Input"],

Cell[BoxData[
    \(\(?normalizationRules0\)\)], "Input"],

Cell[BoxData[
    \(load["\<Test1.alpha\>"]; ashow[]\)], "Input"],

Cell[BoxData[
    \(normalizeQ[]\)], "Input"],

Cell[BoxData[
    \(substituteInDef["\<Z\>", "\<Z\>"]; ashow[]\)], "Input"],

Cell["The new program is not normalized: ", "Text"],

Cell[BoxData[
    \(normalizeQ[]\)], "Input"],

Cell[BoxData[
    \(normalize0Q[]\)], "Input"],

Cell["Normalize0 does not simplify case expressions:", "Text"],

Cell[BoxData[
    \(normalize0[]; ashow[]\)], "Input"],

Cell[BoxData[
    \(normalize0Q[]\)], "Input"],

Cell[BoxData[
    \(normalizeQ[]\)], "Input"],

Cell["Normalize it: ", "Text"],

Cell[BoxData[
    \(normalize[]; ashow[]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["expDimension", "Section",
  FontColor->RGBColor[0, 0, 1]],

Cell["Again, load test program:", "Text"],

Cell[BoxData[
    \(load["\<Test2.alpha\>"]; ashow[]\)], "Input"],

Cell["Add a new equation \"U = Z\", and rename old variable Z as U:", "Text"],

Cell[BoxData[
    \(addlocal["\<U\>", "\<Z\>"]; ashow[]\)], "Input"],

Cell["Substitute U in z twice, and U in U:", "Text"],

Cell[BoxData[{
    \(\(substituteInDef["\<Z\>", "\<U\>"];\)\), "\n", 
    \(\(substituteInDef["\<Z\>", "\<U\>"];\)\), "\n", 
    \(substituteInDef["\<U\>", "\<U\>"]; ashow[]\)}], "Input"],

Cell["Normalize only definition of Z :", "Text"],

Cell[BoxData[{
    \(\(normalizeDef["\<Z\>"];\)\), "\n", 
    \(ashow[]\)}], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Other functions", "Section",
  FontColor->RGBColor[0, 0, 1]],

Cell[CellGroupData[{

Cell["checkRestrictions", "Subsection"],

Cell["\<\
This function is essentially for internal use by \
normalization.\
\>", "Text"],

Cell[BoxData[
    \(\(?checkRestrictions\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["normalizeInCtxt", "Subsection"],

Cell[BoxData[
    \(\(?normalizeInCtxt\)\)], "Input"],

Cell[BoxData[
    \(\(load["\<Test2.alpha\>"];\)\)], "Input"],

Cell[BoxData[
    \(show[]\)], "Input"],

Cell[BoxData[
    \(ee = getDefinition["\<Z\>"]; ashow[ee]\)], "Input"],

Cell[BoxData[
    \(analyze[]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["simplifyInContext", "Subsection"],

Cell[BoxData[
    \(\(load["\<QRerr.alpha\>"];\)\)], "Input"],

Cell[BoxData[
    \(analyze[]\)], "Input"],

Cell[BoxData[
    \(\(simplifySystem[];\)\)], "Input"],

Cell[BoxData[
    \(analyze[]\)], "Input"],

Cell[BoxData[
    \(\(?simplifyInContext\)\)], "Input"],

Cell[BoxData[
    \(\(load["\<err.alpha\>"];\)\)], "Input"],

Cell[BoxData[
    \(ashow[]\)], "Input"],

Cell[BoxData[
    \(analyze[]\)], "Input"],

Cell[BoxData[
    \(\(simplifyInContext[];\)\)], "Input"],

Cell[BoxData[
    \(analyze[]\)], "Input"],

Cell[BoxData[
    \(ashow[]\)], "Input"],

Cell[BoxData[
    \(load["\<errsimple.alpha\>"]; ashow[]\)], "Input"],

Cell[BoxData[
    \(analyze[]\)], "Input"],

Cell[BoxData[
    \(\(asave["\<errerr.alpha\>"];\)\)], "Input"],

Cell[BoxData[
    \(load["\<errerr.alpha\>"]; ashow[]\)], "Input"],

Cell[BoxData[
    \(analyze[]\)], "Input"],

Cell[BoxData[
    \(getContextDomain[{6, 1, 2, 1, 2, 1}, debug \[Rule] False, 
      checkCase \[Rule] True]\)], "Input"],

Cell[BoxData[
    \(getContextDomain[{6, 1, 2, 1, 2, 1}, debug \[Rule] False, 
      checkCase \[Rule] False]\)], "Input"],

Cell[BoxData[
    \(ashow[getContextDomain[{6, 1, 2}, debug \[Rule] True]]\)], "Input"],

Cell[BoxData[
    \(\(simplifyInContext[debug \[Rule] False];\)\)], "Input"],

Cell[BoxData[
    \(analyze[]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Test", "Section",
  FontColor->RGBColor[0, 0, 1]],

Cell[BoxData[
    \(tests["\<Semantics\>"]\)], "Input"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"5.2 for Macintosh",
ScreenRectangle->{{0, 1440}, {0, 838}},
AutoGeneratedPackage->None,
WindowToolbars->{"RulerBar", "EditBar"},
WindowSize->{1015, 664},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrintingCopies->1,
PrintingPageRange->{1, 9999},
PageHeaders->{{Cell[ 
        TextData[ {
          CounterBox[ "Page"]}], "PageNumber"], Inherited, Cell[ 
        TextData[ {
          ValueBox[ "FileName"]}], "Header"]}, {Cell[ 
        TextData[ {
          ValueBox[ "FileName"]}], "Header"], Inherited, Cell[ 
        TextData[ {
          CounterBox[ "Page"]}], "PageNumber"]}},
PrintingOptions->{"PaperSize"->{612, 792},
"PaperOrientation"->"Portrait",
"FirstPageHeader"->False,
"FirstPageFooter"->False,
"FacingPages"->True,
"Magnification"->1},
ShowSelection->True,
Magnification->1.5,
StyleDefinitions -> "Default.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 74, 1, 132, "Title"],
Cell[1853, 56, 38, 0, 45, "Subsubtitle"],
Cell[1894, 58, 25, 0, 47, "Text"],
Cell[1922, 60, 97, 3, 62, "SmallText"],

Cell[CellGroupData[{
Cell[2044, 67, 110, 1, 41, "Subsubsection"],
Cell[2157, 70, 116, 2, 42, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[2310, 77, 63, 1, 57, "Section"],
Cell[2376, 80, 218, 7, 47, "Text"],
Cell[2597, 89, 73, 1, 39, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[2707, 95, 61, 1, 57, "Section"],
Cell[2771, 98, 75, 0, 47, "Text"],
Cell[2849, 100, 56, 1, 39, "Input"],
Cell[2908, 103, 57, 1, 39, "Input"],
Cell[2968, 106, 65, 1, 39, "Input"],
Cell[3036, 109, 45, 1, 39, "Input"],
Cell[3084, 112, 75, 1, 39, "Input"],
Cell[3162, 115, 51, 0, 47, "Text"],
Cell[3216, 117, 45, 1, 39, "Input"],
Cell[3264, 120, 46, 1, 39, "Input"],
Cell[3313, 123, 62, 0, 47, "Text"],
Cell[3378, 125, 54, 1, 39, "Input"],
Cell[3435, 128, 46, 1, 39, "Input"],
Cell[3484, 131, 45, 1, 39, "Input"],
Cell[3532, 134, 30, 0, 47, "Text"],
Cell[3565, 136, 53, 1, 39, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[3655, 142, 63, 1, 57, "Section"],
Cell[3721, 145, 41, 0, 47, "Text"],
Cell[3765, 147, 65, 1, 39, "Input"],
Cell[3833, 150, 77, 0, 47, "Text"],
Cell[3913, 152, 68, 1, 39, "Input"],
Cell[3984, 155, 52, 0, 47, "Text"],
Cell[4039, 157, 187, 3, 108, "Input"],
Cell[4229, 162, 48, 0, 47, "Text"],
Cell[4280, 164, 85, 2, 62, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[4402, 171, 66, 1, 57, "Section"],

Cell[CellGroupData[{
Cell[4493, 176, 39, 0, 53, "Subsection"],
Cell[4535, 178, 89, 3, 47, "Text"],
Cell[4627, 183, 55, 1, 39, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[4719, 189, 37, 0, 39, "Subsection"],
Cell[4759, 191, 53, 1, 39, "Input"],
Cell[4815, 194, 61, 1, 39, "Input"],
Cell[4879, 197, 39, 1, 39, "Input"],
Cell[4921, 200, 71, 1, 39, "Input"],
Cell[4995, 203, 42, 1, 39, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[5074, 209, 39, 0, 39, "Subsection"],
Cell[5116, 211, 61, 1, 39, "Input"],
Cell[5180, 214, 42, 1, 39, "Input"],
Cell[5225, 217, 54, 1, 32, "Input"],
Cell[5282, 220, 42, 1, 39, "Input"],
Cell[5327, 223, 55, 1, 32, "Input"],
Cell[5385, 226, 59, 1, 39, "Input"],
Cell[5447, 229, 40, 1, 39, "Input"],
Cell[5490, 232, 42, 1, 39, "Input"],
Cell[5535, 235, 57, 1, 39, "Input"],
Cell[5595, 238, 42, 1, 39, "Input"],
Cell[5640, 241, 40, 1, 39, "Input"],
Cell[5683, 244, 69, 1, 39, "Input"],
Cell[5755, 247, 42, 1, 39, "Input"],
Cell[5800, 250, 63, 1, 39, "Input"],
Cell[5866, 253, 66, 1, 39, "Input"],
Cell[5935, 256, 42, 1, 32, "Input"],
Cell[5980, 259, 121, 2, 39, "Input"],
Cell[6104, 263, 122, 2, 39, "Input"],
Cell[6229, 267, 87, 1, 39, "Input"],
Cell[6319, 270, 76, 1, 39, "Input"],
Cell[6398, 273, 42, 1, 39, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[6489, 280, 55, 1, 57, "Section"],
Cell[6547, 283, 55, 1, 39, "Input"]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

