(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    350244,       9180]
NotebookOptionsPosition[    313197,       8113]
NotebookOutlinePosition[    316503,       8208]
CellTagsIndexPosition[    315741,       8187]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["The structured scheduler", "Title",
 FontColor->RGBColor[1, 0, 0],
 CellTags->"firstcell"],

Cell["\<\
Patrice Quinton, Tanguy Risset
September 2001\
\>", "Subsubtitle"],

Cell[CellGroupData[{

Cell["\<\
Last modification: July 3, 1998. 
Has to be checked...\
\>", "Subsubsection",
 CellChangeTimes->{{3.4809365374370747`*^9, 3.48093654898663*^9}},
 FontColor->RGBColor[0, 1, 0]],

Cell["Cr\[EAcute]dits", "SmallText",
 FontColor->RGBColor[0, 1, 0]],

Cell["\<\
      Zbigniew Chamski 
      Catherine Dezan 
      Florent Dupont de Dinechin 
      Patricia Le Mo\[EDoubleDot]nner 
      Herv\[EAcute] Le Verge 
      Christophe Mauras 
      Patrice Quinton 
      Fabien Quillere
      Sanjay Rajopadhye 
      Sophie Robert 
      Tanguy Risset 
      Doran Wilde \
\>", "SmallText"],

Cell["\<\
Irisa, Campus de Beaulieu, 35042, Rennes Cedex, France
quinton@irisa.fr\
\>", "SmallText"]
}, Closed]],

Cell[CellGroupData[{

Cell[" Execute this cell, to go in the right directory. ", "Subsubsection",
 FontColor->RGBColor[1, 0, 0]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"setMMADir", "[", 
  RowBox[{"{", 
   RowBox[{
   "\"\<doc\>\"", ",", "\"\<packages\>\"", ",", 
    "\"\<StructuredScheduler\>\""}], "}"}], "]"}]], "Input",
 InitializationCell->True],

Cell[BoxData["\<\"/Users/patricequinton/mmalpha/doc/Packages/\
StructuredScheduler\"\>"], "Output",
 CellChangeTimes->{3.4809363617491426`*^9, 3.481013686161837*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Introduction",
 FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell["\<\
This demo show the use of the structured schedule on a matrix multiplication \
algorithm described using dot products. \
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<matmults.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[BoxData["\<\"[dot][matmult]\"\>"], "Print",
 CellChangeTimes->{3.4809363620484543`*^9, 3.481013686364038*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input"],

Cell[BoxData["\<\"system matmult :{N | 2<=N}\\n               (a : {i,j | \
1<=i<=N; 1<=j<=N} of integer; \\n                b : {i,j | 1<=i<=N; 1<=j<=N} \
of integer)\\n       returns (c : {i,j | 1<=i<=N; 1<=j<=N} of integer);\\nvar\
\\n  A : {k,i,j | 0<=k<=N; 1<=i<=N; 1<=j<=N} of integer;\\n  B : {k,i,j | \
0<=k<=N; 1<=i<=N; 1<=j<=N} of integer;\\nlet\\n  A[k,i,j] = \\n      case\\n  \
      { | k=0} : a[i,j];\\n        { | 1<=k; 2<=j} : A[i,j-1,k];\\n        { \
| 1<=k; j=1} : a[i,k];\\n      esac;\\n  B[k,i,j] = \\n      case\\n        { \
| k=0} : b[i,j];\\n        { | 1<=k; 2<=i} : B[k,i-1,j];\\n        { | 1<=k; \
i=1} : b[j,k];\\n      esac;\\n  use {i,j | 1<=i<=N; 1<=j<=N} dot[N] (A, B) \
returns  (c) ;\\ntel;\"\>"], "Print",
 CellChangeTimes->{3.48093636289811*^9, 3.4810136876125507`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"analyze", "[", 
  RowBox[{"recurse", "\[Rule]", "True"}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Need to analyze : \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"dot\"\>", ",", "\<\"matmult\"\>"}], "}"}]}],
  SequenceForm["Need to analyze : ", {"dot", "matmult"}],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.481013689132648*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.481013689191895*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"dot\"\>"}],
  SequenceForm["Static Analysis of system ", "dot"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.48101368926077*^9}],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.481013689331971*^9}],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.481013689399385*^9}],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.481013689464147*^9}],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.481013689529172*^9}],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.4810136895983067`*^9}],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.48101368967614*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", 
   "\[InvisibleSpace]", "\<\"Acc\"\>"}],
  SequenceForm["----equation defining ", "Acc"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.4810136897313213`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", "\[InvisibleSpace]", "\<\"c\"\>"}],
  SequenceForm["----equation defining ", "c"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.4810136897983637`*^9}],

Cell[BoxData["\<\"--Checking regularity of output equations\"\>"], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.48101368986415*^9}],

Cell[BoxData["\<\"----Outputs equations are regular.\"\>"], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.4810136899483356`*^9}],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.481013690015329*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.4810136900825377`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"matmult\"\>"}],
  SequenceForm["Static Analysis of system ", "matmult"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.481013690147949*^9}],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.481013690239517*^9}],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.4810136902961407`*^9}],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.481013690415594*^9}],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.481013690490494*^9}],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.4810136905476913`*^9}],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.4810136906129093`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", "\[InvisibleSpace]", "\<\"A\"\>"}],
  SequenceForm["----equation defining ", "A"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.481013690680984*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", "\[InvisibleSpace]", "\<\"B\"\>"}],
  SequenceForm["----equation defining ", "B"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.481013690747645*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----use \"\>", "\[InvisibleSpace]", "\<\"dot\"\>", 
   "\[InvisibleSpace]", "\<\"...\"\>"}],
  SequenceForm["----use ", "dot", "..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.4810136908153877`*^9}],

Cell[BoxData["\<\"--Checking regularity of output equations\"\>"], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.48101369088107*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"getEquation", "::", "\<\"EquIsUse\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Warning, variable \\\\\\\"\\\
\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"c\\\"\\), \\\"MT\\\"]\
\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" defined as output of system \
\\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"dot\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.480936365917006*^9, 3.481013690956559*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"isOutputRegular", "::", "\<\"error2\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"could not find definition of \
\\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"c\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.480936365917006*^9, 3.481013691014743*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"areAllOutputsRegular", "::", "\<\"error2\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"error while calling \
isOutputRegular\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.480936365917006*^9, 3.4810136910812817`*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.481013691130959*^9}],

Cell[BoxData["\<\"\\nRecursive Analysis Successful.\"\>"], "Print",
 CellChangeTimes->{3.4809363640506983`*^9, 3.481013691182597*^9}]
}, Open  ]],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.480936366213024*^9, 3.481013691247961*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input",
 CellChangeTimes->{{3.481013705780034*^9, 3.481013711517745*^9}}],

Cell[BoxData["\<\"system matmult :{N | 2<=N}\\n               (a : {i,j | \
1<=i<=N; 1<=j<=N} of integer; \\n                b : {i,j | 1<=i<=N; 1<=j<=N} \
of integer)\\n       returns (c : {i,j | 1<=i<=N; 1<=j<=N} of integer);\\nvar\
\\n  A : {k,i,j | 0<=k<=N; 1<=i<=N; 1<=j<=N} of integer;\\n  B : {k,i,j | \
0<=k<=N; 1<=i<=N; 1<=j<=N} of integer;\\nlet\\n  A[k,i,j] = \\n      case\\n  \
      { | k=0} : a[i,j];\\n        { | 1<=k; 2<=j} : A[i,j-1,k];\\n        { \
| 1<=k; j=1} : a[i,k];\\n      esac;\\n  B[k,i,j] = \\n      case\\n        { \
| k=0} : b[i,j];\\n        { | 1<=k; 2<=i} : B[k,i-1,j];\\n        { | 1<=k; \
i=1} : b[j,k];\\n      esac;\\n  use {i,j | 1<=i<=N; 1<=j<=N} dot[N] (A, B) \
returns  (c) ;\\ntel;\"\>"], "Print",
 CellChangeTimes->{3.481013712006178*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["The developper's corner",
 FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell["\<\
Here are a few explanations. Schedules are stored in a variable called \
$scheduleLibrary. The format of a schedule is as follows:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"$scheduleLibrary", "=", 
  RowBox[{"{", "}"}]}], "\n", 
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<dot\>\"", "]"}], ";"}], "\n", 
 RowBox[{"scd", "[", 
  RowBox[{"addConstraints", "\[Rule]", 
   RowBox[{"{", 
    RowBox[{"\"\<TaD1==1\>\"", ",", "\"\<TbD1==1\>\""}], "}"}]}], "]"}], "\n", 
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<matmult\>\"", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.480936396975934*^9, 3.480936402315721*^9}}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{{3.4809363925840054`*^9, 3.4809364033140993`*^9}, 
   3.4810137578127117`*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"Method Minimize\"\>"], "Print",
 CellChangeTimes->{3.4809364034041653`*^9, 3.4810137579209642`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "33", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "13", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   "0.00391500000000633`"}],
  SequenceForm[33, " constraints, ", 13, " variables ", 0.00391500000000633],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364034041653`*^9, 3.481013757955076*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"dot\"\>", ",", "13", ",", "30", ",", "0.00391500000000633`", 
   ",", "\<\"Vertex\"\>", ",", "\<\"Flat\"\>"}], "}"}]], "Print",
 CellChangeTimes->{3.4809364034041653`*^9, 3.481013757994954*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"dot\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"a\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Acc\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"b\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"c\"\>", ",", 
       RowBox[{"{", "\<\"N\"\>", "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", "1", "}"}], ",", "2"}], "]"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{{3.4809363925840054`*^9, 3.4809364033140993`*^9}, 
   3.4810137580582323`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"structSched", "[", 
  RowBox[{"debug", "\[Rule]", "False"}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Checking options...\"\>"], "Print",
 CellChangeTimes->{3.480936406452114*^9, 3.48101376519473*^9}],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print",
 CellChangeTimes->{3.480936406452114*^9, 3.481013765268812*^9}],

Cell[BoxData["\<\"Building LP...\"\>"], "Print",
 CellChangeTimes->{3.480936406452114*^9, 3.4810137654249277`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "10", "\[InvisibleSpace]", "\<\" Recognized added Constraints: \"\>"}],
  SequenceForm[10, " Recognized added Constraints: "],
  Editable->False]], "Print",
 CellChangeTimes->{3.480936406452114*^9, 3.481013765473768*^9}],

Cell[BoxData["\<\"   -1 + TAD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.480936406452114*^9, 3.481013765554845*^9}],

Cell[BoxData["\<\"   -CA + CB = 0,\"\>"], "Print",
 CellChangeTimes->{3.480936406452114*^9, 3.481013765620783*^9}],

Cell[BoxData["\<\"   -1 + TBD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.480936406452114*^9, 3.481013765673307*^9}],

Cell[BoxData["\<\"   -TAD4 + TBD4 = 0,\"\>"], "Print",
 CellChangeTimes->{3.480936406452114*^9, 3.481013765740296*^9}],

Cell[BoxData["\<\"   -2 - CA + Cc = 0,\"\>"], "Print",
 CellChangeTimes->{3.480936406452114*^9, 3.4810137658077707`*^9}],

Cell[BoxData["\<\"   -1 - TAD4 + TcD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.480936406452114*^9, 3.481013765873692*^9}],

Cell[BoxData["\<\"   -TAD2 + TBD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.480936406452114*^9, 3.4810137659480667`*^9}],

Cell[BoxData["\<\"   -TAD3 + TBD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.480936406452114*^9, 3.481013766007468*^9}],

Cell[BoxData["\<\"   -TAD2 + TcD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.480936406452114*^9, 3.481013766073381*^9}],

Cell[BoxData["\<\"   -TAD3 + TcD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.480936406452114*^9, 3.4810137661407557`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "124", 
   "\[InvisibleSpace]", "\<\"\\n\\t\\t\\t   variables, \"\>", 
   "\[InvisibleSpace]", "132", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 124, "\n\t\t\t   variables, ", 132, " Constraints"],
  Editable->False]], "Print",
 CellChangeTimes->{3.480936406452114*^9, 3.481013766211265*^9}],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print",
 CellChangeTimes->{3.480936406452114*^9, 3.481013766273621*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Writing line \"\>", "\[InvisibleSpace]", "100"}],
  SequenceForm["Writing line ", 100],
  Editable->False]], "Print",
 CellChangeTimes->{3.480936406452114*^9, 3.4810137663410177`*^9}],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print",
 CellChangeTimes->{3.480936406452114*^9, 3.48101376640799*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Total execution Time: \"\>", "\[InvisibleSpace]", 
   RowBox[{"1", "+", 
    RowBox[{"3", " ", "\<\"N\"\>"}]}]}],
  SequenceForm["Total execution Time: ", 1 + 3 "N"],
  Editable->False]], "Print",
 CellChangeTimes->{3.480936406452114*^9, 3.481013766482541*^9}],

Cell[BoxData["\<\"T_a{i, j, N} = 0\\nT_b{i, j, N} = 0\\nT_c{i, j, N} = 1 + i \
+ j + N\\nT_A{k, i, j, N} = -1 + i + j + k\\nT_B{k, i, j, N} = -1 + i + j + k\
\"\>"], "Print",
 CellChangeTimes->{3.480936406452114*^9, 3.481013766542199*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"matmult\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"a\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"b\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"c\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", "1"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "1"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"B\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "1"}]}], "]"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.480936407852559*^9, 3.481013766609899*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"structSched", "[", 
  RowBox[{"debug", "\[Rule]", "True"}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\n********  USE \"\>", "\[InvisibleSpace]", "\<\"dot\"\>", 
   "\[InvisibleSpace]", "\<\"******\"\>"}],
  SequenceForm["\n********  USE ", "dot", "******"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137702033463`*^9}],

Cell[BoxData["\<\"----\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137702639093`*^9}],

Cell[BoxData["\<\"T_a{k, N} = k\\nT_b{k, N} = k\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137703334618`*^9}],

Cell[BoxData["\<\"use {i,j,N | 1<=i<=N; 1<=j<=N} dot.(i,j,N->N) (A, B) \
returns  (c) ;\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013770401198*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"structSchedType: \"\>", "\[InvisibleSpace]", "mono"}],
  SequenceForm["structSchedType: ", Alpha`Options`mono],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137704673157`*^9}],

Cell[BoxData["\<\"This is a Vertex type Schedule\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.48101377052934*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"First in var: \"\>", "\[InvisibleSpace]", "\<\"A\"\>"}],
  SequenceForm["First in var: ", "A"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013770580841*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"First in var called: \"\>", "\[InvisibleSpace]", "\<\"a\"\>"}],
  SequenceForm["First in var called: ", "a"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013770647182*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Schedule of the first in var: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"a\"\>", ",", 
     RowBox[{"{", 
      RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
     RowBox[{"sched", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}]}],
  SequenceForm["Schedule of the first in var: ", {"a", {"k", "N"}, 
    Alpha`sched[{1, 0}, 0]}],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013770714459*^9}],

Cell[BoxData["\<\"Callee Indices constraints: \"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013770809753*^9}],

Cell[BoxData["\<\"TAD1==1\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013770865144*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Constant constraint: \"\>", 
   "\[InvisibleSpace]", "\<\"CB-CA==0\"\>"}],
  SequenceForm["Constant constraint: ", "CB-CA==0"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013770930952*^9}],

Cell[BoxData["\<\"Callee Indices constraints: \"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.48101377099891*^9}],

Cell[BoxData["\<\"TBD1==1\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137710659018`*^9}],

Cell[BoxData["\<\"Extension constraints: \"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013771132187*^9}],

Cell[BoxData[
 RowBox[{"{", "\<\"TBD2-TAD2==0\"\>", "}"}]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013771199237*^9}],

Cell[BoxData["\<\"Extension constraints: \"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.48101377126606*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"TBD2-TAD2==0\"\>", ",", "\<\"TBD3-TAD3==0\"\>"}], 
  "}"}]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137713470507`*^9}],

Cell[BoxData["\<\"Parameter constraints: \"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013771399641*^9}],

Cell[BoxData["\<\"TBD4-TAD4==0\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.48101377146587*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Constant constraint: \"\>", 
   "\[InvisibleSpace]", "\<\"Cc-CA==2\"\>"}],
  SequenceForm["Constant constraint: ", "Cc-CA==2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137715351267`*^9}],

Cell[BoxData["\<\"Callee Indices constraints: \"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013771604896*^9}],

Cell[BoxData["\<\"Extension constraints: \"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013771665625*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"TBD2-TAD2==0\"\>", ",", "\<\"TBD3-TAD3==0\"\>", 
   ",", "\<\"TcD1-TAD2==0\"\>"}], "}"}]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013771732432*^9}],

Cell[BoxData["\<\"Extension constraints: \"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013771800397*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"TBD2-TAD2==0\"\>", ",", "\<\"TBD3-TAD3==0\"\>", 
   ",", "\<\"TcD1-TAD2==0\"\>", ",", "\<\"TcD2-TAD3==0\"\>"}], "}"}]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013771867386*^9}],

Cell[BoxData["\<\"Parameter constraints: \"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013771933367*^9}],

Cell[BoxData["\<\"TcD3-TAD4==1\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013772002226*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"current builded constraints:\\n\\t\\t\\t      \\n\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"TAD1==1\"\>", ",", "\<\"CB-CA==0\"\>", 
     ",", "\<\"TBD1==1\"\>", ",", "\<\"TBD4-TAD4==0\"\>", 
     ",", "\<\"Cc-CA==2\"\>", ",", "\<\"TcD3-TAD4==1\"\>", 
     ",", "\<\"TBD2-TAD2==0\"\>", ",", "\<\"TBD3-TAD3==0\"\>", 
     ",", "\<\"TcD1-TAD2==0\"\>", ",", "\<\"TcD2-TAD3==0\"\>"}], "}"}]}],
  SequenceForm[
  "current builded constraints:\n\t\t\t      \n", {
   "TAD1==1", "CB-CA==0", "TBD1==1", "TBD4-TAD4==0", "Cc-CA==2", 
    "TcD3-TAD4==1", "TBD2-TAD2==0", "TBD3-TAD3==0", "TcD1-TAD2==0", 
    "TcD2-TAD3==0"}],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013772068055*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"builded constraints: \\n\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"TAD1==1\"\>", ",", "\<\"CB-CA==0\"\>", 
     ",", "\<\"TBD1==1\"\>", ",", "\<\"TBD4-TAD4==0\"\>", 
     ",", "\<\"Cc-CA==2\"\>", ",", "\<\"TcD3-TAD4==1\"\>", 
     ",", "\<\"TBD2-TAD2==0\"\>", ",", "\<\"TBD3-TAD3==0\"\>", 
     ",", "\<\"TcD1-TAD2==0\"\>", ",", "\<\"TcD2-TAD3==0\"\>"}], "}"}]}],
  SequenceForm[
  "builded constraints: \n", {
   "TAD1==1", "CB-CA==0", "TBD1==1", "TBD4-TAD4==0", "Cc-CA==2", 
    "TcD3-TAD4==1", "TBD2-TAD2==0", "TBD3-TAD3==0", "TcD1-TAD2==0", 
    "TcD2-TAD3==0"}],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137721447563`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"built constraints:\\n\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"TAD1==1\"\>", ",", "\<\"CB-CA==0\"\>", 
     ",", "\<\"TBD1==1\"\>", ",", "\<\"TBD4-TAD4==0\"\>", 
     ",", "\<\"Cc-CA==2\"\>", ",", "\<\"TcD3-TAD4==1\"\>", 
     ",", "\<\"TBD2-TAD2==0\"\>", ",", "\<\"TBD3-TAD3==0\"\>", 
     ",", "\<\"TcD1-TAD2==0\"\>", ",", "\<\"TcD2-TAD3==0\"\>"}], "}"}]}],
  SequenceForm[
  "built constraints:\n", {
   "TAD1==1", "CB-CA==0", "TBD1==1", "TBD4-TAD4==0", "Cc-CA==2", 
    "TcD3-TAD4==1", "TBD2-TAD2==0", "TBD3-TAD3==0", "TcD1-TAD2==0", 
    "TcD2-TAD3==0"}],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013772200939*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"builded constraints:\\n\"\>", "\[InvisibleSpace]", 
   TagBox[
    StyleBox[
     RowBox[{"List", "[", 
      RowBox[{
      "\"\<TAD1==1\>\"", ",", "\"\<CB-CA==0\>\"", ",", "\"\<TBD1==1\>\"", 
       ",", "\"\<TBD4-TAD4==0\>\"", ",", "\"\<Cc-CA==2\>\"", ",", 
       "\"\<TcD3-TAD4==1\>\"", ",", "\"\<TBD2-TAD2==0\>\"", ",", 
       "\"\<TBD3-TAD3==0\>\"", ",", "\"\<TcD1-TAD2==0\>\"", ",", 
       "\"\<TcD2-TAD3==0\>\""}], "]"}],
     ShowSpecialCharacters->False,
     ShowStringCharacters->True,
     NumberMarks->True],
    FullForm]}],
  SequenceForm["builded constraints:\n", 
   FullForm[{
    "TAD1==1", "CB-CA==0", "TBD1==1", "TBD4-TAD4==0", "Cc-CA==2", 
     "TcD3-TAD4==1", "TBD2-TAD2==0", "TBD3-TAD3==0", "TcD1-TAD2==0", 
     "TcD2-TAD3==0"}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013772268868*^9}],

Cell[BoxData["\<\"Checking options...\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013772334284*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"optimization Type: \"\>", "\[InvisibleSpace]", "time"}],
  SequenceForm["optimization Type: ", Alpha`Options`time],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137724013453`*^9}],

Cell[BoxData["\<\"Number of Variables: \"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137724674997`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"a\"\>", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"b\"\>", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"c\"\>", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"A\"\>", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"B\"\>", ",", "5"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137725375433`*^9}],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013772601646*^9}],

Cell[BoxData["\<\"Dependencies (numbered in this order):\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013772676194*^9}],

Cell[BoxData["\<\"-- Regular dependencies:\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013772734947*^9}],

Cell[BoxData["\<\"{k,i,j,N | k=0; 1<=i<=N; 1<=j<=N; 2<=N} : A[k,i,j,N] -> \
a[k+i,j,N]\\n{k,i,j,N | 1<=k<=N; 1<=i<=N; 2<=j<=N} : A[k,i,j,N] -> \
A[i,j-1,k,N]\\n{k,i,j,N | 1<=k<=N; 1<=i<=N; j=1; 2<=N} : A[k,i,j,N] -> \
a[i,k,j+N-1]\\n{k,i,j,N | k=0; 1<=i<=N; 1<=j<=N; 2<=N} : B[k,i,j,N] -> \
b[k+i,j,N]\\n{k,i,j,N | 1<=k<=N; 2<=i<=N; 1<=j<=N} : B[k,i,j,N] -> \
B[k,i-1,j,N]\\n{k,i,j,N | 1<=k<=N; i=1; 1<=j<=N; 2<=N} : B[k,i,j,N] -> \
b[j,k,N]\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013772802621*^9}],

Cell[BoxData["\<\"-- Dependencies of use statements:\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013772886245*^9}],

Cell[BoxData["\<\"dot[(i,j,N->N)](A,B) <- (c)\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013772951087*^9}],

Cell[BoxData["\<\"Duration : 1 for each equation \"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.48101377301877*^9}],

Cell[BoxData["\<\"Building LP...\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013773085185*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "10", "\[InvisibleSpace]", "\<\" Recognized added Constraints: \"\>"}],
  SequenceForm[10, " Recognized added Constraints: "],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137731533327`*^9}],

Cell[BoxData["\<\"   -1 + TAD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013773225423*^9}],

Cell[BoxData["\<\"   -CA + CB = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137732861147`*^9}],

Cell[BoxData["\<\"   -1 + TBD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013773352397*^9}],

Cell[BoxData["\<\"   -TAD4 + TBD4 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137734226217`*^9}],

Cell[BoxData["\<\"   -2 - CA + Cc = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137734864063`*^9}],

Cell[BoxData["\<\"   -1 - TAD4 + TcD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013773553034*^9}],

Cell[BoxData["\<\"   -TAD2 + TBD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013773620583*^9}],

Cell[BoxData["\<\"   -TAD3 + TBD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013773687044*^9}],

Cell[BoxData["\<\"   -TAD2 + TcD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137737584753`*^9}],

Cell[BoxData["\<\"   -TAD3 + TcD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.48101377381986*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "124", 
   "\[InvisibleSpace]", "\<\"\\n\\t\\t\\t   variables, \"\>", 
   "\[InvisibleSpace]", "132", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 124, "\n\t\t\t   variables, ", 132, " Constraints"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137738874807`*^9}],

Cell[BoxData["\<\"   MuTAD4 - MuTAD5 + TAD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013773956532*^9}],

Cell[BoxData["\<\"   MuTAD3 - MuTAD7 + TAD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013774021261*^9}],

Cell[BoxData["\<\"   MuTAD2 - MuTAD6 + TAD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013774086741*^9}],

Cell[BoxData["\<\"   -MuTAD1 - MuTAD2 - MuTAD3 - MuTAD4 + TAD4 = 0,\"\>"], \
"Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013774153597*^9}],

Cell[BoxData["\<\"   CA + 2 MuTAD1 + MuTAD6 + MuTAD7 - MuTAD8 - MuTAD9 = 0,\"\
\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.48101377422122*^9}],

Cell[BoxData["\<\"   MuTBD4 - MuTBD5 + TBD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013774294957*^9}],

Cell[BoxData["\<\"   MuTBD3 - MuTBD7 + TBD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013774353722*^9}],

Cell[BoxData["\<\"   MuTBD2 - MuTBD6 + TBD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013774423695*^9}],

Cell[BoxData["\<\"   -MuTBD1 - MuTBD2 - MuTBD3 - MuTBD4 + TBD4 = 0,\"\>"], \
"Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013774490637*^9}],

Cell[BoxData["\<\"   CB + 2 MuTBD1 + MuTBD6 + MuTBD7 - MuTBD8 - MuTBD9 = 0,\"\
\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013774554323*^9}],

Cell[BoxData["\<\"   MuTcD1 - MuTcD5 + TcD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137746214733`*^9}],

Cell[BoxData["\<\"   MuTcD2 - MuTcD4 + TcD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013774690995*^9}],

Cell[BoxData["\<\"   -MuTcD1 - MuTcD2 - MuTcD3 + TcD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013774754052*^9}],

Cell[BoxData["\<\"   Cc + 2 MuTcD3 + MuTcD4 + MuTcD5 - MuTcD6 - MuTcD7 = 0,\"\
\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137748276873`*^9}],

Cell[BoxData["\<\"   MuTaD1 - MuTaD5 + TaD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013774888398*^9}],

Cell[BoxData["\<\"   MuTaD2 - MuTaD4 + TaD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013774954501*^9}],

Cell[BoxData["\<\"   -MuTaD1 - MuTaD2 - MuTaD3 + TaD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137750218554`*^9}],

Cell[BoxData["\<\"   Ca + 2 MuTaD3 + MuTaD4 + MuTaD5 - MuTaD6 - MuTaD7 = 0,\"\
\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013775088537*^9}],

Cell[BoxData["\<\"   MuTbD1 - MuTbD5 + TbD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137751546097`*^9}],

Cell[BoxData["\<\"   MuTbD2 - MuTbD4 + TbD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137752222767`*^9}],

Cell[BoxData["\<\"   -MuTbD1 - MuTbD2 - MuTbD3 + TbD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137752896967`*^9}],

Cell[BoxData["\<\"   Cb + 2 MuTbD3 + MuTbD4 + MuTbD5 - MuTbD6 - MuTbD7 = 0,\"\
\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013775366227*^9}],

Cell[BoxData["\<\"   RhoTcD1 - RhoTcD5 - TcD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013775422827*^9}],

Cell[BoxData["\<\"   RhoTcD2 - RhoTcD4 - TcD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013775489005*^9}],

Cell[BoxData["\<\"   Phi1 - RhoTcD1 - RhoTcD2 - RhoTcD3 - TcD3 = 0,\"\>"], \
"Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137755596647`*^9}],

Cell[BoxData["\<\"   -Cc + Phi0 + 2 RhoTcD3 + RhoTcD4 + RhoTcD5 - RhoTcD6 - \
RhoTcD7 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137756231403`*^9}],

Cell[BoxData["\<\"   -LamDepT411 + LamDepT412 - TaD1 + TAD1 = 0,\"\>"], \
"Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137756892157`*^9}],

Cell[BoxData["\<\"   LamDepT413 - LamDepT417 - TaD1 + TAD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013775756366*^9}],

Cell[BoxData["\<\"   LamDepT414 - LamDepT416 - TaD2 + TAD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013775823435*^9}],

Cell[BoxData["\<\"   -LamDepT413 - LamDepT414 - LamDepT415 - TaD3 + TAD4 = 0,\
\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013775897084*^9}],

Cell[BoxData["\<\"   -1 - Ca + CA + 2 LamDepT415 + LamDepT416 + LamDepT417 - \
LamDepT418 - LamDepT419 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013775956197*^9}],

Cell[BoxData["\<\"   LamDepT423 - LamDepT427 + TAD1 - TaD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013776025701*^9}],

Cell[BoxData["\<\"   LamDepT424 - LamDepT426 - TaD1 + TAD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013776091947*^9}],

Cell[BoxData["\<\"   -LamDepT421 + LamDepT422 - TaD3 + TAD3 = 0,\"\>"], \
"Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013776157441*^9}],

Cell[BoxData["\<\"   -LamDepT423 - LamDepT424 - LamDepT425 - TaD3 + TAD4 = 0,\
\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013776224412*^9}],

Cell[BoxData["\<\"   -1 - Ca + CA + LamDepT421 - LamDepT422 + 2 LamDepT425 + \
LamDepT426 + LamDepT427 - LamDepT428 - LamDepT429 + TaD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013776290572*^9}],

Cell[BoxData["\<\"   -LamDepT431 + LamDepT432 - TbD1 + TBD1 = 0,\"\>"], \
"Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013776377095*^9}],

Cell[BoxData["\<\"   LamDepT433 - LamDepT437 - TbD1 + TBD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013776445959*^9}],

Cell[BoxData["\<\"   LamDepT434 - LamDepT436 - TbD2 + TBD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013776508389*^9}],

Cell[BoxData["\<\"   -LamDepT433 - LamDepT434 - LamDepT435 - TbD3 + TBD4 = 0,\
\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013776577817*^9}],

Cell[BoxData["\<\"   -1 - Cb + CB + 2 LamDepT435 + LamDepT436 + LamDepT437 - \
LamDepT438 - LamDepT439 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013776641624*^9}],

Cell[BoxData["\<\"   LamDepT443 - LamDepT447 + TBD1 - TbD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137767137127`*^9}],

Cell[BoxData["\<\"   -LamDepT441 + LamDepT442 + TBD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013776774973*^9}],

Cell[BoxData["\<\"   LamDepT444 - LamDepT446 - TbD1 + TBD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137768416767`*^9}],

Cell[BoxData["\<\"   -LamDepT443 - LamDepT444 - LamDepT445 - TbD3 + TBD4 = 0,\
\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013776910735*^9}],

Cell[BoxData["\<\"   -1 - Cb + CB + LamDepT441 - LamDepT442 + 2 LamDepT445 + \
LamDepT446 + LamDepT447 - LamDepT448 - LamDepT449 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013776982834*^9}],

Cell[BoxData["\<\"   LamDepT553 - LamDepT555 + TAD1 - TAD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013777042577*^9}],

Cell[BoxData["\<\"   LamDepT554 - LamDepT556 - TAD1 + TAD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013777108337*^9}],

Cell[BoxData["\<\"   LamDepT551 - LamDepT552 - TAD2 + TAD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013777175736*^9}],

Cell[BoxData["\<\"   -LamDepT551 - LamDepT553 - LamDepT554 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013777243058*^9}],

Cell[BoxData["\<\"   -1 + 2 LamDepT552 + LamDepT555 + LamDepT556 - LamDepT557 \
- LamDepT558 + TAD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013777311345*^9}],

Cell[BoxData["\<\"   LamDepT563 - LamDepT566 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013777376627*^9}],

Cell[BoxData["\<\"   -LamDepT561 + LamDepT562 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013777445012*^9}],

Cell[BoxData["\<\"   LamDepT564 - LamDepT565 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137775172157`*^9}],

Cell[BoxData["\<\"   -LamDepT562 - LamDepT563 - LamDepT564 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013777580118*^9}],

Cell[BoxData["\<\"   -1 + 2 LamDepT561 + LamDepT565 + LamDepT566 - LamDepT567 \
- LamDepT568 + TBD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013777643414*^9}],

Cell[BoxData["\<\"   -1 + TAD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013777710701*^9}],

Cell[BoxData["\<\"   -CA + CB = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137777791862`*^9}],

Cell[BoxData["\<\"   -1 + TBD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013777843009*^9}],

Cell[BoxData["\<\"   -TAD4 + TBD4 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137779099197`*^9}],

Cell[BoxData["\<\"   -2 - CA + Cc = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013777977055*^9}],

Cell[BoxData["\<\"   -1 - TAD4 + TcD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137780516243`*^9}],

Cell[BoxData["\<\"   -TAD2 + TBD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137781110363`*^9}],

Cell[BoxData["\<\"   -TAD3 + TBD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137781782007`*^9}],

Cell[BoxData["\<\"   -TAD2 + TcD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013778244046*^9}],

Cell[BoxData["\<\"   -TAD3 + TcD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013778313813*^9}],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137783779716`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"temporary file: \"\>", 
   "\[InvisibleSpace]", "\<\"/tmp/m004993123811\"\>"}],
  SequenceForm["temporary file: ", "/tmp/m004993123811"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013778447084*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Opening: \"\>", 
   "\[InvisibleSpace]", "\<\"/tmp/m004993123811.pip\"\>"}],
  SequenceForm["Opening: ", "/tmp/m004993123811.pip"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013778511838*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Opening \"\>", 
   "\[InvisibleSpace]", "\<\"/tmp/m004994123811\"\>"}],
  SequenceForm["Opening ", "/tmp/m004994123811"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137785842257`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Writing line \"\>", "\[InvisibleSpace]", "100"}],
  SequenceForm["Writing line ", 100],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013778647736*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Running sed process on \"\>", 
   "\[InvisibleSpace]", "\<\"/tmp/m004994123811\"\>", 
   "\[InvisibleSpace]", "\<\" to \"\>", 
   "\[InvisibleSpace]", "\<\"/tmp/m004995123811\"\>"}],
  SequenceForm[
  "Running sed process on ", "/tmp/m004994123811", " to ", 
   "/tmp/m004995123811"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137787120523`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Appending \"\>", 
   "\[InvisibleSpace]", "\<\"/tmp/m004995123811\"\>", 
   "\[InvisibleSpace]", "\<\" the end of \"\>", 
   "\[InvisibleSpace]", "\<\"/tmp/m004993123811.pip\"\>"}],
  SequenceForm[
  "Appending ", "/tmp/m004995123811", " the end of ", 
   "/tmp/m004993123811.pip"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137787819853`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"/tmp/m004994123811\"\>", 
   "\[InvisibleSpace]", "\<\"/tmp/m004995123811\"\>", 
   "\[InvisibleSpace]", "\<\" generated\"\>"}],
  SequenceForm["/tmp/m004994123811", "/tmp/m004995123811", " generated"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013778846683*^9}],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137789136477`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Shift coef: \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["Shift coef: ", 1],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.4810137789787893`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Total execution Time: \"\>", "\[InvisibleSpace]", 
   RowBox[{"1", "+", 
    RowBox[{"3", " ", "\<\"N\"\>"}]}]}],
  SequenceForm["Total execution Time: ", 1 + 3 "N"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013779048561*^9}],

Cell[BoxData["\<\"T_a{i, j, N} = 0\\nT_b{i, j, N} = 0\\nT_c{i, j, N} = 1 + i \
+ j + N\\nT_A{k, i, j, N} = -1 + i + j + k\\nT_B{k, i, j, N} = -1 + i + j + k\
\"\>"], "Print",
 CellChangeTimes->{3.4809364107599783`*^9, 3.481013779119039*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"matmult\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"a\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"b\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"c\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", "1"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "1"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"B\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "1"}]}], "]"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.480936419671829*^9, 3.481013779184885*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullForm", "[", "$schedule", "]"}]], "Input"],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"scheduleResult", "[", 
    RowBox[{"\"\<matmult\>\"", ",", 
     RowBox[{"List", "[", 
      RowBox[{
       RowBox[{"List", "[", 
        RowBox[{"\"\<a\>\"", ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<i\>\"", ",", "\"\<j\>\"", ",", "\"\<N\>\""}], "]"}], 
         ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"List", "[", 
            RowBox[{"0", ",", "0", ",", "0"}], "]"}], ",", "0"}], "]"}]}], 
        "]"}], ",", 
       RowBox[{"List", "[", 
        RowBox[{"\"\<b\>\"", ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<i\>\"", ",", "\"\<j\>\"", ",", "\"\<N\>\""}], "]"}], 
         ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"List", "[", 
            RowBox[{"0", ",", "0", ",", "0"}], "]"}], ",", "0"}], "]"}]}], 
        "]"}], ",", 
       RowBox[{"List", "[", 
        RowBox[{"\"\<c\>\"", ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<i\>\"", ",", "\"\<j\>\"", ",", "\"\<N\>\""}], "]"}], 
         ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"List", "[", 
            RowBox[{"1", ",", "1", ",", "1"}], "]"}], ",", "1"}], "]"}]}], 
        "]"}], ",", 
       RowBox[{"List", "[", 
        RowBox[{"\"\<A\>\"", ",", 
         RowBox[{"List", "[", 
          RowBox[{
          "\"\<k\>\"", ",", "\"\<i\>\"", ",", "\"\<j\>\"", ",", "\"\<N\>\""}],
           "]"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"List", "[", 
            RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "]"}], ",", 
           RowBox[{"-", "1"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"List", "[", 
        RowBox[{"\"\<B\>\"", ",", 
         RowBox[{"List", "[", 
          RowBox[{
          "\"\<k\>\"", ",", "\"\<i\>\"", ",", "\"\<j\>\"", ",", "\"\<N\>\""}],
           "]"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"List", "[", 
            RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "]"}], ",", 
           RowBox[{"-", "1"}]}], "]"}]}], "]"}]}], "]"}], ",", 
     RowBox[{"List", "[", 
      RowBox[{"3", ",", "1"}], "]"}]}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 CellChangeTimes->{3.4809364214833517`*^9, 3.4810137810533247`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<dot\>\"", "]"}], ";"}], "\n", 
 RowBox[{"schedule", "[", "]"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Checking options...\"\>"], "Print",
 CellChangeTimes->{3.480936423296274*^9, 3.48101378439151*^9}],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print",
 CellChangeTimes->{3.480936423296274*^9, 3.481013784449851*^9}],

Cell[BoxData["\<\"Building LP...\"\>"], "Print",
 CellChangeTimes->{3.480936423296274*^9, 3.4810137845173817`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "49", 
   "\[InvisibleSpace]", "\<\"\\n\\t\\t\\t   variables, \"\>", 
   "\[InvisibleSpace]", "48", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 49, "\n\t\t\t   variables, ", 48, " Constraints"],
  Editable->False]], "Print",
 CellChangeTimes->{3.480936423296274*^9, 3.481013784573206*^9}],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print",
 CellChangeTimes->{3.480936423296274*^9, 3.481013784640347*^9}],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print",
 CellChangeTimes->{3.480936423296274*^9, 3.4810137847051563`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Total execution Time: \"\>", "\[InvisibleSpace]", 
   RowBox[{"1", "+", "\<\"N\"\>"}]}],
  SequenceForm["Total execution Time: ", 1 + "N"],
  Editable->False]], "Print",
 CellChangeTimes->{3.480936423296274*^9, 3.4810137847716417`*^9}],

Cell[BoxData["\<\"T_a{k, N} = 0\\nT_b{k, N} = 0\\nT_c{N} = 1 + N\\nT_Acc{k, \
N} = k\"\>"], "Print",
 CellChangeTimes->{3.480936423296274*^9, 3.481013784839006*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"dot\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"a\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"b\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"c\"\>", ",", 
       RowBox[{"{", "\<\"N\"\>", "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", "1", "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Acc\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}]}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.48093642380329*^9, 3.4810137849164267`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullForm", "[", "$schedule", "]"}]], "Input"],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"scheduleResult", "[", 
    RowBox[{"\"\<dot\>\"", ",", 
     RowBox[{"List", "[", 
      RowBox[{
       RowBox[{"List", "[", 
        RowBox[{"\"\<a\>\"", ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<k\>\"", ",", "\"\<N\>\""}], "]"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"List", "[", 
            RowBox[{"0", ",", "0"}], "]"}], ",", "0"}], "]"}]}], "]"}], ",", 
       RowBox[{"List", "[", 
        RowBox[{"\"\<b\>\"", ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<k\>\"", ",", "\"\<N\>\""}], "]"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"List", "[", 
            RowBox[{"0", ",", "0"}], "]"}], ",", "0"}], "]"}]}], "]"}], ",", 
       RowBox[{"List", "[", 
        RowBox[{"\"\<c\>\"", ",", 
         RowBox[{"List", "[", "\"\<N\>\"", "]"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"List", "[", "1", "]"}], ",", "1"}], "]"}]}], "]"}], ",", 
       RowBox[{"List", "[", 
        RowBox[{"\"\<Acc\>\"", ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<k\>\"", ",", "\"\<N\>\""}], "]"}], ",", 
         RowBox[{"sched", "[", 
          RowBox[{
           RowBox[{"List", "[", 
            RowBox[{"1", ",", "0"}], "]"}], ",", "0"}], "]"}]}], "]"}]}], 
      "]"}], ",", 
     RowBox[{"List", "[", 
      RowBox[{"1", ",", "1"}], "]"}]}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 CellChangeTimes->{3.480936425540524*^9, 3.48101378631037*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullForm", "[", "$scheduleLibrary", "]"}]], "Input"],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"List", "[", 
    RowBox[{
     RowBox[{"scheduleResult", "[", 
      RowBox[{"\"\<dot\>\"", ",", 
       RowBox[{"List", "[", "\"\<N\>\"", "]"}], ",", 
       RowBox[{"List", "[", 
        RowBox[{
         RowBox[{"List", "[", 
          RowBox[{"\"\<a\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{"\"\<k\>\"", ",", "\"\<N\>\""}], "]"}], ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"0", ",", "0"}], "]"}], ",", "0"}], "]"}]}], "]"}], ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<b\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{"\"\<k\>\"", ",", "\"\<N\>\""}], "]"}], ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"0", ",", "0"}], "]"}], ",", "0"}], "]"}]}], "]"}]}], 
        "]"}], ",", 
       RowBox[{"List", "[", 
        RowBox[{"List", "[", 
         RowBox[{"\"\<c\>\"", ",", 
          RowBox[{"List", "[", "\"\<N\>\"", "]"}], ",", 
          RowBox[{"sched", "[", 
           RowBox[{
            RowBox[{"List", "[", "1", "]"}], ",", "1"}], "]"}]}], "]"}], 
        "]"}]}], "]"}], ",", 
     RowBox[{"scheduleResult", "[", 
      RowBox[{"\"\<matmult\>\"", ",", 
       RowBox[{"List", "[", "\"\<N\>\"", "]"}], ",", 
       RowBox[{"List", "[", 
        RowBox[{
         RowBox[{"List", "[", 
          RowBox[{"\"\<a\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{"\"\<i\>\"", ",", "\"\<j\>\"", ",", "\"\<N\>\""}], "]"}], 
           ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"0", ",", "0", ",", "0"}], "]"}], ",", "0"}], "]"}]}], 
          "]"}], ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<b\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{"\"\<i\>\"", ",", "\"\<j\>\"", ",", "\"\<N\>\""}], "]"}], 
           ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"0", ",", "0", ",", "0"}], "]"}], ",", "0"}], "]"}]}], 
          "]"}]}], "]"}], ",", 
       RowBox[{"List", "[", 
        RowBox[{"List", "[", 
         RowBox[{"\"\<c\>\"", ",", 
          RowBox[{"List", "[", 
           RowBox[{"\"\<i\>\"", ",", "\"\<j\>\"", ",", "\"\<N\>\""}], "]"}], 
          ",", 
          RowBox[{"sched", "[", 
           RowBox[{
            RowBox[{"List", "[", 
             RowBox[{"1", ",", "1", ",", "1"}], "]"}], ",", "1"}], "]"}]}], 
         "]"}], "]"}]}], "]"}]}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 CellChangeTimes->{3.4809364268047028`*^9, 3.481013787645595*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "adaptUses"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"adaptUses[] modifies all use statements, by adding extra input \
\\nequations\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.4809364292981997`*^9},
 CellTags->"Info3480943629-7789177"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "saveScheduleLibrary"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"saveScheduleLibrary[sys] saves the content of global variable \
$scheduleLibrary \\nin the file sys.scdlib. saveScheduleLibrary[] saves the \
content of $scheduleLibrary in\\nthe file name.scdlib, where name is the name \
of the system currently contained\\nin $result. To save only the schedule of \
the system in $result, use \\nsaveScheduleLibrary[ onlyMainSystem -> True \
].\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.480936434618794*^9},
 CellTags->"Info3480943634-9637942"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "loadScheduleLibrary"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"loadScheduleLibrary[sys] loads in global variable \
$scheduleLibrary \\nthe content of the file sys.scdlib\"\>", "MSG"]], "Print",\
 "PrintUsage",
 CellChangeTimes->{3.480936436520617*^9},
 CellTags->"Info3480943636-4954515"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "slackOf"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"slackOf[listOfConstraints] gives the difference between the \
lhs and \\nthe rhs in the constraints, using the solution contained in \
$scheduleMDSol[1].\\nThis function allows somehow to explore a given \
schedule.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.4809364633279867`*^9},
 CellTags->"Info3480943663-5598681"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "constOf"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"constOf[symbol] gives the value of symbol\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.480936467752483*^9},
 CellTags->"Info3480943667-3693900"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "valueOf"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Information", "::", "\<\"notfound\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Symbol \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"valueOf\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" not \
found.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/notfound\\\", \
ButtonNote -> \\\"Information::notfound\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.480936469273354*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "depCycles"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"depCycles[] computes the elementary cycles in the dependence \
graph. \\ndepCycles[ selfDep->False ] computes the elementary cycles, \
\\nwithout the self dependences\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.480936471799367*^9},
 CellTags->"Info3480943671-1876946"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "depComponents"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"depComponents[] computes the strongly connected components of \
\\nthe dependence graph\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.4809364737130413`*^9},
 CellTags->"Info3480943673-5663851"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "depGraph"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"depGraph[] computes and displays the dependence graph of \
$result in\\nthe format of the Combinatorica package. This function assumes \
that\\nthe dependence graph has already been computed. See also \
Options[\\ndepGraph ]. Inputs are green, outputs are blue and selfvertices \
are\\nred.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.480936475069089*^9},
 CellTags->"Info3480943674-6337480"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "topoSort"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"topoSort[lib] returns the list of system names of library \
\\nlib, sorted in the reverse hierachical order, i.e. if a system A \\nuses a \
system B and a system C, topoSort returns {B, C, A} or {C, B, A}\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.480936476334112*^9},
 CellTags->"Info3480943676-5972647"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "sortEquations"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"sortEquations[sys:_system] returns a the same system where the \
equation \\nhave been reordered in such a way that all computation executed \
\\nsimultaneously (with duration 0) can be executed in the textual \
order,\\nit currently assumes that the time is one dimensionnal and the first \
indice.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.480936479889215*^9},
 CellTags->"Info3480943679-1570090"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "matrix2mma"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"matrix2mma[m] computes the mma form of the Alpha matrix \
m.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.480936481543545*^9},
 CellTags->"Info3480943681-3850717"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "getLinPart"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"getLinPart[m] computes the mma form of the linear part of the \
Alpha\\nmatrix m, considered as an affine function. Note: use \
getLinearPart\\ninstead.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.4809364832632093`*^9},
 CellTags->"Info3480943683-2152991"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "matrixTransPart"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"matrixTransPart[m] computes the mma form of the translation \
part of\\nthe Alpha matrix m, considered as an affine function.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.4809364844450827`*^9},
 CellTags->"Info3480943684-5679283"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "scheduleConstraints"}]], "Input"],

Cell[CellGroupData[{

Cell["Alpha`VertexSchedule`scheduleConstraints", "Print", "PrintUsage",
 CellChangeTimes->{3.48093648580158*^9},
 CellTags->"Info3480943685-7374309"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{
         "scheduleConstraints", "[", 
          "Alpha`VertexSchedule`Private`options___Rule", "]"}], ":=", 
         RowBox[{"scheduleConstraints", "[", 
          RowBox[{"$result", ",", 
           RowBox[{"{", "}"}], ",", "Alpha`VertexSchedule`Private`options"}], 
          "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"scheduleConstraints", "[", 
          RowBox[{
          "Alpha`VertexSchedule`Private`sys_system", ",", 
           "Alpha`VertexSchedule`Private`options___Rule"}], "]"}], ":=", 
         RowBox[{"scheduleConstraints", "[", 
          RowBox[{"Alpha`VertexSchedule`Private`sys", ",", 
           RowBox[{"{", "}"}], ",", "Alpha`VertexSchedule`Private`options"}], 
          "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"scheduleConstraints", "[", 
          RowBox[{
          "Alpha`VertexSchedule`Private`variable_String", ",", 
           "Alpha`VertexSchedule`Private`options___Rule"}], "]"}], ":=", 
         RowBox[{"scheduleConstraints", "[", 
          RowBox[{
          "$result", ",", "Alpha`VertexSchedule`Private`variable", ",", 
           "Alpha`VertexSchedule`Private`options"}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"scheduleConstraints", "[", 
          RowBox[{"Alpha`VertexSchedule`Private`sys_system", ",", 
           RowBox[{"Alpha`VertexSchedule`Private`variable", ":", 
            RowBox[{"_String", "|", 
             RowBox[{"{", "}"}]}]}], ",", 
           "Alpha`VertexSchedule`Private`options___Rule"}], "]"}], ":=", 
         RowBox[{"Catch", "[", 
          RowBox[{"Module", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "Alpha`VertexSchedule`Private`v", ",", 
              "Alpha`VertexSchedule`Private`lv", ",", 
              "Alpha`VertexSchedule`Private`iv", ",", 
              "Alpha`VertexSchedule`Private`ov", ",", 
              "Alpha`VertexSchedule`Private`declarat", ",", 
              "Alpha`VertexSchedule`Private`dims", ",", 
              "Alpha`VertexSchedule`Private`coeffstau", ",", 
              "Alpha`VertexSchedule`Private`coeffsalpha", ",", 
              "Alpha`VertexSchedule`Private`defs", ",", 
              "Alpha`VertexSchedule`Private`aux", ",", 
              "Alpha`VertexSchedule`Private`result", ",", 
              "Alpha`VertexSchedule`Private`result1", ",", 
              "Alpha`VertexSchedule`Private`pos", ",", 
              "Alpha`VertexSchedule`Private`oploc", ",", 
              "Alpha`VertexSchedule`Private`slp", ",", 
              "Alpha`VertexSchedule`Private`vrb", ",", 
              "Alpha`VertexSchedule`Private`extrac", ",", 
              "Alpha`VertexSchedule`Private`multidim", ",", 
              "Alpha`VertexSchedule`Private`bd", ",", 
              "Alpha`VertexSchedule`Private`vpc", ",", 
              "Alpha`VertexSchedule`Private`dponly", ",", 
              "Alpha`VertexSchedule`Private`dbg", ",", 
              "Alpha`VertexSchedule`Private`depcomp", ",", 
              "Alpha`VertexSchedule`Private`sbs", ",", 
              "Alpha`VertexSchedule`Private`useConstraints", ",", 
              "Alpha`VertexSchedule`Private`df", ",", 
              "Alpha`VertexSchedule`Private`onlyV", ",", 
              "Alpha`VertexSchedule`Private`onlyE", ",", 
              "Alpha`VertexSchedule`Private`onlyD", ",", 
              "Alpha`VertexSchedule`Private`reuseS", ",", 
              "Alpha`VertexSchedule`Private`dur", ",", 
              "Alpha`VertexSchedule`Private`durNZ", ",", 
              "Alpha`VertexSchedule`Private`onlyUseD"}], "}"}], ",", 
            RowBox[{
             RowBox[{"$dependencyConstraints", "=", 
              RowBox[{"{", "}"}]}], ";", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Alpha`VertexSchedule`Private`sys", "===", 
                RowBox[{"{", "}"}]}], ",", 
               RowBox[{"Throw", "[", 
                RowBox[{"Message", "[", 
                 RowBox[{"scheduleConstraints", "::", "\<\"emptyprog\"\>"}], 
                 "]"}], "]"}]}], "]"}], ";", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"!", 
                RowBox[{
                "normalizeQ", "[", "Alpha`VertexSchedule`Private`sys", 
                 "]"}]}], ",", 
               RowBox[{"Throw", "[", 
                RowBox[{"Message", "[", 
                 RowBox[{"scheduleConstraints", "::", "\<\"norm\"\>"}], "]"}],
                 "]"}]}], "]"}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`sbs", "=", 
              RowBox[{
               RowBox[{"subSystems", "/.", "\[InvisibleSpace]", 
                RowBox[{"{", "Alpha`VertexSchedule`Private`options", "}"}]}], 
               "/.", "\[InvisibleSpace]", 
               RowBox[{"Options", "[", "scheduleConstraints", "]"}]}]}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`vpc", "=", 
              RowBox[{
               RowBox[{"verticesPositive", "/.", "\[InvisibleSpace]", 
                RowBox[{"{", "Alpha`VertexSchedule`Private`options", "}"}]}], 
               "/.", "\[InvisibleSpace]", 
               RowBox[{"Options", "[", "scheduleConstraints", "]"}]}]}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`dponly", "=", 
              RowBox[{
               RowBox[{"dependenciesOnly", "/.", "\[InvisibleSpace]", 
                RowBox[{"{", "Alpha`VertexSchedule`Private`options", "}"}]}], 
               "/.", "\[InvisibleSpace]", 
               RowBox[{"Options", "[", "scheduleConstraints", "]"}]}]}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`slp", "=", 
              RowBox[{
               RowBox[{"scheduleType", "/.", "\[InvisibleSpace]", 
                RowBox[{"{", "Alpha`VertexSchedule`Private`options", "}"}]}], 
               "/.", "\[InvisibleSpace]", 
               RowBox[{"Options", "[", "scheduleConstraints", "]"}]}]}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`vrb", "=", 
              RowBox[{
               RowBox[{"verbose", "/.", "\[InvisibleSpace]", 
                RowBox[{"{", "Alpha`VertexSchedule`Private`options", "}"}]}], 
               "/.", "\[InvisibleSpace]", 
               RowBox[{"Options", "[", "scheduleConstraints", "]"}]}]}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`df", "=", 
              RowBox[{
               RowBox[{"dataFlow", "/.", "\[InvisibleSpace]", 
                RowBox[{"{", "Alpha`VertexSchedule`Private`options", "}"}]}], 
               "/.", "\[InvisibleSpace]", 
               RowBox[{"Options", "[", "scheduleConstraints", "]"}]}]}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`multidim", "=", 
              RowBox[{"If", "[", 
               RowBox[{"Alpha`VertexSchedule`Private`df", ",", "True", ",", 
                RowBox[{
                 RowBox[{"multidimensional", "/.", "\[InvisibleSpace]", 
                  RowBox[{
                  "{", "Alpha`VertexSchedule`Private`options", "}"}]}], "/.", 
                 "\[InvisibleSpace]", 
                 RowBox[{"Options", "[", "scheduleConstraints", "]"}]}]}], 
               "]"}]}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`dbg", "=", 
              RowBox[{
               RowBox[{"debug", "/.", "\[InvisibleSpace]", 
                RowBox[{"{", "Alpha`VertexSchedule`Private`options", "}"}]}], 
               "/.", "\[InvisibleSpace]", 
               RowBox[{"Options", "[", "scheduleConstraints", "]"}]}]}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`depcomp", "=", 
              RowBox[{
               RowBox[{"depComputed", "/.", "\[InvisibleSpace]", 
                RowBox[{"{", "Alpha`VertexSchedule`Private`options", "}"}]}], 
               "/.", "\[InvisibleSpace]", 
               RowBox[{"Options", "[", "scheduleConstraints", "]"}]}]}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`dur", "=", 
              RowBox[{
               RowBox[{"durations", "/.", "\[InvisibleSpace]", 
                RowBox[{"{", "Alpha`VertexSchedule`Private`options", "}"}]}], 
               "/.", "\[InvisibleSpace]", 
               RowBox[{"Options", "[", "scheduleConstraints", "]"}]}]}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`durNZ", "=", 
              RowBox[{
               RowBox[{"durationsNonZero", "/.", "\[InvisibleSpace]", 
                RowBox[{"{", "Alpha`VertexSchedule`Private`options", "}"}]}], 
               "/.", "\[InvisibleSpace]", 
               RowBox[{"Options", "[", "scheduleConstraints", "]"}]}]}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`onlyV", "=", 
              RowBox[{
               RowBox[{"onlyVars", "/.", "\[InvisibleSpace]", 
                RowBox[{"{", "Alpha`VertexSchedule`Private`options", "}"}]}], 
               "/.", "\[InvisibleSpace]", 
               RowBox[{"Options", "[", "scheduleConstraints", "]"}]}]}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`onlyE", "=", 
              RowBox[{
               RowBox[{"onlyEquations", "/.", "\[InvisibleSpace]", 
                RowBox[{"{", "Alpha`VertexSchedule`Private`options", "}"}]}], 
               "/.", "\[InvisibleSpace]", 
               RowBox[{"Options", "[", "scheduleConstraints", "]"}]}]}], ";", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Alpha`VertexSchedule`Private`onlyE", "=!=", "all"}], 
               ",", 
               RowBox[{
               "Print", 
                "[", "\<\"Warning: option onlyEquations in not \
implemented\"\>", "]"}]}], "]"}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`onlyD", "=", 
              RowBox[{
               RowBox[{"onlyDep", "/.", "\[InvisibleSpace]", 
                RowBox[{"{", "Alpha`VertexSchedule`Private`options", "}"}]}], 
               "/.", "\[InvisibleSpace]", 
               RowBox[{"Options", "[", "scheduleConstraints", "]"}]}]}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`onlyUseD", "=", 
              RowBox[{
               RowBox[{"onlyUseDep", "/.", "\[InvisibleSpace]", 
                RowBox[{"{", "Alpha`VertexSchedule`Private`options", "}"}]}], 
               "/.", "\[InvisibleSpace]", 
               RowBox[{"Options", "[", "scheduleConstraints", "]"}]}]}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`reuseS", "=", 
              RowBox[{
               RowBox[{"reuseSchedule", "/.", "\[InvisibleSpace]", 
                RowBox[{"{", "Alpha`VertexSchedule`Private`options", "}"}]}], 
               "/.", "\[InvisibleSpace]", 
               RowBox[{"Options", "[", "scheduleConstraints", "]"}]}]}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`lv", "=", 
              RowBox[{"getLocalVars", "[", "]"}]}], ";", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Alpha`VertexSchedule`Private`onlyV", "=!=", "all"}], 
               ",", 
               RowBox[{"Alpha`VertexSchedule`Private`lv", "=", 
                RowBox[{
                "Alpha`VertexSchedule`Private`lv", "\[Intersection]", 
                 "Alpha`VertexSchedule`Private`onlyV"}]}]}], "]"}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`iv", "=", 
              RowBox[{"getInputVars", "[", "]"}]}], ";", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Alpha`VertexSchedule`Private`onlyV", "=!=", "all"}], 
               ",", 
               RowBox[{"Alpha`VertexSchedule`Private`iv", "=", 
                RowBox[{
                "Alpha`VertexSchedule`Private`iv", "\[Intersection]", 
                 "Alpha`VertexSchedule`Private`onlyV"}]}]}], "]"}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`ov", "=", 
              RowBox[{"getOutputVars", "[", "]"}]}], ";", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Alpha`VertexSchedule`Private`onlyV", "=!=", "all"}], 
               ",", 
               RowBox[{"Alpha`VertexSchedule`Private`ov", "=", 
                RowBox[{
                "Alpha`VertexSchedule`Private`ov", "\[Intersection]", 
                 "Alpha`VertexSchedule`Private`onlyV"}]}]}], "]"}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`v", "=", 
              RowBox[{
              "Alpha`VertexSchedule`Private`lv", "\[Union]", 
               "Alpha`VertexSchedule`Private`iv", "\[Union]", 
               "Alpha`VertexSchedule`Private`ov"}]}], ";", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Alpha`VertexSchedule`Private`variable", "=!=", 
                RowBox[{"{", "}"}]}], ",", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"!", 
                  RowBox[{"MemberQ", "[", 
                   RowBox[{
                   "Alpha`VertexSchedule`Private`v", ",", 
                    "Alpha`VertexSchedule`Private`variable"}], "]"}]}], ",", 
                 RowBox[{"Throw", "[", 
                  RowBox[{"Message", "[", 
                   RowBox[{
                    RowBox[{"scheduleConstraints", "::", "\<\"wrgvar\"\>"}], 
                    ",", "Alpha`VertexSchedule`Private`variable"}], "]"}], 
                  "]"}]}], "]"}]}], "]"}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`dv", "=", 
              RowBox[{
              "Alpha`VertexSchedule`Private`lv", "\[Union]", 
               "Alpha`VertexSchedule`Private`ov"}]}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`declarat", "=", 
              RowBox[{
              "getDeclaration", "/@", "Alpha`VertexSchedule`Private`v"}]}], 
             ";", 
             RowBox[{"Alpha`VertexSchedule`Private`domains", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                 "#1", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}],
                  "&"}], ")"}], "/@", 
               "Alpha`VertexSchedule`Private`declarat"}]}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`dims", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"First", "[", "#1", "]"}], "&"}], ")"}], "/@", 
               "Alpha`VertexSchedule`Private`domains"}]}], ";", 
             RowBox[{"BeginPackage", "[", "\<\"Alpha`Work`\"\>", "]"}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`coeffstau", "=", 
              RowBox[{"MapThread", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"ToExpression", "[", 
                    RowBox[{"\<\"T\"\>", "<>", "#2", "<>", "\<\"D\"\>", "<>", 
                    RowBox[{
                    "ToString", "[", "Alpha`VertexSchedule`Private`i", 
                    "]"}]}], "]"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    "Alpha`VertexSchedule`Private`i", ",", "1", ",", "#1"}], 
                    "}"}]}], "]"}], "&"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "Alpha`VertexSchedule`Private`dims", ",", 
                  "Alpha`VertexSchedule`Private`v"}], "}"}]}], "]"}]}], ";", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
               "Alpha`VertexSchedule`Private`slp", "===", "sameLinearPart"}], 
               ",", 
               RowBox[{"Alpha`VertexSchedule`Private`coeffstau", "=", 
                RowBox[{"MapThread", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{"Alpha`VertexSchedule`Private`lv", ",", "#2"}], 
                    "]"}], ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"ToExpression", "[", 
                    RowBox[{"\<\"TD\"\>", "<>", 
                    RowBox[{
                    "ToString", "[", "Alpha`VertexSchedule`Private`i", 
                    "]"}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    "Alpha`VertexSchedule`Private`i", ",", "1", ",", "#3"}], 
                    "}"}]}], "]"}], ",", "#1"}], "]"}], "&"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                   "Alpha`VertexSchedule`Private`coeffstau", ",", 
                    "Alpha`VertexSchedule`Private`v", ",", 
                    "Alpha`VertexSchedule`Private`dims"}], "}"}]}], "]"}]}]}],
               "]"}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`coeffsalpha", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"ToExpression", "[", 
                  RowBox[{"\<\"A\"\>", "<>", "#1"}], "]"}], "&"}], ")"}], "/@",
                "Alpha`VertexSchedule`Private`v"}]}], ";", 
             RowBox[{"EndPackage", "[", "]"}], ";", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"!", "Alpha`VertexSchedule`Private`depcomp"}], ",", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{"Alpha`VertexSchedule`Private`dbg", ",", 
                  RowBox[{
                  "Print", "[", "\<\"Computing dependency Table\"\>", "]"}]}],
                  "]"}], ";", 
                RowBox[{"$scheduleDepTable", "=", 
                 RowBox[{"Check", "[", 
                  RowBox[{
                   RowBox[{"dep", "[", 
                    RowBox[{
                    "Alpha`VertexSchedule`Private`sys", ",", 
                    "Alpha`VertexSchedule`Private`options", ",", 
                    RowBox[{"parameterConstraints", "\[Rule]", "True"}], ",", 
                    RowBox[{"subSystems", "\[Rule]", "True"}]}], "]"}], ",", 
                   RowBox[{"Throw", "[", 
                    RowBox[{"Message", "[", 
                    RowBox[{"scheduleConstraints", "::", "\<\"dep\"\>"}], 
                    "]"}], "]"}]}], "]"}]}]}], ",", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"!", 
                   RowBox[{"MatchQ", "[", 
                    RowBox[{"$scheduleDepTable", ",", 
                    RowBox[{
                    RowBox[{"dtable", "[", 
                    RowBox[{
                    RowBox[{"{", "___depend", "}"}], ",", 
                    RowBox[{"{", "___dependuse", "}"}]}], "]"}], "|", 
                    RowBox[{"dtable", "[", 
                    RowBox[{"{", "___depend", "}"}], "]"}]}]}], "]"}]}], ",", 
                  RowBox[{"Throw", "[", 
                   RowBox[{"Message", "[", 
                    RowBox[{
                    "scheduleConstraints", "::", "\<\"nodeptable\"\>"}], 
                    "]"}], "]"}]}], "]"}], ";"}]}], "]"}], ";", 
             RowBox[{"If", "[", 
              RowBox[{"Alpha`VertexSchedule`Private`dbg", ",", 
               RowBox[{"show", "[", "$scheduleDepTable", "]"}]}], "]"}], ";", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Alpha`VertexSchedule`Private`onlyD", "=!=", "all"}], 
               ",", 
               RowBox[{"With", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Alpha`VertexSchedule`Private`dept", "=", 
                    RowBox[{
                    "$scheduleDepTable", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}]}], ",", 
                   RowBox[{"Alpha`VertexSchedule`Private`usedept", "=", 
                    RowBox[{
                    "$scheduleDepTable", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}]}]}], "}"}], ",", 
                 RowBox[{"$scheduleDepTable", "=", 
                  RowBox[{"dtable", "[", 
                   RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{
                    "Alpha`VertexSchedule`Private`dept", 
                    "\[LeftDoubleBracket]", 
                    RowBox[{
                    "Alpha`VertexSchedule`Private`onlyD", 
                    "\[LeftDoubleBracket]", "Alpha`VertexSchedule`Private`i", 
                    "\[RightDoubleBracket]"}], "\[RightDoubleBracket]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Alpha`VertexSchedule`Private`i", ",", "1", ",", 
                    RowBox[{
                    "Length", "[", "Alpha`VertexSchedule`Private`onlyD", 
                    "]"}]}], "}"}]}], "]"}], ",", 
                    "Alpha`VertexSchedule`Private`usedept"}], "]"}]}]}], 
                "]"}]}], "]"}], ";", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
               "Alpha`VertexSchedule`Private`onlyUseD", "=!=", "all"}], ",", 
               RowBox[{"With", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Alpha`VertexSchedule`Private`dept", "=", 
                    RowBox[{
                    "$scheduleDepTable", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}]}], ",", 
                   RowBox[{"Alpha`VertexSchedule`Private`usedept", "=", 
                    RowBox[{
                    "$scheduleDepTable", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}]}]}], "}"}], ",", 
                 RowBox[{"$scheduleDepTable", "=", 
                  RowBox[{"dtable", "[", 
                   RowBox[{"Alpha`VertexSchedule`Private`dept", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{
                    "Alpha`VertexSchedule`Private`usedept", 
                    "\[LeftDoubleBracket]", 
                    RowBox[{
                    "Alpha`VertexSchedule`Private`onlyUseD", 
                    "\[LeftDoubleBracket]", "Alpha`VertexSchedule`Private`i", 
                    "\[RightDoubleBracket]"}], "\[RightDoubleBracket]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Alpha`VertexSchedule`Private`i", ",", "1", ",", 
                    RowBox[{
                    "Length", "[", "Alpha`VertexSchedule`Private`onlyUseD", 
                    "]"}]}], "}"}]}], "]"}]}], "]"}]}]}], "]"}]}], "]"}], ";", 
             RowBox[{"If", "[", 
              RowBox[{"Alpha`VertexSchedule`Private`dbg", ",", 
               RowBox[{"show", "[", "$scheduleDepTable", "]"}]}], "]"}], ";", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
               "Alpha`VertexSchedule`Private`vrb", "||", 
                "Alpha`VertexSchedule`Private`dbg"}], ",", 
               RowBox[{
                RowBox[{"Print", "[", "\<\"Dependencies kept are:\"\>", "]"}],
                 ";", 
                RowBox[{"show", "[", "$scheduleDepTable", "]"}], ";", 
                RowBox[{
                "Print", "[", "\<\"----------------------------\"\>", "]"}], 
                ";"}]}], "]"}], ";", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Alpha`VertexSchedule`Private`onlyV", "=!=", "all"}], 
               ",", 
               RowBox[{"$scheduleDepTable", "=", 
                RowBox[{"dtable", "[", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Alpha`VertexSchedule`Private`dept", "=", 
                    RowBox[{
                    "$scheduleDepTable", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}]}], "}"}], ",", 
                    RowBox[{"Select", "[", 
                    RowBox[{"Alpha`VertexSchedule`Private`dept", ",", 
                    RowBox[{"Function", "[", 
                    RowBox[{
                    RowBox[{"{", "Alpha`VertexSchedule`Private`x", "}"}], ",", 
                    RowBox[{"Module", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "Alpha`VertexSchedule`Private`v1", ",", 
                    "Alpha`VertexSchedule`Private`v2"}], "}"}], ",", 
                    RowBox[{
                    RowBox[{"Alpha`VertexSchedule`Private`v1", "=", 
                    RowBox[{
                    "Alpha`VertexSchedule`Private`x", "\[LeftDoubleBracket]", 
                    "2", "\[RightDoubleBracket]"}]}], ";", 
                    RowBox[{"Alpha`VertexSchedule`Private`v2", "=", 
                    RowBox[{
                    "Alpha`VertexSchedule`Private`x", "\[LeftDoubleBracket]", 
                    "3", "\[RightDoubleBracket]"}]}], ";", 
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    "Alpha`VertexSchedule`Private`v", ",", 
                    "Alpha`VertexSchedule`Private`v1"}], "]"}], "&&", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    "Alpha`VertexSchedule`Private`v", ",", 
                    "Alpha`VertexSchedule`Private`v2"}], "]"}]}]}]}], "]"}]}],
                     "]"}]}], "]"}]}], "]"}], ",", 
                  RowBox[{
                  "$scheduleDepTable", "\[LeftDoubleBracket]", "2", 
                   "\[RightDoubleBracket]"}]}], "]"}]}]}], "]"}], ";", 
             RowBox[{"If", "[", 
              RowBox[{"Alpha`VertexSchedule`Private`dbg", ",", 
               RowBox[{"Print", "[", 
                RowBox[{"\<\"Dependency Table:\\n\"\>", ",", 
                 RowBox[{"show", "[", 
                  RowBox[{"$scheduleDepTable", ",", 
                   RowBox[{"silent", "\[Rule]", "True"}]}], "]"}]}], "]"}]}], 
              "]"}], ";", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"$scheduleDepTable", "\[Equal]", 
                RowBox[{"dtable", "[", 
                 RowBox[{"{", "}"}], "]"}]}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{
                 "scheduleConstraints", "::", "\<\"emptydeptable\"\>"}], 
                 "=", "\<\"dependence table is empty\"\>"}], ";", 
                RowBox[{"Throw", "[", 
                 RowBox[{"Message", "[", 
                  RowBox[{
                  "scheduleConstraints", "::", "\<\"emptydeptable\"\>"}], 
                  "]"}], "]"}]}]}], "]"}], ";", 
             RowBox[{"If", "[", 
              RowBox[{"Alpha`VertexSchedule`Private`dbg", ",", 
               RowBox[{
               "Print", "[", "\<\"Computing dependence constraints\"\>", 
                "]"}]}], "]"}], ";", 
             RowBox[{"Module", "[", 
              RowBox[{
               RowBox[{"{", "Alpha`VertexSchedule`Private`locVar", "}"}], ",", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"Alpha`VertexSchedule`Private`durNZ", "=!=", 
                   RowBox[{"{", "}"}]}], ",", 
                  RowBox[{
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Alpha`VertexSchedule`Private`dur", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{
                    "Print", 
                    "[", "\<\"Warning, option durations supercedes \
durationsNonZero\"\>", "]"}]}], "]"}], ";", 
                   RowBox[{"Alpha`VertexSchedule`Private`dur", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"{", 
                    RowBox[{"Alpha`VertexSchedule`Private`i", ",", "1", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{
                    "$scheduleDepTable", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], "]"}]}], "}"}]}], "]"}]}], ";", 
                   RowBox[{"Alpha`VertexSchedule`Private`locVar", "=", 
                    RowBox[{"Select", "[", 
                    RowBox[{"Alpha`VertexSchedule`Private`durNZ", ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"Length", "[", 
                    RowBox[{
                    "$scheduleDepTable", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], "]"}]}], "\[LessEqual]", "#1", 
                    "\[LessEqual]", 
                    RowBox[{"Length", "[", 
                    RowBox[{
                    "$scheduleDepTable", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], "]"}]}], "&"}]}], "]"}]}], ";", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    "Alpha`VertexSchedule`Private`locVar", "=!=", 
                    "Alpha`VertexSchedule`Private`dur"}], ",", 
                    RowBox[{"Print", "[", 
                    
                    RowBox[{"\<\"Warning: Positions in durationsNonZero \
option \"\>", ",", "\<\"should be in the range of the dependence table.\"\>", 
                    ",", "\<\"  Wrong positions ignored.\"\>"}], "]"}]}], 
                    "]"}], ";", 
                   RowBox[{"Check", "[", 
                    RowBox[{
                    RowBox[{"Alpha`VertexSchedule`Private`dur", "=", 
                    RowBox[{"Fold", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"ReplacePart", "[", 
                    RowBox[{"#1", ",", 
                    RowBox[{"#2", "\[Rule]", "1"}]}], "]"}], "&"}], ",", 
                    "Alpha`VertexSchedule`Private`dur", ",", 
                    "Alpha`VertexSchedule`Private`durNZ"}], "]"}]}], ",", 
                    RowBox[{
                    RowBox[{
                    "Print", 
                    "[", "\<\"Warning, option durationsNonZero is incorrect, \
and ignored\"\>", "]"}], ";", 
                    RowBox[{"Alpha`VertexSchedule`Private`dur", "=", 
                    RowBox[{"{", "}"}]}]}]}], "]"}], ";"}]}], "]"}], ";"}]}], 
              "]"}], ";", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Alpha`VertexSchedule`Private`dur", "===", 
                RowBox[{"{", "}"}]}], ",", 
               RowBox[{"Alpha`VertexSchedule`Private`dur", "=", 
                RowBox[{"Table", "[", 
                 RowBox[{"1", ",", 
                  RowBox[{"{", 
                   RowBox[{"Alpha`VertexSchedule`Private`i", ",", "1", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{
                    "$scheduleDepTable", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], "]"}]}], "}"}]}], "]"}]}]}], 
              "]"}], ";", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Alpha`VertexSchedule`Private`onlyD", "===", "all"}], 
               ",", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                   "Length", "[", "Alpha`VertexSchedule`Private`dur", "]"}], "=!=", 
                   RowBox[{"Length", "[", 
                    RowBox[{
                    "$scheduleDepTable", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], "]"}]}], ",", 
                  RowBox[{"Throw", "[", 
                   RowBox[{"Message", "[", 
                    RowBox[{
                    "scheduleConstraints", "::", "\<\"wrgduration\"\>"}], 
                    "]"}], "]"}]}], "]"}], ";"}], ",", 
               RowBox[{"Alpha`VertexSchedule`Private`dur", "=", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                   "Alpha`VertexSchedule`Private`dur", "\[LeftDoubleBracket]",
                     "#1", "\[RightDoubleBracket]"}], "&"}], ")"}], "/@", 
                 "Alpha`VertexSchedule`Private`onlyD"}]}]}], "]"}], ";", 
             RowBox[{"If", "[", 
              RowBox[{"Alpha`VertexSchedule`Private`dbg", ",", 
               RowBox[{"Print", "[", 
                
                RowBox[{"\<\"Durations: \"\>", ",", 
                 "Alpha`VertexSchedule`Private`dur"}], "]"}]}], "]"}], ";", 
             RowBox[{"Module", "[", 
              RowBox[{
               RowBox[{
               "{", "Alpha`VertexSchedule`Private`listvariables", "}"}], ",", 
               RowBox[{
                RowBox[{"Alpha`VertexSchedule`Private`listvariables", "=", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"Alpha`VertexSchedule`Private`variable", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                   RowBox[{
                   "{", "Alpha`VertexSchedule`Private`variable", "}"}], ",", 
                   "Alpha`VertexSchedule`Private`v"}], "]"}]}], ";", 
                RowBox[{"Alpha`VertexSchedule`Private`result1", "=", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"affineDepConsts", "[", 
                    RowBox[{
                    RowBox[{"depend", "[", 
                    RowBox[{
                    RowBox[{"getDeclarationDomain", "[", "#1", "]"}], ",", 
                    "#1", ",", "\<\"\"\>", ",", "Null", ",", "_"}], "]"}], 
                    ",", "Alpha`VertexSchedule`Private`v", ",", "0", ",", 
                    "Alpha`VertexSchedule`Private`coeffstau", ",", 
                    "Alpha`VertexSchedule`Private`coeffsalpha", ",", 
                    "Alpha`VertexSchedule`Private`options"}], "]"}], "&"}], 
                   ")"}], "/@", "Alpha`VertexSchedule`Private`iv"}]}], ";", 
                RowBox[{"Alpha`VertexSchedule`Private`result", "=", 
                 RowBox[{"MapThread", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"affineDepConsts", "[", 
                    RowBox[{
                    "#1", ",", "Alpha`VertexSchedule`Private`v", ",", "#2", 
                    ",", "Alpha`VertexSchedule`Private`coeffstau", ",", 
                    "Alpha`VertexSchedule`Private`coeffsalpha", ",", 
                    "Alpha`VertexSchedule`Private`options"}], "]"}], "&"}], 
                   ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    "$scheduleDepTable", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], ",", 
                    "Alpha`VertexSchedule`Private`dur"}], "}"}]}], "]"}]}], 
                ";", 
                RowBox[{"Alpha`VertexSchedule`Private`result", "=", 
                 RowBox[{"Join", "[", 
                  RowBox[{
                  "Alpha`VertexSchedule`Private`result1", ",", 
                   "Alpha`VertexSchedule`Private`result"}], "]"}]}], ";"}]}], 
              "]"}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`result", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Complement", "[", 
                  RowBox[{"#1", ",", 
                   RowBox[{"{", "True", "}"}]}], "]"}], "&"}], ")"}], "/@", 
               "Alpha`VertexSchedule`Private`result"}]}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`pos", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"Position", "[", 
                    RowBox[{"Alpha`VertexSchedule`Private`v", ",", "#1"}], 
                    "]"}], "\[LeftDoubleBracket]", "1", 
                   "\[RightDoubleBracket]"}], "\[LeftDoubleBracket]", "1", 
                  "\[RightDoubleBracket]"}], "&"}], ")"}], "/@", 
               "Alpha`VertexSchedule`Private`v"}]}], ";", 
             RowBox[{"Alpha`VertexSchedule`Private`pos", "=", 
              RowBox[{
               RowBox[{"Flatten", "[", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                   "Alpha`VertexSchedule`Private`coeffstau", 
                    "\[LeftDoubleBracket]", "#1", "\[RightDoubleBracket]"}], 
                   "&"}], ")"}], "/@", "Alpha`VertexSchedule`Private`pos"}], 
                "]"}], "\[Union]", 
               RowBox[{"Flatten", "[", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                   "Alpha`VertexSchedule`Private`coeffsalpha", 
                    "\[LeftDoubleBracket]", "#1", "\[RightDoubleBracket]"}], 
                   "&"}], ")"}], "/@", "Alpha`VertexSchedule`Private`pos"}], 
                "]"}]}]}], ";", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"!", "Alpha`VertexSchedule`Private`multidim"}], ",", 
               RowBox[{
                RowBox[{"Alpha`VertexSchedule`Private`result", "=", 
                 RowBox[{
                 "Alpha`VertexSchedule`Private`result", "/.", 
                  "\[InvisibleSpace]", 
                  RowBox[{
                   RowBox[{"\<\"ge\"\>", "[", 
                    RowBox[{
                    "Alpha`VertexSchedule`Private`x_", ",", 
                    "Alpha`VertexSchedule`Private`y_"}], "]"}], "\[Rule]", 
                   RowBox[{
                   "Alpha`VertexSchedule`Private`x", "\[GreaterEqual]", 
                    "Alpha`VertexSchedule`Private`y"}]}]}]}], ";", 
                RowBox[{"$dependencyConstraints", "=", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Complement", "[", 
                    RowBox[{
                    RowBox[{
                    "Union", "@@", "Alpha`VertexSchedule`Private`result"}], 
                    ",", 
                    RowBox[{"{", "True", "}"}]}], "]"}], ",", 
                   "Alpha`VertexSchedule`Private`pos"}], "}"}]}], ";", 
                RowBox[{"If", "[", 
                 RowBox[{"Alpha`VertexSchedule`Private`dbg", ",", 
                  RowBox[{
                   RowBox[{
                   "Print", "[", "\<\"----------- Dep table : \"\>", "]"}], 
                   ";", 
                   RowBox[{"show", "[", "$scheduleDepTable", "]"}]}]}], "]"}],
                 ";", 
                RowBox[{"If", "[", 
                 RowBox[{"Alpha`VertexSchedule`Private`sbs", ",", 
                  RowBox[{
                   RowBox[{"Alpha`VertexSchedule`Private`useConstraints", "=", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Length", "[", "$scheduleDepTable", "]"}], "=!=", 
                    "2"}], ",", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{"Alpha`VertexSchedule`Private`vrb", ",", 
                    RowBox[{"Print", "[", 
                    RowBox[{"scheduleConstraints", "::", "\<\"noUse\"\>"}], 
                    "]"}]}], "]"}], ";", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"Check", "[", 
                    RowBox[{
                    RowBox[{
                    "Alpha`VertexSchedule`Private`useConstraints", "=", 
                    RowBox[{"getUseSchedule", "[", 
                    RowBox[{
                    RowBox[{
                    "$scheduleDepTable", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}], ",", 
                    "Alpha`VertexSchedule`Private`options"}], "]"}]}], ",", 
                    RowBox[{
                    "Throw", 
                    "[", "\<\"Error while calling getUseSchedule...\"\>", 
                    "]"}]}], "]"}]}], "]"}]}], ";", 
                   RowBox[{"$dependencyConstraints", "=", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    "$dependencyConstraints", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], "\[Union]", 
                    RowBox[{"Union", "@@", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    "#1", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], "&"}], ")"}], "/@", 
                    "Alpha`VertexSchedule`Private`useConstraints"}]}]}], ",", 
                    RowBox[{
                    RowBox[{
                    "$dependencyConstraints", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}], "\[Union]", 
                    RowBox[{"Union", "@@", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    "#1", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}], "&"}], ")"}], "/@", 
                    "Alpha`VertexSchedule`Private`useConstraints"}]}]}]}], 
                    "}"}]}]}]}], "]"}], ";", "$dependencyConstraints"}], ",", 
               RowBox[{"Module", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                  "Alpha`VertexSchedule`Private`aux", ",", 
                   "Alpha`VertexSchedule`Private`temp"}], "}"}], ",", 
                 RowBox[{
                  RowBox[{
                  "Clear", "[", "Alpha`VertexSchedule`Private`aux", "]"}], 
                  ";", 
                  RowBox[{
                   RowBox[{"Alpha`VertexSchedule`Private`aux", "[", 
                    RowBox[{"Alpha`VertexSchedule`Private`c_", ",", 
                    RowBox[{"index", ":", 
                    RowBox[{"_Integer", "|", "Null"}]}]}], "]"}], ":=", 
                   RowBox[{"Module", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "Alpha`VertexSchedule`Private`cons1", ",", 
                    "Alpha`VertexSchedule`Private`cons2", ",", 
                    "Alpha`VertexSchedule`Private`vars", ",", 
                    "Alpha`VertexSchedule`Private`cons3", ",", 
                    "Alpha`VertexSchedule`Private`cons"}], "}"}], ",", 
                    RowBox[{
                    RowBox[{"Alpha`VertexSchedule`Private`cons1", "=", 
                    RowBox[{"Cases", "[", 
                    RowBox[{"Alpha`VertexSchedule`Private`c", ",", 
                    RowBox[{
                    RowBox[{"\<\"ge\"\>", "[", 
                    RowBox[{"_", ",", "Alpha`VertexSchedule`Private`x_"}], 
                    "]"}], "/;", 
                    RowBox[{"Alpha`VertexSchedule`Private`x", ">", "0"}]}], 
                    ",", "2"}], "]"}]}], ";", 
                    RowBox[{"Alpha`VertexSchedule`Private`cons2", "=", 
                    RowBox[{"Cases", "[", 
                    RowBox[{"Alpha`VertexSchedule`Private`c", ",", 
                    RowBox[{
                    RowBox[{"\<\"ge\"\>", "[", 
                    RowBox[{"Alpha`VertexSchedule`Private`x_", ",", "0"}], 
                    "]"}], "\[Rule]", 
                    RowBox[{
                    "Alpha`VertexSchedule`Private`x", "\[GreaterEqual]", 
                    "0"}]}], ",", "2"}], "]"}]}], ";", 
                    RowBox[{"BeginPackage", "[", "\<\"Alpha`Work`\"\>", "]"}],
                     ";", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"index", "=!=", "Null"}], ",", 
                    RowBox[{
                    RowBox[{"Alpha`VertexSchedule`Private`cons1", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    "Alpha`VertexSchedule`Private`cons1", 
                    "\[LeftDoubleBracket]", "Alpha`VertexSchedule`Private`i", 
                    "\[RightDoubleBracket]"}], "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], "\[GreaterEqual]", 
                    RowBox[{
                    RowBox[{
                    "Alpha`VertexSchedule`Private`dur", 
                    "\[LeftDoubleBracket]", "index", 
                    "\[RightDoubleBracket]"}], " ", 
                    RowBox[{"ToExpression", "[", 
                    RowBox[{"\<\"slack\"\>", "<>", 
                    RowBox[{"ToString", "[", "index", "]"}]}], "]"}]}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Alpha`VertexSchedule`Private`i", ",", "1", ",", 
                    RowBox[{
                    "Length", "[", "Alpha`VertexSchedule`Private`cons1", 
                    "]"}]}], "}"}]}], "]"}]}], ";", 
                    RowBox[{"Alpha`VertexSchedule`Private`vars", "=", 
                    RowBox[{"{", 
                    RowBox[{"ToExpression", "[", 
                    RowBox[{"\<\"slack\"\>", "<>", 
                    RowBox[{"ToString", "[", "index", "]"}]}], "]"}], "}"}]}],
                     ";"}], ",", 
                    RowBox[{
                    RowBox[{"Alpha`VertexSchedule`Private`cons1", "=", 
                    RowBox[{"{", "}"}]}], ";", 
                    RowBox[{"Alpha`VertexSchedule`Private`vars", "=", 
                    RowBox[{"{", "}"}]}], ";"}]}], "]"}], ";", 
                    RowBox[{"EndPackage", "[", "]"}], ";", 
                    RowBox[{"Alpha`VertexSchedule`Private`cons3", "=", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"0", "\[LessEqual]", "#1", "\[LessEqual]", "1"}], 
                    "&"}], ")"}], "/@", 
                    "Alpha`VertexSchedule`Private`vars"}]}], ";", 
                    RowBox[{"Alpha`VertexSchedule`Private`cons", "=", 
                    RowBox[{"Complement", "[", 
                    RowBox[{
                    RowBox[{
                    "Alpha`VertexSchedule`Private`cons3", "\[Union]", 
                    "Alpha`VertexSchedule`Private`cons1", "\[Union]", 
                    "Alpha`VertexSchedule`Private`cons2"}], ",", 
                    RowBox[{"{", "True", "}"}]}], "]"}]}], ";", 
                    RowBox[{"{", 
                    RowBox[{
                    "Alpha`VertexSchedule`Private`cons", ",", 
                    "Alpha`VertexSchedule`Private`vars"}], "}"}]}]}], "]"}]}],
                   ";", 
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Alpha`VertexSchedule`Private`r1", "=", 
                    RowBox[{"Take", "[", 
                    RowBox[{"Alpha`VertexSchedule`Private`result", ",", 
                    RowBox[{
                    "Length", "[", "Alpha`VertexSchedule`Private`iv", "]"}]}],
                     "]"}]}], ",", 
                    RowBox[{"Alpha`VertexSchedule`Private`r2", "=", 
                    RowBox[{"Drop", "[", 
                    RowBox[{"Alpha`VertexSchedule`Private`result", ",", 
                    RowBox[{
                    "Length", "[", "Alpha`VertexSchedule`Private`iv", "]"}]}],
                     "]"}]}]}], "}"}], ",", 
                    RowBox[{
                    RowBox[{"Alpha`VertexSchedule`Private`temp", "=", 
                    RowBox[{"MapThread", "[", 
                    RowBox[{"Alpha`VertexSchedule`Private`aux", ",", 
                    RowBox[{"{", 
                    RowBox[{"Alpha`VertexSchedule`Private`r1", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{"Null", ",", 
                    RowBox[{"{", 
                    RowBox[{"Alpha`VertexSchedule`Private`i", ",", "1", ",", 
                    RowBox[{
                    "Length", "[", "Alpha`VertexSchedule`Private`r1", "]"}]}],
                     "}"}]}], "]"}]}], "}"}]}], "]"}]}], ";", 
                    RowBox[{"Alpha`VertexSchedule`Private`temp", "=", 
                    RowBox[{"Join", "[", 
                    RowBox[{"Alpha`VertexSchedule`Private`temp", ",", 
                    RowBox[{"MapThread", "[", 
                    RowBox[{"Alpha`VertexSchedule`Private`aux", ",", 
                    RowBox[{"{", 
                    RowBox[{"Alpha`VertexSchedule`Private`r2", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{"Alpha`VertexSchedule`Private`i", ",", 
                    RowBox[{"{", 
                    RowBox[{"Alpha`VertexSchedule`Private`i", ",", "1", ",", 
                    RowBox[{
                    "Length", "[", "Alpha`VertexSchedule`Private`r2", "]"}]}],
                     "}"}]}], "]"}]}], "}"}]}], "]"}]}], "]"}]}], ";"}]}], 
                   "]"}], ";", 
                  RowBox[{"Alpha`VertexSchedule`Private`pos", "=", 
                   RowBox[{"Alpha`VertexSchedule`Private`pos", "\[Union]", 
                    RowBox[{"Union", "@@", 
                    RowBox[{
                    "Last", "/@", "Alpha`VertexSchedule`Private`temp"}]}]}]}],
                   ";", 
                  RowBox[{"$dependencyConstraints", "=", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    "First", "/@", "Alpha`VertexSchedule`Private`temp"}], ",",
                     "Alpha`VertexSchedule`Private`pos"}], "}"}]}], ";"}]}], 
                "]"}]}], "]"}], ";", 
             RowBox[{"If", "[", 
              RowBox[{"Alpha`VertexSchedule`Private`reuseS", ",", 
               RowBox[{"Module", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                  "Alpha`VertexSchedule`Private`rules", ",", 
                   "Alpha`VertexSchedule`Private`varNamesloc"}], "}"}], ",", 
                 RowBox[{
                  RowBox[{
                  "Clear", "[", "Alpha`VertexSchedule`Private`auxFunction", 
                   "]"}], ";", 
                  RowBox[{
                   RowBox[{"Alpha`VertexSchedule`Private`auxFunction", "[", 
                    RowBox[{"{", 
                    RowBox[{"Alpha`VertexSchedule`Private`name_String", ",", 
                    RowBox[{"{", "___String", "}"}], ",", 
                    RowBox[{"sched", "[", 
                    RowBox[{
                    RowBox[{"Alpha`VertexSchedule`Private`values", ":", 
                    RowBox[{"{", "___Integer", "}"}]}], ",", 
                    "Alpha`VertexSchedule`Private`constant_Integer"}], 
                    "]"}]}], "}"}], "]"}], ":=", 
                   RowBox[{"Module", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "Alpha`VertexSchedule`Private`tauCoeffs", ",", 
                    "Alpha`VertexSchedule`Private`alphaCoeff"}], "}"}], ",", 
                    RowBox[{
                    RowBox[{"BeginPackage", "[", "\<\"Alpha`Work`\"\>", "]"}],
                     ";", 
                    RowBox[{"Alpha`VertexSchedule`Private`tauCoeffs", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"ToExpression", "[", 
                    
                    RowBox[{"\<\"T\"\>", "<>", 
                    "Alpha`VertexSchedule`Private`name", "<>", "\<\"D\"\>", "<>", 
                    RowBox[{
                    "ToString", "[", "Alpha`VertexSchedule`Private`i", 
                    "]"}]}], "]"}], "\[Rule]", 
                    RowBox[{
                    "Alpha`VertexSchedule`Private`values", 
                    "\[LeftDoubleBracket]", "Alpha`VertexSchedule`Private`i", 
                    "\[RightDoubleBracket]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Alpha`VertexSchedule`Private`i", ",", "1", ",", 
                    RowBox[{
                    "Length", "[", "Alpha`VertexSchedule`Private`values", 
                    "]"}]}], "}"}]}], "]"}]}], ";", 
                    RowBox[{"Alpha`VertexSchedule`Private`alphaCoeff", "=", 
                    RowBox[{
                    RowBox[{"ToExpression", "[", 
                    
                    RowBox[{"\<\"A\"\>", "<>", 
                    "Alpha`VertexSchedule`Private`name"}], "]"}], "\[Rule]", 
                    "Alpha`VertexSchedule`Private`constant"}]}], ";", 
                    RowBox[{"EndPackage", "[", "]"}], ";", 
                    RowBox[{"Append", "[", 
                    RowBox[{
                    "Alpha`VertexSchedule`Private`tauCoeffs", ",", 
                    "Alpha`VertexSchedule`Private`alphaCoeff"}], "]"}]}]}], 
                    "]"}]}], ";", 
                  RowBox[{"Alpha`VertexSchedule`Private`rules", "=", 
                   RowBox[{"Union", "@@", 
                    RowBox[{"Alpha`VertexSchedule`Private`auxFunction", "/@", 
                    RowBox[{
                    "$schedule", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}]}]}]}], ";", 
                  RowBox[{"If", "[", 
                   RowBox[{"Alpha`VertexSchedule`Private`dbg", ",", 
                    RowBox[{
                    "Print", "[", "Alpha`VertexSchedule`Private`rules", 
                    "]"}]}], "]"}], ";", 
                  RowBox[{"Alpha`VertexSchedule`Private`varNamesloc", "=", 
                   RowBox[{
                   "First", "/@", "Alpha`VertexSchedule`Private`rules"}]}], 
                  ";", 
                  RowBox[{"If", "[", 
                   RowBox[{"Alpha`VertexSchedule`Private`dbg", ",", 
                    RowBox[{
                    "Print", "[", "Alpha`VertexSchedule`Private`varNamesloc", 
                    "]"}]}], "]"}], ";", 
                  RowBox[{"$dependencyConstraints", "=", 
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Alpha`VertexSchedule`Private`r", "=", 
                    RowBox[{
                    "$dependencyConstraints", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}]}], ",", 
                    RowBox[{"Alpha`VertexSchedule`Private`v", "=", 
                    RowBox[{
                    "$dependencyConstraints", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}]}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Complement", "[", 
                    RowBox[{
                    RowBox[{
                    "Alpha`VertexSchedule`Private`r", "/.", 
                    "\[InvisibleSpace]", 
                    "Alpha`VertexSchedule`Private`rules"}], ",", 
                    RowBox[{"{", "True", "}"}]}], "]"}], ",", 
                    RowBox[{"Complement", "[", 
                    RowBox[{
                    "Alpha`VertexSchedule`Private`v", ",", 
                    "Alpha`VertexSchedule`Private`varNamesloc"}], "]"}]}], 
                    "}"}]}], "]"}]}], ";", 
                  RowBox[{"If", "[", 
                   RowBox[{"Alpha`VertexSchedule`Private`dbg", ",", 
                    RowBox[{"Print", "[", "$dependencyConstraints", "]"}]}], 
                   "]"}]}]}], "]"}]}], "]"}], ";", 
             "$dependencyConstraints"}]}], "]"}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"scheduleConstraints", "[", "___", "]"}], ":=", 
         RowBox[{"Message", "[", 
          RowBox[{"scheduleConstraints", "::", "\<\"params\"\>"}], "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"Options", "[", "scheduleConstraints", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"scheduleType", "\[Rule]", "affineByVar"}], ",", 
           RowBox[{"verbose", "\[Rule]", "False"}], ",", 
           RowBox[{"addConstraints", "\[Rule]", 
            RowBox[{"{", "}"}]}], ",", 
           RowBox[{"multidimensional", "\[Rule]", "False"}], ",", 
           RowBox[{"verticesPositive", "\[Rule]", "False"}], ",", 
           RowBox[{"dependenciesOnly", "\[Rule]", "False"}], ",", 
           RowBox[{"onlyEquations", "\[Rule]", "all"}], ",", 
           RowBox[{"onlyVars", "\[Rule]", "all"}], ",", 
           RowBox[{"onlyDep", "\[Rule]", "all"}], ",", 
           RowBox[{"onlyUseDep", "\[Rule]", "all"}], ",", 
           RowBox[{"debug", "\[Rule]", "False"}], ",", 
           RowBox[{"depComputed", "\[Rule]", "False"}], ",", 
           RowBox[{"durations", "\[Rule]", 
            RowBox[{"{", "}"}]}], ",", 
           RowBox[{"durationsNonZero", "\[Rule]", 
            RowBox[{"{", "}"}]}], ",", 
           RowBox[{"reuseSchedule", "\[Rule]", "False"}], ",", 
           RowBox[{"subSystems", "\[Rule]", "True"}], ",", 
           RowBox[{"eliminatesDoubles", "\[Rule]", "False"}], ",", 
           RowBox[{"dataFlow", "\[Rule]", "False"}]}], "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[Alpha`VertexSchedule`scheduleConstraints],
  Editable->False]], "Print",
 CellChangeTimes->{3.480936485929101*^9},
 CellTags->"Info3480943685-7374309"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "timeMinSchedConstraints"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"Timeminschedconstraints[] computes the constraints needed to \
minimize\\nthe total execution time of\\n$result. \
timeMinSchedConstraints[var_String] computes only the\\ndependence \
constraints for variable var. Options of\\ntimeMinSchedConstraints are \
sameLinearPart (default False),\\naddConstraints ({}) and verbose \
(False).\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.480936488197507*^9},
 CellTags->"Info3480943687-5539735"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "checkSchedOptions"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"checkSchedOptions[options] checks the options against the \
\\noptions of scd\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.480936489971636*^9},
 CellTags->"Info3480943689-3045987"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"?", "scd"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "getUseSchedule"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "encodeSchedule"}]], "Input"],

Cell[BoxData[
 RowBox[{"?", "simplex"}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Scheduling the dot product (using schedule)",
 FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell["\<\
We first schedule the dot product. This means that we select it (getSystem), \
and schedule it using the farkas scheduler. Important, and difficult to \
explain in a few words: we need to force the inputs of the dot product to \
have the same linear part as the outputs... The result show that the kth \
component of the vector is scheduled at time k, which is reasonable...\
\>", "Text",
 TextAlignment->Left,
 TextJustification->1],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<dot\>\"", "]"}], ";"}], "\n", 
 RowBox[{"schedule", "[", 
  RowBox[{"addConstraints", "\[Rule]", 
   RowBox[{"{", 
    RowBox[{"\"\<TaD1==1\>\"", ",", "\"\<TbD1==1\>\""}], "}"}]}], 
  "]"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Checking options...\"\>"], "Print",
 CellChangeTimes->{3.4809365043112717`*^9, 3.4810138219375677`*^9}],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print",
 CellChangeTimes->{3.4809365043112717`*^9, 3.481013821970173*^9}],

Cell[BoxData["\<\"Building LP...\"\>"], "Print",
 CellChangeTimes->{3.4809365043112717`*^9, 3.4810138220344343`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "2", "\[InvisibleSpace]", "\<\" Recognized added Constraints: \"\>"}],
  SequenceForm[2, " Recognized added Constraints: "],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809365043112717`*^9, 3.481013822085837*^9}],

Cell[BoxData["\<\"   -1 + TaD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809365043112717`*^9, 3.481013822171577*^9}],

Cell[BoxData["\<\"   -1 + TbD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4809365043112717`*^9, 3.481013822250942*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "49", 
   "\[InvisibleSpace]", "\<\"\\n\\t\\t\\t   variables, \"\>", 
   "\[InvisibleSpace]", "52", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 49, "\n\t\t\t   variables, ", 52, " Constraints"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809365043112717`*^9, 3.4810138223371468`*^9}],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print",
 CellChangeTimes->{3.4809365043112717`*^9, 3.481013822417396*^9}],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print",
 CellChangeTimes->{3.4809365043112717`*^9, 3.481013822501296*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Total execution Time: \"\>", "\[InvisibleSpace]", 
   RowBox[{"1", "+", "\<\"N\"\>"}]}],
  SequenceForm["Total execution Time: ", 1 + "N"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809365043112717`*^9, 3.4810138225842123`*^9}],

Cell[BoxData["\<\"T_a{k, N} = -1 + k\\nT_b{k, N} = -1 + k\\nT_c{N} = 1 + \
N\\nT_Acc{k, N} = k\"\>"], "Print",
 CellChangeTimes->{3.4809365043112717`*^9, 3.48101382267909*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"dot\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"a\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "1"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"b\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "1"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"c\"\>", ",", 
       RowBox[{"{", "\<\"N\"\>", "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", "1", "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Acc\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}]}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.4809365050702753`*^9, 3.481013822736187*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<dot\>\"", "]"}], ";"}], "\n", 
 RowBox[{"scd", "[", 
  RowBox[{"addConstraints", "\[Rule]", 
   RowBox[{"{", 
    RowBox[{"\"\<TaD1==1\>\"", ",", "\"\<TbD1==1\>\""}], "}"}]}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.480936511487111*^9, 3.4809365218301764`*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"Method Minimize\"\>"], "Print",
 CellChangeTimes->{3.4809365227693357`*^9, 3.481013823913218*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "33", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "13", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   "0.004187999999999192`"}],
  SequenceForm[33, " constraints, ", 13, " variables ", 0.004187999999999192],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809365227693357`*^9, 3.481013823948575*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"dot\"\>", ",", "13", ",", "30", ",", "0.004187999999999192`", 
   ",", "\<\"Vertex\"\>", ",", "\<\"Flat\"\>"}], "}"}]], "Print",
 CellChangeTimes->{3.4809365227693357`*^9, 3.4810138240028963`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"dot\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"a\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Acc\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"b\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"c\"\>", ",", 
       RowBox[{"{", "\<\"N\"\>", "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", "1", "}"}], ",", "2"}], "]"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.480936522906919*^9, 3.481013824076412*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"saveScheduleLibrary", "[", "\"\<dot\>\"", "]"}], ";"}]], "Input"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Schedule(s) were saved in file \"\>", 
   "\[InvisibleSpace]", "\<\"dot.scdlib\"\>"}],
  SequenceForm["Schedule(s) were saved in file ", "dot.scdlib"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4809365251781683`*^9, 3.4810138252428713`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Scheduling the matmult product",
 FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell["\<\
Then we schedule the main system. This is done by selecting the matmult \
system, and by calling the structured scheduler, structSched. \
\>", "Text",
 TextAlignment->Left,
 TextJustification->1],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<matmults.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[BoxData["\<\"[dot][matmult]\"\>"], "Print",
 CellChangeTimes->{3.481013831152605*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input"],

Cell[BoxData["\<\"system matmult :{N | 2<=N}\\n               (a : {i,j | \
1<=i<=N; 1<=j<=N} of integer; \\n                b : {i,j | 1<=i<=N; 1<=j<=N} \
of integer)\\n       returns (c : {i,j | 1<=i<=N; 1<=j<=N} of integer);\\nvar\
\\n  A : {k,i,j | 0<=k<=N; 1<=i<=N; 1<=j<=N} of integer;\\n  B : {k,i,j | \
0<=k<=N; 1<=i<=N; 1<=j<=N} of integer;\\nlet\\n  A[k,i,j] = \\n      case\\n  \
      { | k=0} : a[i,j];\\n        { | 1<=k; 2<=j} : A[i,j-1,k];\\n        { \
| 1<=k; j=1} : a[i,k];\\n      esac;\\n  B[k,i,j] = \\n      case\\n        { \
| k=0} : b[i,j];\\n        { | 1<=k; 2<=i} : B[k,i-1,j];\\n        { | 1<=k; \
i=1} : b[j,k];\\n      esac;\\n  use {i,j | 1<=i<=N; 1<=j<=N} dot[N] (A, B) \
returns  (c) ;\\ntel;\"\>"], "Print",
 CellChangeTimes->{3.4810138321221867`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<matmult\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"loadScheduleLibrary", "[", "\"\<dot\>\"", "]"}], ";"}], "\n", 
 RowBox[{"scd", "[", 
  RowBox[{
   RowBox[{"addConstraints", "\[Rule]", 
    RowBox[{"{", "\"\<TBD4==0\>\"", "}"}]}], ",", 
   RowBox[{"verbose", "\[Rule]", "True"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.481013836878933*^9, 3.481013838758272*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Value of integerSolution: \"\>", "\[InvisibleSpace]", "False"}],
  SequenceForm["Value of integerSolution: ", False],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013846716694*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Value of linear resolution: \"\>", "\[InvisibleSpace]", 
   "False"}],
  SequenceForm["Value of linear resolution: ", False],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013846720339*^9}}],

Cell[BoxData["\<\"Dependencies kept are:\"\>"], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013846835*^9}}],

Cell[BoxData["\<\"-- Regular dependencies:\"\>"], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013846838229*^9}}],

Cell[BoxData["\<\"{k,i,j,N | k=0; 1<=i<=N; 1<=j<=N; 2<=N} : A[k,i,j,N] -> \
a[k+i,j,N]\\n{k,i,j,N | 1<=k<=N; 1<=i<=N; 2<=j<=N} : A[k,i,j,N] -> \
A[i,j-1,k,N]\\n{k,i,j,N | 1<=k<=N; 1<=i<=N; j=1; 2<=N} : A[k,i,j,N] -> \
a[i,k,j+N-1]\\n{k,i,j,N | k=0; 1<=i<=N; 1<=j<=N; 2<=N} : B[k,i,j,N] -> \
b[k+i,j,N]\\n{k,i,j,N | 1<=k<=N; 2<=i<=N; 1<=j<=N} : B[k,i,j,N] -> \
B[k,i-1,j,N]\\n{k,i,j,N | 1<=k<=N; i=1; 1<=j<=N; 2<=N} : B[k,i,j,N] -> \
b[j,k,N]\"\>"], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013846891464*^9}}],

Cell[BoxData["\<\"-- Dependencies of use statements:\"\>"], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013846894459*^9}}],

Cell[BoxData["\<\"dot[(i,j,N->N)](A,B) <- (c)\"\>"], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013846897731*^9}}],

Cell[BoxData["\<\"----------------------------\"\>"], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013846900773*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--- LHS variable: \"\>", "\[InvisibleSpace]", "\<\"a\"\>", 
   "\[InvisibleSpace]", "\<\", RHS variable: \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["--- LHS variable: ", "a", ", RHS variable: ", ""],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.4810138469044323`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constraints: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"TaD3", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TaD1", "+", "TaD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TaD2", "+", "TaD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TaD1", "+", "TaD2", "+", "TaD3"}], "\[GreaterEqual]", "0"}]}], 
    "}"}]}],
  SequenceForm[
  "    Constraints: ", {
   Alpha`Work`TaD3 >= 0, Alpha`Work`TaD1 + Alpha`Work`TaD3 >= 0, 
    Alpha`Work`TaD2 + Alpha`Work`TaD3 >= 0, 
    Alpha`Work`TaD1 + Alpha`Work`TaD2 + Alpha`Work`TaD3 >= 0}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013846960454*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--- LHS variable: \"\>", "\[InvisibleSpace]", "\<\"b\"\>", 
   "\[InvisibleSpace]", "\<\", RHS variable: \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["--- LHS variable: ", "b", ", RHS variable: ", ""],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.4810138470253696`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constraints: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"TbD3", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TbD1", "+", "TbD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TbD2", "+", "TbD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TbD1", "+", "TbD2", "+", "TbD3"}], "\[GreaterEqual]", "0"}]}], 
    "}"}]}],
  SequenceForm[
  "    Constraints: ", {
   Alpha`Work`TbD3 >= 0, Alpha`Work`TbD1 + Alpha`Work`TbD3 >= 0, 
    Alpha`Work`TbD2 + Alpha`Work`TbD3 >= 0, 
    Alpha`Work`TbD1 + Alpha`Work`TbD2 + Alpha`Work`TbD3 >= 0}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013847091444*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--- LHS variable: \"\>", "\[InvisibleSpace]", "\<\"A\"\>", 
   "\[InvisibleSpace]", "\<\", RHS variable: \"\>", 
   "\[InvisibleSpace]", "\<\"a\"\>"}],
  SequenceForm["--- LHS variable: ", "A", ", RHS variable: ", "a"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.4810138471705008`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constraints: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"TAD4", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD2", "+", "TAD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TaD3"}], "+", "TAD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TaD1"}], "+", "TAD2", "-", "TaD3", "+", "TAD4"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD3", "+", "TAD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD2", "+", "TAD3", "+", "TAD4"}], "\[GreaterEqual]", "0"}], 
     ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TaD2"}], "-", "TaD3", "+", "TAD3", "+", "TAD4"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TaD1"}], "-", "TaD2", "+", "TAD2", "-", "TaD3", "+", 
       "TAD3", "+", "TAD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aa"}], "+", "AA", "-", "TaD1", "-", "TaD2", "+", "TAD2", 
       "-", 
       RowBox[{"2", " ", "TaD3"}], "+", "TAD3", "+", 
       RowBox[{"2", " ", "TAD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aa"}], "+", "AA", "-", 
       RowBox[{"2", " ", "TaD1"}], "-", "TaD2", "+", 
       RowBox[{"2", " ", "TAD2"}], "-", 
       RowBox[{"2", " ", "TaD3"}], "+", "TAD3", "+", 
       RowBox[{"2", " ", "TAD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aa"}], "+", "AA", "-", "TaD1", "-", 
       RowBox[{"2", " ", "TaD2"}], "+", "TAD2", "-", 
       RowBox[{"2", " ", "TaD3"}], "+", 
       RowBox[{"2", " ", "TAD3"}], "+", 
       RowBox[{"2", " ", "TAD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aa"}], "+", "AA", "-", 
       RowBox[{"2", " ", "TaD1"}], "-", 
       RowBox[{"2", " ", "TaD2"}], "+", 
       RowBox[{"2", " ", "TAD2"}], "-", 
       RowBox[{"2", " ", "TaD3"}], "+", 
       RowBox[{"2", " ", "TAD3"}], "+", 
       RowBox[{"2", " ", "TAD4"}]}], "\[GreaterEqual]", "1"}]}], "}"}]}],
  SequenceForm[
  "    Constraints: ", {
   Alpha`Work`TAD4 >= 0, Alpha`Work`TAD2 + Alpha`Work`TAD4 >= 
    0, -Alpha`Work`TaD3 + Alpha`Work`TAD4 >= 
    0, -Alpha`Work`TaD1 + Alpha`Work`TAD2 - Alpha`Work`TaD3 + Alpha`Work`TAD4 >= 
    0, Alpha`Work`TAD3 + Alpha`Work`TAD4 >= 0, 
    Alpha`Work`TAD2 + Alpha`Work`TAD3 + Alpha`Work`TAD4 >= 
    0, -Alpha`Work`TaD2 - Alpha`Work`TaD3 + Alpha`Work`TAD3 + Alpha`Work`TAD4 >= 
    0, -Alpha`Work`TaD1 - Alpha`Work`TaD2 + Alpha`Work`TAD2 - Alpha`Work`TaD3 + 
     Alpha`Work`TAD3 + Alpha`Work`TAD4 >= 
    0, -Alpha`Work`Aa + Alpha`Work`AA - Alpha`Work`TaD1 - Alpha`Work`TaD2 + 
     Alpha`Work`TAD2 - 2 Alpha`Work`TaD3 + Alpha`Work`TAD3 + 
     2 Alpha`Work`TAD4 >= 
    1, -Alpha`Work`Aa + Alpha`Work`AA - 2 Alpha`Work`TaD1 - Alpha`Work`TaD2 + 
     2 Alpha`Work`TAD2 - 2 Alpha`Work`TaD3 + Alpha`Work`TAD3 + 
     2 Alpha`Work`TAD4 >= 
    1, -Alpha`Work`Aa + Alpha`Work`AA - Alpha`Work`TaD1 - 2 Alpha`Work`TaD2 + 
     Alpha`Work`TAD2 - 2 Alpha`Work`TaD3 + 2 Alpha`Work`TAD3 + 
     2 Alpha`Work`TAD4 >= 
    1, -Alpha`Work`Aa + Alpha`Work`AA - 2 Alpha`Work`TaD1 - 2 Alpha`Work`TaD2 + 
     2 Alpha`Work`TAD2 - 2 Alpha`Work`TaD3 + 2 Alpha`Work`TAD3 + 
     2 Alpha`Work`TAD4 >= 1}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013847226708*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--- LHS variable: \"\>", "\[InvisibleSpace]", "\<\"A\"\>", 
   "\[InvisibleSpace]", "\<\", RHS variable: \"\>", 
   "\[InvisibleSpace]", "\<\"A\"\>"}],
  SequenceForm["--- LHS variable: ", "A", ", RHS variable: ", "A"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.4810138472922773`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constraints: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"True", ",", 
     RowBox[{"TAD1", "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{"TAD1", "-", "TAD2"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"TAD2", "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TAD1"}], "+", "TAD2"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD1", "-", "TAD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD2", "-", "TAD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"TAD3", "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TAD1"}], "+", "TAD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TAD2"}], "+", "TAD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TAD1"}], "+", "TAD2", "+", "TAD3"}], "\[GreaterEqual]", 
      "1"}], ",", 
     RowBox[{"TAD4", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD1", "+", "TAD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD2", "+", "TAD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD1", "+", "TAD2", "+", "TAD4"}], "\[GreaterEqual]", "0"}], 
     ",", 
     RowBox[{
      RowBox[{"TAD3", "+", "TAD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD1", "+", "TAD3", "+", "TAD4"}], "\[GreaterEqual]", "0"}], 
     ",", 
     RowBox[{
      RowBox[{"TAD2", "+", "TAD3", "+", "TAD4"}], "\[GreaterEqual]", "0"}], 
     ",", 
     RowBox[{
      RowBox[{"TAD1", "+", "TAD2", "+", "TAD3", "+", "TAD4"}], 
      "\[GreaterEqual]", "0"}]}], "}"}]}],
  SequenceForm[
  "    Constraints: ", {
   True, Alpha`Work`TAD1 >= 1, Alpha`Work`TAD1 - Alpha`Work`TAD2 >= 0, 
    Alpha`Work`TAD2 >= 1, -Alpha`Work`TAD1 + Alpha`Work`TAD2 >= 0, 
    Alpha`Work`TAD1 - Alpha`Work`TAD3 >= 0, Alpha`Work`TAD2 - Alpha`Work`TAD3 >= 
    0, Alpha`Work`TAD3 >= 1, -Alpha`Work`TAD1 + Alpha`Work`TAD3 >= 
    0, -Alpha`Work`TAD2 + Alpha`Work`TAD3 >= 
    0, -Alpha`Work`TAD1 + Alpha`Work`TAD2 + Alpha`Work`TAD3 >= 1, 
    Alpha`Work`TAD4 >= 0, Alpha`Work`TAD1 + Alpha`Work`TAD4 >= 0, 
    Alpha`Work`TAD2 + Alpha`Work`TAD4 >= 0, 
    Alpha`Work`TAD1 + Alpha`Work`TAD2 + Alpha`Work`TAD4 >= 0, 
    Alpha`Work`TAD3 + Alpha`Work`TAD4 >= 0, 
    Alpha`Work`TAD1 + Alpha`Work`TAD3 + Alpha`Work`TAD4 >= 0, 
    Alpha`Work`TAD2 + Alpha`Work`TAD3 + Alpha`Work`TAD4 >= 0, 
    Alpha`Work`TAD1 + Alpha`Work`TAD2 + Alpha`Work`TAD3 + Alpha`Work`TAD4 >= 
    0}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013847360743*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--- LHS variable: \"\>", "\[InvisibleSpace]", "\<\"A\"\>", 
   "\[InvisibleSpace]", "\<\", RHS variable: \"\>", 
   "\[InvisibleSpace]", "\<\"a\"\>"}],
  SequenceForm["--- LHS variable: ", "A", ", RHS variable: ", "a"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013847435528*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constraints: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"TAD4", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD1", "+", "TAD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD2", "+", "TAD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD1", "+", "TAD2", "+", "TAD4"}], "\[GreaterEqual]", "0"}], 
     ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TaD3"}], "+", "TAD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD1", "-", "TaD2", "-", "TaD3", "+", "TAD4"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TaD1"}], "+", "TAD2", "-", "TaD3", "+", "TAD4"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TaD1"}], "+", "TAD1", "-", "TaD2", "+", "TAD2", "-", 
       "TaD3", "+", "TAD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aa"}], "+", "AA", "-", "TaD1", "+", 
       RowBox[{"2", " ", "TAD1"}], "-", 
       RowBox[{"2", " ", "TaD2"}], "+", "TAD2", "-", 
       RowBox[{"2", " ", "TaD3"}], "+", "TAD3", "+", 
       RowBox[{"2", " ", "TAD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aa"}], "+", "AA", "-", "TaD1", "+", "TAD1", "-", "TaD2", 
       "+", "TAD2", "-", 
       RowBox[{"2", " ", "TaD3"}], "+", "TAD3", "+", 
       RowBox[{"2", " ", "TAD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aa"}], "+", "AA", "-", 
       RowBox[{"2", " ", "TaD1"}], "+", 
       RowBox[{"2", " ", "TAD1"}], "-", 
       RowBox[{"2", " ", "TaD2"}], "+", 
       RowBox[{"2", " ", "TAD2"}], "-", 
       RowBox[{"2", " ", "TaD3"}], "+", "TAD3", "+", 
       RowBox[{"2", " ", "TAD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aa"}], "+", "AA", "-", 
       RowBox[{"2", " ", "TaD1"}], "+", "TAD1", "-", "TaD2", "+", 
       RowBox[{"2", " ", "TAD2"}], "-", 
       RowBox[{"2", " ", "TaD3"}], "+", "TAD3", "+", 
       RowBox[{"2", " ", "TAD4"}]}], "\[GreaterEqual]", "1"}]}], "}"}]}],
  SequenceForm[
  "    Constraints: ", {
   Alpha`Work`TAD4 >= 0, Alpha`Work`TAD1 + Alpha`Work`TAD4 >= 0, 
    Alpha`Work`TAD2 + Alpha`Work`TAD4 >= 0, 
    Alpha`Work`TAD1 + Alpha`Work`TAD2 + Alpha`Work`TAD4 >= 
    0, -Alpha`Work`TaD3 + Alpha`Work`TAD4 >= 0, 
    Alpha`Work`TAD1 - Alpha`Work`TaD2 - Alpha`Work`TaD3 + Alpha`Work`TAD4 >= 
    0, -Alpha`Work`TaD1 + Alpha`Work`TAD2 - Alpha`Work`TaD3 + Alpha`Work`TAD4 >= 
    0, -Alpha`Work`TaD1 + Alpha`Work`TAD1 - Alpha`Work`TaD2 + Alpha`Work`TAD2 - 
     Alpha`Work`TaD3 + Alpha`Work`TAD4 >= 
    0, -Alpha`Work`Aa + Alpha`Work`AA - Alpha`Work`TaD1 + 2 Alpha`Work`TAD1 - 
     2 Alpha`Work`TaD2 + Alpha`Work`TAD2 - 2 Alpha`Work`TaD3 + 
     Alpha`Work`TAD3 + 2 Alpha`Work`TAD4 >= 
    1, -Alpha`Work`Aa + Alpha`Work`AA - Alpha`Work`TaD1 + Alpha`Work`TAD1 - 
     Alpha`Work`TaD2 + Alpha`Work`TAD2 - 2 Alpha`Work`TaD3 + Alpha`Work`TAD3 + 
     2 Alpha`Work`TAD4 >= 
    1, -Alpha`Work`Aa + Alpha`Work`AA - 2 Alpha`Work`TaD1 + 2 Alpha`Work`TAD1 - 
     2 Alpha`Work`TaD2 + 2 Alpha`Work`TAD2 - 2 Alpha`Work`TaD3 + 
     Alpha`Work`TAD3 + 2 Alpha`Work`TAD4 >= 
    1, -Alpha`Work`Aa + Alpha`Work`AA - 2 Alpha`Work`TaD1 + Alpha`Work`TAD1 - 
     Alpha`Work`TaD2 + 2 Alpha`Work`TAD2 - 2 Alpha`Work`TaD3 + 
     Alpha`Work`TAD3 + 2 Alpha`Work`TAD4 >= 1}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.4810138474948397`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--- LHS variable: \"\>", "\[InvisibleSpace]", "\<\"B\"\>", 
   "\[InvisibleSpace]", "\<\", RHS variable: \"\>", 
   "\[InvisibleSpace]", "\<\"b\"\>"}],
  SequenceForm["--- LHS variable: ", "B", ", RHS variable: ", "b"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013847560363*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constraints: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"TBD4", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TBD2", "+", "TBD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TbD3"}], "+", "TBD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TbD1"}], "+", "TBD2", "-", "TbD3", "+", "TBD4"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TBD3", "+", "TBD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TBD2", "+", "TBD3", "+", "TBD4"}], "\[GreaterEqual]", "0"}], 
     ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TbD2"}], "-", "TbD3", "+", "TBD3", "+", "TBD4"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TbD1"}], "-", "TbD2", "+", "TBD2", "-", "TbD3", "+", 
       "TBD3", "+", "TBD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ab"}], "+", "AB", "-", "TbD1", "-", "TbD2", "+", "TBD2", 
       "-", 
       RowBox[{"2", " ", "TbD3"}], "+", "TBD3", "+", 
       RowBox[{"2", " ", "TBD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ab"}], "+", "AB", "-", 
       RowBox[{"2", " ", "TbD1"}], "-", "TbD2", "+", 
       RowBox[{"2", " ", "TBD2"}], "-", 
       RowBox[{"2", " ", "TbD3"}], "+", "TBD3", "+", 
       RowBox[{"2", " ", "TBD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ab"}], "+", "AB", "-", "TbD1", "-", 
       RowBox[{"2", " ", "TbD2"}], "+", "TBD2", "-", 
       RowBox[{"2", " ", "TbD3"}], "+", 
       RowBox[{"2", " ", "TBD3"}], "+", 
       RowBox[{"2", " ", "TBD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ab"}], "+", "AB", "-", 
       RowBox[{"2", " ", "TbD1"}], "-", 
       RowBox[{"2", " ", "TbD2"}], "+", 
       RowBox[{"2", " ", "TBD2"}], "-", 
       RowBox[{"2", " ", "TbD3"}], "+", 
       RowBox[{"2", " ", "TBD3"}], "+", 
       RowBox[{"2", " ", "TBD4"}]}], "\[GreaterEqual]", "1"}]}], "}"}]}],
  SequenceForm[
  "    Constraints: ", {
   Alpha`Work`TBD4 >= 0, Alpha`Work`TBD2 + Alpha`Work`TBD4 >= 
    0, -Alpha`Work`TbD3 + Alpha`Work`TBD4 >= 
    0, -Alpha`Work`TbD1 + Alpha`Work`TBD2 - Alpha`Work`TbD3 + Alpha`Work`TBD4 >= 
    0, Alpha`Work`TBD3 + Alpha`Work`TBD4 >= 0, 
    Alpha`Work`TBD2 + Alpha`Work`TBD3 + Alpha`Work`TBD4 >= 
    0, -Alpha`Work`TbD2 - Alpha`Work`TbD3 + Alpha`Work`TBD3 + Alpha`Work`TBD4 >= 
    0, -Alpha`Work`TbD1 - Alpha`Work`TbD2 + Alpha`Work`TBD2 - Alpha`Work`TbD3 + 
     Alpha`Work`TBD3 + Alpha`Work`TBD4 >= 
    0, -Alpha`Work`Ab + Alpha`Work`AB - Alpha`Work`TbD1 - Alpha`Work`TbD2 + 
     Alpha`Work`TBD2 - 2 Alpha`Work`TbD3 + Alpha`Work`TBD3 + 
     2 Alpha`Work`TBD4 >= 
    1, -Alpha`Work`Ab + Alpha`Work`AB - 2 Alpha`Work`TbD1 - Alpha`Work`TbD2 + 
     2 Alpha`Work`TBD2 - 2 Alpha`Work`TbD3 + Alpha`Work`TBD3 + 
     2 Alpha`Work`TBD4 >= 
    1, -Alpha`Work`Ab + Alpha`Work`AB - Alpha`Work`TbD1 - 2 Alpha`Work`TbD2 + 
     Alpha`Work`TBD2 - 2 Alpha`Work`TbD3 + 2 Alpha`Work`TBD3 + 
     2 Alpha`Work`TBD4 >= 
    1, -Alpha`Work`Ab + Alpha`Work`AB - 2 Alpha`Work`TbD1 - 2 Alpha`Work`TbD2 + 
     2 Alpha`Work`TBD2 - 2 Alpha`Work`TbD3 + 2 Alpha`Work`TBD3 + 
     2 Alpha`Work`TBD4 >= 1}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013847628489*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--- LHS variable: \"\>", "\[InvisibleSpace]", "\<\"B\"\>", 
   "\[InvisibleSpace]", "\<\", RHS variable: \"\>", 
   "\[InvisibleSpace]", "\<\"B\"\>"}],
  SequenceForm["--- LHS variable: ", "B", ", RHS variable: ", "B"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013847693181*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constraints: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"True", ",", 
     RowBox[{"TBD2", "\[GreaterEqual]", "1"}], ",", 
     RowBox[{"TBD4", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TBD1", "+", "TBD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TBD2", "+", "TBD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TBD1", "+", "TBD2", "+", "TBD4"}], "\[GreaterEqual]", "0"}], 
     ",", 
     RowBox[{
      RowBox[{"TBD3", "+", "TBD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TBD1", "+", "TBD3", "+", "TBD4"}], "\[GreaterEqual]", "0"}], 
     ",", 
     RowBox[{
      RowBox[{"TBD2", "+", "TBD3", "+", "TBD4"}], "\[GreaterEqual]", "0"}], 
     ",", 
     RowBox[{
      RowBox[{"TBD1", "+", "TBD2", "+", "TBD3", "+", "TBD4"}], 
      "\[GreaterEqual]", "0"}]}], "}"}]}],
  SequenceForm[
  "    Constraints: ", {
   True, Alpha`Work`TBD2 >= 1, Alpha`Work`TBD4 >= 0, 
    Alpha`Work`TBD1 + Alpha`Work`TBD4 >= 0, Alpha`Work`TBD2 + Alpha`Work`TBD4 >= 
    0, Alpha`Work`TBD1 + Alpha`Work`TBD2 + Alpha`Work`TBD4 >= 0, 
    Alpha`Work`TBD3 + Alpha`Work`TBD4 >= 0, 
    Alpha`Work`TBD1 + Alpha`Work`TBD3 + Alpha`Work`TBD4 >= 0, 
    Alpha`Work`TBD2 + Alpha`Work`TBD3 + Alpha`Work`TBD4 >= 0, 
    Alpha`Work`TBD1 + Alpha`Work`TBD2 + Alpha`Work`TBD3 + Alpha`Work`TBD4 >= 
    0}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013847761174*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--- LHS variable: \"\>", "\[InvisibleSpace]", "\<\"B\"\>", 
   "\[InvisibleSpace]", "\<\", RHS variable: \"\>", 
   "\[InvisibleSpace]", "\<\"b\"\>"}],
  SequenceForm["--- LHS variable: ", "B", ", RHS variable: ", "b"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013847826789*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constraints: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"TBD4", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TBD1", "+", "TBD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TbD3"}], "+", "TBD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TBD1", "-", "TbD2", "-", "TbD3", "+", "TBD4"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TBD3", "+", "TBD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TBD1", "+", "TBD3", "+", "TBD4"}], "\[GreaterEqual]", "0"}], 
     ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TbD1"}], "-", "TbD3", "+", "TBD3", "+", "TBD4"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TbD1"}], "+", "TBD1", "-", "TbD2", "-", "TbD3", "+", 
       "TBD3", "+", "TBD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ab"}], "+", "AB", "-", "TbD1", "+", 
       RowBox[{"2", " ", "TBD1"}], "-", 
       RowBox[{"2", " ", "TbD2"}], "+", "TBD2", "-", 
       RowBox[{"2", " ", "TbD3"}], "+", "TBD3", "+", 
       RowBox[{"2", " ", "TBD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ab"}], "+", "AB", "-", "TbD1", "+", "TBD1", "-", "TbD2", 
       "+", "TBD2", "-", 
       RowBox[{"2", " ", "TbD3"}], "+", "TBD3", "+", 
       RowBox[{"2", " ", "TBD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ab"}], "+", "AB", "-", 
       RowBox[{"2", " ", "TbD1"}], "+", 
       RowBox[{"2", " ", "TBD1"}], "-", 
       RowBox[{"2", " ", "TbD2"}], "+", "TBD2", "-", 
       RowBox[{"2", " ", "TbD3"}], "+", 
       RowBox[{"2", " ", "TBD3"}], "+", 
       RowBox[{"2", " ", "TBD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ab"}], "+", "AB", "-", 
       RowBox[{"2", " ", "TbD1"}], "+", "TBD1", "-", "TbD2", "+", "TBD2", "-", 
       RowBox[{"2", " ", "TbD3"}], "+", 
       RowBox[{"2", " ", "TBD3"}], "+", 
       RowBox[{"2", " ", "TBD4"}]}], "\[GreaterEqual]", "1"}]}], "}"}]}],
  SequenceForm[
  "    Constraints: ", {
   Alpha`Work`TBD4 >= 0, Alpha`Work`TBD1 + Alpha`Work`TBD4 >= 
    0, -Alpha`Work`TbD3 + Alpha`Work`TBD4 >= 0, 
    Alpha`Work`TBD1 - Alpha`Work`TbD2 - Alpha`Work`TbD3 + Alpha`Work`TBD4 >= 
    0, Alpha`Work`TBD3 + Alpha`Work`TBD4 >= 0, 
    Alpha`Work`TBD1 + Alpha`Work`TBD3 + Alpha`Work`TBD4 >= 
    0, -Alpha`Work`TbD1 - Alpha`Work`TbD3 + Alpha`Work`TBD3 + Alpha`Work`TBD4 >= 
    0, -Alpha`Work`TbD1 + Alpha`Work`TBD1 - Alpha`Work`TbD2 - Alpha`Work`TbD3 + 
     Alpha`Work`TBD3 + Alpha`Work`TBD4 >= 
    0, -Alpha`Work`Ab + Alpha`Work`AB - Alpha`Work`TbD1 + 2 Alpha`Work`TBD1 - 
     2 Alpha`Work`TbD2 + Alpha`Work`TBD2 - 2 Alpha`Work`TbD3 + 
     Alpha`Work`TBD3 + 2 Alpha`Work`TBD4 >= 
    1, -Alpha`Work`Ab + Alpha`Work`AB - Alpha`Work`TbD1 + Alpha`Work`TBD1 - 
     Alpha`Work`TbD2 + Alpha`Work`TBD2 - 2 Alpha`Work`TbD3 + Alpha`Work`TBD3 + 
     2 Alpha`Work`TBD4 >= 
    1, -Alpha`Work`Ab + Alpha`Work`AB - 2 Alpha`Work`TbD1 + 2 Alpha`Work`TBD1 - 
     2 Alpha`Work`TbD2 + Alpha`Work`TBD2 - 2 Alpha`Work`TbD3 + 
     2 Alpha`Work`TBD3 + 2 Alpha`Work`TBD4 >= 
    1, -Alpha`Work`Ab + Alpha`Work`AB - 2 Alpha`Work`TbD1 + Alpha`Work`TBD1 - 
     Alpha`Work`TbD2 + Alpha`Work`TBD2 - 2 Alpha`Work`TbD3 + 
     2 Alpha`Work`TBD3 + 2 Alpha`Work`TBD4 >= 1}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013847894734*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Periods: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "}"}]}],
  SequenceForm["Periods: ", {}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013847966425*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"-----------------------\\n\"\>", 
   "\[InvisibleSpace]", "\<\"Entering getUseSchedule on subsystem: \"\>", 
   "\[InvisibleSpace]", "\<\"dot\"\>"}],
  SequenceForm[
  "-----------------------\n", "Entering getUseSchedule on subsystem: ", 
   "dot"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.48101384802715*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Result : \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AA", "\[Equal]", "AlphaVars`Tuse1"}], ",", 
       RowBox[{"AB", "\[Equal]", "AlphaVars`Tuse1"}], ",", 
       RowBox[{"Ac", "\[Equal]", 
        RowBox[{"2", "+", "AlphaVars`Tuse1"}]}], ",", 
       RowBox[{"TAD1", "\[Equal]", "1"}], ",", 
       RowBox[{"TAD2", "\[Equal]", "AlphaVars`TuseExt11"}], ",", 
       RowBox[{"TAD3", "\[Equal]", "AlphaVars`TuseExt21"}], ",", 
       RowBox[{"TAD4", "\[Equal]", "AlphaVars`TuseN1"}], ",", 
       RowBox[{"TBD1", "\[Equal]", "1"}], ",", 
       RowBox[{"TBD2", "\[Equal]", "AlphaVars`TuseExt11"}], ",", 
       RowBox[{"TBD3", "\[Equal]", "AlphaVars`TuseExt21"}], ",", 
       RowBox[{"TBD4", "\[Equal]", "AlphaVars`TuseN1"}], ",", 
       RowBox[{"TcD1", "\[Equal]", "AlphaVars`TuseExt11"}], ",", 
       RowBox[{"TcD2", "\[Equal]", "AlphaVars`TuseExt21"}], ",", 
       RowBox[{"TcD3", "\[Equal]", 
        RowBox[{"1", "+", "AlphaVars`TuseN1"}]}], ",", 
       RowBox[{"TcD3", "\[GreaterEqual]", "TAD4"}], ",", 
       RowBox[{"TcD3", "\[GreaterEqual]", "TBD4"}], ",", 
       RowBox[{"AlphaVars`Tuse1", "\[GreaterEqual]", "0"}], ",", 
       RowBox[{"AlphaVars`TuseN1", "\[GreaterEqual]", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "AlphaVars`Tuse1", ",", "AlphaVars`TuseExt11", ",", 
       "AlphaVars`TuseExt21", ",", "AlphaVars`TuseN1"}], "}"}]}], "}"}]}],
  SequenceForm[
  "Result : ", {{
    Alpha`Work`AA == AlphaVars`Tuse1, Alpha`Work`AB == AlphaVars`Tuse1, 
     Alpha`Work`Ac == 2 + AlphaVars`Tuse1, Alpha`Work`TAD1 == 1, 
     Alpha`Work`TAD2 == AlphaVars`TuseExt11, Alpha`Work`TAD3 == 
     AlphaVars`TuseExt21, Alpha`Work`TAD4 == AlphaVars`TuseN1, 
     Alpha`Work`TBD1 == 1, Alpha`Work`TBD2 == AlphaVars`TuseExt11, 
     Alpha`Work`TBD3 == AlphaVars`TuseExt21, Alpha`Work`TBD4 == 
     AlphaVars`TuseN1, Alpha`Work`TcD1 == AlphaVars`TuseExt11, 
     Alpha`Work`TcD2 == AlphaVars`TuseExt21, Alpha`Work`TcD3 == 
     1 + AlphaVars`TuseN1, Alpha`Work`TcD3 >= Alpha`Work`TAD4, 
     Alpha`Work`TcD3 >= Alpha`Work`TBD4, AlphaVars`Tuse1 >= 0, 
     AlphaVars`TuseN1 >= 0}, {
    AlphaVars`Tuse1, AlphaVars`TuseExt11, AlphaVars`TuseExt21, 
     AlphaVars`TuseN1}}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.4810138480946302`*^9}}],

Cell[BoxData["\<\"Calling timeMinSchedConstraints\"\>"], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013848160614*^9}}],

Cell[BoxData["\<\"Looking for a unidimensional schedule...\"\>"], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013848230022*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Dependency constraints: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AA", "\[Equal]", "AlphaVars`Tuse1"}], ",", 
     RowBox[{"AB", "\[Equal]", "AlphaVars`Tuse1"}], ",", 
     RowBox[{"Ac", "\[Equal]", 
      RowBox[{"2", "+", "AlphaVars`Tuse1"}]}], ",", 
     RowBox[{"TAD1", "\[Equal]", "1"}], ",", 
     RowBox[{"TAD2", "\[Equal]", "AlphaVars`TuseExt11"}], ",", 
     RowBox[{"TAD3", "\[Equal]", "AlphaVars`TuseExt21"}], ",", 
     RowBox[{"TAD4", "\[Equal]", "AlphaVars`TuseN1"}], ",", 
     RowBox[{"TBD1", "\[Equal]", "1"}], ",", 
     RowBox[{"TBD2", "\[Equal]", "AlphaVars`TuseExt11"}], ",", 
     RowBox[{"TBD3", "\[Equal]", "AlphaVars`TuseExt21"}], ",", 
     RowBox[{"TBD4", "\[Equal]", "AlphaVars`TuseN1"}], ",", 
     RowBox[{"TcD1", "\[Equal]", "AlphaVars`TuseExt11"}], ",", 
     RowBox[{"TcD2", "\[Equal]", "AlphaVars`TuseExt21"}], ",", 
     RowBox[{"TcD3", "\[Equal]", 
      RowBox[{"1", "+", "AlphaVars`TuseN1"}]}], ",", 
     RowBox[{"TAD1", "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{"TAD1", "-", "TAD2"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"TAD2", "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TAD1"}], "+", "TAD2"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"TaD3", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TaD1", "+", "TaD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TaD2", "+", "TaD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TaD1", "+", "TaD2", "+", "TaD3"}], "\[GreaterEqual]", "0"}], 
     ",", 
     RowBox[{
      RowBox[{"TAD1", "-", "TAD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD2", "-", "TAD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"TAD3", "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TAD1"}], "+", "TAD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TAD2"}], "+", "TAD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TAD1"}], "+", "TAD2", "+", "TAD3"}], "\[GreaterEqual]", 
      "1"}], ",", 
     RowBox[{"TAD4", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD1", "+", "TAD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD2", "+", "TAD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD1", "+", "TAD2", "+", "TAD4"}], "\[GreaterEqual]", "0"}], 
     ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TaD3"}], "+", "TAD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD1", "-", "TaD2", "-", "TaD3", "+", "TAD4"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TaD1"}], "+", "TAD2", "-", "TaD3", "+", "TAD4"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TaD1"}], "+", "TAD1", "-", "TaD2", "+", "TAD2", "-", 
       "TaD3", "+", "TAD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD3", "+", "TAD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TAD1", "+", "TAD3", "+", "TAD4"}], "\[GreaterEqual]", "0"}], 
     ",", 
     RowBox[{
      RowBox[{"TAD2", "+", "TAD3", "+", "TAD4"}], "\[GreaterEqual]", "0"}], 
     ",", 
     RowBox[{
      RowBox[{"TAD1", "+", "TAD2", "+", "TAD3", "+", "TAD4"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TaD2"}], "-", "TaD3", "+", "TAD3", "+", "TAD4"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TaD1"}], "-", "TaD2", "+", "TAD2", "-", "TaD3", "+", 
       "TAD3", "+", "TAD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aa"}], "+", "AA", "-", "TaD1", "+", 
       RowBox[{"2", " ", "TAD1"}], "-", 
       RowBox[{"2", " ", "TaD2"}], "+", "TAD2", "-", 
       RowBox[{"2", " ", "TaD3"}], "+", "TAD3", "+", 
       RowBox[{"2", " ", "TAD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aa"}], "+", "AA", "-", "TaD1", "-", "TaD2", "+", "TAD2", 
       "-", 
       RowBox[{"2", " ", "TaD3"}], "+", "TAD3", "+", 
       RowBox[{"2", " ", "TAD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aa"}], "+", "AA", "-", "TaD1", "+", "TAD1", "-", "TaD2", 
       "+", "TAD2", "-", 
       RowBox[{"2", " ", "TaD3"}], "+", "TAD3", "+", 
       RowBox[{"2", " ", "TAD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aa"}], "+", "AA", "-", 
       RowBox[{"2", " ", "TaD1"}], "+", 
       RowBox[{"2", " ", "TAD1"}], "-", 
       RowBox[{"2", " ", "TaD2"}], "+", 
       RowBox[{"2", " ", "TAD2"}], "-", 
       RowBox[{"2", " ", "TaD3"}], "+", "TAD3", "+", 
       RowBox[{"2", " ", "TAD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aa"}], "+", "AA", "-", 
       RowBox[{"2", " ", "TaD1"}], "-", "TaD2", "+", 
       RowBox[{"2", " ", "TAD2"}], "-", 
       RowBox[{"2", " ", "TaD3"}], "+", "TAD3", "+", 
       RowBox[{"2", " ", "TAD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aa"}], "+", "AA", "-", 
       RowBox[{"2", " ", "TaD1"}], "+", "TAD1", "-", "TaD2", "+", 
       RowBox[{"2", " ", "TAD2"}], "-", 
       RowBox[{"2", " ", "TaD3"}], "+", "TAD3", "+", 
       RowBox[{"2", " ", "TAD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aa"}], "+", "AA", "-", "TaD1", "-", 
       RowBox[{"2", " ", "TaD2"}], "+", "TAD2", "-", 
       RowBox[{"2", " ", "TaD3"}], "+", 
       RowBox[{"2", " ", "TAD3"}], "+", 
       RowBox[{"2", " ", "TAD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aa"}], "+", "AA", "-", 
       RowBox[{"2", " ", "TaD1"}], "-", 
       RowBox[{"2", " ", "TaD2"}], "+", 
       RowBox[{"2", " ", "TAD2"}], "-", 
       RowBox[{"2", " ", "TaD3"}], "+", 
       RowBox[{"2", " ", "TAD3"}], "+", 
       RowBox[{"2", " ", "TAD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{"TBD2", "\[GreaterEqual]", "1"}], ",", 
     RowBox[{"TbD3", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TbD1", "+", "TbD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TbD2", "+", "TbD3"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TbD1", "+", "TbD2", "+", "TbD3"}], "\[GreaterEqual]", "0"}], 
     ",", 
     RowBox[{"TBD4", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TBD1", "+", "TBD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TBD2", "+", "TBD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TBD1", "+", "TBD2", "+", "TBD4"}], "\[GreaterEqual]", "0"}], 
     ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TbD3"}], "+", "TBD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TBD1", "-", "TbD2", "-", "TbD3", "+", "TBD4"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TbD1"}], "+", "TBD2", "-", "TbD3", "+", "TBD4"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TBD3", "+", "TBD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{"TBD1", "+", "TBD3", "+", "TBD4"}], "\[GreaterEqual]", "0"}], 
     ",", 
     RowBox[{
      RowBox[{"TBD2", "+", "TBD3", "+", "TBD4"}], "\[GreaterEqual]", "0"}], 
     ",", 
     RowBox[{
      RowBox[{"TBD1", "+", "TBD2", "+", "TBD3", "+", "TBD4"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TbD1"}], "-", "TbD3", "+", "TBD3", "+", "TBD4"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TbD2"}], "-", "TbD3", "+", "TBD3", "+", "TBD4"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TbD1"}], "+", "TBD1", "-", "TbD2", "-", "TbD3", "+", 
       "TBD3", "+", "TBD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TbD1"}], "-", "TbD2", "+", "TBD2", "-", "TbD3", "+", 
       "TBD3", "+", "TBD4"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ab"}], "+", "AB", "-", "TbD1", "+", 
       RowBox[{"2", " ", "TBD1"}], "-", 
       RowBox[{"2", " ", "TbD2"}], "+", "TBD2", "-", 
       RowBox[{"2", " ", "TbD3"}], "+", "TBD3", "+", 
       RowBox[{"2", " ", "TBD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ab"}], "+", "AB", "-", "TbD1", "-", "TbD2", "+", "TBD2", 
       "-", 
       RowBox[{"2", " ", "TbD3"}], "+", "TBD3", "+", 
       RowBox[{"2", " ", "TBD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ab"}], "+", "AB", "-", "TbD1", "+", "TBD1", "-", "TbD2", 
       "+", "TBD2", "-", 
       RowBox[{"2", " ", "TbD3"}], "+", "TBD3", "+", 
       RowBox[{"2", " ", "TBD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ab"}], "+", "AB", "-", 
       RowBox[{"2", " ", "TbD1"}], "-", "TbD2", "+", 
       RowBox[{"2", " ", "TBD2"}], "-", 
       RowBox[{"2", " ", "TbD3"}], "+", "TBD3", "+", 
       RowBox[{"2", " ", "TBD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ab"}], "+", "AB", "-", "TbD1", "-", 
       RowBox[{"2", " ", "TbD2"}], "+", "TBD2", "-", 
       RowBox[{"2", " ", "TbD3"}], "+", 
       RowBox[{"2", " ", "TBD3"}], "+", 
       RowBox[{"2", " ", "TBD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ab"}], "+", "AB", "-", 
       RowBox[{"2", " ", "TbD1"}], "+", 
       RowBox[{"2", " ", "TBD1"}], "-", 
       RowBox[{"2", " ", "TbD2"}], "+", "TBD2", "-", 
       RowBox[{"2", " ", "TbD3"}], "+", 
       RowBox[{"2", " ", "TBD3"}], "+", 
       RowBox[{"2", " ", "TBD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ab"}], "+", "AB", "-", 
       RowBox[{"2", " ", "TbD1"}], "+", "TBD1", "-", "TbD2", "+", "TBD2", "-", 
       RowBox[{"2", " ", "TbD3"}], "+", 
       RowBox[{"2", " ", "TBD3"}], "+", 
       RowBox[{"2", " ", "TBD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ab"}], "+", "AB", "-", 
       RowBox[{"2", " ", "TbD1"}], "-", 
       RowBox[{"2", " ", "TbD2"}], "+", 
       RowBox[{"2", " ", "TBD2"}], "-", 
       RowBox[{"2", " ", "TbD3"}], "+", 
       RowBox[{"2", " ", "TBD3"}], "+", 
       RowBox[{"2", " ", "TBD4"}]}], "\[GreaterEqual]", "1"}], ",", 
     RowBox[{"TcD3", "\[GreaterEqual]", "TAD4"}], ",", 
     RowBox[{"TcD3", "\[GreaterEqual]", "TBD4"}], ",", 
     RowBox[{"AlphaVars`Tuse1", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"AlphaVars`TuseN1", "\[GreaterEqual]", "0"}]}], "}"}]}],
  SequenceForm[
  "Dependency constraints: ", {
   Alpha`Work`AA == AlphaVars`Tuse1, Alpha`Work`AB == AlphaVars`Tuse1, 
    Alpha`Work`Ac == 2 + AlphaVars`Tuse1, Alpha`Work`TAD1 == 1, 
    Alpha`Work`TAD2 == AlphaVars`TuseExt11, Alpha`Work`TAD3 == 
    AlphaVars`TuseExt21, Alpha`Work`TAD4 == AlphaVars`TuseN1, Alpha`Work`TBD1 == 
    1, Alpha`Work`TBD2 == AlphaVars`TuseExt11, Alpha`Work`TBD3 == 
    AlphaVars`TuseExt21, Alpha`Work`TBD4 == AlphaVars`TuseN1, Alpha`Work`TcD1 == 
    AlphaVars`TuseExt11, Alpha`Work`TcD2 == AlphaVars`TuseExt21, 
    Alpha`Work`TcD3 == 1 + AlphaVars`TuseN1, Alpha`Work`TAD1 >= 1, 
    Alpha`Work`TAD1 - Alpha`Work`TAD2 >= 0, Alpha`Work`TAD2 >= 
    1, -Alpha`Work`TAD1 + Alpha`Work`TAD2 >= 0, Alpha`Work`TaD3 >= 0, 
    Alpha`Work`TaD1 + Alpha`Work`TaD3 >= 0, Alpha`Work`TaD2 + Alpha`Work`TaD3 >= 
    0, Alpha`Work`TaD1 + Alpha`Work`TaD2 + Alpha`Work`TaD3 >= 0, 
    Alpha`Work`TAD1 - Alpha`Work`TAD3 >= 0, Alpha`Work`TAD2 - Alpha`Work`TAD3 >= 
    0, Alpha`Work`TAD3 >= 1, -Alpha`Work`TAD1 + Alpha`Work`TAD3 >= 
    0, -Alpha`Work`TAD2 + Alpha`Work`TAD3 >= 
    0, -Alpha`Work`TAD1 + Alpha`Work`TAD2 + Alpha`Work`TAD3 >= 1, 
    Alpha`Work`TAD4 >= 0, Alpha`Work`TAD1 + Alpha`Work`TAD4 >= 0, 
    Alpha`Work`TAD2 + Alpha`Work`TAD4 >= 0, 
    Alpha`Work`TAD1 + Alpha`Work`TAD2 + Alpha`Work`TAD4 >= 
    0, -Alpha`Work`TaD3 + Alpha`Work`TAD4 >= 0, 
    Alpha`Work`TAD1 - Alpha`Work`TaD2 - Alpha`Work`TaD3 + Alpha`Work`TAD4 >= 
    0, -Alpha`Work`TaD1 + Alpha`Work`TAD2 - Alpha`Work`TaD3 + Alpha`Work`TAD4 >= 
    0, -Alpha`Work`TaD1 + Alpha`Work`TAD1 - Alpha`Work`TaD2 + Alpha`Work`TAD2 - 
     Alpha`Work`TaD3 + Alpha`Work`TAD4 >= 0, 
    Alpha`Work`TAD3 + Alpha`Work`TAD4 >= 0, 
    Alpha`Work`TAD1 + Alpha`Work`TAD3 + Alpha`Work`TAD4 >= 0, 
    Alpha`Work`TAD2 + Alpha`Work`TAD3 + Alpha`Work`TAD4 >= 0, 
    Alpha`Work`TAD1 + Alpha`Work`TAD2 + Alpha`Work`TAD3 + Alpha`Work`TAD4 >= 
    0, -Alpha`Work`TaD2 - Alpha`Work`TaD3 + Alpha`Work`TAD3 + Alpha`Work`TAD4 >= 
    0, -Alpha`Work`TaD1 - Alpha`Work`TaD2 + Alpha`Work`TAD2 - Alpha`Work`TaD3 + 
     Alpha`Work`TAD3 + Alpha`Work`TAD4 >= 
    0, -Alpha`Work`Aa + Alpha`Work`AA - Alpha`Work`TaD1 + 2 Alpha`Work`TAD1 - 
     2 Alpha`Work`TaD2 + Alpha`Work`TAD2 - 2 Alpha`Work`TaD3 + 
     Alpha`Work`TAD3 + 2 Alpha`Work`TAD4 >= 
    1, -Alpha`Work`Aa + Alpha`Work`AA - Alpha`Work`TaD1 - Alpha`Work`TaD2 + 
     Alpha`Work`TAD2 - 2 Alpha`Work`TaD3 + Alpha`Work`TAD3 + 
     2 Alpha`Work`TAD4 >= 
    1, -Alpha`Work`Aa + Alpha`Work`AA - Alpha`Work`TaD1 + Alpha`Work`TAD1 - 
     Alpha`Work`TaD2 + Alpha`Work`TAD2 - 2 Alpha`Work`TaD3 + Alpha`Work`TAD3 + 
     2 Alpha`Work`TAD4 >= 
    1, -Alpha`Work`Aa + Alpha`Work`AA - 2 Alpha`Work`TaD1 + 2 Alpha`Work`TAD1 - 
     2 Alpha`Work`TaD2 + 2 Alpha`Work`TAD2 - 2 Alpha`Work`TaD3 + 
     Alpha`Work`TAD3 + 2 Alpha`Work`TAD4 >= 
    1, -Alpha`Work`Aa + Alpha`Work`AA - 2 Alpha`Work`TaD1 - Alpha`Work`TaD2 + 
     2 Alpha`Work`TAD2 - 2 Alpha`Work`TaD3 + Alpha`Work`TAD3 + 
     2 Alpha`Work`TAD4 >= 
    1, -Alpha`Work`Aa + Alpha`Work`AA - 2 Alpha`Work`TaD1 + Alpha`Work`TAD1 - 
     Alpha`Work`TaD2 + 2 Alpha`Work`TAD2 - 2 Alpha`Work`TaD3 + 
     Alpha`Work`TAD3 + 2 Alpha`Work`TAD4 >= 
    1, -Alpha`Work`Aa + Alpha`Work`AA - Alpha`Work`TaD1 - 2 Alpha`Work`TaD2 + 
     Alpha`Work`TAD2 - 2 Alpha`Work`TaD3 + 2 Alpha`Work`TAD3 + 
     2 Alpha`Work`TAD4 >= 
    1, -Alpha`Work`Aa + Alpha`Work`AA - 2 Alpha`Work`TaD1 - 2 Alpha`Work`TaD2 + 
     2 Alpha`Work`TAD2 - 2 Alpha`Work`TaD3 + 2 Alpha`Work`TAD3 + 
     2 Alpha`Work`TAD4 >= 1, Alpha`Work`TBD2 >= 1, Alpha`Work`TbD3 >= 0, 
    Alpha`Work`TbD1 + Alpha`Work`TbD3 >= 0, Alpha`Work`TbD2 + Alpha`Work`TbD3 >= 
    0, Alpha`Work`TbD1 + Alpha`Work`TbD2 + Alpha`Work`TbD3 >= 0, 
    Alpha`Work`TBD4 >= 0, Alpha`Work`TBD1 + Alpha`Work`TBD4 >= 0, 
    Alpha`Work`TBD2 + Alpha`Work`TBD4 >= 0, 
    Alpha`Work`TBD1 + Alpha`Work`TBD2 + Alpha`Work`TBD4 >= 
    0, -Alpha`Work`TbD3 + Alpha`Work`TBD4 >= 0, 
    Alpha`Work`TBD1 - Alpha`Work`TbD2 - Alpha`Work`TbD3 + Alpha`Work`TBD4 >= 
    0, -Alpha`Work`TbD1 + Alpha`Work`TBD2 - Alpha`Work`TbD3 + Alpha`Work`TBD4 >= 
    0, Alpha`Work`TBD3 + Alpha`Work`TBD4 >= 0, 
    Alpha`Work`TBD1 + Alpha`Work`TBD3 + Alpha`Work`TBD4 >= 0, 
    Alpha`Work`TBD2 + Alpha`Work`TBD3 + Alpha`Work`TBD4 >= 0, 
    Alpha`Work`TBD1 + Alpha`Work`TBD2 + Alpha`Work`TBD3 + Alpha`Work`TBD4 >= 
    0, -Alpha`Work`TbD1 - Alpha`Work`TbD3 + Alpha`Work`TBD3 + Alpha`Work`TBD4 >= 
    0, -Alpha`Work`TbD2 - Alpha`Work`TbD3 + Alpha`Work`TBD3 + Alpha`Work`TBD4 >= 
    0, -Alpha`Work`TbD1 + Alpha`Work`TBD1 - Alpha`Work`TbD2 - Alpha`Work`TbD3 + 
     Alpha`Work`TBD3 + Alpha`Work`TBD4 >= 
    0, -Alpha`Work`TbD1 - Alpha`Work`TbD2 + Alpha`Work`TBD2 - Alpha`Work`TbD3 + 
     Alpha`Work`TBD3 + Alpha`Work`TBD4 >= 
    0, -Alpha`Work`Ab + Alpha`Work`AB - Alpha`Work`TbD1 + 2 Alpha`Work`TBD1 - 
     2 Alpha`Work`TbD2 + Alpha`Work`TBD2 - 2 Alpha`Work`TbD3 + 
     Alpha`Work`TBD3 + 2 Alpha`Work`TBD4 >= 
    1, -Alpha`Work`Ab + Alpha`Work`AB - Alpha`Work`TbD1 - Alpha`Work`TbD2 + 
     Alpha`Work`TBD2 - 2 Alpha`Work`TbD3 + Alpha`Work`TBD3 + 
     2 Alpha`Work`TBD4 >= 
    1, -Alpha`Work`Ab + Alpha`Work`AB - Alpha`Work`TbD1 + Alpha`Work`TBD1 - 
     Alpha`Work`TbD2 + Alpha`Work`TBD2 - 2 Alpha`Work`TbD3 + Alpha`Work`TBD3 + 
     2 Alpha`Work`TBD4 >= 
    1, -Alpha`Work`Ab + Alpha`Work`AB - 2 Alpha`Work`TbD1 - Alpha`Work`TbD2 + 
     2 Alpha`Work`TBD2 - 2 Alpha`Work`TbD3 + Alpha`Work`TBD3 + 
     2 Alpha`Work`TBD4 >= 
    1, -Alpha`Work`Ab + Alpha`Work`AB - Alpha`Work`TbD1 - 2 Alpha`Work`TbD2 + 
     Alpha`Work`TBD2 - 2 Alpha`Work`TbD3 + 2 Alpha`Work`TBD3 + 
     2 Alpha`Work`TBD4 >= 
    1, -Alpha`Work`Ab + Alpha`Work`AB - 2 Alpha`Work`TbD1 + 2 Alpha`Work`TBD1 - 
     2 Alpha`Work`TbD2 + Alpha`Work`TBD2 - 2 Alpha`Work`TbD3 + 
     2 Alpha`Work`TBD3 + 2 Alpha`Work`TBD4 >= 
    1, -Alpha`Work`Ab + Alpha`Work`AB - 2 Alpha`Work`TbD1 + Alpha`Work`TBD1 - 
     Alpha`Work`TbD2 + Alpha`Work`TBD2 - 2 Alpha`Work`TbD3 + 
     2 Alpha`Work`TBD3 + 2 Alpha`Work`TBD4 >= 
    1, -Alpha`Work`Ab + Alpha`Work`AB - 2 Alpha`Work`TbD1 - 2 Alpha`Work`TbD2 + 
     2 Alpha`Work`TBD2 - 2 Alpha`Work`TbD3 + 2 Alpha`Work`TBD3 + 
     2 Alpha`Work`TBD4 >= 1, Alpha`Work`TcD3 >= Alpha`Work`TAD4, 
    Alpha`Work`TcD3 >= Alpha`Work`TBD4, AlphaVars`Tuse1 >= 0, 
    AlphaVars`TuseN1 >= 0}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013848300371*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Optimisation constraints: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", "TaD3"}], "+", "TN"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TaD1"}], "-", "TaD3", "+", "TN"}], "\[GreaterEqual]", 
      "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TaD2"}], "-", "TaD3", "+", "TN"}], "\[GreaterEqual]", 
      "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TaD1"}], "-", "TaD2", "-", "TaD3", "+", "TN"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TAD4"}], "+", "TN"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TAD1"}], "-", "TAD4", "+", "TN"}], "\[GreaterEqual]", 
      "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TAD2"}], "-", "TAD4", "+", "TN"}], "\[GreaterEqual]", 
      "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TAD1"}], "-", "TAD2", "-", "TAD4", "+", "TN"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TAD3"}], "-", "TAD4", "+", "TN"}], "\[GreaterEqual]", 
      "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TAD1"}], "-", "TAD3", "-", "TAD4", "+", "TN"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TAD2"}], "-", "TAD3", "-", "TAD4", "+", "TN"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TAD1"}], "-", "TAD2", "-", "TAD3", "-", "TAD4", "+", 
       "TN"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TbD3"}], "+", "TN"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TbD1"}], "-", "TbD3", "+", "TN"}], "\[GreaterEqual]", 
      "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TbD2"}], "-", "TbD3", "+", "TN"}], "\[GreaterEqual]", 
      "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TbD1"}], "-", "TbD2", "-", "TbD3", "+", "TN"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TBD4"}], "+", "TN"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TBD1"}], "-", "TBD4", "+", "TN"}], "\[GreaterEqual]", 
      "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TBD2"}], "-", "TBD4", "+", "TN"}], "\[GreaterEqual]", 
      "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TBD1"}], "-", "TBD2", "-", "TBD4", "+", "TN"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TBD3"}], "-", "TBD4", "+", "TN"}], "\[GreaterEqual]", 
      "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TBD1"}], "-", "TBD3", "-", "TBD4", "+", "TN"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TBD2"}], "-", "TBD3", "-", "TBD4", "+", "TN"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TBD1"}], "-", "TBD2", "-", "TBD3", "-", "TBD4", "+", 
       "TN"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TcD3"}], "+", "TN"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TcD1"}], "-", "TcD3", "+", "TN"}], "\[GreaterEqual]", 
      "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TcD2"}], "-", "TcD3", "+", "TN"}], "\[GreaterEqual]", 
      "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "TcD1"}], "-", "TcD2", "-", "TcD3", "+", "TN"}], 
      "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aa"}], "+", "aparam", "-", 
       RowBox[{"2", " ", "TaD1"}], "-", 
       RowBox[{"2", " ", "TaD2"}], "-", 
       RowBox[{"2", " ", "TaD3"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aa"}], "+", "aparam", "-", "TaD1", "-", 
       RowBox[{"2", " ", "TaD2"}], "-", 
       RowBox[{"2", " ", "TaD3"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aa"}], "+", "aparam", "-", 
       RowBox[{"2", " ", "TaD1"}], "-", "TaD2", "-", 
       RowBox[{"2", " ", "TaD3"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Aa"}], "+", "aparam", "-", "TaD1", "-", "TaD2", "-", 
       RowBox[{"2", " ", "TaD3"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "AA"}], "+", "aparam", "-", 
       RowBox[{"2", " ", "TAD2"}], "-", 
       RowBox[{"2", " ", "TAD3"}], "-", 
       RowBox[{"2", " ", "TAD4"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "AA"}], "+", "aparam", "-", 
       RowBox[{"2", " ", "TAD1"}], "-", 
       RowBox[{"2", " ", "TAD2"}], "-", 
       RowBox[{"2", " ", "TAD3"}], "-", 
       RowBox[{"2", " ", "TAD4"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "AA"}], "+", "aparam", "-", "TAD2", "-", 
       RowBox[{"2", " ", "TAD3"}], "-", 
       RowBox[{"2", " ", "TAD4"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "AA"}], "+", "aparam", "-", 
       RowBox[{"2", " ", "TAD1"}], "-", "TAD2", "-", 
       RowBox[{"2", " ", "TAD3"}], "-", 
       RowBox[{"2", " ", "TAD4"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "AA"}], "+", "aparam", "-", 
       RowBox[{"2", " ", "TAD2"}], "-", "TAD3", "-", 
       RowBox[{"2", " ", "TAD4"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "AA"}], "+", "aparam", "-", 
       RowBox[{"2", " ", "TAD1"}], "-", 
       RowBox[{"2", " ", "TAD2"}], "-", "TAD3", "-", 
       RowBox[{"2", " ", "TAD4"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "AA"}], "+", "aparam", "-", "TAD2", "-", "TAD3", "-", 
       RowBox[{"2", " ", "TAD4"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "AA"}], "+", "aparam", "-", 
       RowBox[{"2", " ", "TAD1"}], "-", "TAD2", "-", "TAD3", "-", 
       RowBox[{"2", " ", "TAD4"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ab"}], "+", "aparam", "-", 
       RowBox[{"2", " ", "TbD1"}], "-", 
       RowBox[{"2", " ", "TbD2"}], "-", 
       RowBox[{"2", " ", "TbD3"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ab"}], "+", "aparam", "-", "TbD1", "-", 
       RowBox[{"2", " ", "TbD2"}], "-", 
       RowBox[{"2", " ", "TbD3"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ab"}], "+", "aparam", "-", 
       RowBox[{"2", " ", "TbD1"}], "-", "TbD2", "-", 
       RowBox[{"2", " ", "TbD3"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ab"}], "+", "aparam", "-", "TbD1", "-", "TbD2", "-", 
       RowBox[{"2", " ", "TbD3"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "AB"}], "+", "aparam", "-", 
       RowBox[{"2", " ", "TBD2"}], "-", 
       RowBox[{"2", " ", "TBD3"}], "-", 
       RowBox[{"2", " ", "TBD4"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "AB"}], "+", "aparam", "-", 
       RowBox[{"2", " ", "TBD1"}], "-", 
       RowBox[{"2", " ", "TBD2"}], "-", 
       RowBox[{"2", " ", "TBD3"}], "-", 
       RowBox[{"2", " ", "TBD4"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "AB"}], "+", "aparam", "-", "TBD2", "-", 
       RowBox[{"2", " ", "TBD3"}], "-", 
       RowBox[{"2", " ", "TBD4"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "AB"}], "+", "aparam", "-", 
       RowBox[{"2", " ", "TBD1"}], "-", "TBD2", "-", 
       RowBox[{"2", " ", "TBD3"}], "-", 
       RowBox[{"2", " ", "TBD4"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "AB"}], "+", "aparam", "-", 
       RowBox[{"2", " ", "TBD2"}], "-", "TBD3", "-", 
       RowBox[{"2", " ", "TBD4"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "AB"}], "+", "aparam", "-", 
       RowBox[{"2", " ", "TBD1"}], "-", 
       RowBox[{"2", " ", "TBD2"}], "-", "TBD3", "-", 
       RowBox[{"2", " ", "TBD4"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "AB"}], "+", "aparam", "-", "TBD2", "-", "TBD3", "-", 
       RowBox[{"2", " ", "TBD4"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "AB"}], "+", "aparam", "-", 
       RowBox[{"2", " ", "TBD1"}], "-", "TBD2", "-", "TBD3", "-", 
       RowBox[{"2", " ", "TBD4"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ac"}], "+", "aparam", "-", 
       RowBox[{"2", " ", "TcD1"}], "-", 
       RowBox[{"2", " ", "TcD2"}], "-", 
       RowBox[{"2", " ", "TcD3"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ac"}], "+", "aparam", "-", "TcD1", "-", 
       RowBox[{"2", " ", "TcD2"}], "-", 
       RowBox[{"2", " ", "TcD3"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ac"}], "+", "aparam", "-", 
       RowBox[{"2", " ", "TcD1"}], "-", "TcD2", "-", 
       RowBox[{"2", " ", "TcD3"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "Ac"}], "+", "aparam", "-", "TcD1", "-", "TcD2", "-", 
       RowBox[{"2", " ", "TcD3"}], "+", 
       RowBox[{"2", " ", "TN"}]}], "\[GreaterEqual]", "0"}]}], "}"}]}],
  SequenceForm[
  "Optimisation constraints: ", {-Alpha`Work`TaD3 + Alpha`Work`TN >= 
    0, -Alpha`Work`TaD1 - Alpha`Work`TaD3 + Alpha`Work`TN >= 
    0, -Alpha`Work`TaD2 - Alpha`Work`TaD3 + Alpha`Work`TN >= 
    0, -Alpha`Work`TaD1 - Alpha`Work`TaD2 - Alpha`Work`TaD3 + Alpha`Work`TN >= 
    0, -Alpha`Work`TAD4 + Alpha`Work`TN >= 
    0, -Alpha`Work`TAD1 - Alpha`Work`TAD4 + Alpha`Work`TN >= 
    0, -Alpha`Work`TAD2 - Alpha`Work`TAD4 + Alpha`Work`TN >= 
    0, -Alpha`Work`TAD1 - Alpha`Work`TAD2 - Alpha`Work`TAD4 + Alpha`Work`TN >= 
    0, -Alpha`Work`TAD3 - Alpha`Work`TAD4 + Alpha`Work`TN >= 
    0, -Alpha`Work`TAD1 - Alpha`Work`TAD3 - Alpha`Work`TAD4 + Alpha`Work`TN >= 
    0, -Alpha`Work`TAD2 - Alpha`Work`TAD3 - Alpha`Work`TAD4 + Alpha`Work`TN >= 
    0, -Alpha`Work`TAD1 - Alpha`Work`TAD2 - Alpha`Work`TAD3 - Alpha`Work`TAD4 + 
     Alpha`Work`TN >= 0, -Alpha`Work`TbD3 + Alpha`Work`TN >= 
    0, -Alpha`Work`TbD1 - Alpha`Work`TbD3 + Alpha`Work`TN >= 
    0, -Alpha`Work`TbD2 - Alpha`Work`TbD3 + Alpha`Work`TN >= 
    0, -Alpha`Work`TbD1 - Alpha`Work`TbD2 - Alpha`Work`TbD3 + Alpha`Work`TN >= 
    0, -Alpha`Work`TBD4 + Alpha`Work`TN >= 
    0, -Alpha`Work`TBD1 - Alpha`Work`TBD4 + Alpha`Work`TN >= 
    0, -Alpha`Work`TBD2 - Alpha`Work`TBD4 + Alpha`Work`TN >= 
    0, -Alpha`Work`TBD1 - Alpha`Work`TBD2 - Alpha`Work`TBD4 + Alpha`Work`TN >= 
    0, -Alpha`Work`TBD3 - Alpha`Work`TBD4 + Alpha`Work`TN >= 
    0, -Alpha`Work`TBD1 - Alpha`Work`TBD3 - Alpha`Work`TBD4 + Alpha`Work`TN >= 
    0, -Alpha`Work`TBD2 - Alpha`Work`TBD3 - Alpha`Work`TBD4 + Alpha`Work`TN >= 
    0, -Alpha`Work`TBD1 - Alpha`Work`TBD2 - Alpha`Work`TBD3 - Alpha`Work`TBD4 + 
     Alpha`Work`TN >= 0, -Alpha`Work`TcD3 + Alpha`Work`TN >= 
    0, -Alpha`Work`TcD1 - Alpha`Work`TcD3 + Alpha`Work`TN >= 
    0, -Alpha`Work`TcD2 - Alpha`Work`TcD3 + Alpha`Work`TN >= 
    0, -Alpha`Work`TcD1 - Alpha`Work`TcD2 - Alpha`Work`TcD3 + Alpha`Work`TN >= 
    0, -Alpha`Work`Aa + Alpha`Work`aparam - 2 Alpha`Work`TaD1 - 2 
     Alpha`Work`TaD2 - 2 Alpha`Work`TaD3 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`Aa + Alpha`Work`aparam - Alpha`Work`TaD1 - 2 
     Alpha`Work`TaD2 - 2 Alpha`Work`TaD3 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`Aa + Alpha`Work`aparam - 2 Alpha`Work`TaD1 - 
     Alpha`Work`TaD2 - 2 Alpha`Work`TaD3 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`Aa + Alpha`Work`aparam - Alpha`Work`TaD1 - Alpha`Work`TaD2 - 
     2 Alpha`Work`TaD3 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`AA + Alpha`Work`aparam - 2 Alpha`Work`TAD2 - 2 
     Alpha`Work`TAD3 - 2 Alpha`Work`TAD4 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`AA + Alpha`Work`aparam - 2 Alpha`Work`TAD1 - 2 
     Alpha`Work`TAD2 - 2 Alpha`Work`TAD3 - 2 Alpha`Work`TAD4 + 
     2 Alpha`Work`TN >= 
    0, -Alpha`Work`AA + Alpha`Work`aparam - Alpha`Work`TAD2 - 2 
     Alpha`Work`TAD3 - 2 Alpha`Work`TAD4 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`AA + Alpha`Work`aparam - 2 Alpha`Work`TAD1 - 
     Alpha`Work`TAD2 - 2 Alpha`Work`TAD3 - 2 Alpha`Work`TAD4 + 
     2 Alpha`Work`TN >= 
    0, -Alpha`Work`AA + Alpha`Work`aparam - 2 Alpha`Work`TAD2 - 
     Alpha`Work`TAD3 - 2 Alpha`Work`TAD4 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`AA + Alpha`Work`aparam - 2 Alpha`Work`TAD1 - 2 
     Alpha`Work`TAD2 - Alpha`Work`TAD3 - 2 Alpha`Work`TAD4 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`AA + Alpha`Work`aparam - Alpha`Work`TAD2 - Alpha`Work`TAD3 - 
     2 Alpha`Work`TAD4 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`AA + Alpha`Work`aparam - 2 Alpha`Work`TAD1 - 
     Alpha`Work`TAD2 - Alpha`Work`TAD3 - 2 Alpha`Work`TAD4 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`Ab + Alpha`Work`aparam - 2 Alpha`Work`TbD1 - 2 
     Alpha`Work`TbD2 - 2 Alpha`Work`TbD3 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`Ab + Alpha`Work`aparam - Alpha`Work`TbD1 - 2 
     Alpha`Work`TbD2 - 2 Alpha`Work`TbD3 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`Ab + Alpha`Work`aparam - 2 Alpha`Work`TbD1 - 
     Alpha`Work`TbD2 - 2 Alpha`Work`TbD3 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`Ab + Alpha`Work`aparam - Alpha`Work`TbD1 - Alpha`Work`TbD2 - 
     2 Alpha`Work`TbD3 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`AB + Alpha`Work`aparam - 2 Alpha`Work`TBD2 - 2 
     Alpha`Work`TBD3 - 2 Alpha`Work`TBD4 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`AB + Alpha`Work`aparam - 2 Alpha`Work`TBD1 - 2 
     Alpha`Work`TBD2 - 2 Alpha`Work`TBD3 - 2 Alpha`Work`TBD4 + 
     2 Alpha`Work`TN >= 
    0, -Alpha`Work`AB + Alpha`Work`aparam - Alpha`Work`TBD2 - 2 
     Alpha`Work`TBD3 - 2 Alpha`Work`TBD4 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`AB + Alpha`Work`aparam - 2 Alpha`Work`TBD1 - 
     Alpha`Work`TBD2 - 2 Alpha`Work`TBD3 - 2 Alpha`Work`TBD4 + 
     2 Alpha`Work`TN >= 
    0, -Alpha`Work`AB + Alpha`Work`aparam - 2 Alpha`Work`TBD2 - 
     Alpha`Work`TBD3 - 2 Alpha`Work`TBD4 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`AB + Alpha`Work`aparam - 2 Alpha`Work`TBD1 - 2 
     Alpha`Work`TBD2 - Alpha`Work`TBD3 - 2 Alpha`Work`TBD4 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`AB + Alpha`Work`aparam - Alpha`Work`TBD2 - Alpha`Work`TBD3 - 
     2 Alpha`Work`TBD4 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`AB + Alpha`Work`aparam - 2 Alpha`Work`TBD1 - 
     Alpha`Work`TBD2 - Alpha`Work`TBD3 - 2 Alpha`Work`TBD4 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`Ac + Alpha`Work`aparam - 2 Alpha`Work`TcD1 - 2 
     Alpha`Work`TcD2 - 2 Alpha`Work`TcD3 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`Ac + Alpha`Work`aparam - Alpha`Work`TcD1 - 2 
     Alpha`Work`TcD2 - 2 Alpha`Work`TcD3 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`Ac + Alpha`Work`aparam - 2 Alpha`Work`TcD1 - 
     Alpha`Work`TcD2 - 2 Alpha`Work`TcD3 + 2 Alpha`Work`TN >= 
    0, -Alpha`Work`Ac + Alpha`Work`aparam - Alpha`Work`TcD1 - Alpha`Work`TcD2 - 
     2 Alpha`Work`TcD3 + 2 Alpha`Work`TN >= 0}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013848351871*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Additional objective function: \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"-", "21"}], "-", 
    RowBox[{"12", " ", "Aa"}], "-", 
    RowBox[{"12", " ", "Ab"}], "-", 
    RowBox[{"4", " ", "Ac"}], "+", 
    RowBox[{"28", " ", "aparam"}], "-", 
    RowBox[{"21", " ", "TaD1"}], "-", 
    RowBox[{"22", " ", "TaD2"}], "+", 
    RowBox[{"5", " ", "TAD2"}], "-", 
    RowBox[{"30", " ", "TaD3"}], "+", 
    RowBox[{"2", " ", "TAD3"}], "+", 
    RowBox[{"5", " ", "TAD4"}], "-", 
    RowBox[{"22", " ", "TbD1"}], "-", 
    RowBox[{"22", " ", "TbD2"}], "+", "TBD2", "-", 
    RowBox[{"31", " ", "TbD3"}], "+", 
    RowBox[{"4", " ", "TBD3"}], "+", 
    RowBox[{"6", " ", "TBD4"}], "-", 
    RowBox[{"8", " ", "TcD1"}], "-", 
    RowBox[{"8", " ", "TcD2"}], "-", 
    RowBox[{"10", " ", "TcD3"}], "+", 
    RowBox[{"84", " ", "TN"}], "+", "AlphaVars`Tuse1", "+", 
    "AlphaVars`TuseN1"}]}],
  SequenceForm[
  "Additional objective function: ", -21 - 12 Alpha`Work`Aa - 12 
   Alpha`Work`Ab - 4 Alpha`Work`Ac + 28 Alpha`Work`aparam - 21 
   Alpha`Work`TaD1 - 22 Alpha`Work`TaD2 + 5 Alpha`Work`TAD2 - 30 
   Alpha`Work`TaD3 + 2 Alpha`Work`TAD3 + 5 Alpha`Work`TAD4 - 22 
   Alpha`Work`TbD1 - 22 Alpha`Work`TbD2 + Alpha`Work`TBD2 - 31 
   Alpha`Work`TbD3 + 4 Alpha`Work`TBD3 + 6 Alpha`Work`TBD4 - 8 
   Alpha`Work`TcD1 - 8 Alpha`Work`TcD2 - 10 Alpha`Work`TcD3 + 
   84 Alpha`Work`TN + AlphaVars`Tuse1 + AlphaVars`TuseN1],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013848399701*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "21"}], "-", 
  RowBox[{"12", " ", "Aa"}], "-", 
  RowBox[{"12", " ", "Ab"}], "-", 
  RowBox[{"4", " ", "Ac"}], "+", 
  RowBox[{"28", " ", "aparam"}], "-", 
  RowBox[{"21", " ", "TaD1"}], "-", 
  RowBox[{"22", " ", "TaD2"}], "+", 
  RowBox[{"5", " ", "TAD2"}], "-", 
  RowBox[{"30", " ", "TaD3"}], "+", 
  RowBox[{"2", " ", "TAD3"}], "+", 
  RowBox[{"5", " ", "TAD4"}], "-", 
  RowBox[{"22", " ", "TbD1"}], "-", 
  RowBox[{"22", " ", "TbD2"}], "+", "TBD2", "-", 
  RowBox[{"31", " ", "TbD3"}], "+", 
  RowBox[{"4", " ", "TBD3"}], "+", 
  RowBox[{"6", " ", "TBD4"}], "-", 
  RowBox[{"8", " ", "TcD1"}], "-", 
  RowBox[{"8", " ", "TcD2"}], "-", 
  RowBox[{"10", " ", "TcD3"}], "+", 
  RowBox[{"85", " ", "TN"}], "+", "AlphaVars`Tuse1", "+", 
  "AlphaVars`TuseN1"}]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013848462344*^9}}],

Cell[BoxData["\<\"Method Minimize\"\>"], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013848527986*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "155", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "28", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   "0.10913399999998319`"}],
  SequenceForm[155, " constraints, ", 28, " variables ", 0.10913399999998319`],
  Editable->False]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.4810138485950212`*^9}}],

Cell[BoxData["\<\"Solution to simplex :\"\>"], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.48101384866184*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"205", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Aa", "\[Rule]", 
      RowBox[{"-", "1"}]}], ",", 
     RowBox[{"AA", "\[Rule]", "0"}], ",", 
     RowBox[{"Ab", "\[Rule]", 
      RowBox[{"-", "1"}]}], ",", 
     RowBox[{"AB", "\[Rule]", "0"}], ",", 
     RowBox[{"Ac", "\[Rule]", "2"}], ",", 
     RowBox[{"aparam", "\[Rule]", "2"}], ",", 
     RowBox[{"TaD1", "\[Rule]", "1"}], ",", 
     RowBox[{"TAD1", "\[Rule]", "1"}], ",", 
     RowBox[{"TaD2", "\[Rule]", "1"}], ",", 
     RowBox[{"TAD2", "\[Rule]", "1"}], ",", 
     RowBox[{"TaD3", "\[Rule]", "0"}], ",", 
     RowBox[{"TAD3", "\[Rule]", "1"}], ",", 
     RowBox[{"TAD4", "\[Rule]", "0"}], ",", 
     RowBox[{"TbD1", "\[Rule]", "1"}], ",", 
     RowBox[{"TBD1", "\[Rule]", "1"}], ",", 
     RowBox[{"TbD2", "\[Rule]", "1"}], ",", 
     RowBox[{"TBD2", "\[Rule]", "1"}], ",", 
     RowBox[{"TbD3", "\[Rule]", "0"}], ",", 
     RowBox[{"TBD3", "\[Rule]", "1"}], ",", 
     RowBox[{"TBD4", "\[Rule]", "0"}], ",", 
     RowBox[{"TcD1", "\[Rule]", "1"}], ",", 
     RowBox[{"TcD2", "\[Rule]", "1"}], ",", 
     RowBox[{"TcD3", "\[Rule]", "1"}], ",", 
     RowBox[{"TN", "\[Rule]", "3"}], ",", 
     RowBox[{"AlphaVars`Tuse1", "\[Rule]", "0"}], ",", 
     RowBox[{"AlphaVars`TuseExt11", "\[Rule]", "1"}], ",", 
     RowBox[{"AlphaVars`TuseExt21", "\[Rule]", "1"}], ",", 
     RowBox[{"AlphaVars`TuseN1", "\[Rule]", "0"}]}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013848728963*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"matmult\"\>", ",", "28", ",", "139", ",", 
   "0.10913399999998319`", ",", "\<\"Vertex\"\>", ",", "\<\"Structured\"\>"}],
   "}"}]], "Print",
 CellChangeTimes->{{3.481013839432765*^9, 3.481013848802607*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"matmult\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"a\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "1"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", "0"}], 
        "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"b\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "1"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"B\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", "0"}], 
        "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"c\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", "2"}], "]"}]}], 
      "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2"}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.481013848862947*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<matmult\>\"", "]"}], ";"}], "\n", 
 RowBox[{"structSched", "[", "]"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Checking options...\"\>"], "Print",
 CellChangeTimes->{3.481013851588346*^9}],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print",
 CellChangeTimes->{3.481013851679441*^9}],

Cell[BoxData["\<\"Building LP...\"\>"], "Print",
 CellChangeTimes->{3.481013851819717*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "10", "\[InvisibleSpace]", "\<\" Recognized added Constraints: \"\>"}],
  SequenceForm[10, " Recognized added Constraints: "],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013851876542*^9}],

Cell[BoxData["\<\"   -1 + TAD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4810138519329844`*^9}],

Cell[BoxData["\<\"   -CA + CB = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013851997621*^9}],

Cell[BoxData["\<\"   -1 + TBD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4810138520675*^9}],

Cell[BoxData["\<\"   -TAD4 + TBD4 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013852134035*^9}],

Cell[BoxData["\<\"   -2 - CA + Cc = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013852216558*^9}],

Cell[BoxData["\<\"   -1 - TAD4 + TcD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013852284936*^9}],

Cell[BoxData["\<\"   -TAD2 + TBD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013852351159*^9}],

Cell[BoxData["\<\"   -TAD3 + TBD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.48101385242393*^9}],

Cell[BoxData["\<\"   -TAD2 + TcD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013852484345*^9}],

Cell[BoxData["\<\"   -TAD3 + TcD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013852551777*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "124", 
   "\[InvisibleSpace]", "\<\"\\n\\t\\t\\t   variables, \"\>", 
   "\[InvisibleSpace]", "132", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 124, "\n\t\t\t   variables, ", 132, " Constraints"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4810138526182823`*^9}],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print",
 CellChangeTimes->{3.4810138526851883`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Writing line \"\>", "\[InvisibleSpace]", "100"}],
  SequenceForm["Writing line ", 100],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013852752995*^9}],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print",
 CellChangeTimes->{3.481013852818461*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Total execution Time: \"\>", "\[InvisibleSpace]", 
   RowBox[{"1", "+", 
    RowBox[{"3", " ", "\<\"N\"\>"}]}]}],
  SequenceForm["Total execution Time: ", 1 + 3 "N"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013852885886*^9}],

Cell[BoxData["\<\"T_a{i, j, N} = 0\\nT_b{i, j, N} = 0\\nT_c{i, j, N} = 1 + i \
+ j + N\\nT_A{k, i, j, N} = -1 + i + j + k\\nT_B{k, i, j, N} = -1 + i + j + k\
\"\>"], "Print",
 CellChangeTimes->{3.4810138529583607`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"matmult\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"a\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"b\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"c\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", "1"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "1"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"B\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "1"}]}], "]"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.4810138530212173`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"showSchedResult", "[", "]"}]], "Input"],

Cell[BoxData["\<\"T_a{i, j, N} = 0\\nT_b{i, j, N} = 0\\nT_c{i, j, N} = 1 + i \
+ j + N\\nT_A{k, i, j, N} = -1 + i + j + k\\nT_B{k, i, j, N} = -1 + i + j + k\
\"\>"], "Print",
 CellChangeTimes->{3.4810138554106216`*^9}]
}, Open  ]],

Cell["\<\
The result is the normal schedule for the systolic matrix multiplication \
algorithm. \
\>", "Text",
 TextAlignment->Left,
 TextJustification->1],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input"],

Cell[BoxData["\<\"system matmult :{N | 2<=N}\\n               (a : {i,j | \
1<=i<=N; 1<=j<=N} of integer; \\n                b : {i,j | 1<=i<=N; 1<=j<=N} \
of integer)\\n       returns (c : {i,j | 1<=i<=N; 1<=j<=N} of integer);\\nvar\
\\n  A : {k,i,j | 0<=k<=N; 1<=i<=N; 1<=j<=N} of integer;\\n  B : {k,i,j | \
0<=k<=N; 1<=i<=N; 1<=j<=N} of integer;\\nlet\\n  A[k,i,j] = \\n      case\\n  \
      { | k=0} : a[i,j];\\n        { | 1<=k; 2<=j} : A[i,j-1,k];\\n        { \
| 1<=k; j=1} : a[i,k];\\n      esac;\\n  B[k,i,j] = \\n      case\\n        { \
| k=0} : b[i,j];\\n        { | 1<=k; 2<=i} : B[k,i-1,j];\\n        { | 1<=k; \
i=1} : b[j,k];\\n      esac;\\n  use {i,j | 1<=i<=N; 1<=j<=N} dot[N] (A, B) \
returns  (c) ;\\ntel;\"\>"], "Print",
 CellChangeTimes->{3.4810138589158983`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"scd", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Periods: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "}"}]}],
  SequenceForm["Periods: ", {}],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013860080212*^9}],

Cell[BoxData["\<\"Method Minimize\"\>"], "Print",
 CellChangeTimes->{3.4810138601815243`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "153", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "28", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   "0.09799299999997402`"}],
  SequenceForm[153, " constraints, ", 28, " variables ", 0.09799299999997402],
  Editable->False]], "Print",
 CellChangeTimes->{3.4810138602843037`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"matmult\"\>", ",", "28", ",", "138", ",", 
   "0.09799299999997402`", ",", "\<\"Vertex\"\>", ",", "\<\"Structured\"\>"}],
   "}"}]], "Print",
 CellChangeTimes->{3.4810138603341208`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"matmult\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"a\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "1"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", "0"}], 
        "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"b\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "1"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"B\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", "0"}], 
        "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"c\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", "2"}], "]"}]}], 
      "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2"}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.481013860401576*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["The full adder example, using scd",
 FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell["\<\
Here, we schedule an adder (Plus) using a full adder elementary cell.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<fulladder.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[BoxData["\<\"[FullAdder][Plus]\"\>"], "Print",
 CellChangeTimes->{3.481013868064699*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<FullAdder\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"scd", "[", "]"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Method Minimize\"\>"], "Print",
 CellChangeTimes->{3.481013869010166*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "12", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "6", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   "0.001449000000036449`"}],
  SequenceForm[12, " constraints, ", 6, " variables ", 0.001449000000036449],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013869012261*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"FullAdder\"\>", ",", "6", ",", "11", ",", 
   "0.001449000000036449`", ",", "\<\"Vertex\"\>", ",", "\<\"Flat\"\>"}], 
  "}"}]], "Print",
 CellChangeTimes->{3.481013869015465*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"FullAdder\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"B\"\>", ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Cin\"\>", ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Cout\"\>", ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"X\"\>", ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", "1"}], "]"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", "1", "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.481013869019912*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input"],

Cell[BoxData["\<\"system FullAdder (A :  boolean; \\n                  B :  \
boolean; \\n                  Cin :  boolean)\\n       returns   (X :  \
boolean; \\n                  Cout :  boolean);\\nlet\\n  X[] = A xor B xor \
Cin;\\n  Cout[] = A and B or A and Cin or B and Cin;\\ntel;\"\>"], "Print",
 CellChangeTimes->{3.481013870401866*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"saveScheduleLibrary", "[", 
   RowBox[{"onlyMainSystem", "\[Rule]", "True"}], "]"}], ";"}]], "Input"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Schedule(s) were saved in file \"\>", 
   "\[InvisibleSpace]", "\<\"FullAdder.scdlib\"\>"}],
  SequenceForm["Schedule(s) were saved in file ", "FullAdder.scdlib"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013873457727*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$scheduleLibrary", "=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"loadScheduleLibrary", "[", "\"\<FullAdder\>\"", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"scheduleResult", "[", 
   RowBox[{"\<\"FullAdder\"\>", ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"A\"\>", ",", 
        RowBox[{"{", "}"}], ",", 
        RowBox[{"sched", "[", 
         RowBox[{
          RowBox[{"{", "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\<\"B\"\>", ",", 
        RowBox[{"{", "}"}], ",", 
        RowBox[{"sched", "[", 
         RowBox[{
          RowBox[{"{", "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\<\"Cin\"\>", ",", 
        RowBox[{"{", "}"}], ",", 
        RowBox[{"sched", "[", 
         RowBox[{
          RowBox[{"{", "}"}], ",", "0"}], "]"}]}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"X\"\>", ",", 
        RowBox[{"{", "}"}], ",", 
        RowBox[{"sched", "[", 
         RowBox[{
          RowBox[{"{", "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\<\"Cout\"\>", ",", 
        RowBox[{"{", "}"}], ",", 
        RowBox[{"sched", "[", 
         RowBox[{
          RowBox[{"{", "}"}], ",", "1"}], "]"}]}], "}"}]}], "}"}]}], "]"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.481013877732045*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<Plus\>\"", "]"}], ";", 
  RowBox[{"show", "[", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"scd", "[", "]"}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"system Plus :  {W | 2<=W}\\n               (A : {b | \
0<=b<=W} of boolean; \\n                B : {b | 0<=b<=W} of boolean)\\n      \
 returns (S : {b | 0<=b<=W} of boolean);\\nvar\\n  Cin : {b | 0<=b<=W-1} of \
boolean;\\n  Cout : {b | 0<=b<=W-1} of boolean;\\n  X : {b | 0<=b<=W-1} of \
boolean;\\nlet\\n  use {b | 0<=b<=W-1} FullAdder.(b->) (A, B, Cin) returns  \
(X, Cout) ;\\n  Cin = \\n      case\\n        {b | b=0} : False.(b->);\\n     \
   {b | 1<=b} : Cout.(b->b-1);\\n      esac;\\n  S = case\\n        {b | \
b<=W-1} : X.(b->b);\\n        {b | b=W} : Cout.(b->W-1);\\n      esac;\\ntel;\
\"\>"], "Print",
 CellChangeTimes->{3.481013878865653*^9}],

Cell[BoxData["\<\"Method Minimize\"\>"], "Print",
 CellChangeTimes->{3.481013879015184*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "70", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "23", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   "0.01859999999999218`"}],
  SequenceForm[70, " constraints, ", 23, " variables ", 0.01859999999999218],
  Editable->False]], "Print",
 CellChangeTimes->{3.4810138790762978`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Plus\"\>", ",", "23", ",", "59", ",", "0.01859999999999218`", 
   ",", "\<\"Vertex\"\>", ",", "\<\"Structured\"\>"}], "}"}]], "Print",
 CellChangeTimes->{3.481013879131229*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"saveScheduleLibrary", "[", 
   RowBox[{"onlyMainSystem", "\[Rule]", "True"}], "]"}], ";"}]], "Input"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Schedule(s) were saved in file \"\>", 
   "\[InvisibleSpace]", "\<\"Plus.scdlib\"\>"}],
  SequenceForm["Schedule(s) were saved in file ", "Plus.scdlib"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4810138803686237`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"show", "[", 
  RowBox[{"dep", "[", "]"}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"-- Regular dependencies:\"\>"], "Print",
 CellChangeTimes->{3.481013881745636*^9}],

Cell[BoxData["\<\"{b,W | 1<=b<=W-1} : Cin[b,W] -> Cout[b-1,W]\\n{b,W | \
0<=b<=W-1} : S[b,W] -> X[b,W]\\n{b,W | b=W; 1<=W} : S[b,W] -> \
Cout[b-1,W]\"\>"], "Print",
 CellChangeTimes->{3.481013881779104*^9}],

Cell[BoxData["\<\"-- Dependencies of use statements:\"\>"], "Print",
 CellChangeTimes->{3.4810138818342533`*^9}],

Cell[BoxData["\<\"FullAdder[(b,W->)](A,B,Cin) <- (X,Cout)\"\>"], "Print",
 CellChangeTimes->{3.481013881902616*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<Plus\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"saveScheduleLibrary", "[", 
   RowBox[{"onlyMainSystem", "\[Rule]", "True"}], "]"}], ";"}], "\n", 
 RowBox[{"structSched", "[", 
  RowBox[{"debug", "\[Rule]", "False"}], "]"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Schedule(s) were saved in file \"\>", 
   "\[InvisibleSpace]", "\<\"Plus.scdlib\"\>"}],
  SequenceForm["Schedule(s) were saved in file ", "Plus.scdlib"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013883141095*^9}],

Cell[BoxData["\<\"Checking options...\"\>"], "Print",
 CellChangeTimes->{3.48101388320061*^9}],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print",
 CellChangeTimes->{3.481013883267997*^9}],

Cell[BoxData["\<\"Building LP...\"\>"], "Print",
 CellChangeTimes->{3.48101388335679*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "12", "\[InvisibleSpace]", "\<\" Recognized added Constraints: \"\>"}],
  SequenceForm[12, " Recognized added Constraints: "],
  Editable->False]], "Print",
 CellChangeTimes->{3.4810138834205*^9}],

Cell[BoxData["\<\"   -CA + CB = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013883487506*^9}],

Cell[BoxData["\<\"   -TAD2 + TBD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.48101388355441*^9}],

Cell[BoxData["\<\"   -CA + CCin = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013883620241*^9}],

Cell[BoxData["\<\"   -TAD2 + TCinD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4810138836959877`*^9}],

Cell[BoxData["\<\"   -1 - CA + CX = 0,\"\>"], "Print",
 CellChangeTimes->{3.4810138837544947`*^9}],

Cell[BoxData["\<\"   -TAD2 + TXD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4810138838207808`*^9}],

Cell[BoxData["\<\"   -1 - CA + CCout = 0,\"\>"], "Print",
 CellChangeTimes->{3.4810138838875504`*^9}],

Cell[BoxData["\<\"   -TAD2 + TCoutD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013883954926*^9}],

Cell[BoxData["\<\"   -TAD1 + TBD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013884021185*^9}],

Cell[BoxData["\<\"   -TAD1 + TCinD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013884088524*^9}],

Cell[BoxData["\<\"   -TAD1 + TXD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4810138841549063`*^9}],

Cell[BoxData["\<\"   -TAD1 + TCoutD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013884248828*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "71", 
   "\[InvisibleSpace]", "\<\"\\n\\t\\t\\t   variables, \"\>", 
   "\[InvisibleSpace]", "84", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 71, "\n\t\t\t   variables, ", 84, " Constraints"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013884304985*^9}],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print",
 CellChangeTimes->{3.481013884370872*^9}],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print",
 CellChangeTimes->{3.481013884438525*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Total execution Time: \"\>", "\[InvisibleSpace]", 
   RowBox[{"2", " ", "\<\"W\"\>"}]}],
  SequenceForm["Total execution Time: ", 2 "W"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013884509386*^9}],

Cell[BoxData["\<\"T_A{b, W} = 2 b\\nT_B{b, W} = 2 b\\nT_S{b, W} = 2 \
W\\nT_Cin{b, W} = 2 b\\nT_Cout{b, W} = 1 + 2 b\\nT_X{b, W} = 1 + 2 b\"\>"], \
"Print",
 CellChangeTimes->{3.48101388457201*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"Plus\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"B\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"S\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "2"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Cin\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Cout\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"X\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"b\"\>", ",", "\<\"W\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}]}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "0"}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.48101388463997*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tests", "[", "\"\<VertexSchedule\>\"", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Test report file is in \"\>", 
   "\[InvisibleSpace]", \
"\<\"/Users/patricequinton/mmalpha/doc/Packages/StructuredScheduler/\
TestingReport.txt\"\>"}],
  SequenceForm[
  "Test report file is in ", 
   "/Users/patricequinton/mmalpha/doc/Packages/StructuredScheduler/\
TestingReport.txt"],
  Editable->False]], "Print",
 CellChangeTimes->{3.48101388577811*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Calling Test: \"\>", 
   "\[InvisibleSpace]", "\<\"VertexSchedule.m\"\>"}],
  SequenceForm["Calling Test: ", "VertexSchedule.m"],
  Editable->False]], "Print",
 CellChangeTimes->{3.48101388584068*^9}],

Cell[BoxData["\<\"Test for VertexSchedule.m\"\>"], "Print",
 CellChangeTimes->{3.481013885903901*^9}],

Cell[BoxData["\<\"[dot][matmult]\"\>"], "Print",
 CellChangeTimes->{3.4810138859628696`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"scd", "::", "\<\"addConstraintsOpt\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\*StyleBox[\\!\\({TBD4 \[Equal] 0}\\), \\\
\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is not a value for the \
addConstraints Option\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.481013886026442*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"testFunction", "::", "\<\"abntest\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"************* -> abnormal \
result in test \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\
\\\"VertexSchedule 1-1\\\"\\), \\\"MT\\\"]\\)\[NoBreak]\"\>"}]], "Message", \
"MSG",
 CellChangeTimes->{3.4810138860951643`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Returned value was: \\n\"\>", "\[InvisibleSpace]", 
   TagBox[
    StyleBox["Null",
     ShowSpecialCharacters->False,
     ShowStringCharacters->True,
     NumberMarks->True],
    FullForm], "\[InvisibleSpace]", "\<\"\\nExpected value was:\\n\"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    StyleBox[
     RowBox[{"scheduleResult", "[", 
      RowBox[{"\"\<matmult\>\"", ",", 
       RowBox[{"List", "[", 
        RowBox[{
         RowBox[{"List", "[", 
          RowBox[{"\"\<a\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{"\"\<i\>\"", ",", "\"\<j\>\"", ",", "\"\<N\>\""}], "]"}], 
           ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"0", ",", "1", ",", "0"}], "]"}], ",", 
             RowBox[{"-", "1"}]}], "]"}]}], "]"}], ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<A\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{
            "\"\<k\>\"", ",", "\"\<i\>\"", ",", "\"\<j\>\"", ",", 
             "\"\<N\>\""}], "]"}], ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "]"}], ",", 
             RowBox[{"-", "1"}]}], "]"}]}], "]"}], ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<adaptIn31\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{
            "\"\<k\>\"", ",", "\"\<i\>\"", ",", "\"\<j\>\"", ",", 
             "\"\<N\>\""}], "]"}], ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"1", ",", "1", ",", 
               RowBox[{"Rational", "[", 
                RowBox[{"2", ",", "3"}], "]"}], ",", 
               RowBox[{"Rational", "[", 
                RowBox[{"1", ",", "3"}], "]"}]}], "]"}], ",", "0"}], "]"}]}], 
          "]"}], ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<adaptIn32\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{
            "\"\<k\>\"", ",", "\"\<i\>\"", ",", "\"\<j\>\"", ",", 
             "\"\<N\>\""}], "]"}], ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"1", ",", "1", ",", 
               RowBox[{"Rational", "[", 
                RowBox[{"2", ",", "3"}], "]"}], ",", 
               RowBox[{"Rational", "[", 
                RowBox[{"1", ",", "3"}], "]"}]}], "]"}], ",", "0"}], "]"}]}], 
          "]"}], ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<b\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{"\"\<i\>\"", ",", "\"\<j\>\"", ",", "\"\<N\>\""}], "]"}], 
           ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{
               RowBox[{"Rational", "[", 
                RowBox[{"2", ",", "3"}], "]"}], ",", 
               RowBox[{"Rational", "[", 
                RowBox[{"2", ",", "3"}], "]"}], ",", "0"}], "]"}], ",", 
             RowBox[{"-", "1"}]}], "]"}]}], "]"}], ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<B\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{
            "\"\<k\>\"", ",", "\"\<i\>\"", ",", "\"\<j\>\"", ",", 
             "\"\<N\>\""}], "]"}], ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"1", ",", "1", ",", 
               RowBox[{"Rational", "[", 
                RowBox[{"2", ",", "3"}], "]"}], ",", "0"}], "]"}], ",", 
             RowBox[{"Rational", "[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "3"}], "]"}]}], "]"}]}], "]"}], ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<c\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{"\"\<i\>\"", ",", "\"\<j\>\"", ",", "\"\<N\>\""}], "]"}], 
           ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"1", ",", 
               RowBox[{"Rational", "[", 
                RowBox[{"2", ",", "3"}], "]"}], ",", 
               RowBox[{"Rational", "[", 
                RowBox[{"4", ",", "3"}], "]"}]}], "]"}], ",", "2"}], "]"}]}], 
          "]"}]}], "]"}], ",", 
       RowBox[{"List", "[", 
        RowBox[{"3", ",", "2"}], "]"}]}], "]"}],
     ShowSpecialCharacters->False,
     ShowStringCharacters->True,
     NumberMarks->True],
    FullForm]}],
  SequenceForm["Returned value was: \n", 
   FullForm[Null], "\nExpected value was:\n", 
   FullForm[
    Alpha`scheduleResult["matmult", {{"a", {"i", "j", "N"}, 
       Alpha`sched[{0, 1, 0}, -1]}, {"A", {"k", "i", "j", "N"}, 
       Alpha`sched[{1, 1, 1, 0}, -1]}, {"adaptIn31", {"k", "i", "j", "N"}, 
       Alpha`sched[{1, 1, 
         Rational[2, 3], 
         Rational[1, 3]}, 0]}, {"adaptIn32", {"k", "i", "j", "N"}, 
       Alpha`sched[{1, 1, 
         Rational[2, 3], 
         Rational[1, 3]}, 0]}, {"b", {"i", "j", "N"}, 
       Alpha`sched[{
         Rational[2, 3], 
         Rational[2, 3], 0}, -1]}, {"B", {"k", "i", "j", "N"}, 
       Alpha`sched[{1, 1, 
         Rational[2, 3], 0}, 
        Rational[-1, 3]]}, {"c", {"i", "j", "N"}, 
       Alpha`sched[{1, 
         Rational[2, 3], 
         Rational[4, 3]}, 2]}}, {3, 2}]]],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013886180128*^9}],

Cell[BoxData["\<\"[dot][matmult]\"\>"], "Print",
 CellChangeTimes->{3.481013886243156*^9}],

Cell[BoxData["\<\"Checking options...\"\>"], "Print",
 CellChangeTimes->{3.4810138863161*^9}],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print",
 CellChangeTimes->{3.4810138863741493`*^9}],

Cell[BoxData["\<\"Building LP...\"\>"], "Print",
 CellChangeTimes->{3.481013886439856*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "10", "\[InvisibleSpace]", "\<\" Recognized added Constraints: \"\>"}],
  SequenceForm[10, " Recognized added Constraints: "],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013886506308*^9}],

Cell[BoxData["\<\"   -1 + TadaptIn31D1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013886558269*^9}],

Cell[BoxData["\<\"   -CadaptIn31 + CadaptIn32 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013886626902*^9}],

Cell[BoxData["\<\"   -1 + TadaptIn32D1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013886692565*^9}],

Cell[BoxData["\<\"   -TadaptIn31D4 + TadaptIn32D4 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013886757243*^9}],

Cell[BoxData["\<\"   -2 - CadaptIn31 + Cc = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013886851893*^9}],

Cell[BoxData["\<\"   -1 - TadaptIn31D4 + TcD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013886910928*^9}],

Cell[BoxData["\<\"   -TadaptIn31D2 + TadaptIn32D2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4810138869759808`*^9}],

Cell[BoxData["\<\"   -TadaptIn31D3 + TadaptIn32D3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013887042858*^9}],

Cell[BoxData["\<\"   -TadaptIn31D2 + TcD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013887111373*^9}],

Cell[BoxData["\<\"   -TadaptIn31D3 + TcD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013887174798*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "170", 
   "\[InvisibleSpace]", "\<\"\\n\\t\\t\\t   variables, \"\>", 
   "\[InvisibleSpace]", "172", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 170, "\n\t\t\t   variables, ", 172, " Constraints"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4810138872436237`*^9}],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print",
 CellChangeTimes->{3.481013887311095*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Writing line \"\>", "\[InvisibleSpace]", "100"}],
  SequenceForm["Writing line ", 100],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013887378305*^9}],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print",
 CellChangeTimes->{3.481013887443337*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Total execution Time: \"\>", "\[InvisibleSpace]", 
   RowBox[{"2", "+", 
    RowBox[{"3", " ", "\<\"N\"\>"}]}]}],
  SequenceForm["Total execution Time: ", 2 + 3 "N"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013887510023*^9}],

Cell[BoxData["\<\"T_a{i, j, N} = 0\\nT_b{i, j, N} = 0\\nT_c{i, j, N} = 2 + i \
+ j + N\\nT_A{k, i, j, N} = -1 + i + j + k\\nT_B{k, i, j, N} = \
i\\nT_adaptIn31{k, i, j, N} = i + j + k\\nT_adaptIn32{k, i, j, N} = i + j + k\
\"\>"], "Print",
 CellChangeTimes->{3.481013887576705*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--------> Passed test \"\>", 
   "\[InvisibleSpace]", "\<\"VertexSchedule 1-2\"\>"}],
  SequenceForm["--------> Passed test ", "VertexSchedule 1-2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013887656748*^9}],

Cell[BoxData["\<\"[FullAdder][Plus]\"\>"], "Print",
 CellChangeTimes->{3.481013887712243*^9}],

Cell[BoxData["\<\"Method Minimize\"\>"], "Print",
 CellChangeTimes->{3.481013887777356*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "70", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "23", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   "0.017204999999989923`"}],
  SequenceForm[70, " constraints, ", 23, " variables ", 0.017204999999989923`],
  Editable->False]], "Print",
 CellChangeTimes->{3.48101388784273*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Plus\"\>", ",", "23", ",", "59", ",", "0.017204999999989923`", 
   ",", "\<\"Vertex\"\>", ",", "\<\"Structured\"\>"}], "}"}]], "Print",
 CellChangeTimes->{3.481013887910881*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"testFunction", "::", "\<\"abntest\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"************* -> abnormal \
result in test \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\
\\\"VertexSchedule 2-1\\\"\\), \\\"MT\\\"]\\)\[NoBreak]\"\>"}]], "Message", \
"MSG",
 CellChangeTimes->{3.481013887977738*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Returned value was: \\n\"\>", "\[InvisibleSpace]", 
   TagBox[
    StyleBox[
     RowBox[{"scheduleResult", "[", 
      RowBox[{"\"\<Plus\>\"", ",", 
       RowBox[{"List", "[", 
        RowBox[{
         RowBox[{"List", "[", 
          RowBox[{"\"\<A\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{"\"\<b\>\"", ",", "\"\<W\>\""}], "]"}], ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"2", ",", "0"}], "]"}], ",", "0"}], "]"}]}], "]"}], ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<B\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{"\"\<b\>\"", ",", "\"\<W\>\""}], "]"}], ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"2", ",", "0"}], "]"}], ",", "0"}], "]"}]}], "]"}], ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<Cin\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{"\"\<b\>\"", ",", "\"\<W\>\""}], "]"}], ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"2", ",", "0"}], "]"}], ",", "0"}], "]"}]}], "]"}], ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<Cout\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{"\"\<b\>\"", ",", "\"\<W\>\""}], "]"}], ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"2", ",", "0"}], "]"}], ",", "1"}], "]"}]}], "]"}], ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<S\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{"\"\<b\>\"", ",", "\"\<W\>\""}], "]"}], ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"0", ",", "2"}], "]"}], ",", "0"}], "]"}]}], "]"}], ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<X\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{"\"\<b\>\"", ",", "\"\<W\>\""}], "]"}], ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"2", ",", "0"}], "]"}], ",", "1"}], "]"}]}], "]"}]}], 
        "]"}], ",", 
       RowBox[{"List", "[", 
        RowBox[{"2", ",", "0"}], "]"}]}], "]"}],
     ShowSpecialCharacters->False,
     ShowStringCharacters->True,
     NumberMarks->True],
    FullForm], "\[InvisibleSpace]", "\<\"\\nExpected value was:\\n\"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    StyleBox[
     RowBox[{"scheduleResult", "[", 
      RowBox[{"\"\<Plus\>\"", ",", 
       RowBox[{"List", "[", 
        RowBox[{
         RowBox[{"List", "[", 
          RowBox[{"\"\<A\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{"\"\<b\>\"", ",", "\"\<W\>\""}], "]"}], ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"0", ",", "0"}], "]"}], ",", "0"}], "]"}]}], "]"}], ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<B\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{"\"\<b\>\"", ",", "\"\<W\>\""}], "]"}], ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"0", ",", "0"}], "]"}], ",", "0"}], "]"}]}], "]"}], ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<Cin\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{"\"\<b\>\"", ",", "\"\<W\>\""}], "]"}], ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"0", ",", "0"}], "]"}], ",", "0"}], "]"}]}], "]"}], ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<Cout\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{"\"\<b\>\"", ",", "\"\<W\>\""}], "]"}], ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"0", ",", 
               RowBox[{"-", "1"}]}], "]"}], ",", "1"}], "]"}]}], "]"}], ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<S\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{"\"\<b\>\"", ",", "\"\<W\>\""}], "]"}], ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"0", ",", "0"}], "]"}], ",", "0"}], "]"}]}], "]"}], ",", 
         RowBox[{"List", "[", 
          RowBox[{"\"\<X\>\"", ",", 
           RowBox[{"List", "[", 
            RowBox[{"\"\<b\>\"", ",", "\"\<W\>\""}], "]"}], ",", 
           RowBox[{"sched", "[", 
            RowBox[{
             RowBox[{"List", "[", 
              RowBox[{"0", ",", 
               RowBox[{"-", "1"}]}], "]"}], ",", "1"}], "]"}]}], "]"}]}], 
        "]"}], ",", 
       RowBox[{"List", "[", 
        RowBox[{"0", ",", "0"}], "]"}]}], "]"}],
     ShowSpecialCharacters->False,
     ShowStringCharacters->True,
     NumberMarks->True],
    FullForm]}],
  SequenceForm["Returned value was: \n", 
   FullForm[
    Alpha`scheduleResult["Plus", {{"A", {"b", "W"}, 
       Alpha`sched[{2, 0}, 0]}, {"B", {"b", "W"}, 
       Alpha`sched[{2, 0}, 0]}, {"Cin", {"b", "W"}, 
       Alpha`sched[{2, 0}, 0]}, {"Cout", {"b", "W"}, 
       Alpha`sched[{2, 0}, 1]}, {"S", {"b", "W"}, 
       Alpha`sched[{0, 2}, 0]}, {"X", {"b", "W"}, 
       Alpha`sched[{2, 0}, 1]}}, {2, 0}]], "\nExpected value was:\n", 
   FullForm[
    Alpha`scheduleResult["Plus", {{"A", {"b", "W"}, 
       Alpha`sched[{0, 0}, 0]}, {"B", {"b", "W"}, 
       Alpha`sched[{0, 0}, 0]}, {"Cin", {"b", "W"}, 
       Alpha`sched[{0, 0}, 0]}, {"Cout", {"b", "W"}, 
       Alpha`sched[{0, -1}, 1]}, {"S", {"b", "W"}, 
       Alpha`sched[{0, 0}, 0]}, {"X", {"b", "W"}, 
       Alpha`sched[{0, -1}, 1]}}, {0, 0}]]],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013888048924*^9}],

Cell[BoxData["\<\"[FullAdder][Plus]\"\>"], "Print",
 CellChangeTimes->{3.4810138881110153`*^9}],

Cell[BoxData["\<\"Checking options...\"\>"], "Print",
 CellChangeTimes->{3.481013888185508*^9}],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print",
 CellChangeTimes->{3.48101388824529*^9}],

Cell[BoxData["\<\"Building LP...\"\>"], "Print",
 CellChangeTimes->{3.481013888310856*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "12", "\[InvisibleSpace]", "\<\" Recognized added Constraints: \"\>"}],
  SequenceForm[12, " Recognized added Constraints: "],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013888380251*^9}],

Cell[BoxData["\<\"   -CadaptIn11 + CadaptIn12 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013888445294*^9}],

Cell[BoxData["\<\"   -TadaptIn11D2 + TadaptIn12D2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013888511326*^9}],

Cell[BoxData["\<\"   -CadaptIn11 + CadaptIn13 = 0,\"\>"], "Print",
 CellChangeTimes->{3.48101388857719*^9}],

Cell[BoxData["\<\"   -TadaptIn11D2 + TadaptIn13D2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013888644142*^9}],

Cell[BoxData["\<\"   -1 - CadaptIn11 + CX = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013888755694*^9}],

Cell[BoxData["\<\"   -TadaptIn11D2 + TXD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4810138888130913`*^9}],

Cell[BoxData["\<\"   -1 - CadaptIn11 + CCout = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013888877728*^9}],

Cell[BoxData["\<\"   -TadaptIn11D2 + TCoutD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4810138889468527`*^9}],

Cell[BoxData["\<\"   -TadaptIn11D1 + TadaptIn12D1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013889013136*^9}],

Cell[BoxData["\<\"   -TadaptIn11D1 + TadaptIn13D1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013889079317*^9}],

Cell[BoxData["\<\"   -TadaptIn11D1 + TXD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013889146718*^9}],

Cell[BoxData["\<\"   -TadaptIn11D1 + TCoutD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.48101388921329*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "110", 
   "\[InvisibleSpace]", "\<\"\\n\\t\\t\\t   variables, \"\>", 
   "\[InvisibleSpace]", "120", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 110, "\n\t\t\t   variables, ", 120, " Constraints"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013889303175*^9}],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print",
 CellChangeTimes->{3.48101388936372*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Writing line \"\>", "\[InvisibleSpace]", "100"}],
  SequenceForm["Writing line ", 100],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013889430529*^9}],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print",
 CellChangeTimes->{3.481013889496974*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Total execution Time: \"\>", "\[InvisibleSpace]", 
   RowBox[{"3", " ", "\<\"W\"\>"}]}],
  SequenceForm["Total execution Time: ", 3 "W"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013889563613*^9}],

Cell[BoxData["\<\"T_A{b, W} = 0\\nT_B{b, W} = 0\\nT_S{b, W} = 3 W\\nT_Cin{b, \
W} = 3 b\\nT_Cout{b, W} = 2 + 3 b\\nT_X{b, W} = 2 + 3 b\\nT_adaptIn11{b, W} = \
1 + 3 b\\nT_adaptIn12{b, W} = 1 + 3 b\\nT_adaptIn13{b, W} = 1 + 3 b\"\>"], \
"Print",
 CellChangeTimes->{3.4810138896311817`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--------> Passed test \"\>", 
   "\[InvisibleSpace]", "\<\"VertexSchedule 2-2\"\>"}],
  SequenceForm["--------> Passed test ", "VertexSchedule 2-2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013889697419*^9}],

Cell[BoxData["\<\"[add][testscd1]\"\>"], "Print",
 CellChangeTimes->{3.481013889763688*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"scd", "::", "\<\"addConstraintsOpt\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\*StyleBox[\\!\\({\\(\\(TaD1 \[Equal] \
1\\)\\), \\(\\(TbD1 \[Equal] 1\\)\\), \\(\\(TcD1 \[Equal] 1\\)\\)}\\), \\\"MT\
\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is not a value for the \
addConstraints Option\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4810138898533297`*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"Method Minimize\"\>"], "Print",
 CellChangeTimes->{3.481013889914118*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "55", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "19", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   "0.008611999999970976`"}],
  SequenceForm[55, " constraints, ", 19, " variables ", 0.008611999999970976],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013889979763*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"testscd1\"\>", ",", "19", ",", "45", ",", 
   "0.008611999999970976`", ",", "\<\"Vertex\"\>", 
   ",", "\<\"Structured\"\>"}], "}"}]], "Print",
 CellChangeTimes->{3.481013890047434*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--------> Passed test \"\>", 
   "\[InvisibleSpace]", "\<\"VertexSchedule 3-1\"\>"}],
  SequenceForm["--------> Passed test ", "VertexSchedule 3-1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013890113798*^9}],

Cell[BoxData["\<\"[add][testscd1]\"\>"], "Print",
 CellChangeTimes->{3.481013890182384*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"scd", "::", "\<\"addConstraintsOpt\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\*StyleBox[\\!\\({\\(\\(TaD1 \[Equal] \
1\\)\\), \\(\\(TbD1 \[Equal] 1\\)\\), \\(\\(TcD1 \[Equal] 1\\)\\)}\\), \\\"MT\
\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is not a value for the \
addConstraints Option\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.481013890248983*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Further output of \\\\\\\"\\\
\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(scd :: \
\\\"addConstraintsOpt\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" will be suppressed \
during this calculation.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.48101389033785*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"Checking options...\"\>"], "Print",
 CellChangeTimes->{3.4810138903979053`*^9}],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print",
 CellChangeTimes->{3.4810138904647417`*^9}],

Cell[BoxData["\<\"Building LP...\"\>"], "Print",
 CellChangeTimes->{3.4810138905306587`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "7", "\[InvisibleSpace]", "\<\" Recognized added Constraints: \"\>"}],
  SequenceForm[7, " Recognized added Constraints: "],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013890598933*^9}],

Cell[BoxData["\<\"   -1 + TinD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013890665617*^9}],

Cell[BoxData["\<\"   CA - Cin = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013890733261*^9}],

Cell[BoxData["\<\"   -1 + TAD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013890798428*^9}],

Cell[BoxData["\<\"   TAD2 - TinD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013890871408*^9}],

Cell[BoxData["\<\"   -1 - Cin + Cout = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013890932016*^9}],

Cell[BoxData["\<\"   -1 + ToutD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013890999202*^9}],

Cell[BoxData["\<\"   -TinD2 + ToutD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013891065694*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "33", 
   "\[InvisibleSpace]", "\<\"\\n\\t\\t\\t   variables, \"\>", 
   "\[InvisibleSpace]", "44", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 33, "\n\t\t\t   variables, ", 44, " Constraints"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4810138911321983`*^9}],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print",
 CellChangeTimes->{3.4810138911993*^9}],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print",
 CellChangeTimes->{3.481013891266471*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "Alpha`FarkasSchedule`Private`ReadPipResult", 
   "::", "\<\"PipOutputError\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\" No schedule found, \
sorry\\\\\\\\t ...\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.481013891345007*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--------> Passed test \"\>", 
   "\[InvisibleSpace]", "\<\"VertexSchedule 3-2\"\>"}],
  SequenceForm["--------> Passed test ", "VertexSchedule 3-2"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013891399136*^9}],

Cell[BoxData["\<\"[add][testscd1]\"\>"], "Print",
 CellChangeTimes->{3.481013891450057*^9}],

Cell[BoxData["\<\"Checking options...\"\>"], "Print",
 CellChangeTimes->{3.481013891516255*^9}],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print",
 CellChangeTimes->{3.481013891583495*^9}],

Cell[BoxData["\<\"Building LP...\"\>"], "Print",
 CellChangeTimes->{3.4810138916499968`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "7", "\[InvisibleSpace]", "\<\" Recognized added Constraints: \"\>"}],
  SequenceForm[7, " Recognized added Constraints: "],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013891717844*^9}],

Cell[BoxData["\<\"   -1 + TadaptIn21D1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013891784101*^9}],

Cell[BoxData["\<\"   -CadaptIn21 + CadaptIn22 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013891850081*^9}],

Cell[BoxData["\<\"   -1 + TadaptIn22D1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013891923847*^9}],

Cell[BoxData["\<\"   -TadaptIn21D2 + TadaptIn22D2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.48101389198354*^9}],

Cell[BoxData["\<\"   -1 - CadaptIn21 + Cout = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013892050675*^9}],

Cell[BoxData["\<\"   -1 + ToutD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013892117722*^9}],

Cell[BoxData["\<\"   -TadaptIn21D2 + ToutD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013892184155*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "55", 
   "\[InvisibleSpace]", "\<\"\\n\\t\\t\\t   variables, \"\>", 
   "\[InvisibleSpace]", "68", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 55, "\n\t\t\t   variables, ", 68, " Constraints"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013892251322*^9}],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print",
 CellChangeTimes->{3.48101389231688*^9}],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print",
 CellChangeTimes->{3.48101389238419*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Total execution Time: \"\>", "\[InvisibleSpace]", 
   RowBox[{"2", "+", "\<\"M\"\>"}]}],
  SequenceForm["Total execution Time: ", 2 + "M"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4810138924574966`*^9}],

Cell[BoxData["\<\"T_in{k, M} = 0\\nT_out{k, M} = 2 + k\\nT_A{k, M} = \
1\\nT_adaptIn21{k, M} = 1 + k\\nT_adaptIn22{k, M} = 1 + k\"\>"], "Print",
 CellChangeTimes->{3.481013892518923*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"--------> Passed test \"\>", 
   "\[InvisibleSpace]", "\<\"VertexSchedule 3-3\"\>"}],
  SequenceForm["--------> Passed test ", "VertexSchedule 3-3"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013892585923*^9}],

Cell[BoxData["\<\"**** Something was wrong for VertexSchedule.m\"\>"], "Print",
 CellChangeTimes->{3.4810138926521807`*^9}]
}, Open  ]],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.48101389271768*^9}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["The full adder example, using schedule",
 FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell["\<\
Here, we schedule an adder (Plus) using a full adder elementary cell.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<fulladder.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[BoxData["\<\"[FullAdder][Plus]\"\>"], "Print",
 CellChangeTimes->{3.481013917538103*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<FullAdder\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"schedule", "[", "]"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Checking options...\"\>"], "Print",
 CellChangeTimes->{3.481013917613948*^9}],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print",
 CellChangeTimes->{3.4810139176161957`*^9}],

Cell[BoxData["\<\"Building LP...\"\>"], "Print",
 CellChangeTimes->{3.481013917680727*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "40", 
   "\[InvisibleSpace]", "\<\"\\n\\t\\t\\t   variables, \"\>", 
   "\[InvisibleSpace]", "32", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 40, "\n\t\t\t   variables, ", 32, " Constraints"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013917684121*^9}],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print",
 CellChangeTimes->{3.481013917687416*^9}],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print",
 CellChangeTimes->{3.481013917759112*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Total execution Time: \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["Total execution Time: ", 1],
  Editable->False]], "Print",
 CellChangeTimes->{3.4810139178261337`*^9}],

Cell[BoxData["\<\"T_A{} = 0\\nT_B{} = 0\\nT_Cin{} = 0\\nT_X{} = 1\\nT_Cout{} \
= 1\"\>"], "Print",
 CellChangeTimes->{3.481013917894095*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"FullAdder\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"B\"\>", ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Cin\"\>", ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"X\"\>", ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Cout\"\>", ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", "1"}], "]"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", "1", "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.481013917962338*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input"],

Cell[BoxData["\<\"system FullAdder (A :  boolean; \\n                  B :  \
boolean; \\n                  Cin :  boolean)\\n       returns   (X :  \
boolean; \\n                  Cout :  boolean);\\nlet\\n  X[] = A xor B xor \
Cin;\\n  Cout[] = A and B or A and Cin or B and Cin;\\ntel;\"\>"], "Print",
 CellChangeTimes->{3.481013918081091*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$scheduleLibrary", "=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<Plus\>\"", "]"}], ";", 
  RowBox[{"show", "[", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"structSched", "[", "]"}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"system Plus :  {W | 2<=W}\\n               (A : {b | \
0<=b<=W} of boolean; \\n                B : {b | 0<=b<=W} of boolean)\\n      \
 returns (S : {b | 0<=b<=W} of boolean);\\nvar\\n  Cin : {b | 0<=b<=W-1} of \
boolean;\\n  Cout : {b | 0<=b<=W-1} of boolean;\\n  X : {b | 0<=b<=W-1} of \
boolean;\\nlet\\n  use {b | 0<=b<=W-1} FullAdder.(b->) (A, B, Cin) returns  \
(X, Cout) ;\\n  Cin = \\n      case\\n        {b | b=0} : False.(b->);\\n     \
   {b | 1<=b} : Cout.(b->b-1);\\n      esac;\\n  S = case\\n        {b | \
b<=W-1} : X.(b->b);\\n        {b | b=W} : Cout.(b->W-1);\\n      esac;\\ntel;\
\"\>"], "Print",
 CellChangeTimes->{3.481013918197981*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Incompatibility between the number of schedule\\navailable and \
the number of uses of \"\>", "\[InvisibleSpace]", "\<\"Plus\"\>"}],
  SequenceForm[
  "Incompatibility between the number of schedule\navailable and the number \
of uses of ", "Plus"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013918263152*^9}],

Cell[BoxData["\<\"Checking options...\"\>"], "Print",
 CellChangeTimes->{3.481013918329885*^9}],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print",
 CellChangeTimes->{3.481013918394326*^9}],

Cell[BoxData["\<\"Building LP...\"\>"], "Print",
 CellChangeTimes->{3.4810139184628897`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "71", 
   "\[InvisibleSpace]", "\<\"\\n\\t\\t\\t   variables, \"\>", 
   "\[InvisibleSpace]", "60", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 71, "\n\t\t\t   variables, ", 60, " Constraints"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4810139185287647`*^9}],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print",
 CellChangeTimes->{3.481013918595563*^9}],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print",
 CellChangeTimes->{3.481013918661305*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Total execution Time: \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["Total execution Time: ", 1],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013918738761*^9}],

Cell[BoxData["\<\"T_A{b, W} = 0\\nT_B{b, W} = 0\\nT_S{b, W} = 1\\nT_Cin{b, W} \
= 1\\nT_Cout{b, W} = 0\\nT_X{b, W} = 0\"\>"], "Print",
 CellChangeTimes->{3.481013918795912*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Running the example all at once",
 FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"load", "[", "\"\<matmults.alpha\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<dot\>\"", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"schedule", "[", 
   RowBox[{"addConstraints", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<TaD1==1\>\"", ",", "\"\<TbD1==1\>\""}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<matmult\>\"", "]"}], ";"}], "\n", 
 RowBox[{"structSched", "[", "]"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"[dot][matmult]\"\>"], "Print",
 CellChangeTimes->{3.481013941605526*^9}],

Cell[BoxData["\<\"Checking options...\"\>"], "Print",
 CellChangeTimes->{3.481013941608399*^9}],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print",
 CellChangeTimes->{3.481013941669998*^9}],

Cell[BoxData["\<\"Building LP...\"\>"], "Print",
 CellChangeTimes->{3.481013941762126*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "2", "\[InvisibleSpace]", "\<\" Recognized added Constraints: \"\>"}],
  SequenceForm[2, " Recognized added Constraints: "],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013941765226*^9}],

Cell[BoxData["\<\"   -1 + TaD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4810139418199167`*^9}],

Cell[BoxData["\<\"   -1 + TbD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013941885858*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "49", 
   "\[InvisibleSpace]", "\<\"\\n\\t\\t\\t   variables, \"\>", 
   "\[InvisibleSpace]", "52", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 49, "\n\t\t\t   variables, ", 52, " Constraints"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013941968576*^9}],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print",
 CellChangeTimes->{3.481013942052902*^9}],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print",
 CellChangeTimes->{3.481013942117358*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Total execution Time: \"\>", "\[InvisibleSpace]", 
   RowBox[{"1", "+", "\<\"N\"\>"}]}],
  SequenceForm["Total execution Time: ", 1 + "N"],
  Editable->False]], "Print",
 CellChangeTimes->{3.48101394218434*^9}],

Cell[BoxData["\<\"T_a{k, N} = -1 + k\\nT_b{k, N} = -1 + k\\nT_c{N} = 1 + \
N\\nT_Acc{k, N} = k\"\>"], "Print",
 CellChangeTimes->{3.4810139422495213`*^9}],

Cell[BoxData["\<\"Checking options...\"\>"], "Print",
 CellChangeTimes->{3.481013942325575*^9}],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print",
 CellChangeTimes->{3.481013942384822*^9}],

Cell[BoxData["\<\"Building LP...\"\>"], "Print",
 CellChangeTimes->{3.481013942451458*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "10", "\[InvisibleSpace]", "\<\" Recognized added Constraints: \"\>"}],
  SequenceForm[10, " Recognized added Constraints: "],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013942518456*^9}],

Cell[BoxData["\<\"   -1 + TAD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013942585065*^9}],

Cell[BoxData["\<\"   -CA + CB = 0,\"\>"], "Print",
 CellChangeTimes->{3.4810139426515102`*^9}],

Cell[BoxData["\<\"   -1 + TBD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013942717998*^9}],

Cell[BoxData["\<\"   -TAD4 + TBD4 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013942786654*^9}],

Cell[BoxData["\<\"   -2 - CA + Cc = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013942862639*^9}],

Cell[BoxData["\<\"   -1 - TAD4 + TcD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4810139429186497`*^9}],

Cell[BoxData["\<\"   -TAD2 + TBD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013942986021*^9}],

Cell[BoxData["\<\"   -TAD3 + TBD3 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4810139430518208`*^9}],

Cell[BoxData["\<\"   -TAD2 + TcD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013943125224*^9}],

Cell[BoxData["\<\"   -TAD3 + TcD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4810139431862926`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "124", 
   "\[InvisibleSpace]", "\<\"\\n\\t\\t\\t   variables, \"\>", 
   "\[InvisibleSpace]", "132", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 124, "\n\t\t\t   variables, ", 132, " Constraints"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013943252997*^9}],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print",
 CellChangeTimes->{3.481013943319715*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Writing line \"\>", "\[InvisibleSpace]", "100"}],
  SequenceForm["Writing line ", 100],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013943386002*^9}],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print",
 CellChangeTimes->{3.4810139434540243`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Total execution Time: \"\>", "\[InvisibleSpace]", 
   RowBox[{"1", "+", 
    RowBox[{"3", " ", "\<\"N\"\>"}]}]}],
  SequenceForm["Total execution Time: ", 1 + 3 "N"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4810139435194073`*^9}],

Cell[BoxData["\<\"T_a{i, j, N} = 0\\nT_b{i, j, N} = 0\\nT_c{i, j, N} = 1 + i \
+ j + N\\nT_A{k, i, j, N} = -1 + i + j + k\\nT_B{k, i, j, N} = -1 + i + j + k\
\"\>"], "Print",
 CellChangeTimes->{3.4810139435867853`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"matmult\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"a\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"b\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"c\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", "1"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "1"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"B\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", 
         ",", "\<\"N\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "1"}]}], "]"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.481013943660143*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Test1 of scd",
 FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell["\<\
This example contains the call to a vector adder add (reads two vectors of \
same size, and adds it).\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<testscd1.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[BoxData["\<\"[add][testscd1]\"\>"], "Print",
 CellChangeTimes->{3.4810139497172003`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input"],

Cell[BoxData["\<\"system testscd1 :{M | 1<=M}\\n                (in : {k | \
1<=k<=M} of integer)\\n       returns  (out : {k | 1<=k<=M} of \
integer);\\nvar\\n  A : {k | 1<=k<=M} of integer;\\nlet\\n  A[k] = in;\\n  \
use  add[M] (in, A) returns  (out) ;\\ntel;\"\>"], "Print",
 CellChangeTimes->{3.481013949801261*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"analyze", "[", 
  RowBox[{"recurse", "\[Rule]", "True"}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Need to analyze : \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"add\"\>", ",", "\<\"testscd1\"\>"}], "}"}]}],
  SequenceForm["Need to analyze : ", {"add", "testscd1"}],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013949867403*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.481013949926496*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"add\"\>"}],
  SequenceForm["Static Analysis of system ", "add"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4810139499797087`*^9}],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print",
 CellChangeTimes->{3.4810139500478277`*^9}],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print",
 CellChangeTimes->{3.481013950114888*^9}],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print",
 CellChangeTimes->{3.481013950181397*^9}],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print",
 CellChangeTimes->{3.481013950248426*^9}],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print",
 CellChangeTimes->{3.481013950314754*^9}],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print",
 CellChangeTimes->{3.4810139503999023`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", "\[InvisibleSpace]", "\<\"c\"\>"}],
  SequenceForm["----equation defining ", "c"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013950448234*^9}],

Cell[BoxData["\<\"--Checking regularity of output equations\"\>"], "Print",
 CellChangeTimes->{3.48101395051575*^9}],

Cell[BoxData["\<\"----Outputs equations are not regular. Use \
mkAllOutputsRegular.\"\>"], "Print",
 CellChangeTimes->{3.481013950582171*^9}],

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print",
 CellChangeTimes->{3.481013950649146*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.481013950715578*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Static Analysis of system \"\>", 
   "\[InvisibleSpace]", "\<\"testscd1\"\>"}],
  SequenceForm["Static Analysis of system ", "testscd1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013950782852*^9}],

Cell[BoxData["\<\"--Checking declaration of variables.\"\>"], "Print",
 CellChangeTimes->{3.481013950849077*^9}],

Cell[BoxData["\<\"--Checking single assignment rule.\"\>"], "Print",
 CellChangeTimes->{3.481013950924015*^9}],

Cell[BoxData["\<\"--Checking definitions of output/local variables.\"\>"], \
"Print",
 CellChangeTimes->{3.481013950983054*^9}],

Cell[BoxData["\<\"--Checking definition of input variables.\"\>"], "Print",
 CellChangeTimes->{3.481013951049114*^9}],

Cell[BoxData["\<\"--Checking that input/local variables are used.\"\>"], \
"Print",
 CellChangeTimes->{3.481013951116048*^9}],

Cell[BoxData["\<\"--Checking type and domain consistency in the \
equations:\"\>"], "Print",
 CellChangeTimes->{3.481013951187243*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----equation defining \"\>", "\[InvisibleSpace]", "\<\"A\"\>"}],
  SequenceForm["----equation defining ", "A"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4810139512508574`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"----use \"\>", "\[InvisibleSpace]", "\<\"add\"\>", 
   "\[InvisibleSpace]", "\<\"...\"\>"}],
  SequenceForm["----use ", "add", "..."],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013951315839*^9}],

Cell[BoxData["\<\"--Checking regularity of output equations\"\>"], "Print",
 CellChangeTimes->{3.481013951383224*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"getEquation", "::", "\<\"EquIsUse\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Warning, variable \\\\\\\"\\\
\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"out\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" defined as output of \
system \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"add\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4810139514514627`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"isOutputRegular", "::", "\<\"error2\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"could not find definition of \
\\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"out\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4810139515174713`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"areAllOutputsRegular", "::", "\<\"error2\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"error while calling \
isOutputRegular\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.481013951586588*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"\\nAnalysis Successful...\"\>"], "Print",
 CellChangeTimes->{3.4810139516517563`*^9}],

Cell[BoxData["\<\"\\nRecursive Analysis Successful.\"\>"], "Print",
 CellChangeTimes->{3.4810139517243156`*^9}]
}, Open  ]],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.4810139517864447`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<add\>\"", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input"],

Cell[BoxData["\<\"system add :   {N | 1<=N}\\n               (a : {k | \
1<=k<=N} of integer; \\n                b : {k | 1<=k<=N} of integer)\\n      \
 returns (c : {k | 1<=k<=N} of integer);\\nlet\\n  c[k] = a + \
b;\\ntel;\"\>"], "Print",
 CellChangeTimes->{3.4810139520699883`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"scd", "[", 
  RowBox[{"addConstraints", "\[Rule]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"TaD1", "==", "1"}], ",", 
     RowBox[{"TbD1", "==", "1"}], ",", 
     RowBox[{"TcD1", "\[Equal]", "1"}]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"scd", "::", "\<\"addConstraintsOpt\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\*StyleBox[\\!\\({\\(\\(TaD1 \[Equal] \
1\\)\\), \\(\\(TbD1 \[Equal] 1\\)\\), \\(\\(TcD1 \[Equal] 1\\)\\)}\\), \\\"MT\
\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is not a value for the \
addConstraints Option\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.481013952170974*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"showSchedResult", "[", "]"}]], "Input"],

Cell[BoxData["\<\"T_a{i, j, N} = 0\\nT_b{i, j, N} = 0\\nT_c{i, j, N} = 1 + i \
+ j + N\\nT_A{k, i, j, N} = -1 + i + j + k\\nT_B{k, i, j, N} = -1 + i + j + k\
\"\>"], "Print",
 CellChangeTimes->{3.481013952256851*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<testscd1\>\"", "]"}], ";", 
  RowBox[{"ashow", "[", "]"}]}]], "Input"],

Cell[BoxData["\<\"system testscd1 :{M | 1<=M}\\n                (in : {k | \
1<=k<=M} of integer)\\n       returns  (out : {k | 1<=k<=M} of \
integer);\\nvar\\n  A : {k | 1<=k<=M} of integer;\\nlet\\n  A[k] = in;\\n  \
use  add[M] (in, A) returns  (out) ;\\ntel;\"\>"], "Print",
 CellChangeTimes->{3.48101395235226*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"scd", "[", 
  RowBox[{"debug", "\[Rule]", "False"}], "]"}]], "Input"],

Cell[BoxData["\<\"Method Minimize\"\>"], "Print",
 CellChangeTimes->{3.481013952474452*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Minimize", "::", "\<\"infeas\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"There are no values of \
\\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\({AA, Ain, Aout, \
aparam, TAD1, TAD2, TinD1, TinD2, TM, ToutD1, ToutD2, AlphaVars`Tuse1, \
AlphaVars`TuseM1, Alpha`VertexSchedule`Private`$$x}\\), \\\"MT\\\"]\\)\
\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" for which the constraints \\\\\\\"\\\
\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" \
are satisfied and the objective function \\\\\\\"\\\", \\\"MT\\\"]\\)\
\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\(\\(-1\\)\\) - Aout + TAD1 + TAD2 - \
ToutD2 + \\(\\(\[LeftSkeleton] 9 \[RightSkeleton]\\)\\) + \\(\\(10\\\\ \
\\(\\((TM - Alpha`VertexSchedule`Private`$$x)\\)\\)\\)\\) - \\(\\(2\\\\ \
\\(\\((ToutD1 - Alpha`VertexSchedule`Private`$$x)\\)\\)\\)\\) - \\(\\(2\\\\ \
Alpha`VertexSchedule`Private`$$x\\)\\)\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is real-valued. \\\\\\\
\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Minimize\\\", ButtonNote -> \\\"Minimize::infeas\\\
\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.481013952514011*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "39", "\[InvisibleSpace]", "\<\" constraints, \"\>", "\[InvisibleSpace]", 
   "13", "\[InvisibleSpace]", "\<\" variables \"\>", "\[InvisibleSpace]", 
   "0.006622999999990498`"}],
  SequenceForm[39, " constraints, ", 13, " variables ", 0.006622999999990498],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013952569275*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"testscd1\"\>", ",", "13", ",", "29", ",", 
   "0.006622999999990498`", ",", "\<\"Vertex\"\>", 
   ",", "\<\"Structured\"\>"}], "}"}]], "Print",
 CellChangeTimes->{3.481013952635704*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"testscd1\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Indeterminate", ",", "Indeterminate"}], "}"}], ",", 
         "Indeterminate"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"in\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Indeterminate", ",", "Indeterminate"}], "}"}], ",", 
         "Indeterminate"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"out\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Indeterminate", ",", "Indeterminate"}], "}"}], ",", 
         "Indeterminate"}], "]"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"Indeterminate", ",", "Indeterminate"}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.481013952703182*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"adaptUses", "[", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"system", "[", 
  RowBox[{"\<\"testscd1\"\>", ",", 
   RowBox[{"domain", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", "\<\"M\"\>", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"pol", "[", 
       RowBox[{"2", ",", "2", ",", "0", ",", "0", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}]}], "]"}], 
      "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"decl", "[", 
     RowBox[{"\<\"in\"\>", ",", "integer", ",", 
      RowBox[{"domain", "[", 
       RowBox[{"2", ",", 
        RowBox[{"{", 
         RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"pol", "[", 
          RowBox[{"3", ",", "3", ",", "0", ",", "0", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "1", ",", "0", ",", 
               RowBox[{"-", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
          "]"}], "}"}]}], "]"}]}], "]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"decl", "[", 
     RowBox[{"\<\"out\"\>", ",", "integer", ",", 
      RowBox[{"domain", "[", 
       RowBox[{"2", ",", 
        RowBox[{"{", 
         RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"pol", "[", 
          RowBox[{"3", ",", "3", ",", "0", ",", "0", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "1", ",", "0", ",", 
               RowBox[{"-", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
          "]"}], "}"}]}], "]"}]}], "]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"decl", "[", 
      RowBox[{"\<\"A\"\>", ",", "integer", ",", 
       RowBox[{"domain", "[", 
        RowBox[{"2", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"pol", "[", 
           RowBox[{"3", ",", "3", ",", "0", ",", "0", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "0", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
           "]"}], "}"}]}], "]"}]}], "]"}], ",", 
     RowBox[{"decl", "[", 
      RowBox[{"\<\"adaptIn21\"\>", ",", "integer", ",", 
       RowBox[{"domain", "[", 
        RowBox[{"2", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"pol", "[", 
           RowBox[{"3", ",", "3", ",", "0", ",", "0", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "0", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
           "]"}], "}"}]}], "]"}]}], "]"}], ",", 
     RowBox[{"decl", "[", 
      RowBox[{"\<\"adaptIn22\"\>", ",", "integer", ",", 
       RowBox[{"domain", "[", 
        RowBox[{"2", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"pol", "[", 
           RowBox[{"3", ",", "3", ",", "0", ",", "0", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "0", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
           "]"}], "}"}]}], "]"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"equation", "[", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"var", "[", "\<\"in\"\>", "]"}]}], "]"}], ",", 
     RowBox[{"equation", "[", 
      RowBox[{"\<\"adaptIn21\"\>", ",", 
       RowBox[{"var", "[", "\<\"in\"\>", "]"}]}], "]"}], ",", 
     RowBox[{"equation", "[", 
      RowBox[{"\<\"adaptIn22\"\>", ",", 
       RowBox[{"var", "[", "\<\"A\"\>", "]"}]}], "]"}], ",", 
     RowBox[{"use", "[", 
      RowBox[{"\<\"add\"\>", ",", 
       RowBox[{"domain", "[", 
        RowBox[{"1", ",", 
         RowBox[{"{", "\<\"M\"\>", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"pol", "[", 
           RowBox[{"2", ",", "2", ",", "0", ",", "0", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}]}], "]"}], 
          "}"}]}], "]"}], ",", 
       RowBox[{"matrix", "[", 
        RowBox[{"2", ",", "2", ",", 
         RowBox[{"{", "\<\"M\"\>", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"var", "[", "\<\"adaptIn21\"\>", "]"}], ",", 
         RowBox[{"var", "[", "\<\"adaptIn22\"\>", "]"}]}], "}"}], ",", 
       RowBox[{"{", "\<\"out\"\>", "}"}]}], "]"}]}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.481013952828865*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"showSchedResult", "[", "]"}]], "Input"],

Cell[BoxData["\<\"T_A{k, M} = Indeterminate\\nT_in{k, M} = \
Indeterminate\\nT_out{k, M} = Indeterminate\"\>"], "Print",
 CellChangeTimes->{3.4810139530936193`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"structSched", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Checking options...\"\>"], "Print",
 CellChangeTimes->{3.481013953186544*^9}],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print",
 CellChangeTimes->{3.481013953231956*^9}],

Cell[BoxData["\<\"Building LP...\"\>"], "Print",
 CellChangeTimes->{3.481013953281254*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "7", "\[InvisibleSpace]", "\<\" Recognized added Constraints: \"\>"}],
  SequenceForm[7, " Recognized added Constraints: "],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013953335846*^9}],

Cell[BoxData["\<\"   -1 + TadaptIn21D1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013953403607*^9}],

Cell[BoxData["\<\"   -CadaptIn21 + CadaptIn22 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013953470564*^9}],

Cell[BoxData["\<\"   -1 + TadaptIn22D1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013953537058*^9}],

Cell[BoxData["\<\"   -TadaptIn21D2 + TadaptIn22D2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013953603772*^9}],

Cell[BoxData["\<\"   -1 - CadaptIn21 + Cout = 0,\"\>"], "Print",
 CellChangeTimes->{3.4810139536706667`*^9}],

Cell[BoxData["\<\"   -1 + ToutD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013953747759*^9}],

Cell[BoxData["\<\"   -TadaptIn21D2 + ToutD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4810139538042173`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "55", 
   "\[InvisibleSpace]", "\<\"\\n\\t\\t\\t   variables, \"\>", 
   "\[InvisibleSpace]", "68", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 55, "\n\t\t\t   variables, ", 68, " Constraints"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013953870822*^9}],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print",
 CellChangeTimes->{3.481013953937224*^9}],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print",
 CellChangeTimes->{3.4810139540038433`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Total execution Time: \"\>", "\[InvisibleSpace]", 
   RowBox[{"2", "+", "\<\"M\"\>"}]}],
  SequenceForm["Total execution Time: ", 2 + "M"],
  Editable->False]], "Print",
 CellChangeTimes->{3.48101395407022*^9}],

Cell[BoxData["\<\"T_in{k, M} = 0\\nT_out{k, M} = 2 + k\\nT_A{k, M} = \
1\\nT_adaptIn21{k, M} = 1 + k\\nT_adaptIn22{k, M} = 1 + k\"\>"], "Print",
 CellChangeTimes->{3.481013954137941*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"testscd1\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"in\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"out\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "2"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"adaptIn21\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"adaptIn22\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}]}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.481013954213891*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"adaptUses", "[", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"system", "[", 
  RowBox[{"\<\"testscd1\"\>", ",", 
   RowBox[{"domain", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", "\<\"M\"\>", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"pol", "[", 
       RowBox[{"2", ",", "2", ",", "0", ",", "0", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}]}], "]"}], 
      "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"decl", "[", 
     RowBox[{"\<\"in\"\>", ",", "integer", ",", 
      RowBox[{"domain", "[", 
       RowBox[{"2", ",", 
        RowBox[{"{", 
         RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"pol", "[", 
          RowBox[{"3", ",", "3", ",", "0", ",", "0", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "1", ",", "0", ",", 
               RowBox[{"-", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
          "]"}], "}"}]}], "]"}]}], "]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"decl", "[", 
     RowBox[{"\<\"out\"\>", ",", "integer", ",", 
      RowBox[{"domain", "[", 
       RowBox[{"2", ",", 
        RowBox[{"{", 
         RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"pol", "[", 
          RowBox[{"3", ",", "3", ",", "0", ",", "0", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "1", ",", "0", ",", 
               RowBox[{"-", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
          "]"}], "}"}]}], "]"}]}], "]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"decl", "[", 
      RowBox[{"\<\"A\"\>", ",", "integer", ",", 
       RowBox[{"domain", "[", 
        RowBox[{"2", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"pol", "[", 
           RowBox[{"3", ",", "3", ",", "0", ",", "0", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "0", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
           "]"}], "}"}]}], "]"}]}], "]"}], ",", 
     RowBox[{"decl", "[", 
      RowBox[{"\<\"adaptIn21\"\>", ",", "integer", ",", 
       RowBox[{"domain", "[", 
        RowBox[{"2", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"pol", "[", 
           RowBox[{"3", ",", "3", ",", "0", ",", "0", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "0", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
           "]"}], "}"}]}], "]"}]}], "]"}], ",", 
     RowBox[{"decl", "[", 
      RowBox[{"\<\"adaptIn22\"\>", ",", "integer", ",", 
       RowBox[{"domain", "[", 
        RowBox[{"2", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"pol", "[", 
           RowBox[{"3", ",", "3", ",", "0", ",", "0", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "0", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
           "]"}], "}"}]}], "]"}]}], "]"}], ",", 
     RowBox[{"decl", "[", 
      RowBox[{"\<\"adaptIn41\"\>", ",", "integer", ",", 
       RowBox[{"domain", "[", 
        RowBox[{"2", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"pol", "[", 
           RowBox[{"3", ",", "3", ",", "0", ",", "0", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "0", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
           "]"}], "}"}]}], "]"}]}], "]"}], ",", 
     RowBox[{"decl", "[", 
      RowBox[{"\<\"adaptIn42\"\>", ",", "integer", ",", 
       RowBox[{"domain", "[", 
        RowBox[{"2", ",", 
         RowBox[{"{", 
          RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"pol", "[", 
           RowBox[{"3", ",", "3", ",", "0", ",", "0", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "0", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
           "]"}], "}"}]}], "]"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"equation", "[", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"var", "[", "\<\"in\"\>", "]"}]}], "]"}], ",", 
     RowBox[{"equation", "[", 
      RowBox[{"\<\"adaptIn21\"\>", ",", 
       RowBox[{"var", "[", "\<\"in\"\>", "]"}]}], "]"}], ",", 
     RowBox[{"equation", "[", 
      RowBox[{"\<\"adaptIn22\"\>", ",", 
       RowBox[{"var", "[", "\<\"A\"\>", "]"}]}], "]"}], ",", 
     RowBox[{"equation", "[", 
      RowBox[{"\<\"adaptIn41\"\>", ",", 
       RowBox[{"var", "[", "\<\"adaptIn21\"\>", "]"}]}], "]"}], ",", 
     RowBox[{"equation", "[", 
      RowBox[{"\<\"adaptIn42\"\>", ",", 
       RowBox[{"var", "[", "\<\"adaptIn22\"\>", "]"}]}], "]"}], ",", 
     RowBox[{"use", "[", 
      RowBox[{"\<\"add\"\>", ",", 
       RowBox[{"domain", "[", 
        RowBox[{"1", ",", 
         RowBox[{"{", "\<\"M\"\>", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"pol", "[", 
           RowBox[{"2", ",", "2", ",", "0", ",", "0", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}]}], "]"}], 
          "}"}]}], "]"}], ",", 
       RowBox[{"matrix", "[", 
        RowBox[{"2", ",", "2", ",", 
         RowBox[{"{", "\<\"M\"\>", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"var", "[", "\<\"adaptIn41\"\>", "]"}], ",", 
         RowBox[{"var", "[", "\<\"adaptIn42\"\>", "]"}]}], "}"}], ",", 
       RowBox[{"{", "\<\"out\"\>", "}"}]}], "]"}]}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.481013954469179*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input"],

Cell[BoxData["\<\"system testscd1 :{M | 1<=M}\\n                (in : {k | \
1<=k<=M} of integer)\\n       returns  (out : {k | 1<=k<=M} of \
integer);\\nvar\\n  A : {k | 1<=k<=M} of integer;\\n  adaptIn21 : {k | \
1<=k<=M} of integer;\\n  adaptIn22 : {k | 1<=k<=M} of integer;\\n  adaptIn41 \
: {k | 1<=k<=M} of integer;\\n  adaptIn42 : {k | 1<=k<=M} of \
integer;\\nlet\\n  A[k] = in;\\n  adaptIn21[k] = in;\\n  adaptIn22[k] = A;\\n \
 adaptIn41[k] = adaptIn21;\\n  adaptIn42[k] = adaptIn22;\\n  use  add[M] \
(adaptIn41, adaptIn42) returns  (out) ;\\ntel;\"\>"], "Print",
 CellChangeTimes->{3.4810139545530853`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"structSched", "[", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Checking options...\"\>"], "Print",
 CellChangeTimes->{3.481013954641788*^9}],

Cell[BoxData["\<\"Dependence analysis...\"\>"], "Print",
 CellChangeTimes->{3.4810139547007303`*^9}],

Cell[BoxData["\<\"Building LP...\"\>"], "Print",
 CellChangeTimes->{3.481013954751217*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "7", "\[InvisibleSpace]", "\<\" Recognized added Constraints: \"\>"}],
  SequenceForm[7, " Recognized added Constraints: "],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013954804899*^9}],

Cell[BoxData["\<\"   -1 + TadaptIn41D1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013954871459*^9}],

Cell[BoxData["\<\"   -CadaptIn41 + CadaptIn42 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013954938896*^9}],

Cell[BoxData["\<\"   -1 + TadaptIn42D1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013955006688*^9}],

Cell[BoxData["\<\"   -TadaptIn41D2 + TadaptIn42D2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013955072378*^9}],

Cell[BoxData["\<\"   -1 - CadaptIn41 + Cout = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013955139001*^9}],

Cell[BoxData["\<\"   -1 + ToutD1 = 0,\"\>"], "Print",
 CellChangeTimes->{3.481013955214196*^9}],

Cell[BoxData["\<\"   -TadaptIn41D2 + ToutD2 = 0,\"\>"], "Print",
 CellChangeTimes->{3.4810139552725897`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LP: \"\>", "\[InvisibleSpace]", "77", 
   "\[InvisibleSpace]", "\<\"\\n\\t\\t\\t   variables, \"\>", 
   "\[InvisibleSpace]", "92", "\[InvisibleSpace]", "\<\" Constraints\"\>"}],
  SequenceForm["LP: ", 77, "\n\t\t\t   variables, ", 92, " Constraints"],
  Editable->False]], "Print",
 CellChangeTimes->{3.481013955339478*^9}],

Cell[BoxData["\<\"Writing file for PIP....\"\>"], "Print",
 CellChangeTimes->{3.481013955406909*^9}],

Cell[BoxData["\<\"Solving the LP...\"\>"], "Print",
 CellChangeTimes->{3.481013955475903*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Total execution Time: \"\>", "\[InvisibleSpace]", 
   RowBox[{"3", "+", "\<\"M\"\>"}]}],
  SequenceForm["Total execution Time: ", 3 + "M"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4810139555404654`*^9}],

Cell[BoxData["\<\"T_in{k, M} = 0\\nT_out{k, M} = 3 + k\\nT_A{k, M} = \
1\\nT_adaptIn21{k, M} = 1\\nT_adaptIn22{k, M} = 2\\nT_adaptIn41{k, M} = 2 + k\
\\nT_adaptIn42{k, M} = 2 + k\"\>"], "Print",
 CellChangeTimes->{3.481013955607266*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"scheduleResult", "[", 
  RowBox[{"\<\"testscd1\"\>", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"in\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"out\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "3"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"A\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"adaptIn21\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"adaptIn22\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", "2"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"adaptIn41\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "2"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"adaptIn42\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"\<\"k\"\>", ",", "\<\"M\"\>"}], "}"}], ",", 
       RowBox[{"sched", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", "2"}], "]"}]}], "}"}]}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.481013955685008*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"showSchedResult", "[", "]"}]], "Input"],

Cell[BoxData["\<\"T_in{k, M} = 0\\nT_out{k, M} = 3 + k\\nT_A{k, M} = \
1\\nT_adaptIn21{k, M} = 1\\nT_adaptIn22{k, M} = 2\\nT_adaptIn41{k, M} = 2 + k\
\\nT_adaptIn42{k, M} = 2 + k\"\>"], "Print",
 CellChangeTimes->{3.4810139559157763`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Test2 of scd",
 FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<testscd2.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"asaveLib", "[", "\"\<testscd1\>\"", "]"}], ";"}], "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"ashow", "[", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"analyze", "[", 
  RowBox[{"recurse", "\[Rule]", "True"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<add\>\"", "]"}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{"scd", "[", 
  RowBox[{"addConstraints", "\[Rule]", 
   RowBox[{"{", 
    RowBox[{"TaD1", "\[Equal]", "TbD1", "\[Equal]", "1"}], "}"}]}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<testscd2\>\"", "]"}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{"scd", "[", 
  RowBox[{
   RowBox[{"addConstraints", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"debug", "\[Rule]", "False"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"showSchedResult", "[", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"adaptUses", "[", "]"}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{"scd", "[", 
  RowBox[{
   RowBox[{"addConstraints", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"TinD1", "\[Equal]", "0"}], "}"}]}], ",", 
   RowBox[{"debug", "\[Rule]", "False"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"showSchedResult", "[", "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Test3 of scd",
 FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<testscd3.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"asaveLib", "[", "\"\<testscd1\>\"", "]"}], ";"}], "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"analyze", "[", 
  RowBox[{"recurse", "\[Rule]", "True"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<testscd2\>\"", "]"}], ";", 
  RowBox[{"ashow", "[", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"scd", "[", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"addConstraints", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"TinD1", "\[Equal]", "0"}], "}"}]}], ","}], "*)"}], 
  RowBox[{"debug", "\[Rule]", "False"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"$scheduleMDSol", "[", "1", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"adaptUses", "[", "]"}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{"scd", "[", 
  RowBox[{
   RowBox[{"addConstraints", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"TinD2", "\[Equal]", "0"}], ",", 
      RowBox[{"TinD1", "\[Equal]", "0"}], ",", 
      RowBox[{"TadaptIn11D2", "\[Equal]", "0"}], ",", 
      RowBox[{"TadaptIn12D2", "\[Equal]", "0"}]}], "}"}]}], ",", 
   RowBox[{"debug", "\[Rule]", "False"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"showSchedResult", "[", "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Test4 of scd",
 FontColor->RGBColor[0, 0, 1]]], "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"load", "[", "\"\<testscd4.alpha\>\"", "]"}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"asaveLib", "[", "\"\<testscd1\>\"", "]"}], ";"}], "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"analyze", "[", 
  RowBox[{"recurse", "\[Rule]", "True"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"getSystem", "[", "\"\<testscd4\>\"", "]"}], ";", 
  RowBox[{"ashow", "[", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"analyze", "[", 
  RowBox[{"recurse", "\[Rule]", "True"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"show", "[", 
  RowBox[{"$scheduleDepTable", ",", 
   RowBox[{"silent", "\[Rule]", "True"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"scd", "[", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"addConstraints", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"TinD1", "\[Equal]", "0"}], "}"}]}], ","}], "*)"}], 
  RowBox[{
   RowBox[{"debug", "\[Rule]", "False"}], ",", 
   RowBox[{"verbose", "\[Rule]", "True"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"$scheduleMDSol", "[", "1", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"FullForm", "[", 
  RowBox[{
   RowBox[{"$scheduleMDSol", "[", "1", "]"}], "[", 
   RowBox[{"[", 
    RowBox[{"2", ",", "4"}], "]"}], "]"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"adaptUses", "[", "]"}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{"scd", "[", 
  RowBox[{
   RowBox[{"addConstraints", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"TinD2", "\[Equal]", "0"}], ",", 
      RowBox[{"TinD1", "\[Equal]", "0"}], ",", 
      RowBox[{"TadaptIn11D2", "\[Equal]", "0"}], ",", 
      RowBox[{"TadaptIn12D2", "\[Equal]", "0"}]}], "}"}]}], ",", 
   RowBox[{"debug", "\[Rule]", "False"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"showSchedResult", "[", "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Tests (has to be corrected, some additional \
constraints have the old form without strings)",
 FontColor->RGBColor[0, 0, 1]]], "Section",
 CellChangeTimes->{{3.481013981743668*^9, 3.4810140074939003`*^9}}],

Cell[BoxData[
 RowBox[{"tests", "[", "\"\<VertexSchedule\>\"", "]"}]], "Input"]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->None,
WindowToolbars->{"RulerBar", "EditBar"},
Evaluator->"Local",
WindowSize->{927, 642},
WindowMargins->{{160, Automatic}, {Automatic, 25}},
DockedCells->FEPrivate`FrontEndResource[
 "FEExpressions", "CompatibilityToolbar"],
ShowSelection->True,
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.25, 1.25 Inherited],
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (February 18, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "firstcell"->{
  Cell[567, 22, 96, 2, 95, "Title",
   CellTags->"firstcell"]},
 "Info3480943629-7789177"->{
  Cell[57368, 1550, 225, 4, 70, "Print",
   CellTags->"Info3480943629-7789177"]},
 "Info3480943634-9637942"->{
  Cell[57695, 1562, 525, 8, 130, "Print",
   CellTags->"Info3480943634-9637942"]},
 "Info3480943636-4954515"->{
  Cell[58322, 1578, 254, 5, 70, "Print",
   CellTags->"Info3480943636-4954515"]},
 "Info3480943663-5598681"->{
  Cell[58666, 1591, 363, 6, 90, "Print",
   CellTags->"Info3480943663-5598681"]},
 "Info3480943667-3693900"->{
  Cell[59119, 1605, 190, 4, 49, "Print",
   CellTags->"Info3480943667-3693900"]},
 "Info3480943671-1876946"->{
  Cell[60088, 1636, 312, 5, 90, "Print",
   CellTags->"Info3480943671-1876946"]},
 "Info3480943673-5663851"->{
  Cell[60496, 1649, 235, 4, 70, "Print",
   CellTags->"Info3480943673-5663851"]},
 "Info3480943674-6337480"->{
  Cell[60822, 1661, 436, 7, 130, "Print",
   CellTags->"Info3480943674-6337480"]},
 "Info3480943676-5972647"->{
  Cell[61349, 1676, 353, 6, 90, "Print",
   CellTags->"Info3480943676-5972647"]},
 "Info3480943679-1570090"->{
  Cell[61798, 1690, 445, 7, 110, "Print",
   CellTags->"Info3480943679-1570090"]},
 "Info3480943681-3850717"->{
  Cell[62336, 1705, 206, 4, 49, "Print",
   CellTags->"Info3480943681-3850717"]},
 "Info3480943683-2152991"->{
  Cell[62635, 1717, 300, 5, 90, "Print",
   CellTags->"Info3480943683-2152991"]},
 "Info3480943684-5679283"->{
  Cell[63033, 1730, 276, 5, 70, "Print",
   CellTags->"Info3480943684-5679283"]},
 "Info3480943685-7374309"->{
  Cell[63433, 1745, 149, 2, 48, "Print",
   CellTags->"Info3480943685-7374309"],
  Cell[63585, 1749, 58131, 1183, 5359, "Print",
   CellTags->"Info3480943685-7374309"]},
 "Info3480943687-5539735"->{
  Cell[121834, 2941, 479, 8, 150, "Print",
   CellTags->"Info3480943687-5539735"]},
 "Info3480943689-3045987"->{
  Cell[122413, 2957, 223, 4, 70, "Print",
   CellTags->"Info3480943689-3045987"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"firstcell", 313784, 8131},
 {"Info3480943629-7789177", 313877, 8134},
 {"Info3480943634-9637942", 313988, 8137},
 {"Info3480943636-4954515", 314100, 8140},
 {"Info3480943663-5598681", 314211, 8143},
 {"Info3480943667-3693900", 314322, 8146},
 {"Info3480943671-1876946", 314433, 8149},
 {"Info3480943673-5663851", 314544, 8152},
 {"Info3480943674-6337480", 314655, 8155},
 {"Info3480943676-5972647", 314767, 8158},
 {"Info3480943679-1570090", 314878, 8161},
 {"Info3480943681-3850717", 314990, 8164},
 {"Info3480943683-2152991", 315101, 8167},
 {"Info3480943684-5679283", 315212, 8170},
 {"Info3480943685-7374309", 315323, 8173},
 {"Info3480943687-5539735", 315522, 8178},
 {"Info3480943689-3045987", 315635, 8181}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 96, 2, 95, "Title",
 CellTags->"firstcell"],
Cell[666, 26, 76, 3, 54, "Subsubtitle"],
Cell[CellGroupData[{
Cell[767, 33, 185, 5, 47, "Subsubsection"],
Cell[955, 40, 67, 1, 40, "SmallText"],
Cell[1025, 43, 334, 13, 287, "SmallText"],
Cell[1362, 58, 100, 3, 63, "SmallText"]
}, Closed]],
Cell[CellGroupData[{
Cell[1499, 66, 106, 1, 21, "Subsubsection"],
Cell[CellGroupData[{
Cell[1630, 71, 206, 6, 43, "Input",
 InitializationCell->True],
Cell[1839, 79, 165, 2, 70, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[2053, 87, 82, 1, 45, "Section"],
Cell[2138, 90, 143, 3, 32, "Text"],
Cell[CellGroupData[{
Cell[2306, 97, 96, 2, 33, "Input"],
Cell[2405, 101, 114, 1, 25, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2556, 107, 53, 1, 33, "Input"],
Cell[2612, 110, 809, 10, 425, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[3458, 125, 98, 2, 25, "Input"],
Cell[CellGroupData[{
Cell[3581, 131, 328, 7, 25, "Print"],
Cell[3912, 140, 101, 1, 25, "Print"],
Cell[4016, 143, 271, 6, 25, "Print"],
Cell[4290, 151, 136, 1, 25, "Print"],
Cell[4429, 154, 134, 1, 25, "Print"],
Cell[4566, 157, 151, 2, 25, "Print"],
Cell[4720, 161, 141, 1, 25, "Print"],
Cell[4864, 164, 151, 2, 25, "Print"],
Cell[5018, 168, 157, 2, 25, "Print"],
Cell[5178, 172, 266, 6, 25, "Print"],
Cell[5447, 180, 258, 5, 25, "Print"],
Cell[5708, 187, 140, 1, 25, "Print"],
Cell[5851, 190, 136, 1, 25, "Print"],
Cell[5990, 193, 125, 1, 45, "Print"],
Cell[6118, 196, 103, 1, 25, "Print"],
Cell[6224, 199, 280, 6, 25, "Print"],
Cell[6507, 207, 136, 1, 25, "Print"],
Cell[6646, 210, 136, 1, 25, "Print"],
Cell[6785, 213, 151, 2, 25, "Print"],
Cell[6939, 217, 141, 1, 25, "Print"],
Cell[7083, 220, 151, 2, 25, "Print"],
Cell[7237, 224, 160, 2, 25, "Print"],
Cell[7400, 228, 256, 5, 25, "Print"],
Cell[7659, 235, 256, 5, 25, "Print"],
Cell[7918, 242, 281, 6, 25, "Print"],
Cell[8202, 250, 140, 1, 25, "Print"]
}, Open  ]],
Cell[8357, 254, 516, 9, 26, "Message"],
Cell[8876, 265, 364, 7, 26, "Message"],
Cell[9243, 274, 303, 6, 26, "Message"],
Cell[CellGroupData[{
Cell[9571, 284, 125, 1, 45, "Print"],
Cell[9699, 287, 133, 1, 45, "Print"]
}, Open  ]],
Cell[9847, 291, 95, 1, 33, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[9979, 297, 119, 2, 25, "Input"],
Cell[10101, 301, 786, 10, 425, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10936, 317, 93, 1, 83, "Section"],
Cell[11032, 320, 154, 3, 32, "Text"],
Cell[CellGroupData[{
Cell[11211, 327, 461, 11, 91, "Input"],
Cell[11675, 340, 143, 3, 33, "Output"],
Cell[CellGroupData[{
Cell[11843, 347, 117, 1, 25, "Print"],
Cell[11963, 350, 399, 8, 25, "Print"],
Cell[12365, 360, 237, 4, 25, "Print"]
}, Open  ]],
Cell[12617, 367, 1345, 38, 53, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13999, 410, 101, 2, 33, "Input"],
Cell[CellGroupData[{
Cell[14125, 416, 116, 1, 25, "Print"],
Cell[14244, 419, 120, 1, 25, "Print"],
Cell[14367, 422, 114, 1, 25, "Print"],
Cell[14484, 425, 267, 6, 25, "Print"],
Cell[14754, 433, 115, 1, 25, "Print"],
Cell[14872, 436, 114, 1, 25, "Print"],
Cell[14989, 439, 115, 1, 25, "Print"],
Cell[15107, 442, 118, 1, 25, "Print"],
Cell[15228, 445, 120, 1, 25, "Print"],
Cell[15351, 448, 122, 1, 25, "Print"],
Cell[15476, 451, 120, 1, 25, "Print"],
Cell[15599, 454, 118, 1, 25, "Print"],
Cell[15720, 457, 118, 1, 25, "Print"],
Cell[15841, 460, 120, 1, 25, "Print"],
Cell[15964, 463, 399, 7, 45, "Print"],
Cell[16366, 472, 122, 1, 25, "Print"],
Cell[16491, 475, 232, 5, 25, "Print"],
Cell[16726, 482, 114, 1, 25, "Print"],
Cell[16843, 485, 309, 7, 25, "Print"],
Cell[17155, 494, 238, 3, 102, "Print"]
}, Open  ]],
Cell[17408, 500, 1949, 54, 91, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19394, 559, 100, 2, 33, "Input"],
Cell[CellGroupData[{
Cell[19519, 565, 304, 6, 45, "Print"],
Cell[19826, 573, 106, 1, 25, "Print"],
Cell[19935, 576, 131, 1, 45, "Print"],
Cell[20069, 579, 169, 2, 25, "Print"],
Cell[20241, 583, 258, 5, 25, "Print"],
Cell[20502, 590, 129, 1, 25, "Print"],
Cell[20634, 593, 240, 5, 25, "Print"],
Cell[20877, 600, 254, 5, 25, "Print"],
Cell[21134, 607, 562, 14, 25, "Print"],
Cell[21699, 623, 128, 1, 25, "Print"],
Cell[21830, 626, 107, 1, 25, "Print"],
Cell[21940, 629, 272, 6, 25, "Print"],
Cell[22215, 637, 127, 1, 25, "Print"],
Cell[22345, 640, 109, 1, 25, "Print"],
Cell[22457, 643, 123, 1, 25, "Print"],
Cell[22583, 646, 134, 2, 25, "Print"],
Cell[22720, 650, 122, 1, 25, "Print"],
Cell[22845, 653, 181, 4, 25, "Print"],
Cell[23029, 659, 123, 1, 25, "Print"],
Cell[23155, 662, 111, 1, 25, "Print"],
Cell[23269, 665, 274, 6, 25, "Print"],
Cell[23546, 673, 128, 1, 25, "Print"],
Cell[23677, 676, 123, 1, 25, "Print"],
Cell[23803, 679, 209, 4, 25, "Print"],
Cell[24015, 685, 123, 1, 25, "Print"],
Cell[24141, 688, 238, 4, 25, "Print"],
Cell[24382, 694, 123, 1, 25, "Print"],
Cell[24508, 697, 112, 1, 25, "Print"],
Cell[24623, 700, 782, 16, 83, "Print"],
Cell[25408, 718, 734, 15, 64, "Print"],
Cell[26145, 735, 726, 15, 64, "Print"],
Cell[26874, 752, 904, 22, 64, "Print"],
Cell[27781, 776, 119, 1, 25, "Print"],
Cell[27903, 779, 262, 5, 25, "Print"],
Cell[28168, 786, 123, 1, 25, "Print"],
Cell[28294, 789, 455, 13, 25, "Print"],
Cell[28752, 804, 122, 1, 25, "Print"],
Cell[28877, 807, 138, 1, 25, "Print"],
Cell[29018, 810, 124, 1, 25, "Print"],
Cell[29145, 813, 523, 7, 121, "Print"],
Cell[29671, 822, 134, 1, 25, "Print"],
Cell[29808, 825, 127, 1, 25, "Print"],
Cell[29938, 828, 130, 1, 25, "Print"],
Cell[30071, 831, 114, 1, 25, "Print"],
Cell[30188, 834, 271, 6, 25, "Print"],
Cell[30462, 842, 117, 1, 25, "Print"],
Cell[30582, 845, 118, 1, 25, "Print"],
Cell[30703, 848, 117, 1, 25, "Print"],
Cell[30823, 851, 122, 1, 25, "Print"],
Cell[30948, 854, 122, 1, 25, "Print"],
Cell[31073, 857, 124, 1, 25, "Print"],
Cell[31200, 860, 120, 1, 25, "Print"],
Cell[31323, 863, 120, 1, 25, "Print"],
Cell[31446, 866, 122, 1, 25, "Print"],
Cell[31571, 869, 119, 1, 25, "Print"],
Cell[31693, 872, 403, 7, 45, "Print"],
Cell[32099, 881, 130, 1, 25, "Print"],
Cell[32232, 884, 130, 1, 25, "Print"],
Cell[32365, 887, 130, 1, 25, "Print"],
Cell[32498, 890, 151, 2, 25, "Print"],
Cell[32652, 894, 158, 2, 25, "Print"],
Cell[32813, 898, 130, 1, 25, "Print"],
Cell[32946, 901, 130, 1, 25, "Print"],
Cell[33079, 904, 130, 1, 25, "Print"],
Cell[33212, 907, 151, 2, 25, "Print"],
Cell[33366, 911, 159, 2, 25, "Print"],
Cell[33528, 915, 132, 1, 25, "Print"],
Cell[33663, 918, 130, 1, 25, "Print"],
Cell[33796, 921, 140, 1, 25, "Print"],
Cell[33939, 924, 161, 2, 25, "Print"],
Cell[34103, 928, 130, 1, 25, "Print"],
Cell[34236, 931, 130, 1, 25, "Print"],
Cell[34369, 934, 142, 1, 25, "Print"],
Cell[34514, 937, 159, 2, 25, "Print"],
Cell[34676, 941, 132, 1, 25, "Print"],
Cell[34811, 944, 132, 1, 25, "Print"],
Cell[34946, 947, 142, 1, 25, "Print"],
Cell[35091, 950, 159, 2, 25, "Print"],
Cell[35253, 954, 132, 1, 25, "Print"],
Cell[35388, 957, 132, 1, 25, "Print"],
Cell[35523, 960, 153, 2, 25, "Print"],
Cell[35679, 964, 174, 2, 25, "Print"],
Cell[35856, 968, 150, 2, 25, "Print"],
Cell[36009, 972, 145, 1, 25, "Print"],
Cell[36157, 975, 145, 1, 25, "Print"],
Cell[36305, 978, 161, 2, 25, "Print"],
Cell[36469, 982, 189, 2, 25, "Print"],
Cell[36661, 986, 145, 1, 25, "Print"],
Cell[36809, 989, 145, 1, 25, "Print"],
Cell[36957, 992, 148, 2, 25, "Print"],
Cell[37108, 996, 161, 2, 25, "Print"],
Cell[37272, 1000, 222, 2, 45, "Print"],
Cell[37497, 1004, 148, 2, 25, "Print"],
Cell[37648, 1008, 145, 1, 25, "Print"],
Cell[37796, 1011, 145, 1, 25, "Print"],
Cell[37944, 1014, 161, 2, 25, "Print"],
Cell[38108, 1018, 189, 2, 25, "Print"],
Cell[38300, 1022, 147, 1, 25, "Print"],
Cell[38450, 1025, 139, 1, 25, "Print"],
Cell[38592, 1028, 147, 1, 25, "Print"],
Cell[38742, 1031, 161, 2, 25, "Print"],
Cell[38906, 1035, 215, 2, 45, "Print"],
Cell[39124, 1039, 145, 1, 25, "Print"],
Cell[39272, 1042, 145, 1, 25, "Print"],
Cell[39420, 1045, 145, 1, 25, "Print"],
Cell[39568, 1048, 145, 1, 25, "Print"],
Cell[39716, 1051, 186, 2, 25, "Print"],
Cell[39905, 1055, 131, 1, 25, "Print"],
Cell[40039, 1058, 132, 1, 25, "Print"],
Cell[40174, 1061, 133, 1, 25, "Print"],
Cell[40310, 1064, 145, 1, 25, "Print"],
Cell[40458, 1067, 186, 2, 25, "Print"],
Cell[40647, 1071, 117, 1, 25, "Print"],
Cell[40767, 1074, 118, 1, 25, "Print"],
Cell[40888, 1077, 117, 1, 25, "Print"],
Cell[41008, 1080, 122, 1, 25, "Print"],
Cell[41133, 1083, 120, 1, 25, "Print"],
Cell[41256, 1086, 126, 1, 25, "Print"],
Cell[41385, 1089, 122, 1, 25, "Print"],
Cell[41510, 1092, 122, 1, 25, "Print"],
Cell[41635, 1095, 120, 1, 25, "Print"],
Cell[41758, 1098, 120, 1, 25, "Print"],
Cell[41881, 1101, 126, 1, 25, "Print"],
Cell[42010, 1104, 282, 6, 25, "Print"],
Cell[42295, 1112, 276, 6, 25, "Print"],
Cell[42574, 1120, 268, 6, 25, "Print"],
Cell[42845, 1128, 232, 5, 25, "Print"],
Cell[43080, 1135, 431, 10, 25, "Print"],
Cell[43514, 1147, 429, 10, 25, "Print"],
Cell[43946, 1159, 347, 7, 25, "Print"],
Cell[44296, 1168, 119, 1, 25, "Print"],
Cell[44418, 1171, 228, 5, 25, "Print"],
Cell[44649, 1178, 311, 7, 25, "Print"],
Cell[44963, 1187, 240, 3, 102, "Print"]
}, Open  ]],
Cell[45218, 1193, 1949, 54, 91, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[47204, 1252, 69, 1, 33, "Input"],
Cell[47276, 1255, 2366, 65, 124, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[49679, 1325, 132, 3, 53, "Input"],
Cell[CellGroupData[{
Cell[49836, 1332, 116, 1, 25, "Print"],
Cell[49955, 1335, 120, 1, 25, "Print"],
Cell[50078, 1338, 114, 1, 25, "Print"],
Cell[50195, 1341, 395, 7, 45, "Print"],
Cell[50593, 1350, 122, 1, 25, "Print"],
Cell[50718, 1353, 117, 1, 25, "Print"],
Cell[50838, 1356, 284, 6, 25, "Print"],
Cell[51125, 1364, 164, 2, 83, "Print"]
}, Open  ]],
Cell[51304, 1369, 1316, 38, 53, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[52657, 1412, 69, 1, 33, "Input"],
Cell[52729, 1415, 1622, 44, 105, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[54388, 1464, 76, 1, 33, "Input"],
Cell[54467, 1467, 2809, 75, 162, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[57313, 1547, 52, 1, 33, "Input"],
Cell[57368, 1550, 225, 4, 70, "Print",
 CellTags->"Info3480943629-7789177"]
}, Open  ]],
Cell[CellGroupData[{
Cell[57630, 1559, 62, 1, 33, "Input"],
Cell[57695, 1562, 525, 8, 130, "Print",
 CellTags->"Info3480943634-9637942"]
}, Open  ]],
Cell[CellGroupData[{
Cell[58257, 1575, 62, 1, 33, "Input"],
Cell[58322, 1578, 254, 5, 70, "Print",
 CellTags->"Info3480943636-4954515"]
}, Open  ]],
Cell[CellGroupData[{
Cell[58613, 1588, 50, 1, 33, "Input"],
Cell[58666, 1591, 363, 6, 90, "Print",
 CellTags->"Info3480943663-5598681"]
}, Open  ]],
Cell[CellGroupData[{
Cell[59066, 1602, 50, 1, 33, "Input"],
Cell[59119, 1605, 190, 4, 49, "Print",
 CellTags->"Info3480943667-3693900"]
}, Open  ]],
Cell[CellGroupData[{
Cell[59346, 1614, 50, 1, 33, "Input"],
Cell[59399, 1617, 597, 11, 26, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[60033, 1633, 52, 1, 33, "Input"],
Cell[60088, 1636, 312, 5, 90, "Print",
 CellTags->"Info3480943671-1876946"]
}, Open  ]],
Cell[CellGroupData[{
Cell[60437, 1646, 56, 1, 33, "Input"],
Cell[60496, 1649, 235, 4, 70, "Print",
 CellTags->"Info3480943673-5663851"]
}, Open  ]],
Cell[CellGroupData[{
Cell[60768, 1658, 51, 1, 33, "Input"],
Cell[60822, 1661, 436, 7, 130, "Print",
 CellTags->"Info3480943674-6337480"]
}, Open  ]],
Cell[CellGroupData[{
Cell[61295, 1673, 51, 1, 33, "Input"],
Cell[61349, 1676, 353, 6, 90, "Print",
 CellTags->"Info3480943676-5972647"]
}, Open  ]],
Cell[CellGroupData[{
Cell[61739, 1687, 56, 1, 33, "Input"],
Cell[61798, 1690, 445, 7, 110, "Print",
 CellTags->"Info3480943679-1570090"]
}, Open  ]],
Cell[CellGroupData[{
Cell[62280, 1702, 53, 1, 33, "Input"],
Cell[62336, 1705, 206, 4, 49, "Print",
 CellTags->"Info3480943681-3850717"]
}, Open  ]],
Cell[CellGroupData[{
Cell[62579, 1714, 53, 1, 33, "Input"],
Cell[62635, 1717, 300, 5, 90, "Print",
 CellTags->"Info3480943683-2152991"]
}, Open  ]],
Cell[CellGroupData[{
Cell[62972, 1727, 58, 1, 33, "Input"],
Cell[63033, 1730, 276, 5, 70, "Print",
 CellTags->"Info3480943684-5679283"]
}, Open  ]],
Cell[CellGroupData[{
Cell[63346, 1740, 62, 1, 33, "Input"],
Cell[CellGroupData[{
Cell[63433, 1745, 149, 2, 48, "Print",
 CellTags->"Info3480943685-7374309"],
Cell[63585, 1749, 58131, 1183, 5359, "Print",
 CellTags->"Info3480943685-7374309"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[121765, 2938, 66, 1, 25, "Input"],
Cell[121834, 2941, 479, 8, 150, "Print",
 CellTags->"Info3480943687-5539735"]
}, Open  ]],
Cell[CellGroupData[{
Cell[122350, 2954, 60, 1, 33, "Input"],
Cell[122413, 2957, 223, 4, 70, "Print",
 CellTags->"Info3480943689-3045987"]
}, Open  ]],
Cell[122651, 2964, 46, 1, 33, "Input"],
Cell[122700, 2967, 57, 1, 33, "Input"],
Cell[122760, 2970, 57, 1, 33, "Input"],
Cell[122820, 2973, 50, 1, 33, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[122907, 2979, 113, 1, 83, "Section"],
Cell[123023, 2982, 443, 8, 70, "Text"],
Cell[CellGroupData[{
Cell[123491, 2994, 259, 7, 53, "Input"],
Cell[CellGroupData[{
Cell[123775, 3005, 121, 1, 25, "Print"],
Cell[123899, 3008, 122, 1, 25, "Print"],
Cell[124024, 3011, 116, 1, 25, "Print"],
Cell[124143, 3014, 267, 6, 25, "Print"],
Cell[124413, 3022, 117, 1, 25, "Print"],
Cell[124533, 3025, 117, 1, 25, "Print"],
Cell[124653, 3028, 399, 7, 45, "Print"],
Cell[125055, 3037, 124, 1, 25, "Print"],
Cell[125182, 3040, 117, 1, 25, "Print"],
Cell[125302, 3043, 286, 6, 25, "Print"],
Cell[125591, 3051, 175, 2, 83, "Print"]
}, Open  ]],
Cell[125781, 3056, 1367, 40, 53, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[127185, 3101, 322, 8, 53, "Input"],
Cell[CellGroupData[{
Cell[127532, 3113, 115, 1, 25, "Print"],
Cell[127650, 3116, 401, 8, 25, "Print"],
Cell[128054, 3126, 240, 4, 25, "Print"]
}, Open  ]],
Cell[128309, 3133, 1311, 37, 53, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[129657, 3175, 100, 2, 33, "Input"],
Cell[129760, 3179, 298, 6, 25, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[130107, 3191, 100, 1, 83, "Section"],
Cell[130210, 3194, 205, 5, 51, "Text"],
Cell[CellGroupData[{
Cell[130440, 3203, 96, 2, 33, "Input"],
Cell[130539, 3207, 90, 1, 25, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[130666, 3213, 53, 1, 33, "Input"],
Cell[130722, 3216, 788, 10, 425, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[131547, 3231, 450, 11, 72, "Input"],
Cell[CellGroupData[{
Cell[132022, 3246, 262, 5, 25, "Print"],
Cell[132287, 3253, 270, 6, 25, "Print"],
Cell[132560, 3261, 119, 1, 25, "Print"],
Cell[132682, 3264, 124, 1, 25, "Print"],
Cell[132809, 3267, 523, 7, 121, "Print"],
Cell[133335, 3276, 134, 1, 25, "Print"],
Cell[133472, 3279, 127, 1, 25, "Print"],
Cell[133602, 3282, 128, 1, 25, "Print"],
Cell[133733, 3285, 364, 7, 25, "Print"],
Cell[134100, 3294, 761, 19, 25, "Print"],
Cell[134864, 3315, 364, 7, 25, "Print"],
Cell[135231, 3324, 761, 19, 25, "Print"],
Cell[135995, 3345, 366, 7, 25, "Print"],
Cell[136364, 3354, 3502, 80, 140, "Print"],
Cell[139869, 3436, 366, 7, 25, "Print"],
Cell[140238, 3445, 2691, 63, 83, "Print"],
Cell[142932, 3510, 364, 7, 25, "Print"],
Cell[143299, 3519, 3604, 79, 140, "Print"],
Cell[146906, 3600, 364, 7, 25, "Print"],
Cell[147273, 3609, 3502, 80, 140, "Print"],
Cell[150778, 3691, 364, 7, 25, "Print"],
Cell[151145, 3700, 1516, 36, 64, "Print"],
Cell[152664, 3738, 364, 7, 25, "Print"],
Cell[153031, 3747, 3602, 79, 140, "Print"],
Cell[156636, 3828, 240, 6, 25, "Print"],
Cell[156879, 3836, 394, 9, 45, "Print"],
Cell[157276, 3847, 2406, 47, 140, "Print"],
Cell[159685, 3896, 131, 1, 25, "Print"],
Cell[159819, 3899, 140, 1, 25, "Print"],
Cell[159962, 3902, 17324, 368, 653, "Print"],
Cell[177289, 4272, 16521, 378, 596, "Print"],
Cell[193813, 4652, 1566, 35, 64, "Print"],
Cell[195382, 4689, 878, 23, 64, "Print"],
Cell[196263, 4714, 115, 1, 25, "Print"],
Cell[196381, 4717, 404, 8, 25, "Print"],
Cell[196788, 4727, 120, 1, 25, "Print"],
Cell[196911, 4730, 1516, 35, 83, "Print"],
Cell[198430, 4767, 251, 5, 25, "Print"]
}, Open  ]],
Cell[198696, 4775, 1931, 54, 72, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[200664, 4834, 139, 3, 53, "Input"],
Cell[CellGroupData[{
Cell[200828, 4841, 95, 1, 25, "Print"],
Cell[200926, 4844, 98, 1, 25, "Print"],
Cell[201027, 4847, 90, 1, 25, "Print"],
Cell[201120, 4850, 245, 6, 25, "Print"],
Cell[201368, 4858, 95, 1, 25, "Print"],
Cell[201466, 4861, 92, 1, 25, "Print"],
Cell[201561, 4864, 91, 1, 25, "Print"],
Cell[201655, 4867, 96, 1, 25, "Print"],
Cell[201754, 4870, 96, 1, 25, "Print"],
Cell[201853, 4873, 100, 1, 25, "Print"],
Cell[201956, 4876, 96, 1, 25, "Print"],
Cell[202055, 4879, 95, 1, 25, "Print"],
Cell[202153, 4882, 96, 1, 25, "Print"],
Cell[202252, 4885, 96, 1, 25, "Print"],
Cell[202351, 4888, 379, 7, 45, "Print"],
Cell[202733, 4897, 102, 1, 25, "Print"],
Cell[202838, 4900, 208, 5, 25, "Print"],
Cell[203049, 4907, 93, 1, 25, "Print"],
Cell[203145, 4910, 287, 7, 25, "Print"],
Cell[203435, 4919, 218, 3, 102, "Print"]
}, Open  ]],
Cell[203668, 4925, 1929, 54, 91, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[205634, 4984, 63, 1, 33, "Input"],
Cell[205700, 4987, 218, 3, 102, "Print"]
}, Open  ]],
Cell[205933, 4993, 155, 5, 32, "Text"],
Cell[CellGroupData[{
Cell[206113, 5002, 53, 1, 33, "Input"],
Cell[206169, 5005, 788, 10, 425, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[206994, 5020, 51, 1, 33, "Input"],
Cell[CellGroupData[{
Cell[207070, 5025, 216, 6, 25, "Print"],
Cell[207289, 5033, 93, 1, 25, "Print"],
Cell[207385, 5036, 379, 8, 25, "Print"],
Cell[207767, 5046, 229, 5, 25, "Print"]
}, Open  ]],
Cell[208011, 5054, 1931, 54, 72, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[209991, 5114, 103, 1, 83, "Section"],
Cell[210097, 5117, 93, 2, 32, "Text"],
Cell[CellGroupData[{
Cell[210215, 5123, 97, 2, 33, "Input"],
Cell[210315, 5127, 93, 1, 25, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[210445, 5133, 153, 4, 53, "Input"],
Cell[CellGroupData[{
Cell[210623, 5141, 91, 1, 25, "Print"],
Cell[210717, 5144, 375, 8, 25, "Print"],
Cell[211095, 5154, 222, 5, 25, "Print"]
}, Open  ]],
Cell[211332, 5162, 1192, 36, 53, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[212561, 5203, 53, 1, 33, "Input"],
Cell[212617, 5206, 346, 4, 178, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[213000, 5215, 136, 3, 33, "Input"],
Cell[213139, 5220, 284, 6, 25, "Print"]
}, Open  ]],
Cell[213438, 5229, 101, 3, 33, "Input"],
Cell[CellGroupData[{
Cell[213564, 5236, 88, 1, 33, "Input"],
Cell[213655, 5239, 1288, 40, 72, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[214980, 5284, 199, 5, 53, "Input"],
Cell[CellGroupData[{
Cell[215204, 5293, 678, 9, 387, "Print"],
Cell[215885, 5304, 91, 1, 25, "Print"],
Cell[215979, 5307, 377, 8, 25, "Print"],
Cell[216359, 5317, 220, 4, 25, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[216628, 5327, 136, 3, 33, "Input"],
Cell[216767, 5332, 276, 6, 25, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[217080, 5343, 82, 2, 33, "Input"],
Cell[CellGroupData[{
Cell[217187, 5349, 100, 1, 25, "Print"],
Cell[217290, 5352, 206, 3, 64, "Print"],
Cell[217499, 5357, 112, 1, 25, "Print"],
Cell[217614, 5360, 115, 1, 25, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[217778, 5367, 318, 8, 72, "Input"],
Cell[CellGroupData[{
Cell[218121, 5379, 274, 6, 25, "Print"],
Cell[218398, 5387, 94, 1, 25, "Print"],
Cell[218495, 5390, 98, 1, 25, "Print"],
Cell[218596, 5393, 89, 1, 25, "Print"],
Cell[218688, 5396, 243, 6, 25, "Print"],
Cell[218934, 5404, 92, 1, 25, "Print"],
Cell[219029, 5407, 95, 1, 25, "Print"],
Cell[219127, 5410, 94, 1, 25, "Print"],
Cell[219224, 5413, 100, 1, 25, "Print"],
Cell[219327, 5416, 98, 1, 25, "Print"],
Cell[219428, 5419, 98, 1, 25, "Print"],
Cell[219529, 5422, 101, 1, 25, "Print"],
Cell[219633, 5425, 99, 1, 25, "Print"],
Cell[219735, 5428, 96, 1, 25, "Print"],
Cell[219834, 5431, 98, 1, 25, "Print"],
Cell[219935, 5434, 98, 1, 25, "Print"],
Cell[220036, 5437, 99, 1, 25, "Print"],
Cell[220138, 5440, 373, 7, 45, "Print"],
Cell[220514, 5449, 100, 1, 25, "Print"],
Cell[220617, 5452, 93, 1, 25, "Print"],
Cell[220713, 5455, 258, 6, 25, "Print"],
Cell[220974, 5463, 197, 3, 121, "Print"]
}, Open  ]],
Cell[221186, 5469, 1926, 56, 72, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[223149, 5530, 79, 1, 33, "Input"],
Cell[CellGroupData[{
Cell[223253, 5535, 408, 11, 45, "Print"],
Cell[223664, 5548, 249, 6, 25, "Print"],
Cell[223916, 5556, 101, 1, 25, "Print"],
Cell[224020, 5559, 92, 1, 25, "Print"]
}, Open  ]],
Cell[224127, 5563, 365, 7, 26, "Message"],
Cell[224495, 5572, 373, 8, 26, "Message"],
Cell[CellGroupData[{
Cell[224893, 5584, 5409, 138, 254, "Print"],
Cell[230305, 5724, 90, 1, 25, "Print"],
Cell[230398, 5727, 93, 1, 25, "Print"],
Cell[230494, 5730, 100, 1, 25, "Print"],
Cell[230597, 5733, 90, 1, 25, "Print"],
Cell[230690, 5736, 245, 6, 25, "Print"],
Cell[230938, 5744, 101, 1, 25, "Print"],
Cell[231042, 5747, 108, 1, 25, "Print"],
Cell[231153, 5750, 101, 1, 25, "Print"],
Cell[231257, 5753, 112, 1, 25, "Print"],
Cell[231372, 5756, 104, 1, 25, "Print"],
Cell[231479, 5759, 108, 1, 25, "Print"],
Cell[231590, 5762, 114, 1, 25, "Print"],
Cell[231707, 5765, 112, 1, 25, "Print"],
Cell[231822, 5768, 104, 1, 25, "Print"],
Cell[231929, 5771, 104, 1, 25, "Print"],
Cell[232036, 5774, 379, 7, 45, "Print"],
Cell[232418, 5783, 100, 1, 25, "Print"],
Cell[232521, 5786, 208, 5, 25, "Print"],
Cell[232732, 5793, 93, 1, 25, "Print"],
Cell[232828, 5796, 287, 7, 25, "Print"],
Cell[233118, 5805, 281, 4, 140, "Print"],
Cell[233402, 5811, 270, 6, 25, "Print"],
Cell[233675, 5819, 93, 1, 25, "Print"],
Cell[233771, 5822, 91, 1, 25, "Print"],
Cell[233865, 5825, 377, 8, 25, "Print"],
Cell[234245, 5835, 221, 4, 25, "Print"]
}, Open  ]],
Cell[234481, 5842, 371, 8, 26, "Message"],
Cell[CellGroupData[{
Cell[234877, 5854, 5881, 146, 235, "Print"],
Cell[240761, 6002, 95, 1, 25, "Print"],
Cell[240859, 6005, 95, 1, 25, "Print"],
Cell[240957, 6008, 97, 1, 25, "Print"],
Cell[241057, 6011, 90, 1, 25, "Print"],
Cell[241150, 6014, 245, 6, 25, "Print"],
Cell[241398, 6022, 108, 1, 25, "Print"],
Cell[241509, 6025, 112, 1, 25, "Print"],
Cell[241624, 6028, 107, 1, 25, "Print"],
Cell[241734, 6031, 112, 1, 25, "Print"],
Cell[241849, 6034, 104, 1, 25, "Print"],
Cell[241956, 6037, 106, 1, 25, "Print"],
Cell[242065, 6040, 107, 1, 25, "Print"],
Cell[242175, 6043, 109, 1, 25, "Print"],
Cell[242287, 6046, 112, 1, 25, "Print"],
Cell[242402, 6049, 112, 1, 25, "Print"],
Cell[242517, 6052, 104, 1, 25, "Print"],
Cell[242624, 6055, 106, 1, 25, "Print"],
Cell[242733, 6058, 377, 7, 45, "Print"],
Cell[243113, 6067, 99, 1, 25, "Print"],
Cell[243215, 6070, 208, 5, 25, "Print"],
Cell[243426, 6077, 93, 1, 25, "Print"],
Cell[243522, 6080, 258, 6, 25, "Print"],
Cell[243783, 6088, 288, 4, 178, "Print"],
Cell[244074, 6094, 270, 6, 25, "Print"],
Cell[244347, 6102, 91, 1, 25, "Print"]
}, Open  ]],
Cell[244453, 6106, 439, 8, 26, "Message"],
Cell[CellGroupData[{
Cell[244917, 6118, 91, 1, 25, "Print"],
Cell[245011, 6121, 377, 8, 25, "Print"],
Cell[245391, 6131, 229, 5, 25, "Print"],
Cell[245623, 6138, 270, 6, 25, "Print"],
Cell[245896, 6146, 91, 1, 25, "Print"]
}, Open  ]],
Cell[246002, 6150, 437, 8, 26, "Message"],
Cell[246442, 6160, 639, 12, 26, "Message"],
Cell[CellGroupData[{
Cell[247106, 6176, 97, 1, 25, "Print"],
Cell[247206, 6179, 100, 1, 25, "Print"],
Cell[247309, 6182, 92, 1, 25, "Print"],
Cell[247404, 6185, 243, 6, 25, "Print"],
Cell[247650, 6193, 94, 1, 25, "Print"],
Cell[247747, 6196, 92, 1, 25, "Print"],
Cell[247842, 6199, 93, 1, 25, "Print"],
Cell[247938, 6202, 96, 1, 25, "Print"],
Cell[248037, 6205, 99, 1, 25, "Print"],
Cell[248139, 6208, 95, 1, 25, "Print"],
Cell[248237, 6211, 99, 1, 25, "Print"],
Cell[248339, 6214, 375, 7, 45, "Print"],
Cell[248717, 6223, 98, 1, 25, "Print"],
Cell[248818, 6226, 93, 1, 25, "Print"]
}, Open  ]],
Cell[248926, 6230, 319, 8, 26, "Message"],
Cell[CellGroupData[{
Cell[249270, 6242, 270, 6, 25, "Print"],
Cell[249543, 6250, 91, 1, 25, "Print"],
Cell[249637, 6253, 95, 1, 25, "Print"],
Cell[249735, 6256, 98, 1, 25, "Print"],
Cell[249836, 6259, 92, 1, 25, "Print"],
Cell[249931, 6262, 243, 6, 25, "Print"],
Cell[250177, 6270, 101, 1, 25, "Print"],
Cell[250281, 6273, 108, 1, 25, "Print"],
Cell[250392, 6276, 101, 1, 25, "Print"],
Cell[250496, 6279, 111, 1, 25, "Print"],
Cell[250610, 6282, 106, 1, 25, "Print"],
Cell[250719, 6285, 95, 1, 25, "Print"],
Cell[250817, 6288, 106, 1, 25, "Print"],
Cell[250926, 6291, 373, 7, 45, "Print"],
Cell[251302, 6300, 99, 1, 25, "Print"],
Cell[251404, 6303, 92, 1, 25, "Print"],
Cell[251499, 6306, 262, 6, 25, "Print"],
Cell[251764, 6314, 186, 2, 102, "Print"],
Cell[251953, 6318, 270, 6, 25, "Print"],
Cell[252226, 6326, 123, 1, 25, "Print"]
}, Open  ]],
Cell[252364, 6330, 75, 1, 33, "Output"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[252488, 6337, 108, 1, 83, "Section"],
Cell[252599, 6340, 93, 2, 32, "Text"],
Cell[CellGroupData[{
Cell[252717, 6346, 97, 2, 33, "Input"],
Cell[252817, 6350, 93, 1, 25, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[252947, 6356, 158, 4, 53, "Input"],
Cell[CellGroupData[{
Cell[253130, 6364, 95, 1, 25, "Print"],
Cell[253228, 6367, 100, 1, 25, "Print"],
Cell[253331, 6370, 90, 1, 25, "Print"],
Cell[253424, 6373, 373, 7, 45, "Print"],
Cell[253800, 6382, 100, 1, 25, "Print"],
Cell[253903, 6385, 93, 1, 25, "Print"],
Cell[253999, 6388, 224, 5, 25, "Print"],
Cell[254226, 6395, 140, 2, 102, "Print"]
}, Open  ]],
Cell[254381, 6400, 1192, 36, 53, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[255610, 6441, 53, 1, 33, "Input"],
Cell[255666, 6444, 346, 4, 178, "Print"]
}, Open  ]],
Cell[256027, 6451, 101, 3, 33, "Input"],
Cell[CellGroupData[{
Cell[256153, 6458, 207, 5, 53, "Input"],
Cell[CellGroupData[{
Cell[256385, 6467, 678, 9, 387, "Print"],
Cell[257066, 6478, 370, 8, 45, "Print"],
Cell[257439, 6488, 95, 1, 25, "Print"],
Cell[257537, 6491, 98, 1, 25, "Print"],
Cell[257638, 6494, 92, 1, 25, "Print"],
Cell[257733, 6497, 375, 7, 45, "Print"],
Cell[258111, 6506, 100, 1, 25, "Print"],
Cell[258214, 6509, 93, 1, 25, "Print"],
Cell[258310, 6512, 222, 5, 25, "Print"],
Cell[258535, 6519, 176, 2, 121, "Print"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[258772, 6528, 101, 1, 83, "Section"],
Cell[CellGroupData[{
Cell[258898, 6533, 518, 14, 110, "Input"],
Cell[CellGroupData[{
Cell[259441, 6551, 90, 1, 25, "Print"],
Cell[259534, 6554, 95, 1, 25, "Print"],
Cell[259632, 6557, 98, 1, 25, "Print"],
Cell[259733, 6560, 90, 1, 25, "Print"],
Cell[259826, 6563, 243, 6, 25, "Print"],
Cell[260072, 6571, 95, 1, 25, "Print"],
Cell[260170, 6574, 93, 1, 25, "Print"],
Cell[260266, 6577, 373, 7, 45, "Print"],
Cell[260642, 6586, 100, 1, 25, "Print"],
Cell[260745, 6589, 93, 1, 25, "Print"],
Cell[260841, 6592, 259, 6, 25, "Print"],
Cell[261103, 6600, 154, 2, 83, "Print"],
Cell[261260, 6604, 95, 1, 25, "Print"],
Cell[261358, 6607, 98, 1, 25, "Print"],
Cell[261459, 6610, 90, 1, 25, "Print"],
Cell[261552, 6613, 245, 6, 25, "Print"],
Cell[261800, 6621, 93, 1, 25, "Print"],
Cell[261896, 6624, 94, 1, 25, "Print"],
Cell[261993, 6627, 93, 1, 25, "Print"],
Cell[262089, 6630, 96, 1, 25, "Print"],
Cell[262188, 6633, 96, 1, 25, "Print"],
Cell[262287, 6636, 102, 1, 25, "Print"],
Cell[262392, 6639, 96, 1, 25, "Print"],
Cell[262491, 6642, 98, 1, 25, "Print"],
Cell[262592, 6645, 96, 1, 25, "Print"],
Cell[262691, 6648, 98, 1, 25, "Print"],
Cell[262792, 6651, 377, 7, 45, "Print"],
Cell[263172, 6660, 100, 1, 25, "Print"],
Cell[263275, 6663, 208, 5, 25, "Print"],
Cell[263486, 6670, 95, 1, 25, "Print"],
Cell[263584, 6673, 289, 7, 25, "Print"],
Cell[263876, 6682, 218, 3, 102, "Print"]
}, Open  ]],
Cell[264109, 6688, 1927, 54, 91, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[266085, 6748, 82, 1, 83, "Section"],
Cell[266170, 6751, 125, 3, 32, "Text"],
Cell[CellGroupData[{
Cell[266320, 6758, 96, 2, 33, "Input"],
Cell[266419, 6762, 93, 1, 25, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[266549, 6768, 53, 1, 33, "Input"],
Cell[266605, 6771, 320, 4, 178, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[266962, 6780, 98, 2, 33, "Input"],
Cell[CellGroupData[{
Cell[267085, 6786, 306, 7, 25, "Print"],
Cell[267394, 6795, 77, 1, 25, "Print"],
Cell[267474, 6798, 250, 6, 25, "Print"],
Cell[267727, 6806, 114, 1, 25, "Print"],
Cell[267844, 6809, 110, 1, 25, "Print"],
Cell[267957, 6812, 127, 2, 25, "Print"],
Cell[268087, 6816, 117, 1, 25, "Print"],
Cell[268207, 6819, 125, 2, 25, "Print"],
Cell[268335, 6823, 136, 2, 25, "Print"],
Cell[268474, 6827, 232, 5, 25, "Print"],
Cell[268709, 6834, 116, 1, 25, "Print"],
Cell[268828, 6837, 141, 2, 25, "Print"],
Cell[268972, 6841, 101, 1, 45, "Print"],
Cell[269076, 6844, 77, 1, 25, "Print"],
Cell[269156, 6847, 258, 6, 25, "Print"],
Cell[269417, 6855, 112, 1, 25, "Print"],
Cell[269532, 6858, 110, 1, 25, "Print"],
Cell[269645, 6861, 127, 2, 25, "Print"],
Cell[269775, 6865, 117, 1, 25, "Print"],
Cell[269895, 6868, 125, 2, 25, "Print"],
Cell[270023, 6872, 134, 2, 25, "Print"],
Cell[270160, 6876, 234, 5, 25, "Print"],
Cell[270397, 6883, 255, 6, 25, "Print"],
Cell[270655, 6891, 117, 1, 25, "Print"]
}, Open  ]],
Cell[270787, 6895, 500, 10, 26, "Message"],
Cell[271290, 6907, 346, 7, 26, "Message"],
Cell[271639, 6916, 279, 6, 26, "Message"],
Cell[CellGroupData[{
Cell[271943, 6926, 103, 1, 45, "Print"],
Cell[272049, 6929, 111, 1, 45, "Print"]
}, Open  ]],
Cell[272175, 6933, 75, 1, 33, "Output"]
}, Open  ]],
Cell[272265, 6937, 90, 2, 33, "Input"],
Cell[CellGroupData[{
Cell[272380, 6943, 53, 1, 33, "Input"],
Cell[272436, 6946, 286, 4, 140, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[272759, 6955, 253, 7, 33, "Input"],
Cell[273015, 6964, 437, 8, 26, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[273489, 6977, 63, 1, 33, "Input"],
Cell[273555, 6980, 216, 3, 102, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[273808, 6988, 127, 3, 33, "Input"],
Cell[273938, 6993, 319, 4, 178, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[274294, 7002, 93, 2, 33, "Input"],
Cell[274390, 7006, 91, 1, 25, "Print"],
Cell[274484, 7009, 1378, 22, 147, "Message"],
Cell[CellGroupData[{
Cell[275887, 7035, 377, 8, 25, "Print"],
Cell[276267, 7045, 229, 5, 25, "Print"]
}, Open  ]],
Cell[276511, 7053, 1244, 34, 110, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[277792, 7092, 57, 1, 25, "Input"],
Cell[277852, 7095, 8572, 219, 300, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[286461, 7319, 63, 1, 33, "Input"],
Cell[286527, 7322, 164, 2, 64, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[286728, 7329, 59, 1, 33, "Input"],
Cell[CellGroupData[{
Cell[286812, 7334, 95, 1, 25, "Print"],
Cell[286910, 7337, 98, 1, 25, "Print"],
Cell[287011, 7340, 90, 1, 25, "Print"],
Cell[287104, 7343, 243, 6, 25, "Print"],
Cell[287350, 7351, 101, 1, 25, "Print"],
Cell[287454, 7354, 108, 1, 25, "Print"],
Cell[287565, 7357, 101, 1, 25, "Print"],
Cell[287669, 7360, 112, 1, 25, "Print"],
Cell[287784, 7363, 108, 1, 25, "Print"],
Cell[287895, 7366, 95, 1, 25, "Print"],
Cell[287993, 7369, 108, 1, 25, "Print"],
Cell[288104, 7372, 373, 7, 45, "Print"],
Cell[288480, 7381, 100, 1, 25, "Print"],
Cell[288583, 7384, 95, 1, 25, "Print"],
Cell[288681, 7387, 259, 6, 25, "Print"],
Cell[288943, 7395, 186, 2, 102, "Print"]
}, Open  ]],
Cell[289144, 7400, 1664, 48, 72, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[290845, 7453, 57, 1, 33, "Input"],
Cell[290905, 7456, 11228, 283, 433, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[302170, 7744, 53, 1, 33, "Input"],
Cell[302226, 7747, 618, 8, 330, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[302881, 7760, 59, 1, 33, "Input"],
Cell[CellGroupData[{
Cell[302965, 7765, 95, 1, 25, "Print"],
Cell[303063, 7768, 100, 1, 25, "Print"],
Cell[303166, 7771, 90, 1, 25, "Print"],
Cell[303259, 7774, 243, 6, 25, "Print"],
Cell[303505, 7782, 101, 1, 25, "Print"],
Cell[303609, 7785, 108, 1, 25, "Print"],
Cell[303720, 7788, 101, 1, 25, "Print"],
Cell[303824, 7791, 112, 1, 25, "Print"],
Cell[303939, 7794, 106, 1, 25, "Print"],
Cell[304048, 7797, 95, 1, 25, "Print"],
Cell[304146, 7800, 108, 1, 25, "Print"],
Cell[304257, 7803, 373, 7, 45, "Print"],
Cell[304633, 7812, 100, 1, 25, "Print"],
Cell[304736, 7815, 93, 1, 25, "Print"],
Cell[304832, 7818, 262, 6, 25, "Print"],
Cell[305097, 7826, 236, 3, 140, "Print"]
}, Open  ]],
Cell[305348, 7832, 2242, 64, 91, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[307627, 7901, 63, 1, 33, "Input"],
Cell[307693, 7904, 238, 3, 140, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[307980, 7913, 82, 1, 45, "Section"],
Cell[308065, 7916, 96, 2, 41, "Input"],
Cell[308164, 7920, 125, 3, 41, "Input"],
Cell[308292, 7925, 53, 1, 41, "Input"],
Cell[308348, 7928, 98, 2, 41, "Input"],
Cell[308449, 7932, 90, 2, 41, "Input"],
Cell[308542, 7936, 180, 5, 41, "Input"],
Cell[308725, 7943, 95, 2, 41, "Input"],
Cell[308823, 7947, 180, 5, 41, "Input"],
Cell[309006, 7954, 63, 1, 41, "Input"],
Cell[309072, 7957, 75, 2, 41, "Input"],
Cell[309150, 7961, 222, 6, 41, "Input"],
Cell[309375, 7969, 63, 1, 41, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[309475, 7975, 82, 1, 45, "Section"],
Cell[309560, 7978, 96, 2, 41, "Input"],
Cell[309659, 7982, 125, 3, 41, "Input"],
Cell[309787, 7987, 98, 2, 41, "Input"],
Cell[309888, 7991, 127, 3, 41, "Input"],
Cell[310018, 7996, 255, 7, 41, "Input"],
Cell[310276, 8005, 67, 1, 41, "Input"],
Cell[310346, 8008, 75, 2, 41, "Input"],
Cell[310424, 8012, 397, 10, 41, "Input"],
Cell[310824, 8024, 63, 1, 41, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[310924, 8030, 82, 1, 45, "Section"],
Cell[311009, 8033, 96, 2, 41, "Input"],
Cell[311108, 8037, 125, 3, 41, "Input"],
Cell[311236, 8042, 98, 2, 41, "Input"],
Cell[311337, 8046, 127, 3, 37, "Input"],
Cell[311467, 8051, 98, 2, 41, "Input"],
Cell[311568, 8055, 134, 3, 41, "Input"],
Cell[311705, 8060, 318, 9, 41, "Input"],
Cell[312026, 8071, 67, 1, 41, "Input"],
Cell[312096, 8074, 180, 5, 41, "Input"],
Cell[312279, 8081, 75, 2, 41, "Input"],
Cell[312357, 8085, 397, 10, 41, "Input"],
Cell[312757, 8097, 63, 1, 41, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[312857, 8103, 230, 3, 73, "Section"],
Cell[313090, 8108, 79, 1, 33, "Input"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
